// output-es/runtime.js
function binding(init2) {
  let state = 0;
  let value;
  return () => {
    if (state === 2) {
      return value;
    }
    if (state === 1) {
      throw new Error("Binding demanded before initialized");
    }
    state = 1;
    value = init2();
    state = 2;
    return value;
  };
}
function fail() {
  throw new Error("Failed pattern match");
}

// output-es/Data.Function/index.js
var $$const = (a) => (v) => a;
var applyFlipped = (x) => (f) => f(x);
var apply = (f) => (x) => f(x);

// output-es/Control.Semigroupoid/index.js
var semigroupoidFn = { compose: (f) => (g) => (x) => f(g(x)) };

// output-es/Data.Unit/foreign.js
var unit = void 0;

// output-es/Type.Proxy/index.js
var $Proxy = () => ({ tag: "Proxy" });
var $$Proxy = /* @__PURE__ */ $Proxy();

// output-es/Data.Functor/foreign.js
var arrayMap = function(f) {
  return function(arr) {
    var l = arr.length;
    var result = new Array(l);
    for (var i = 0; i < l; i++) {
      result[i] = f(arr[i]);
    }
    return result;
  };
};

// output-es/Data.Functor/index.js
var functorArray = { map: arrayMap };

// output-es/Control.Apply/index.js
var identity = (x) => x;

// output-es/Data.Void/index.js
var absurd = (a) => {
  const spin = (spin$a0$copy) => {
    let spin$a0 = spin$a0$copy, spin$c = true, spin$r;
    while (spin$c) {
      const v = spin$a0;
      spin$a0 = v;
      continue;
    }
    ;
    return spin$r;
  };
  return spin(a);
};

// output-es/Record.Unsafe/foreign.js
var unsafeGet = function(label) {
  return function(rec) {
    return rec[label];
  };
};

// output-es/Data.Semigroup/foreign.js
var concatString = function(s1) {
  return function(s2) {
    return s1 + s2;
  };
};
var concatArray = function(xs) {
  return function(ys) {
    if (xs.length === 0)
      return ys;
    if (ys.length === 0)
      return xs;
    return xs.concat(ys);
  };
};

// output-es/Data.Semigroup/index.js
var semigroupUnit = { append: (v) => (v1) => unit };
var semigroupString = { append: concatString };
var semigroupArray = { append: concatArray };

// output-es/Control.Alternative/index.js
var guard = (dictAlternative) => {
  const pure = dictAlternative.Applicative0().pure;
  const empty4 = dictAlternative.Plus1().empty;
  return (v) => {
    if (v) {
      return pure(unit);
    }
    return empty4;
  };
};

// output-es/Control.Bind/foreign.js
var arrayBind = function(arr) {
  return function(f) {
    var result = [];
    for (var i = 0, l = arr.length; i < l; i++) {
      Array.prototype.push.apply(result, f(arr[i]));
    }
    return result;
  };
};

// output-es/Control.Bind/index.js
var identity2 = (x) => x;

// output-es/Control.Monad.ST.Internal/foreign.js
var bind_ = function(a) {
  return function(f) {
    return function() {
      return f(a())();
    };
  };
};
var run = function(f) {
  return f();
};
function whileST(f) {
  return function(a) {
    return function() {
      while (f()) {
        a();
      }
    };
  };
}
function forST(lo) {
  return function(hi) {
    return function(f) {
      return function() {
        for (var i = lo; i < hi; i++) {
          f(i)();
        }
      };
    };
  };
}
var foreach = function(as) {
  return function(f) {
    return function() {
      for (var i = 0, l = as.length; i < l; i++) {
        f(as[i])();
      }
    };
  };
};

// output-es/Data.Show/foreign.js
var showIntImpl = function(n) {
  return n.toString();
};

// output-es/Data.Ordering/index.js
var $Ordering = (tag) => ({ tag });
var LT = /* @__PURE__ */ $Ordering("LT");
var GT = /* @__PURE__ */ $Ordering("GT");
var EQ = /* @__PURE__ */ $Ordering("EQ");

// output-es/Data.Maybe/index.js
var $Maybe = (tag, _1) => ({ tag, _1 });
var Nothing = /* @__PURE__ */ $Maybe("Nothing");
var Just = (value0) => $Maybe("Just", value0);
var semigroupMaybe = (dictSemigroup) => ({
  append: (v) => (v1) => {
    if (v.tag === "Nothing") {
      return v1;
    }
    if (v1.tag === "Nothing") {
      return v;
    }
    if (v.tag === "Just") {
      if (v1.tag === "Just") {
        return $Maybe("Just", dictSemigroup.append(v._1)(v1._1));
      }
      fail();
    }
    fail();
  }
});
var isNothing = (v2) => {
  if (v2.tag === "Nothing") {
    return true;
  }
  if (v2.tag === "Just") {
    return false;
  }
  fail();
};
var isJust = (v2) => {
  if (v2.tag === "Nothing") {
    return false;
  }
  if (v2.tag === "Just") {
    return true;
  }
  fail();
};
var functorMaybe = {
  map: (v) => (v1) => {
    if (v1.tag === "Just") {
      return $Maybe("Just", v(v1._1));
    }
    return Nothing;
  }
};
var ordMaybe = (dictOrd) => {
  const $1 = dictOrd.Eq0();
  const eqMaybe1 = {
    eq: (x) => (y) => {
      if (x.tag === "Nothing") {
        return y.tag === "Nothing";
      }
      if (x.tag === "Just") {
        if (y.tag === "Just") {
          return $1.eq(x._1)(y._1);
        }
        return false;
      }
      return false;
    }
  };
  return {
    compare: (x) => (y) => {
      if (x.tag === "Nothing") {
        if (y.tag === "Nothing") {
          return EQ;
        }
        return LT;
      }
      if (y.tag === "Nothing") {
        return GT;
      }
      if (x.tag === "Just") {
        if (y.tag === "Just") {
          return dictOrd.compare(x._1)(y._1);
        }
        fail();
      }
      fail();
    },
    Eq0: () => eqMaybe1
  };
};
var applyMaybe = {
  apply: (v) => (v1) => {
    if (v.tag === "Just") {
      if (v1.tag === "Just") {
        return $Maybe("Just", v._1(v1._1));
      }
      return Nothing;
    }
    if (v.tag === "Nothing") {
      return Nothing;
    }
    fail();
  },
  Functor0: () => functorMaybe
};
var applicativeMaybe = { pure: Just, Apply0: () => applyMaybe };
var altMaybe = {
  alt: (v) => (v1) => {
    if (v.tag === "Nothing") {
      return v1;
    }
    return v;
  },
  Functor0: () => functorMaybe
};
var plusMaybe = { empty: Nothing, Alt0: () => altMaybe };
var alternativeMaybe = { Applicative0: () => applicativeMaybe, Plus1: () => plusMaybe };

// output-es/Data.Either/index.js
var $Either = (tag, _1) => ({ tag, _1 });
var Left = (value0) => $Either("Left", value0);
var Right = (value0) => $Either("Right", value0);
var functorEither = {
  map: (f) => (m) => {
    if (m.tag === "Left") {
      return $Either("Left", m._1);
    }
    if (m.tag === "Right") {
      return $Either("Right", f(m._1));
    }
    fail();
  }
};
var applyEither = {
  apply: (v) => (v1) => {
    if (v.tag === "Left") {
      return $Either("Left", v._1);
    }
    if (v.tag === "Right") {
      if (v1.tag === "Left") {
        return $Either("Left", v1._1);
      }
      if (v1.tag === "Right") {
        return $Either("Right", v._1(v1._1));
      }
      fail();
    }
    fail();
  },
  Functor0: () => functorEither
};
var bindEither = {
  bind: (v2) => {
    if (v2.tag === "Left") {
      return (v) => $Either("Left", v2._1);
    }
    if (v2.tag === "Right") {
      return (f) => f(v2._1);
    }
    fail();
  },
  Apply0: () => applyEither
};
var applicativeEither = { pure: Right, Apply0: () => applyEither };

// output-es/Effect/foreign.js
var pureE = function(a) {
  return function() {
    return a;
  };
};
var bindE = function(a) {
  return function(f) {
    return function() {
      return f(a())();
    };
  };
};

// output-es/Effect/index.js
var monadEffect = { Applicative0: () => applicativeEffect, Bind1: () => bindEffect };
var bindEffect = { bind: bindE, Apply0: () => applyEffect };
var applyEffect = {
  apply: (f) => (a) => () => {
    const f$p = f();
    const a$p = a();
    return applicativeEffect.pure(f$p(a$p))();
  },
  Functor0: () => functorEffect
};
var applicativeEffect = { pure: pureE, Apply0: () => applyEffect };
var functorEffect = {
  map: (f) => (a) => () => {
    const a$p = a();
    return f(a$p);
  }
};

// output-es/Data.Array.ST/foreign.js
function newSTArray() {
  return [];
}
var pushAll = function(as) {
  return function(xs) {
    return function() {
      return xs.push.apply(xs, as);
    };
  };
};
var unsafeFreeze = function(xs) {
  return function() {
    return xs;
  };
};
var unsafeThaw = function(xs) {
  return function() {
    return xs;
  };
};
function copyImpl(xs) {
  return function() {
    return xs.slice();
  };
}
var thaw = copyImpl;
var sortByImpl = function() {
  function mergeFromTo(compare4, fromOrdering, xs1, xs2, from, to) {
    var mid;
    var i;
    var j;
    var k;
    var x;
    var y;
    var c;
    mid = from + (to - from >> 1);
    if (mid - from > 1)
      mergeFromTo(compare4, fromOrdering, xs2, xs1, from, mid);
    if (to - mid > 1)
      mergeFromTo(compare4, fromOrdering, xs2, xs1, mid, to);
    i = from;
    j = mid;
    k = from;
    while (i < mid && j < to) {
      x = xs2[i];
      y = xs2[j];
      c = fromOrdering(compare4(x)(y));
      if (c > 0) {
        xs1[k++] = y;
        ++j;
      } else {
        xs1[k++] = x;
        ++i;
      }
    }
    while (i < mid) {
      xs1[k++] = xs2[i++];
    }
    while (j < to) {
      xs1[k++] = xs2[j++];
    }
  }
  return function(compare4) {
    return function(fromOrdering) {
      return function(xs) {
        return function() {
          if (xs.length < 2)
            return xs;
          mergeFromTo(compare4, fromOrdering, xs, xs.slice(0), 0, xs.length);
          return xs;
        };
      };
    };
  };
}();

// output-es/Data.Array.ST/index.js
var withArray = (f) => (xs) => {
  const $2 = thaw(xs);
  return () => {
    const result = $2();
    f(result)();
    return unsafeFreeze(result)();
  };
};

// output-es/Data.Array.ST.Iterator/index.js
var $Iterator = (_1, _2) => ({ tag: "Iterator", _1, _2 });
var pushWhile = (p) => (iter) => (array) => () => {
  const $$break = { value: false };
  return whileST(() => {
    const $4 = $$break.value;
    return !$4;
  })(() => {
    const i = iter._2.value;
    const mx = iter._1(i);
    if (mx.tag === "Just") {
      if (p(mx._1)) {
        pushAll([mx._1])(array)();
        iter._2.value;
        const $8 = iter._2.value;
        iter._2.value = $8 + 1 | 0;
        return unit;
      }
      $$break.value = true;
      return unit;
    }
    $$break.value = true;
    return unit;
  })();
};
var iterate = (iter) => (f) => () => {
  const $$break = { value: false };
  return whileST(() => {
    const $3 = $$break.value;
    return !$3;
  })(() => {
    const i = iter._2.value;
    const $4 = iter._2.value;
    iter._2.value = $4 + 1 | 0;
    const mx = iter._1(i);
    if (mx.tag === "Just") {
      return f(mx._1)();
    }
    if (mx.tag === "Nothing") {
      $$break.value = true;
      return unit;
    }
    fail();
  })();
};

// output-es/Data.Foldable/foreign.js
var foldrArray = function(f) {
  return function(init2) {
    return function(xs) {
      var acc = init2;
      var len = xs.length;
      for (var i = len - 1; i >= 0; i--) {
        acc = f(xs[i])(acc);
      }
      return acc;
    };
  };
};
var foldlArray = function(f) {
  return function(init2) {
    return function(xs) {
      var acc = init2;
      var len = xs.length;
      for (var i = 0; i < len; i++) {
        acc = f(acc)(xs[i]);
      }
      return acc;
    };
  };
};

// output-es/Data.Foldable/index.js
var identity3 = (x) => x;
var traverse_ = (dictApplicative) => {
  const $1 = dictApplicative.Apply0();
  const map = $1.Functor0().map;
  return (dictFoldable) => (f) => dictFoldable.foldr((x) => {
    const $6 = f(x);
    return (b) => $1.apply(map((v) => identity)($6))(b);
  })(dictApplicative.pure(unit));
};
var for_ = (dictApplicative) => {
  const traverse_1 = traverse_(dictApplicative);
  return (dictFoldable) => {
    const $3 = traverse_1(dictFoldable);
    return (b) => (a) => $3(a)(b);
  };
};
var foldableMaybe = {
  foldr: (v) => (z) => (v1) => {
    if (v1.tag === "Nothing") {
      return z;
    }
    if (v1.tag === "Just") {
      return v(v1._1)(z);
    }
    fail();
  },
  foldl: (v) => (z) => (v1) => {
    if (v1.tag === "Nothing") {
      return z;
    }
    if (v1.tag === "Just") {
      return v(z)(v1._1);
    }
    fail();
  },
  foldMap: (dictMonoid) => (v) => (v1) => {
    if (v1.tag === "Nothing") {
      return dictMonoid.mempty;
    }
    if (v1.tag === "Just") {
      return v(v1._1);
    }
    fail();
  }
};
var foldableArray = {
  foldr: foldrArray,
  foldl: foldlArray,
  foldMap: (dictMonoid) => {
    const append = dictMonoid.Semigroup0().append;
    return (f) => foldableArray.foldr((x) => (acc) => append(f(x))(acc))(dictMonoid.mempty);
  }
};
var find = (dictFoldable) => (p) => dictFoldable.foldl((v) => (v1) => {
  if (v.tag === "Nothing") {
    if (p(v1)) {
      return $Maybe("Just", v1);
    }
    return v;
  }
  return v;
})(Nothing);

// output-es/Data.Eq/foreign.js
var refEq = function(r1) {
  return function(r2) {
    return r1 === r2;
  };
};
var eqBooleanImpl = refEq;
var eqIntImpl = refEq;
var eqNumberImpl = refEq;
var eqStringImpl = refEq;
var eqArrayImpl = function(f) {
  return function(xs) {
    return function(ys) {
      if (xs.length !== ys.length)
        return false;
      for (var i = 0; i < xs.length; i++) {
        if (!f(xs[i])(ys[i]))
          return false;
      }
      return true;
    };
  };
};

// output-es/Data.Eq/index.js
var eqString = { eq: eqStringImpl };
var eqNumber = { eq: eqNumberImpl };
var eqInt = { eq: eqIntImpl };
var eqBoolean = { eq: eqBooleanImpl };

// output-es/Data.Ord/foreign.js
var unsafeCompareImpl = function(lt) {
  return function(eq2) {
    return function(gt) {
      return function(x) {
        return function(y) {
          return x < y ? lt : x === y ? eq2 : gt;
        };
      };
    };
  };
};
var ordBooleanImpl = unsafeCompareImpl;
var ordIntImpl = unsafeCompareImpl;
var ordNumberImpl = unsafeCompareImpl;
var ordStringImpl = unsafeCompareImpl;
var ordArrayImpl = function(f) {
  return function(xs) {
    return function(ys) {
      var i = 0;
      var xlen = xs.length;
      var ylen = ys.length;
      while (i < xlen && i < ylen) {
        var x = xs[i];
        var y = ys[i];
        var o = f(x)(y);
        if (o !== 0) {
          return o;
        }
        i++;
      }
      if (xlen === ylen) {
        return 0;
      } else if (xlen > ylen) {
        return -1;
      } else {
        return 1;
      }
    };
  };
};

// output-es/Data.Ord/index.js
var ordString = { compare: /* @__PURE__ */ ordStringImpl(LT)(EQ)(GT), Eq0: () => eqString };
var ordNumber = { compare: /* @__PURE__ */ ordNumberImpl(LT)(EQ)(GT), Eq0: () => eqNumber };
var ordInt = { compare: /* @__PURE__ */ ordIntImpl(LT)(EQ)(GT), Eq0: () => eqInt };
var ordBoolean = { compare: /* @__PURE__ */ ordBooleanImpl(LT)(EQ)(GT), Eq0: () => eqBoolean };
var ordArray = (dictOrd) => {
  const eqArray = { eq: eqArrayImpl(dictOrd.Eq0().eq) };
  return {
    compare: (xs) => (ys) => ordInt.compare(0)(ordArrayImpl((x) => (y) => {
      const v = dictOrd.compare(x)(y);
      if (v.tag === "EQ") {
        return 0;
      }
      if (v.tag === "LT") {
        return 1;
      }
      if (v.tag === "GT") {
        return -1;
      }
      fail();
    })(xs)(ys)),
    Eq0: () => eqArray
  };
};

// output-es/Unsafe.Coerce/foreign.js
var unsafeCoerce = function(x) {
  return x;
};

// output-es/Data.Tuple/index.js
var $Tuple = (_1, _2) => ({ tag: "Tuple", _1, _2 });
var Tuple = (value0) => (value1) => $Tuple(value0, value1);
var snd = (v) => v._2;
var fst = (v) => v._1;
var ordTuple = (dictOrd) => {
  const $1 = dictOrd.Eq0();
  return (dictOrd1) => {
    const $3 = dictOrd1.Eq0();
    const eqTuple2 = { eq: (x) => (y) => $1.eq(x._1)(y._1) && $3.eq(x._2)(y._2) };
    return {
      compare: (x) => (y) => {
        const v = dictOrd.compare(x._1)(y._1);
        if (v.tag === "LT") {
          return LT;
        }
        if (v.tag === "GT") {
          return GT;
        }
        return dictOrd1.compare(x._2)(y._2);
      },
      Eq0: () => eqTuple2
    };
  };
};

// output-es/Data.Bifunctor/index.js
var identity4 = (x) => x;
var bifunctorEither = {
  bimap: (v) => (v1) => (v2) => {
    if (v2.tag === "Left") {
      return $Either("Left", v(v2._1));
    }
    if (v2.tag === "Right") {
      return $Either("Right", v1(v2._1));
    }
    fail();
  }
};

// output-es/Data.Traversable/foreign.js
var traverseArrayImpl = function() {
  function array1(a) {
    return [a];
  }
  function array2(a) {
    return function(b) {
      return [a, b];
    };
  }
  function array3(a) {
    return function(b) {
      return function(c) {
        return [a, b, c];
      };
    };
  }
  function concat22(xs) {
    return function(ys) {
      return xs.concat(ys);
    };
  }
  return function(apply2) {
    return function(map) {
      return function(pure) {
        return function(f) {
          return function(array) {
            function go(bot, top) {
              switch (top - bot) {
                case 0:
                  return pure([]);
                case 1:
                  return map(array1)(f(array[bot]));
                case 2:
                  return apply2(map(array2)(f(array[bot])))(f(array[bot + 1]));
                case 3:
                  return apply2(apply2(map(array3)(f(array[bot])))(f(array[bot + 1])))(f(array[bot + 2]));
                default:
                  var pivot = bot + Math.floor((top - bot) / 4) * 2;
                  return apply2(map(concat22)(go(bot, pivot)))(go(pivot, top));
              }
            }
            return go(0, array.length);
          };
        };
      };
    };
  };
}();

// output-es/Data.Traversable/index.js
var identity5 = (x) => x;
var traversableMaybe = {
  traverse: (dictApplicative) => {
    const map = dictApplicative.Apply0().Functor0().map;
    return (v) => (v1) => {
      if (v1.tag === "Nothing") {
        return dictApplicative.pure(Nothing);
      }
      if (v1.tag === "Just") {
        return map(Just)(v(v1._1));
      }
      fail();
    };
  },
  sequence: (dictApplicative) => {
    const map = dictApplicative.Apply0().Functor0().map;
    return (v) => {
      if (v.tag === "Nothing") {
        return dictApplicative.pure(Nothing);
      }
      if (v.tag === "Just") {
        return map(Just)(v._1);
      }
      fail();
    };
  },
  Functor0: () => functorMaybe,
  Foldable1: () => foldableMaybe
};
var traversableArray = {
  traverse: (dictApplicative) => {
    const Apply0 = dictApplicative.Apply0();
    return traverseArrayImpl(Apply0.apply)(Apply0.Functor0().map)(dictApplicative.pure);
  },
  sequence: (dictApplicative) => traversableArray.traverse(dictApplicative)(identity5),
  Functor0: () => functorArray,
  Foldable1: () => foldableArray
};

// output-es/Data.Array/foreign.js
var range = function(start) {
  return function(end) {
    var step = start > end ? -1 : 1;
    var result = new Array(step * (end - start) + 1);
    var i = start, n = 0;
    while (i !== end) {
      result[n++] = i;
      i += step;
    }
    result[n] = i;
    return result;
  };
};
var replicateFill = function(count) {
  return function(value) {
    if (count < 1) {
      return [];
    }
    var result = new Array(count);
    return result.fill(value);
  };
};
var replicatePolyfill = function(count) {
  return function(value) {
    var result = [];
    var n = 0;
    for (var i = 0; i < count; i++) {
      result[n++] = value;
    }
    return result;
  };
};
var replicate = typeof Array.prototype.fill === "function" ? replicateFill : replicatePolyfill;
var fromFoldableImpl = function() {
  function Cons2(head, tail2) {
    this.head = head;
    this.tail = tail2;
  }
  var emptyList = {};
  function curryCons(head) {
    return function(tail2) {
      return new Cons2(head, tail2);
    };
  }
  function listToArray(list) {
    var result = [];
    var count = 0;
    var xs = list;
    while (xs !== emptyList) {
      result[count++] = xs.head;
      xs = xs.tail;
    }
    return result;
  }
  return function(foldr) {
    return function(xs) {
      return listToArray(foldr(curryCons)(emptyList)(xs));
    };
  };
}();
var unconsImpl = function(empty4) {
  return function(next) {
    return function(xs) {
      return xs.length === 0 ? empty4({}) : next(xs[0])(xs.slice(1));
    };
  };
};
var indexImpl = function(just) {
  return function(nothing) {
    return function(xs) {
      return function(i) {
        return i < 0 || i >= xs.length ? nothing : just(xs[i]);
      };
    };
  };
};
var findMapImpl = function(nothing) {
  return function(isJust2) {
    return function(f) {
      return function(xs) {
        for (var i = 0; i < xs.length; i++) {
          var result = f(xs[i]);
          if (isJust2(result))
            return result;
        }
        return nothing;
      };
    };
  };
};
var findIndexImpl = function(just) {
  return function(nothing) {
    return function(f) {
      return function(xs) {
        for (var i = 0, l = xs.length; i < l; i++) {
          if (f(xs[i]))
            return just(i);
        }
        return nothing;
      };
    };
  };
};
var reverse = function(l) {
  return l.slice().reverse();
};
var filter = function(f) {
  return function(xs) {
    return xs.filter(f);
  };
};
var partition = function(f) {
  return function(xs) {
    var yes = [];
    var no = [];
    for (var i = 0; i < xs.length; i++) {
      var x = xs[i];
      if (f(x))
        yes.push(x);
      else
        no.push(x);
    }
    return { yes, no };
  };
};
var sortByImpl2 = function() {
  function mergeFromTo(compare4, fromOrdering, xs1, xs2, from, to) {
    var mid;
    var i;
    var j;
    var k;
    var x;
    var y;
    var c;
    mid = from + (to - from >> 1);
    if (mid - from > 1)
      mergeFromTo(compare4, fromOrdering, xs2, xs1, from, mid);
    if (to - mid > 1)
      mergeFromTo(compare4, fromOrdering, xs2, xs1, mid, to);
    i = from;
    j = mid;
    k = from;
    while (i < mid && j < to) {
      x = xs2[i];
      y = xs2[j];
      c = fromOrdering(compare4(x)(y));
      if (c > 0) {
        xs1[k++] = y;
        ++j;
      } else {
        xs1[k++] = x;
        ++i;
      }
    }
    while (i < mid) {
      xs1[k++] = xs2[i++];
    }
    while (j < to) {
      xs1[k++] = xs2[j++];
    }
  }
  return function(compare4) {
    return function(fromOrdering) {
      return function(xs) {
        var out;
        if (xs.length < 2)
          return xs;
        out = xs.slice(0);
        mergeFromTo(compare4, fromOrdering, out, xs.slice(0), 0, xs.length);
        return out;
      };
    };
  };
}();
var slice = function(s) {
  return function(e) {
    return function(l) {
      return l.slice(s, e);
    };
  };
};
var zipWith = function(f) {
  return function(xs) {
    return function(ys) {
      var l = xs.length < ys.length ? xs.length : ys.length;
      var result = new Array(l);
      for (var i = 0; i < l; i++) {
        result[i] = f(xs[i])(ys[i]);
      }
      return result;
    };
  };
};
var all = function(p) {
  return function(xs) {
    var len = xs.length;
    for (var i = 0; i < len; i++) {
      if (!p(xs[i]))
        return false;
    }
    return true;
  };
};

// output-es/Data.Array/index.js
var intercalate1 = (dictMonoid) => {
  const append = dictMonoid.Semigroup0().append;
  return (sep2) => (xs) => foldlArray((v) => (x) => {
    if (v.init) {
      return { init: false, acc: x };
    }
    return { init: false, acc: append(v.acc)(append(sep2)(x)) };
  })({ init: true, acc: dictMonoid.mempty })(xs).acc;
};
var zip = /* @__PURE__ */ zipWith(Tuple);
var uncons = /* @__PURE__ */ unconsImpl((v) => Nothing)((x) => (xs) => $Maybe("Just", { head: x, tail: xs }));
var tail = /* @__PURE__ */ unconsImpl((v) => Nothing)((v) => (xs) => $Maybe("Just", xs));
var sortBy = (comp) => sortByImpl2(comp)((v) => {
  if (v.tag === "GT") {
    return 1;
  }
  if (v.tag === "EQ") {
    return 0;
  }
  if (v.tag === "LT") {
    return -1;
  }
  fail();
});
var sortWith = (dictOrd) => (f) => sortBy((x) => (y) => dictOrd.compare(f(x))(f(y)));
var intersperse = (a) => (arr) => {
  const v = arr.length;
  if (v < 2) {
    return arr;
  }
  return run(bind_(() => {
    const out = newSTArray();
    pushAll([arr[0]])(out)();
    forST(1)(v)((idx) => {
      const $6 = pushAll([a])(out);
      return () => {
        $6();
        pushAll([arr[idx]])(out)();
        return unit;
      };
    })();
    return out;
  })(unsafeFreeze));
};
var init = (xs) => {
  if (xs.length === 0) {
    return Nothing;
  }
  return $Maybe("Just", slice(0)(xs.length - 1 | 0)(xs));
};
var index = /* @__PURE__ */ indexImpl(Just)(Nothing);
var unsnoc = (xs) => applyMaybe.apply((() => {
  const $1 = init(xs);
  if ($1.tag === "Just") {
    return $Maybe("Just", (v1) => ({ init: $1._1, last: v1 }));
  }
  return Nothing;
})())(index(xs)(xs.length - 1 | 0));
var unzip = (xs) => run(() => {
  const fsts = newSTArray();
  const snds = newSTArray();
  const $3 = { value: 0 };
  iterate($Iterator((v) => index(xs)(v), $3))((v) => () => {
    pushAll([v._1])(fsts)();
    pushAll([v._2])(snds)();
    return unit;
  })();
  const fsts$p = unsafeFreeze(fsts)();
  const snds$p = unsafeFreeze(snds)();
  return $Tuple(fsts$p, snds$p);
});
var nubBy = (comp) => (xs) => {
  const indexedAndSorted = sortBy((x) => (y) => comp(x._2)(y._2))(zipWith(Tuple)(range(0)(xs.length - 1 | 0))(xs));
  const v = index(indexedAndSorted)(0);
  if (v.tag === "Nothing") {
    return [];
  }
  if (v.tag === "Just") {
    return arrayMap(snd)(sortWith(ordInt)(fst)(run((() => {
      const $4 = unsafeThaw([v._1]);
      return () => {
        const result = $4();
        foreach(indexedAndSorted)((v1) => () => {
          const $7 = unsafeFreeze(result)();
          const $8 = index($7)($7.length - 1 | 0);
          const $9 = comp((() => {
            if ($8.tag === "Just") {
              return $8._1._2;
            }
            fail();
          })())(v1._2);
          if ($9.tag === "LT" || ($9.tag === "GT" || !($9.tag === "EQ"))) {
            pushAll([v1])(result)();
            return unit;
          }
          return unit;
        })();
        return unsafeFreeze(result)();
      };
    })())));
  }
  fail();
};
var groupBy = (op) => (xs) => run(() => {
  const result = newSTArray();
  const $3 = { value: 0 };
  const iter = $Iterator((v) => index(xs)(v), $3);
  iterate(iter)((x) => () => {
    const sub1 = newSTArray();
    pushAll([x])(sub1)();
    pushWhile(op(x))(iter)(sub1)();
    const grp = unsafeFreeze(sub1)();
    pushAll([grp])(result)();
    return unit;
  })();
  return unsafeFreeze(result)();
});
var findMap = /* @__PURE__ */ findMapImpl(Nothing)(isJust);
var findIndex = /* @__PURE__ */ findIndexImpl(Just)(Nothing);
var elem = (dictEq) => (a) => (arr) => {
  const $3 = findIndex((v) => dictEq.eq(v)(a))(arr);
  if ($3.tag === "Nothing") {
    return false;
  }
  if ($3.tag === "Just") {
    return true;
  }
  fail();
};
var drop = (n) => (xs) => {
  if (n < 1) {
    return xs;
  }
  return slice(n)(xs.length)(xs);
};
var concatMap = (b) => (a) => arrayBind(a)(b);
var mapMaybe = (f) => concatMap((x) => {
  const $2 = f(x);
  if ($2.tag === "Nothing") {
    return [];
  }
  if ($2.tag === "Just") {
    return [$2._1];
  }
  fail();
});

// output-es/Data.FoldableWithIndex/index.js
var traverseWithIndex_ = (dictApplicative) => {
  const $1 = dictApplicative.Apply0();
  const map = $1.Functor0().map;
  return (dictFoldableWithIndex) => (f) => dictFoldableWithIndex.foldrWithIndex((i) => {
    const $6 = f(i);
    return (x) => {
      const $8 = $6(x);
      return (b) => $1.apply(map((v) => identity)($8))(b);
    };
  })(dictApplicative.pure(unit));
};
var forWithIndex_ = (dictApplicative) => {
  const traverseWithIndex_1 = traverseWithIndex_(dictApplicative);
  return (dictFoldableWithIndex) => {
    const $3 = traverseWithIndex_1(dictFoldableWithIndex);
    return (b) => (a) => $3(a)(b);
  };
};

// output-es/Data.Unfoldable1/foreign.js
var unfoldr1ArrayImpl = function(isNothing2) {
  return function(fromJust3) {
    return function(fst2) {
      return function(snd2) {
        return function(f) {
          return function(b) {
            var result = [];
            var value = b;
            while (true) {
              var tuple = f(value);
              result.push(fst2(tuple));
              var maybe = snd2(tuple);
              if (isNothing2(maybe))
                return result;
              value = fromJust3(maybe);
            }
          };
        };
      };
    };
  };
};

// output-es/Data.Unfoldable1/index.js
var fromJust = (v) => {
  if (v.tag === "Just") {
    return v._1;
  }
  fail();
};
var unfoldable1Array = { unfoldr1: /* @__PURE__ */ unfoldr1ArrayImpl(isNothing)(fromJust)(fst)(snd) };

// output-es/Data.Array.NonEmpty.Internal/foreign.js
var foldr1Impl = function(f) {
  return function(xs) {
    var acc = xs[xs.length - 1];
    for (var i = xs.length - 2; i >= 0; i--) {
      acc = f(xs[i])(acc);
    }
    return acc;
  };
};
var traverse1Impl = function() {
  function Cont(fn) {
    this.fn = fn;
  }
  var emptyList = {};
  var ConsCell = function(head, tail2) {
    this.head = head;
    this.tail = tail2;
  };
  function finalCell(head) {
    return new ConsCell(head, emptyList);
  }
  function consList(x) {
    return function(xs) {
      return new ConsCell(x, xs);
    };
  }
  function listToArray(list) {
    var arr = [];
    var xs = list;
    while (xs !== emptyList) {
      arr.push(xs.head);
      xs = xs.tail;
    }
    return arr;
  }
  return function(apply2) {
    return function(map) {
      return function(f) {
        var buildFrom = function(x, ys) {
          return apply2(map(consList)(f(x)))(ys);
        };
        var go = function(acc, currentLen, xs) {
          if (currentLen === 0) {
            return acc;
          } else {
            var last = xs[currentLen - 1];
            return new Cont(function() {
              var built = go(buildFrom(last, acc), currentLen - 1, xs);
              return built;
            });
          }
        };
        return function(array) {
          var acc = map(finalCell)(f(array[array.length - 1]));
          var result = go(acc, array.length - 1, array);
          while (result instanceof Cont) {
            result = result.fn();
          }
          return map(listToArray)(result);
        };
      };
    };
  };
}();

// output-es/Data.Number/foreign.js
var isFiniteImpl = isFinite;
function fromStringImpl(str, isFinite2, just, nothing) {
  var num = parseFloat(str);
  if (isFinite2(num)) {
    return just(num);
  } else {
    return nothing;
  }
}
var ceil = Math.ceil;

// output-es/Data.Int/foreign.js
var fromNumberImpl = function(just) {
  return function(nothing) {
    return function(n) {
      return (n | 0) === n ? just(n) : nothing;
    };
  };
};
var toNumber = function(n) {
  return n;
};
var fromStringAsImpl = function(just) {
  return function(nothing) {
    return function(radix) {
      var digits;
      if (radix < 11) {
        digits = "[0-" + (radix - 1).toString() + "]";
      } else if (radix === 11) {
        digits = "[0-9a]";
      } else {
        digits = "[0-9a-" + String.fromCharCode(86 + radix) + "]";
      }
      var pattern = new RegExp("^[\\+\\-]?" + digits + "+$", "i");
      return function(s) {
        if (pattern.test(s)) {
          var i = parseInt(s, radix);
          return (i | 0) === i ? just(i) : nothing;
        } else {
          return nothing;
        }
      };
    };
  };
};

// output-es/Data.Int/index.js
var fromStringAs = /* @__PURE__ */ fromStringAsImpl(Just)(Nothing);
var fromString = /* @__PURE__ */ fromStringAs(10);
var fromNumber = /* @__PURE__ */ fromNumberImpl(Just)(Nothing);
var unsafeClamp = (x) => {
  if (!isFiniteImpl(x)) {
    return 0;
  }
  if (x >= toNumber(2147483647)) {
    return 2147483647;
  }
  if (x <= toNumber(-2147483648)) {
    return -2147483648;
  }
  const $1 = fromNumber(x);
  if ($1.tag === "Nothing") {
    return 0;
  }
  if ($1.tag === "Just") {
    return $1._1;
  }
  fail();
};

// output-es/Data.NonEmpty/index.js
var $NonEmpty = (_1, _2) => ({ tag: "NonEmpty", _1, _2 });

// output-es/Data.List.Types/index.js
var $List = (tag, _1, _2) => ({ tag, _1, _2 });
var Nil = /* @__PURE__ */ $List("Nil");
var Cons = (value0) => (value1) => $List("Cons", value0, value1);
var listMap = (f) => {
  const chunkedRevMap = (chunkedRevMap$a0$copy) => (chunkedRevMap$a1$copy) => {
    let chunkedRevMap$a0 = chunkedRevMap$a0$copy, chunkedRevMap$a1 = chunkedRevMap$a1$copy, chunkedRevMap$c = true, chunkedRevMap$r;
    while (chunkedRevMap$c) {
      const chunksAcc = chunkedRevMap$a0, v = chunkedRevMap$a1;
      const $4 = (chunksAcc1, xs) => {
        const reverseUnrolledMap = (reverseUnrolledMap$a0$copy) => (reverseUnrolledMap$a1$copy) => {
          let reverseUnrolledMap$a0 = reverseUnrolledMap$a0$copy, reverseUnrolledMap$a1 = reverseUnrolledMap$a1$copy, reverseUnrolledMap$c = true, reverseUnrolledMap$r;
          while (reverseUnrolledMap$c) {
            const v1 = reverseUnrolledMap$a0, acc = reverseUnrolledMap$a1;
            if (v1.tag === "Cons") {
              if (v1._1.tag === "Cons") {
                if (v1._1._2.tag === "Cons") {
                  if (v1._1._2._2.tag === "Cons") {
                    reverseUnrolledMap$a0 = v1._2;
                    reverseUnrolledMap$a1 = $List("Cons", f(v1._1._1), $List("Cons", f(v1._1._2._1), $List("Cons", f(v1._1._2._2._1), acc)));
                    continue;
                  }
                  reverseUnrolledMap$c = false;
                  reverseUnrolledMap$r = acc;
                  continue;
                }
                reverseUnrolledMap$c = false;
                reverseUnrolledMap$r = acc;
                continue;
              }
              reverseUnrolledMap$c = false;
              reverseUnrolledMap$r = acc;
              continue;
            }
            reverseUnrolledMap$c = false;
            reverseUnrolledMap$r = acc;
            continue;
          }
          ;
          return reverseUnrolledMap$r;
        };
        return reverseUnrolledMap(chunksAcc1)((() => {
          if (xs.tag === "Cons") {
            if (xs._2.tag === "Cons") {
              if (xs._2._2.tag === "Nil") {
                return $List("Cons", f(xs._1), $List("Cons", f(xs._2._1), Nil));
              }
              return Nil;
            }
            if (xs._2.tag === "Nil") {
              return $List("Cons", f(xs._1), Nil);
            }
            return Nil;
          }
          return Nil;
        })());
      };
      if (v.tag === "Cons") {
        if (v._2.tag === "Cons") {
          if (v._2._2.tag === "Cons") {
            chunkedRevMap$a0 = $List("Cons", v, chunksAcc);
            chunkedRevMap$a1 = v._2._2._2;
            continue;
          }
          chunkedRevMap$c = false;
          chunkedRevMap$r = $4(chunksAcc, v);
          continue;
        }
        chunkedRevMap$c = false;
        chunkedRevMap$r = $4(chunksAcc, v);
        continue;
      }
      chunkedRevMap$c = false;
      chunkedRevMap$r = $4(chunksAcc, v);
      continue;
    }
    ;
    return chunkedRevMap$r;
  };
  return chunkedRevMap(Nil);
};
var foldableList = {
  foldr: (f) => (b) => {
    const $2 = foldableList.foldl((b$1) => (a) => f(a)(b$1))(b);
    const $3 = (() => {
      const go = (go$a0$copy) => (go$a1$copy) => {
        let go$a0 = go$a0$copy, go$a1 = go$a1$copy, go$c = true, go$r;
        while (go$c) {
          const acc = go$a0, v = go$a1;
          if (v.tag === "Nil") {
            go$c = false;
            go$r = acc;
            continue;
          }
          if (v.tag === "Cons") {
            go$a0 = $List("Cons", v._1, acc);
            go$a1 = v._2;
            continue;
          }
          fail();
        }
        ;
        return go$r;
      };
      return go(Nil);
    })();
    return (x) => $2($3(x));
  },
  foldl: (f) => {
    const go = (go$a0$copy) => (go$a1$copy) => {
      let go$a0 = go$a0$copy, go$a1 = go$a1$copy, go$c = true, go$r;
      while (go$c) {
        const b = go$a0, v = go$a1;
        if (v.tag === "Nil") {
          go$c = false;
          go$r = b;
          continue;
        }
        if (v.tag === "Cons") {
          go$a0 = f(b)(v._1);
          go$a1 = v._2;
          continue;
        }
        fail();
      }
      ;
      return go$r;
    };
    return go;
  },
  foldMap: (dictMonoid) => {
    const append2 = dictMonoid.Semigroup0().append;
    return (f) => foldableList.foldl((acc) => {
      const $4 = append2(acc);
      return (x) => $4(f(x));
    })(dictMonoid.mempty);
  }
};
var foldableNonEmptyList = {
  foldMap: (dictMonoid) => {
    const append1 = dictMonoid.Semigroup0().append;
    const foldMap13 = foldableList.foldMap(dictMonoid);
    return (f) => (v) => append1(f(v._1))(foldMap13(f)(v._2));
  },
  foldl: (f) => (b) => (v) => {
    const go = (go$a0$copy) => (go$a1$copy) => {
      let go$a0 = go$a0$copy, go$a1 = go$a1$copy, go$c = true, go$r;
      while (go$c) {
        const b$1 = go$a0, v$1 = go$a1;
        if (v$1.tag === "Nil") {
          go$c = false;
          go$r = b$1;
          continue;
        }
        if (v$1.tag === "Cons") {
          go$a0 = f(b$1)(v$1._1);
          go$a1 = v$1._2;
          continue;
        }
        fail();
      }
      ;
      return go$r;
    };
    return go(f(b)(v._1))(v._2);
  },
  foldr: (f) => (b) => (v) => f(v._1)(foldableList.foldr(f)(b)(v._2))
};
var eq1List = {
  eq1: (dictEq) => (xs) => (ys) => {
    const go = (go$a0$copy) => (go$a1$copy) => (go$a2$copy) => {
      let go$a0 = go$a0$copy, go$a1 = go$a1$copy, go$a2 = go$a2$copy, go$c = true, go$r;
      while (go$c) {
        const v = go$a0, v1 = go$a1, v2 = go$a2;
        if (!v2) {
          go$c = false;
          go$r = false;
          continue;
        }
        if (v.tag === "Nil") {
          if (v1.tag === "Nil") {
            go$c = false;
            go$r = v2;
            continue;
          }
          go$c = false;
          go$r = false;
          continue;
        }
        if (v.tag === "Cons") {
          if (v1.tag === "Cons") {
            go$a0 = v._2;
            go$a1 = v1._2;
            go$a2 = v2 && dictEq.eq(v1._1)(v._1);
            continue;
          }
          go$c = false;
          go$r = false;
          continue;
        }
        go$c = false;
        go$r = false;
        continue;
      }
      ;
      return go$r;
    };
    return go(xs)(ys)(true);
  }
};
var ord1List = {
  compare1: (dictOrd) => (xs) => (ys) => {
    const go = (go$a0$copy) => (go$a1$copy) => {
      let go$a0 = go$a0$copy, go$a1 = go$a1$copy, go$c = true, go$r;
      while (go$c) {
        const v = go$a0, v1 = go$a1;
        if (v.tag === "Nil") {
          if (v1.tag === "Nil") {
            go$c = false;
            go$r = EQ;
            continue;
          }
          go$c = false;
          go$r = LT;
          continue;
        }
        if (v1.tag === "Nil") {
          go$c = false;
          go$r = GT;
          continue;
        }
        if (v.tag === "Cons") {
          if (v1.tag === "Cons") {
            const v2 = dictOrd.compare(v._1)(v1._1);
            if (v2.tag === "EQ") {
              go$a0 = v._2;
              go$a1 = v1._2;
              continue;
            }
            go$c = false;
            go$r = v2;
            continue;
          }
          fail();
        }
        fail();
      }
      ;
      return go$r;
    };
    return go(xs)(ys);
  },
  Eq10: () => eq1List
};
var ordList = (dictOrd) => {
  const $1 = dictOrd.Eq0();
  const eqList1 = {
    eq: (xs) => (ys) => {
      const go = (go$a0$copy) => (go$a1$copy) => (go$a2$copy) => {
        let go$a0 = go$a0$copy, go$a1 = go$a1$copy, go$a2 = go$a2$copy, go$c = true, go$r;
        while (go$c) {
          const v = go$a0, v1 = go$a1, v2 = go$a2;
          if (!v2) {
            go$c = false;
            go$r = false;
            continue;
          }
          if (v.tag === "Nil") {
            if (v1.tag === "Nil") {
              go$c = false;
              go$r = v2;
              continue;
            }
            go$c = false;
            go$r = false;
            continue;
          }
          if (v.tag === "Cons") {
            if (v1.tag === "Cons") {
              go$a0 = v._2;
              go$a1 = v1._2;
              go$a2 = v2 && $1.eq(v1._1)(v._1);
              continue;
            }
            go$c = false;
            go$r = false;
            continue;
          }
          go$c = false;
          go$r = false;
          continue;
        }
        ;
        return go$r;
      };
      return go(xs)(ys)(true);
    }
  };
  return { compare: ord1List.compare1(dictOrd), Eq0: () => eqList1 };
};

// output-es/Data.List/index.js
var toUnfoldable = (dictUnfoldable) => dictUnfoldable.unfoldr((xs) => {
  if (xs.tag === "Nil") {
    return Nothing;
  }
  if (xs.tag === "Cons") {
    return $Maybe("Just", $Tuple(xs._1, xs._2));
  }
  fail();
});
var reverse2 = /* @__PURE__ */ (() => {
  const go = (go$a0$copy) => (go$a1$copy) => {
    let go$a0 = go$a0$copy, go$a1 = go$a1$copy, go$c = true, go$r;
    while (go$c) {
      const acc = go$a0, v = go$a1;
      if (v.tag === "Nil") {
        go$c = false;
        go$r = acc;
        continue;
      }
      if (v.tag === "Cons") {
        go$a0 = $List("Cons", v._1, acc);
        go$a1 = v._2;
        continue;
      }
      fail();
    }
    ;
    return go$r;
  };
  return go(Nil);
})();

// output-es/Data.Semiring/foreign.js
var intAdd = function(x) {
  return function(y) {
    return x + y | 0;
  };
};

// output-es/Data.EuclideanRing/foreign.js
var intDiv = function(x) {
  return function(y) {
    if (y === 0)
      return 0;
    return y > 0 ? Math.floor(x / y) : -Math.floor(x / -y);
  };
};
var intMod = function(x) {
  return function(y) {
    if (y === 0)
      return 0;
    var yy = Math.abs(y);
    return (x % yy + yy) % yy;
  };
};

// output-es/Data.Monoid/index.js
var monoidUnit = { mempty: unit, Semigroup0: () => semigroupUnit };
var monoidString = { mempty: "", Semigroup0: () => semigroupString };
var monoidArray = { mempty: [], Semigroup0: () => semigroupArray };
var monoidRecord = () => (dictMonoidRecord) => {
  const semigroupRecord1 = { append: dictMonoidRecord.SemigroupRecord0().appendRecord($$Proxy) };
  return { mempty: dictMonoidRecord.memptyRecord($$Proxy), Semigroup0: () => semigroupRecord1 };
};
var power = (dictMonoid) => {
  const append = dictMonoid.Semigroup0().append;
  return (x) => {
    const go = (p) => {
      if (p <= 0) {
        return dictMonoid.mempty;
      }
      if (p === 1) {
        return x;
      }
      if (intMod(p)(2) === 0) {
        const x$p2 = go(intDiv(p)(2));
        return append(x$p2)(x$p2);
      }
      const x$p = go(intDiv(p)(2));
      return append(x$p)(append(x$p)(x));
    };
    return go;
  };
};

// output-es/Data.Bounded/foreign.js
var topChar = String.fromCharCode(65535);
var bottomChar = String.fromCharCode(0);
var topNumber = Number.POSITIVE_INFINITY;
var bottomNumber = Number.NEGATIVE_INFINITY;

// output-es/Data.Enum/foreign.js
function toCharCode(c) {
  return c.charCodeAt(0);
}
function fromCharCode(c) {
  return String.fromCharCode(c);
}

// output-es/Data.String.Unsafe/foreign.js
var charAt = function(i) {
  return function(s) {
    if (i >= 0 && i < s.length)
      return s.charAt(i);
    throw new Error("Data.String.Unsafe.charAt: Invalid index.");
  };
};

// output-es/Data.String.CodeUnits/foreign.js
var singleton = function(c) {
  return c;
};
var _charAt = function(just) {
  return function(nothing) {
    return function(i) {
      return function(s) {
        return i >= 0 && i < s.length ? just(s.charAt(i)) : nothing;
      };
    };
  };
};
var length2 = function(s) {
  return s.length;
};
var _indexOf = function(just) {
  return function(nothing) {
    return function(x) {
      return function(s) {
        var i = s.indexOf(x);
        return i === -1 ? nothing : just(i);
      };
    };
  };
};
var _indexOfStartingAt = function(just) {
  return function(nothing) {
    return function(x) {
      return function(startAt) {
        return function(s) {
          if (startAt < 0 || startAt > s.length)
            return nothing;
          var i = s.indexOf(x, startAt);
          return i === -1 ? nothing : just(i);
        };
      };
    };
  };
};
var take = function(n) {
  return function(s) {
    return s.substr(0, n);
  };
};
var drop2 = function(n) {
  return function(s) {
    return s.substring(n);
  };
};
var splitAt = function(i) {
  return function(s) {
    return { before: s.substring(0, i), after: s.substring(i) };
  };
};

// output-es/Data.String.CodeUnits/index.js
var stripSuffix = (v) => (str) => {
  const v1 = splitAt(length2(str) - length2(v) | 0)(str);
  if (v1.after === v) {
    return $Maybe("Just", v1.before);
  }
  return Nothing;
};
var stripPrefix = (v) => (str) => {
  const v1 = splitAt(length2(v))(str);
  if (v1.before === v) {
    return $Maybe("Just", v1.after);
  }
  return Nothing;
};
var indexOf$p = /* @__PURE__ */ _indexOfStartingAt(Just)(Nothing);
var indexOf = /* @__PURE__ */ _indexOf(Just)(Nothing);
var charAt2 = /* @__PURE__ */ _charAt(Just)(Nothing);

// output-es/Data.String.Common/foreign.js
var replaceAll = function(s1) {
  return function(s2) {
    return function(s3) {
      return s3.replace(new RegExp(s1.replace(/[-\/\\^$*+?.()|[\]{}]/g, "\\$&"), "g"), s2);
    };
  };
};
var split = function(sep2) {
  return function(s) {
    return s.split(sep2);
  };
};
var joinWith = function(s) {
  return function(xs) {
    return xs.join(s);
  };
};

// output-es/Data.Unfoldable/foreign.js
var unfoldrArrayImpl = function(isNothing2) {
  return function(fromJust3) {
    return function(fst2) {
      return function(snd2) {
        return function(f) {
          return function(b) {
            var result = [];
            var value = b;
            while (true) {
              var maybe = f(value);
              if (isNothing2(maybe))
                return result;
              var tuple = fromJust3(maybe);
              result.push(fst2(tuple));
              value = snd2(tuple);
            }
          };
        };
      };
    };
  };
};

// output-es/Data.Unfoldable/index.js
var fromJust2 = (v) => {
  if (v.tag === "Just") {
    return v._1;
  }
  fail();
};
var unfoldableArray = {
  unfoldr: /* @__PURE__ */ unfoldrArrayImpl(isNothing)(fromJust2)(fst)(snd),
  Unfoldable10: () => unfoldable1Array
};

// output-es/Data.String.CodePoints/foreign.js
var hasArrayFrom = typeof Array.from === "function";
var hasStringIterator = typeof Symbol !== "undefined" && Symbol != null && typeof Symbol.iterator !== "undefined" && typeof String.prototype[Symbol.iterator] === "function";
var hasFromCodePoint = typeof String.prototype.fromCodePoint === "function";
var hasCodePointAt = typeof String.prototype.codePointAt === "function";
var _unsafeCodePointAt0 = function(fallback) {
  return hasCodePointAt ? function(str) {
    return str.codePointAt(0);
  } : fallback;
};
var _countPrefix = function(fallback) {
  return function(unsafeCodePointAt02) {
    if (hasStringIterator) {
      return function(pred) {
        return function(str) {
          var iter = str[Symbol.iterator]();
          for (var cpCount = 0; ; ++cpCount) {
            var o = iter.next();
            if (o.done)
              return cpCount;
            var cp = unsafeCodePointAt02(o.value);
            if (!pred(cp))
              return cpCount;
          }
        };
      };
    }
    return fallback;
  };
};
var _singleton = function(fallback) {
  return hasFromCodePoint ? String.fromCodePoint : fallback;
};
var _take = function(fallback) {
  return function(n) {
    if (hasStringIterator) {
      return function(str) {
        var accum = "";
        var iter = str[Symbol.iterator]();
        for (var i = 0; i < n; ++i) {
          var o = iter.next();
          if (o.done)
            return accum;
          accum += o.value;
        }
        return accum;
      };
    }
    return fallback(n);
  };
};
var _toCodePointArray = function(fallback) {
  return function(unsafeCodePointAt02) {
    if (hasArrayFrom) {
      return function(str) {
        return Array.from(str, unsafeCodePointAt02);
      };
    }
    return fallback;
  };
};

// output-es/Data.String.CodePoints/index.js
var uncons2 = (s) => {
  const v = length2(s);
  if (v === 0) {
    return Nothing;
  }
  if (v === 1) {
    return $Maybe("Just", { head: toCharCode(charAt(0)(s)), tail: "" });
  }
  const cu1 = toCharCode(charAt(1)(s));
  const cu0 = toCharCode(charAt(0)(s));
  if (55296 <= cu0 && cu0 <= 56319 && (56320 <= cu1 && cu1 <= 57343)) {
    return $Maybe("Just", { head: (((cu0 - 55296 | 0) * 1024 | 0) + (cu1 - 56320 | 0) | 0) + 65536 | 0, tail: drop2(2)(s) });
  }
  return $Maybe("Just", { head: cu0, tail: drop2(1)(s) });
};
var unconsButWithTuple = (s) => {
  const $1 = uncons2(s);
  if ($1.tag === "Just") {
    return $Maybe("Just", $Tuple($1._1.head, $1._1.tail));
  }
  return Nothing;
};
var toCodePointArrayFallback = (s) => unfoldableArray.unfoldr(unconsButWithTuple)(s);
var unsafeCodePointAt0Fallback = (s) => {
  const cu0 = toCharCode(charAt(0)(s));
  if (55296 <= cu0 && cu0 <= 56319 && length2(s) > 1) {
    const cu1 = toCharCode(charAt(1)(s));
    if (56320 <= cu1 && cu1 <= 57343) {
      return (((cu0 - 55296 | 0) * 1024 | 0) + (cu1 - 56320 | 0) | 0) + 65536 | 0;
    }
    return cu0;
  }
  return cu0;
};
var unsafeCodePointAt0 = /* @__PURE__ */ _unsafeCodePointAt0(unsafeCodePointAt0Fallback);
var toCodePointArray = /* @__PURE__ */ _toCodePointArray(toCodePointArrayFallback)(unsafeCodePointAt0);
var fromCharCode2 = (x) => singleton((() => {
  if (x >= -2147483648 && x <= 2147483647) {
    return fromCharCode(x);
  }
  if (x < 0) {
    return "\0";
  }
  return "\uFFFF";
})());
var singletonFallback = (v) => {
  if (v <= 65535) {
    return fromCharCode2(v);
  }
  return fromCharCode2(intDiv(v - 65536 | 0)(1024) + 55296 | 0) + fromCharCode2(intMod(v - 65536 | 0)(1024) + 56320 | 0);
};
var singleton2 = /* @__PURE__ */ _singleton(singletonFallback);
var takeFallback = (n) => (v) => {
  if (n < 1) {
    return "";
  }
  const v1 = uncons2(v);
  if (v1.tag === "Just") {
    return singleton2(v1._1.head) + takeFallback(n - 1 | 0)(v1._1.tail);
  }
  return v;
};
var take2 = /* @__PURE__ */ _take(takeFallback);
var countTail = (countTail$a0$copy) => (countTail$a1$copy) => (countTail$a2$copy) => {
  let countTail$a0 = countTail$a0$copy, countTail$a1 = countTail$a1$copy, countTail$a2 = countTail$a2$copy, countTail$c = true, countTail$r;
  while (countTail$c) {
    const p = countTail$a0, s = countTail$a1, accum = countTail$a2;
    const v = uncons2(s);
    if (v.tag === "Just") {
      if (p(v._1.head)) {
        countTail$a0 = p;
        countTail$a1 = v._1.tail;
        countTail$a2 = accum + 1 | 0;
        continue;
      }
      countTail$c = false;
      countTail$r = accum;
      continue;
    }
    countTail$c = false;
    countTail$r = accum;
    continue;
  }
  ;
  return countTail$r;
};
var countFallback = (p) => (s) => countTail(p)(s)(0);
var countPrefix2 = /* @__PURE__ */ _countPrefix(countFallback)(unsafeCodePointAt0);

// output-es/Record.Builder/foreign.js
function unsafeInsert(l) {
  return function(a) {
    return function(rec) {
      rec[l] = a;
      return rec;
    };
  };
}

// output-es/Record.Builder/index.js
var buildFromScratch = (a) => a({});

// output-es/ArgParse.Basic/index.js
var $ArgError = (_1, _2) => ({ tag: "ArgError", _1, _2 });
var $ArgErrorMsg = (tag, _1) => ({ tag, _1 });
var $ArgHelp = (tag, _1, _2, _3) => ({ tag, _1, _2, _3 });
var $ArgParser = (_1, _2) => ({ tag: "ArgParser", _1, _2 });
var $ArgResult = (tag, _1, _2) => ({ tag, _1, _2 });
var $HelpClass = (tag, _1) => ({ tag, _1 });
var $HelpFmt = (tag, _1) => ({ tag, _1 });
var intercalate2 = /* @__PURE__ */ intercalate1(monoidString);
var power2 = /* @__PURE__ */ power(monoidString);
var max2 = (x) => (y) => {
  const v = ordInt.compare(x)(y);
  if (v.tag === "LT") {
    return y;
  }
  if (v.tag === "EQ") {
    return x;
  }
  if (v.tag === "GT") {
    return x;
  }
  fail();
};
var eq = /* @__PURE__ */ eqArrayImpl(eqStringImpl);
var compare = /* @__PURE__ */ (() => ordArray(ordString).compare)();
var intercalate12 = /* @__PURE__ */ intercalate1(monoidArray);
var fromFoldable = /* @__PURE__ */ foldrArray(Cons)(Nil);
var identity9 = (x) => x;
var guard2 = /* @__PURE__ */ guard(alternativeMaybe);
var ExpectedFlag = /* @__PURE__ */ $ArgErrorMsg("ExpectedFlag");
var ExpectedArgValue = /* @__PURE__ */ $ArgErrorMsg("ExpectedArgValue");
var ExpectedArg = /* @__PURE__ */ $ArgErrorMsg("ExpectedArg");
var DuplicateArg = /* @__PURE__ */ $ArgErrorMsg("DuplicateArg");
var ShowHelp = /* @__PURE__ */ $ArgErrorMsg("ShowHelp");
var ArgError = (value0) => (value1) => $ArgError(value0, value1);
var ArgFail = /* @__PURE__ */ $ArgResult("ArgFail");
var unformat = (doc) => (unf) => (v) => {
  const go = (v1) => ({
    step: (stk) => (args) => {
      const v2 = v1.step(stk)(args);
      if (v2.tag === "ArgHalt") {
        if (v2._1._1.tag === "Cons") {
          return $ArgResult("ArgHalt", $ArgError($List("Cons", $ArgHelp("HelpFormat", doc, v._1), v2._1._1._2), v2._1._2));
        }
        return $ArgResult("ArgHalt", v2._1);
      }
      if (v2.tag === "ArgMatch") {
        return $ArgResult("ArgMatch", go(v2._1), v2._2);
      }
      if (v2.tag === "ArgFail") {
        return ArgFail;
      }
      fail();
    },
    done: (stk) => bindEither.bind(v1.done($List("Cons", $ArgHelp("HelpFormat", doc, v._1), stk)))((value) => {
      const $7 = ArgError($List("Cons", $ArgHelp("HelpFormat", doc, v._1), stk));
      return bifunctorEither.bimap((x) => $7($ArgErrorMsg("UnformatFailed", x)))(identity4)(unf(value));
    }),
    saturated: v1.saturated
  });
  return $ArgParser($ArgHelp("HelpFormat", doc, v._1), go(v._2));
};
var semigroupHelp = {
  append: (v) => (v1) => {
    if (v.tag === "HelpArgs") {
      if (v1.tag === "HelpArgs") {
        return $ArgHelp("HelpArgs", concatArray(v._1)(v1._1));
      }
      return $ArgHelp("HelpArgs", run(withArray(pushAll([v1]))(v._1)));
    }
    if (v1.tag === "HelpArgs") {
      return $ArgHelp("HelpArgs", concatArray([v])(v1._1));
    }
    return $ArgHelp("HelpArgs", [v, v1]);
  }
};
var printHelpTable$p = (stk) => (v) => {
  if (v.tag === "HelpFlag") {
    const names = intercalate2(",")(v._1);
    if (stk.tag === "Cons") {
      if (stk._1.tag === "HelpFormat") {
        return [$Tuple($HelpClass("IsFlag", v._1), [$HelpFmt("Text", names + (" " + stk._1._1)), $HelpFmt("Text", v._2)])];
      }
      return [$Tuple($HelpClass("IsFlag", v._1), [$HelpFmt("Text", names), $HelpFmt("Text", v._2)])];
    }
    return [$Tuple($HelpClass("IsFlag", v._1), [$HelpFmt("Text", names), $HelpFmt("Text", v._2)])];
  }
  if (v.tag === "HelpAny") {
    if (stk.tag === "Cons") {
      if (stk._1.tag === "HelpFormat") {
        return [$Tuple($HelpClass("IsAny", stk._1._1), [$HelpFmt("Text", stk._1._1), $HelpFmt("Text", v._1)])];
      }
      return [$Tuple($HelpClass("IsAny", "ANY"), [$HelpFmt("Text", "ANY"), $HelpFmt("Text", v._1)])];
    }
    return [$Tuple($HelpClass("IsAny", "ANY"), [$HelpFmt("Text", "ANY"), $HelpFmt("Text", v._1)])];
  }
  if (v.tag === "HelpRest") {
    return [$Tuple($HelpClass("IsAny", "--"), [$HelpFmt("Text", "--"), $HelpFmt("Text", v._1)])];
  }
  if (v.tag === "HelpCommand") {
    return [$Tuple($HelpClass("IsCommand", v._1), [$HelpFmt("Text", intercalate2(",")(v._1)), $HelpFmt("Text", v._2)])];
  }
  if (v.tag === "HelpFormat") {
    return printHelpTable$p($List("Cons", $ArgHelp("HelpFormat", v._1, v._2), stk))(v._2);
  }
  if (v.tag === "HelpChoose") {
    return arrayBind(v._2)(printHelpTable$p(stk));
  }
  if (v.tag === "HelpArgs") {
    return arrayBind(v._1)(printHelpTable$p(stk));
  }
  fail();
};
var parserHelp = (v) => v._1;
var parseArgs$p = (parseArgs$p$a0$copy) => (parseArgs$p$a1$copy) => (parseArgs$p$a2$copy) => {
  let parseArgs$p$a0 = parseArgs$p$a0$copy, parseArgs$p$a1 = parseArgs$p$a1$copy, parseArgs$p$a2 = parseArgs$p$a2$copy, parseArgs$p$c = true, parseArgs$p$r;
  while (parseArgs$p$c) {
    const v = parseArgs$p$a0, stk = parseArgs$p$a1, args = parseArgs$p$a2;
    const v1 = v.step(stk)(args);
    if (v1.tag === "ArgHalt") {
      parseArgs$p$c = false;
      parseArgs$p$r = $Either("Left", v1._1);
      continue;
    }
    if (v1.tag === "ArgMatch") {
      parseArgs$p$a0 = v1._1;
      parseArgs$p$a1 = stk;
      parseArgs$p$a2 = v1._2;
      continue;
    }
    if (v1.tag === "ArgFail") {
      if (args.tag === "Nil") {
        parseArgs$p$c = false;
        parseArgs$p$r = v.done(stk);
        continue;
      }
      if (args.tag === "Cons") {
        parseArgs$p$c = false;
        parseArgs$p$r = $Either("Left", $ArgError(stk, $ArgErrorMsg("UnknownArg", args._1)));
        continue;
      }
      fail();
    }
    fail();
  }
  ;
  return parseArgs$p$r;
};
var parseArgs = (dictFoldable) => {
  const fromFoldable14 = dictFoldable.foldr(Cons)(Nil);
  return (cmd) => (doc) => (v) => (x) => parseArgs$p(v._2)($List("Cons", $ArgHelp("HelpCommand", [cmd], doc, v._1), Nil))(fromFoldable14(x));
};
var number = /* @__PURE__ */ unformat("NUMBER")((x) => {
  const $1 = fromStringImpl(x, isFiniteImpl, Just, Nothing);
  if ($1.tag === "Nothing") {
    return $Either("Left", "Invalid number.");
  }
  if ($1.tag === "Just") {
    return $Either("Right", $1._1);
  }
  fail();
});
var joinColumns = (width) => (sep2) => (leftLines) => (rightLines) => {
  const go = (left) => (right) => {
    const len = toCodePointArray(left).length;
    if (len < width) {
      return left + (power2(" ")(width - len | 0) + (sep2 + right));
    }
    if (len > width) {
      return take2(width)(left) + (sep2 + right);
    }
    return left + (sep2 + right);
  };
  const diff = leftLines.length - rightLines.length | 0;
  if (diff < 0) {
    return zipWith(go)(concatArray(leftLines)(replicate((() => {
      if (diff >= 0) {
        return diff;
      }
      return -diff;
    })())("")))(rightLines);
  }
  return zipWith(go)(leftLines)(concatArray(rightLines)(replicate(diff)("")));
};
var renderDocLines = (ind) => (v) => {
  if (v.tag === "Paras") {
    return arrayBind(intersperse([""])(filter((x) => x.length !== 0)(arrayMap(renderDocLines(ind))(v._1))))(identity2);
  }
  if (v.tag === "Lines") {
    return arrayBind(v._1)(renderDocLines(ind));
  }
  if (v.tag === "Text") {
    return arrayMap(($2) => ind + $2)(split("\n")(v._1));
  }
  if (v.tag === "Indent") {
    return renderDocLines(ind + "    ")(v._1);
  }
  if (v.tag === "Table") {
    return printTableLines(ind)(v._1);
  }
  fail();
};
var printTableLines = (ind) => (rows) => {
  const rows$p = arrayMap(arrayMap(renderDocLines("")))(rows);
  const colWidths = arrayMap((ix) => foldrArray((() => {
    const $4 = foldrArray((x) => max2(toCodePointArray(x).length))(0);
    return (x) => {
      const $6 = index(x)(ix);
      return max2($4((() => {
        if ($6.tag === "Nothing") {
          return [];
        }
        if ($6.tag === "Just") {
          return $6._1;
        }
        fail();
      })()));
    };
  })())(0)(rows$p))(range(0)(foldrArray((x) => max2(x.length))(0)(rows) - 1 | 0));
  return arrayBind(rows$p)((cols) => {
    const $5 = zip(colWidths)(cols);
    if ($5.length > 0) {
      return arrayMap(($6) => ind + $6)(foldr1Impl((v1) => (v2) => $Tuple(
        v1._1 + v2._1 | 0,
        joinColumns(v1._1)("    ")(v1._2)(v2._2)
      ))($5)._2);
    }
    return [];
  });
};
var renderDoc = /* @__PURE__ */ (() => {
  const $0 = intercalate2("\n");
  return (x) => $0(renderDocLines("")(x));
})();
var $$int = /* @__PURE__ */ unformat("INTEGER")((x) => {
  const $1 = fromString(x);
  if ($1.tag === "Nothing") {
    return $Either("Left", "Invalid integer.");
  }
  if ($1.tag === "Just") {
    return $Either("Right", $1._1);
  }
  fail();
});
var functorArgResult = {
  map: (f) => (m) => {
    if (m.tag === "ArgHalt") {
      return $ArgResult("ArgHalt", m._1);
    }
    if (m.tag === "ArgMatch") {
      return $ArgResult("ArgMatch", f(m._1), m._2);
    }
    if (m.tag === "ArgFail") {
      return ArgFail;
    }
    fail();
  }
};
var partial = (unf) => (v) => {
  const go = (v1) => ({
    step: (stk) => (args) => functorArgResult.map(go)(v1.step(stk)(args)),
    done: (stk) => {
      const $5 = bifunctorEither.bimap(ArgError($List("Cons", v._1, stk)))(identity4);
      return bindEither.bind(v1.done(stk))((x) => $5(unf(x)));
    },
    saturated: false
  });
  return $ArgParser(v._1, go(v._2));
};
var functorArgFold = {
  map: (f) => (m) => ({
    done: (x) => {
      const $3 = m.done(x);
      if ($3.tag === "Left") {
        return $Either("Left", $3._1);
      }
      if ($3.tag === "Right") {
        return $Either("Right", f($3._1));
      }
      fail();
    },
    step: (() => {
      const $2 = semigroupoidFn.compose(functorArgResult.map(functorArgFold.map(f)));
      return (x) => $2(m.step(x));
    })(),
    saturated: m.saturated
  })
};
var functorArgParser = { map: (f) => (m) => $ArgParser(m._1, functorArgFold.map(f)(m._2)) };
var flag$p = (names) => (v) => {
  if (v.tag === "Cons") {
    if (elem(eqString)(v._1)(names)) {
      return $ArgResult("ArgMatch", unit, v._2);
    }
    return ArgFail;
  }
  return ArgFail;
};
var flagHelp = /* @__PURE__ */ (() => {
  const name2 = ["--help", "-h"];
  return $ArgParser(
    $ArgHelp("HelpFlag", name2, "Show this help message."),
    {
      step: (stk) => (args) => {
        const v = flag$p(name2)(args);
        if (v.tag === "ArgHalt") {
          return $ArgResult("ArgHalt", v._1);
        }
        if (v.tag === "ArgFail") {
          return ArgFail;
        }
        if (v.tag === "ArgMatch") {
          return $ArgResult("ArgHalt", $ArgError(stk, ShowHelp));
        }
        fail();
      },
      done: (v) => $Either("Right", unit),
      saturated: true
    }
  );
})();
var flagInfo = (name2) => (doc) => (info2) => $ArgParser(
  $ArgHelp("HelpFlag", name2, doc),
  {
    step: (stk) => (args) => {
      const v = flag$p(name2)(args);
      if (v.tag === "ArgHalt") {
        return $ArgResult("ArgHalt", v._1);
      }
      if (v.tag === "ArgFail") {
        return ArgFail;
      }
      if (v.tag === "ArgMatch") {
        return $ArgResult("ArgHalt", $ArgError($List("Cons", $ArgHelp("HelpFlag", name2, doc), stk), $ArgErrorMsg("ShowInfo", info2)));
      }
      fail();
    },
    done: (v) => $Either("Right", unit),
    saturated: true
  }
);
var failDup = (help) => (errMsg) => (v) => ({
  step: (stk) => (args) => {
    const v1 = v.step(stk)(args);
    if (v1.tag === "ArgHalt") {
      return $ArgResult("ArgHalt", v1._1);
    }
    if (v1.tag === "ArgFail") {
      return ArgFail;
    }
    if (v1.tag === "ArgMatch") {
      return $ArgResult("ArgHalt", $ArgError($List("Cons", help, stk), errMsg));
    }
    fail();
  },
  done: v.done,
  saturated: true
});
var flag = (name2) => (doc) => {
  const step = (v) => {
    const $4 = functorArgResult.map((value) => failDup($ArgHelp("HelpFlag", name2, doc))(DuplicateArg)({ step, done: (v$1) => $Either("Right", value), saturated: true }));
    return (x) => $4(flag$p(name2)(x));
  };
  return $ArgParser(
    $ArgHelp("HelpFlag", name2, doc),
    { step, done: (stk) => $Either("Left", $ArgError($List("Cons", $ArgHelp("HelpFlag", name2, doc), stk), ExpectedFlag)), saturated: false }
  );
};
var many = (v) => {
  const go2 = (acc) => (stk) => (v1) => {
    if (v1.saturated) {
      const v2 = v1.done(stk);
      if (v2.tag === "Left") {
        return { step: (v$1) => (v1$1) => $ArgResult("ArgHalt", v2._1), done: (v$1) => $Either("Left", v2._1), saturated: true };
      }
      if (v2.tag === "Right") {
        return go1($List("Cons", v2._1, acc))(false)(v._2);
      }
      fail();
    }
    return go1(acc)(true)(v1);
  };
  const go1 = (acc) => (parsing) => (v1) => ({
    step: (stk) => {
      const $6 = functorArgResult.map(go2(acc)(stk));
      const $7 = v1.step(stk);
      return (x) => $6($7(x));
    },
    done: (stk) => {
      if (parsing) {
        return bindEither.bind(v1.done(stk))((next) => $Either("Right", reverse2($List("Cons", next, acc))));
      }
      return $Either("Right", reverse2(acc));
    },
    saturated: false
  });
  return $ArgParser(v._1, go1(Nil)(false)(v._2));
};
var many1 = /* @__PURE__ */ (() => {
  const $0 = partial((values2) => {
    if (values2.tag === "Nil") {
      return $Either("Left", ExpectedArg);
    }
    if (values2.tag === "Cons") {
      return $Either("Right", $NonEmpty(values2._1, values2._2));
    }
    fail();
  });
  return (x) => $0(many(x));
})();
var unfolded1 = (dictUnfoldable1) => {
  const $1 = functorArgParser.map(dictUnfoldable1.unfoldr1((nel) => $Tuple(
    nel._1,
    (() => {
      if (nel._2.tag === "Nil") {
        return Nothing;
      }
      if (nel._2.tag === "Cons") {
        return $Maybe("Just", $NonEmpty(nel._2._1, nel._2._2));
      }
      fail();
    })()
  )));
  return (x) => $1(many1(x));
};
var eqHelpClass = {
  eq: (x) => (y) => {
    if (x.tag === "IsFlag") {
      if (y.tag === "IsFlag") {
        return eq(x._1)(y._1);
      }
      return false;
    }
    if (x.tag === "IsAny") {
      if (y.tag === "IsAny") {
        return x._1 === y._1;
      }
      return false;
    }
    if (x.tag === "IsCommand") {
      if (y.tag === "IsCommand") {
        return eq(x._1)(y._1);
      }
      return false;
    }
    return false;
  }
};
var ordHelpClass = {
  compare: (x) => (y) => {
    if (x.tag === "IsFlag") {
      if (y.tag === "IsFlag") {
        return compare(x._1)(y._1);
      }
      return LT;
    }
    if (y.tag === "IsFlag") {
      return GT;
    }
    if (x.tag === "IsAny") {
      if (y.tag === "IsAny") {
        return ordString.compare(x._1)(y._1);
      }
      return LT;
    }
    if (y.tag === "IsAny") {
      return GT;
    }
    if (x.tag === "IsCommand") {
      if (y.tag === "IsCommand") {
        return compare(x._1)(y._1);
      }
      fail();
    }
    fail();
  },
  Eq0: () => eqHelpClass
};
var printHelpTable = (stk) => {
  const $1 = sortBy((x) => (y) => ordHelpClass.compare(x._1)(y._1));
  const $2 = groupBy((x) => (y) => {
    if (x._1.tag === "IsFlag") {
      return y._1.tag === "IsFlag";
    }
    if (x._1.tag === "IsAny") {
      return y._1.tag === "IsAny";
    }
    if (x._1.tag === "IsCommand") {
      return y._1.tag === "IsCommand";
    }
    return false;
  });
  const $3 = arrayMap(arrayMap(snd));
  const $4 = intercalate12([[$HelpFmt("Text", "")]]);
  return (x) => $4($3($2($1(printHelpTable$p(stk)(x)))));
};
var printHelp$p = (stk) => (v) => {
  if (v.tag === "HelpFormat") {
    return printHelp$p($List("Cons", $ArgHelp("HelpFormat", v._1, v._2), stk))(v._2);
  }
  if (v.tag === "HelpCommand") {
    return $HelpFmt(
      "Paras",
      [$HelpFmt("Lines", [$HelpFmt("Text", intercalate2(",")(v._1)), $HelpFmt("Indent", $HelpFmt("Text", v._2))]), $HelpFmt("Indent", printHelp$p(stk)(v._3))]
    );
  }
  return $HelpFmt("Table", printHelpTable(stk)(v));
};
var printArgError = (v) => {
  const getCmd = (getCmd$a0$copy) => (getCmd$a1$copy) => (getCmd$a2$copy) => (getCmd$a3$copy) => {
    let getCmd$a0 = getCmd$a0$copy, getCmd$a1 = getCmd$a1$copy, getCmd$a2 = getCmd$a2$copy, getCmd$a3 = getCmd$a3$copy, getCmd$c = true, getCmd$r;
    while (getCmd$c) {
      const cmd = getCmd$a0, desc = getCmd$a1, help = getCmd$a2, v1 = getCmd$a3;
      if (v1.tag === "Nil") {
        getCmd$c = false;
        getCmd$r = { cmd, desc, help };
        continue;
      }
      if (v1.tag === "Cons") {
        if (v1._1.tag === "HelpCommand") {
          getCmd$a0 = $List("Cons", v1._1._1, cmd);
          getCmd$a1 = (() => {
            if (desc.tag === "Nothing") {
              return $Maybe("Just", v1._1._2);
            }
            return desc;
          })();
          getCmd$a2 = (() => {
            if (help.tag === "Nothing") {
              return $Maybe("Just", v1._1._3);
            }
            return help;
          })();
          getCmd$a3 = v1._2;
          continue;
        }
        if (v1._1.tag === "HelpFlag") {
          getCmd$a0 = $List("Cons", v1._1._1, cmd);
          getCmd$a1 = Nothing;
          getCmd$a2 = $Maybe("Just", $ArgHelp("HelpFlag", v1._1._1, v1._1._2));
          getCmd$a3 = v1._2;
          continue;
        }
        if (v1._1.tag === "HelpAny") {
          getCmd$a0 = cmd;
          getCmd$a1 = Nothing;
          getCmd$a2 = $Maybe("Just", $ArgHelp("HelpAny", v1._1._1));
          getCmd$a3 = v1._2;
          continue;
        }
        if (v1._1.tag === "HelpFormat") {
          getCmd$a0 = cmd;
          getCmd$a1 = desc;
          getCmd$a2 = help;
          getCmd$a3 = $List("Cons", v1._1._2, v1._2);
          continue;
        }
        getCmd$a0 = cmd;
        getCmd$a1 = desc;
        getCmd$a2 = help;
        getCmd$a3 = v1._2;
        continue;
      }
      fail();
    }
    ;
    return getCmd$r;
  };
  const printArgError$p = (err) => {
    const v1 = getCmd(Nil)(Nothing)(Nothing)(v._1);
    return $HelpFmt(
      "Lines",
      [
        $HelpFmt(
          "Text",
          (() => {
            const go = (go$a0$copy) => (go$a1$copy) => {
              let go$a0 = go$a0$copy, go$a1 = go$a1$copy, go$c = true, go$r;
              while (go$c) {
                const b = go$a0, v$1 = go$a1;
                if (v$1.tag === "Nil") {
                  go$c = false;
                  go$r = b;
                  continue;
                }
                if (v$1.tag === "Cons") {
                  go$a0 = (() => {
                    if (b.init) {
                      return { init: false, acc: v$1._1 };
                    }
                    return { init: false, acc: b.acc + (" " + v$1._1) };
                  })();
                  go$a1 = v$1._2;
                  continue;
                }
                fail();
              }
              ;
              return go$r;
            };
            return go({ init: true, acc: "" })(listMap(intercalate2(","))(v1.cmd)).acc;
          })()
        ),
        $HelpFmt(
          "Indent",
          $HelpFmt(
            "Paras",
            [
              err,
              (() => {
                if (v1.desc.tag === "Nothing") {
                  return $HelpFmt("Lines", []);
                }
                if (v1.desc.tag === "Just") {
                  return $HelpFmt("Text", v1.desc._1);
                }
                fail();
              })(),
              (() => {
                if (v1.help.tag === "Nothing") {
                  return $HelpFmt("Lines", []);
                }
                if (v1.help.tag === "Just") {
                  return printHelp$p(v._1)(v1.help._1);
                }
                fail();
              })()
            ]
          )
        )
      ]
    );
  };
  return renderDoc((() => {
    if (v._2.tag === "ExpectedFlag") {
      return printArgError$p($HelpFmt("Text", "Expected flag."));
    }
    if (v._2.tag === "ExpectedArgValue") {
      if (v._1.tag === "Cons") {
        if (v._1._1.tag === "HelpFormat") {
          return printArgError$p($HelpFmt("Text", "Expected " + (v._1._1._1 + ".")));
        }
        return printArgError$p($HelpFmt("Text", "Expected argument value."));
      }
      return printArgError$p($HelpFmt("Text", "Expected argument value."));
    }
    if (v._2.tag === "ExpectedArg") {
      if (v._1.tag === "Cons") {
        if (v._1._1.tag === "HelpFormat") {
          return printArgError$p($HelpFmt("Text", "Expected " + (v._1._1._1 + ".")));
        }
        if (v._1._1.tag === "HelpChoose") {
          return printArgError$p($HelpFmt("Text", "Expected " + (v._1._1._1 + ".")));
        }
        return printArgError$p($HelpFmt("Text", "Expected argument."));
      }
      return printArgError$p($HelpFmt("Text", "Expected argument."));
    }
    if (v._2.tag === "ExpectedRest") {
      return printArgError$p($HelpFmt("Text", "Expected rest arguments."));
    }
    if (v._2.tag === "DuplicateArg") {
      if (v._1.tag === "Cons") {
        if (v._1._1.tag === "HelpChoose") {
          return printArgError$p($HelpFmt("Text", "Duplicate " + (v._1._1._1 + ".")));
        }
        return printArgError$p($HelpFmt("Text", "Duplicate argument."));
      }
      return printArgError$p($HelpFmt("Text", "Duplicate argument."));
    }
    if (v._2.tag === "UnformatFailed") {
      return printArgError$p($HelpFmt("Text", v._2._1));
    }
    if (v._2.tag === "ShowHelp") {
      return printArgError$p($HelpFmt("Lines", []));
    }
    if (v._2.tag === "ShowInfo") {
      return $HelpFmt("Text", v._2._1);
    }
    if (v._2.tag === "UnknownArg") {
      return printArgError$p($HelpFmt("Lines", [$HelpFmt("Text", "Unexpected argument:"), $HelpFmt("Indent", $HelpFmt("Text", v._2._1))]));
    }
    fail();
  })());
};
var $$default = (value) => (v) => $ArgParser(
  v._1,
  {
    step: v._2.step,
    done: (x) => {
      const $3 = v._2.done(x);
      if ($3.tag === "Left") {
        return $Either("Right", value);
      }
      if ($3.tag === "Right") {
        return $Either("Right", $3._1);
      }
      fail();
    },
    saturated: true
  }
);
var choose = (name2) => (parsers) => {
  const help = $ArgHelp("HelpChoose", name2, arrayMap(parserHelp)(parsers));
  const go2 = (stk) => (args) => (acc) => (v) => {
    if (v.tag === "Cons") {
      const v1 = v._1.step(stk)(args);
      if (v1.tag === "ArgHalt") {
        return $ArgResult("ArgHalt", v1._1);
      }
      if (v1.tag === "ArgFail") {
        return go2(stk)(args)($List("Cons", v._1, acc))(v._2);
      }
      if (v1.tag === "ArgMatch") {
        if (v1._1.saturated) {
          return $ArgResult(
            "ArgMatch",
            failDup(help)(DuplicateArg)({
              step: go1(foldableList.foldr(Cons)($List("Cons", v1._1, v._2))(acc)),
              done: v1._1.done,
              saturated: true
            }),
            v1._2
          );
        }
        return $ArgResult(
          "ArgMatch",
          { step: (stk$p) => (args$p$p) => go2(stk$p)(args$p$p)(acc)($List("Cons", v1._1, v._2)), done: v1._1.done, saturated: false },
          v1._2
        );
      }
      fail();
    }
    if (v.tag === "Nil") {
      return ArgFail;
    }
    fail();
  };
  const go1 = (parsers$p) => (stk) => (args) => go2(stk)(args)(Nil)(parsers$p);
  return $ArgParser(
    help,
    {
      step: go1(fromFoldable(arrayMap((v) => v._2)(parsers))),
      done: (stk) => $Either("Left", $ArgError($List("Cons", help, stk), ExpectedArg)),
      saturated: false
    }
  );
};
var fromRecord = () => (dictBuildRecordArgs) => {
  const $2 = dictBuildRecordArgs.buildRecordArgs($$Proxy);
  return (x) => {
    const $4 = $2(x);
    return $ArgParser($4._1, functorArgFold.map(buildFromScratch)($4._2));
  };
};
var $$boolean = (x) => $$default(false)($ArgParser(x._1, functorArgFold.map((v) => true)(x._2)));
var argument$p = (stk) => (names) => (v) => {
  if (v.tag === "Cons") {
    const $3 = findMap((x) => stripPrefix(x)(v._1))(names);
    if ($3.tag === "Just") {
      if (take(1)($3._1) === "=") {
        return $ArgResult("ArgMatch", drop2(1)($3._1), v._2);
      }
      if ($3._1 === "") {
        if (v._2.tag === "Cons") {
          return $ArgResult("ArgMatch", v._2._1, v._2._2);
        }
        return $ArgResult("ArgHalt", $ArgError(stk, ExpectedArgValue));
      }
      return ArgFail;
    }
    return ArgFail;
  }
  return ArgFail;
};
var argument = (name2) => (doc) => {
  const step = (stk) => {
    const $4 = functorArgResult.map((value) => failDup($ArgHelp("HelpFlag", name2, doc))(DuplicateArg)({ step, done: (v) => $Either("Right", value), saturated: true }));
    return (x) => $4(argument$p($List("Cons", $ArgHelp("HelpFlag", name2, doc), stk))(name2)(x));
  };
  return $ArgParser(
    $ArgHelp("HelpFlag", name2, doc),
    { step, done: (stk) => $Either("Left", $ArgError($List("Cons", $ArgHelp("HelpFlag", name2, doc), stk), ExpectedArg)), saturated: false }
  );
};
var applyArgFold = {
  apply: (v) => (v1) => ({
    step: (stk) => (args) => {
      const v2 = v.step(stk)(args);
      if (v2.tag === "ArgHalt") {
        return $ArgResult("ArgHalt", v2._1);
      }
      if (v2.tag === "ArgMatch") {
        return $ArgResult("ArgMatch", applyArgFold.apply(v2._1)(v1), v2._2);
      }
      if (v2.tag === "ArgFail") {
        const v3 = v1.step(stk)(args);
        if (v3.tag === "ArgHalt") {
          return $ArgResult("ArgHalt", v3._1);
        }
        if (v3.tag === "ArgMatch") {
          return $ArgResult("ArgMatch", applyArgFold.apply(v)(v3._1), v3._2);
        }
        if (v3.tag === "ArgFail") {
          return ArgFail;
        }
        fail();
      }
      fail();
    },
    done: (stk) => applyEither.apply(v.done(stk))(v1.done(stk)),
    saturated: v.saturated && v1.saturated
  }),
  Functor0: () => functorArgFold
};
var applyParser = { apply: (v) => (v1) => $ArgParser(semigroupHelp.append(v._1)(v1._1), applyArgFold.apply(v._2)(v1._2)), Functor0: () => functorArgParser };
var buildArgsCons = (dictIsSymbol) => () => () => () => (dictBuildRecordArgs) => ({
  buildRecordArgs: (v) => (rs) => applyParser.apply((() => {
    const $7 = unsafeGet(dictIsSymbol.reflectSymbol($$Proxy))(rs);
    return $ArgParser($7._1, functorArgFold.map((a) => (b) => (x) => b(unsafeInsert(dictIsSymbol.reflectSymbol($$Proxy))(a)(x)))($7._2));
  })())(dictBuildRecordArgs.buildRecordArgs($$Proxy)(rs))
});
var buildRecordArgsNil = {
  buildRecordArgs: (v) => (v1) => $ArgParser($ArgHelp("HelpArgs", []), { step: (v$1) => (v1$1) => ArgFail, done: (v$1) => $Either("Right", identity9), saturated: true })
};
var command = (name2) => (doc) => (v) => $ArgParser(
  $ArgHelp("HelpCommand", name2, doc, v._1),
  {
    step: (stk) => (args) => {
      const v2 = flag$p(name2)(args);
      if (v2.tag === "ArgHalt") {
        return $ArgResult("ArgHalt", v2._1);
      }
      if (v2.tag === "ArgFail") {
        return ArgFail;
      }
      if (v2.tag === "ArgMatch") {
        const v3 = parseArgs$p(v._2)($List("Cons", $ArgHelp("HelpCommand", name2, doc, v._1), stk))(v2._2);
        if (v3.tag === "Left") {
          return $ArgResult("ArgHalt", v3._1);
        }
        if (v3.tag === "Right") {
          return $ArgResult("ArgMatch", { step: (v$1) => (v1) => ArgFail, done: (v$1) => $Either("Right", v3._1), saturated: true }, Nil);
        }
        fail();
      }
      fail();
    },
    done: v._2.done,
    saturated: false
  }
);
var any2 = (name2) => (doc) => (k) => $ArgParser(
  $ArgHelp("HelpFormat", name2, $ArgHelp("HelpAny", doc)),
  {
    step: (v) => (v1) => {
      if (v1.tag === "Cons") {
        const $5 = k(v1._1);
        if ($5.tag === "Just") {
          return $ArgResult("ArgMatch", { step: (v$1) => (v1$1) => ArgFail, done: (v$1) => $Either("Right", $5._1), saturated: true }, v1._2);
        }
        return ArgFail;
      }
      return ArgFail;
    },
    done: (stk) => $Either("Left", $ArgError($List("Cons", $ArgHelp("HelpFormat", name2, $ArgHelp("HelpAny", doc)), stk), ExpectedArg)),
    saturated: false
  }
);
var anyNotFlag = (name2) => (doc) => any2(name2)(doc)((str) => {
  if (guard2(take2(1)(str) !== "-").tag === "Just") {
    return $Maybe("Just", str);
  }
  return Nothing;
});

// output-es/Foreign.Object.ST/foreign.js
var newImpl = function() {
  return {};
};
function poke2(k) {
  return function(v) {
    return function(m) {
      return function() {
        m[k] = v;
        return m;
      };
    };
  };
}

// output-es/Foreign.Object/foreign.js
function _copyST(m) {
  return function() {
    var r = {};
    for (var k in m) {
      if (hasOwnProperty.call(m, k)) {
        r[k] = m[k];
      }
    }
    return r;
  };
}
var empty = {};
function runST(f) {
  return f();
}
function _fmapObject(m0, f) {
  var m = {};
  for (var k in m0) {
    if (hasOwnProperty.call(m0, k)) {
      m[k] = f(m0[k]);
    }
  }
  return m;
}
function _mapWithKey(m0, f) {
  var m = {};
  for (var k in m0) {
    if (hasOwnProperty.call(m0, k)) {
      m[k] = f(k)(m0[k]);
    }
  }
  return m;
}
function _foldM(bind) {
  return function(f) {
    return function(mz) {
      return function(m) {
        var acc = mz;
        function g(k2) {
          return function(z) {
            return f(z)(k2)(m[k2]);
          };
        }
        for (var k in m) {
          if (hasOwnProperty.call(m, k)) {
            acc = bind(acc)(g(k));
          }
        }
        return acc;
      };
    };
  };
}
function _lookup(no, yes, k, m) {
  return k in m ? yes(m[k]) : no;
}
function toArrayWithKey(f) {
  return function(m) {
    var r = [];
    for (var k in m) {
      if (hasOwnProperty.call(m, k)) {
        r.push(f(k)(m[k]));
      }
    }
    return r;
  };
}
var keys = Object.keys || toArrayWithKey(function(k) {
  return function() {
    return k;
  };
});

// output-es/Foreign.Object/index.js
var identity10 = (x) => x;
var values = /* @__PURE__ */ toArrayWithKey((v) => (v1) => v1);
var mutate = (f) => (m) => runST((() => {
  const $2 = _copyST(m);
  return () => {
    const s = $2();
    f(s)();
    return s;
  };
})());
var mapWithKey = (f) => (m) => _mapWithKey(m, f);
var functorObject = { map: (f) => (m) => _fmapObject(m, f) };
var functorWithIndexObject = { mapWithIndex: mapWithKey, Functor0: () => functorObject };
var fromFoldable2 = (dictFoldable) => {
  const fromFoldable14 = fromFoldableImpl(dictFoldable.foldr);
  return (l) => runST(() => {
    const s = newImpl();
    foreach(fromFoldable14(l))((v) => () => {
      poke2(v._1)(v._2)(s)();
      return unit;
    })();
    return s;
  });
};
var fold = /* @__PURE__ */ _foldM(applyFlipped);
var foldMap = (dictMonoid) => {
  const append1 = dictMonoid.Semigroup0().append;
  return (f) => fold((acc) => (k) => (v) => append1(acc)(f(k)(v)))(dictMonoid.mempty);
};
var foldableObject = {
  foldl: (f) => fold((z) => (v) => f(z)),
  foldr: (f) => (z) => (m) => foldrArray(f)(z)(values(m)),
  foldMap: (dictMonoid) => {
    const foldMap13 = foldMap(dictMonoid);
    return (f) => foldMap13((v) => f);
  }
};
var foldableWithIndexObject = {
  foldlWithIndex: (f) => fold((b) => (a) => f(a)(b)),
  foldrWithIndex: (f) => (z) => (m) => foldrArray((v) => f(v._1)(v._2))(z)(toArrayWithKey(Tuple)(m)),
  foldMapWithIndex: (dictMonoid) => foldMap(dictMonoid),
  Foldable0: () => foldableObject
};
var traversableWithIndexObject = {
  traverseWithIndex: (dictApplicative) => {
    const Apply0 = dictApplicative.Apply0();
    const map = Apply0.Functor0().map;
    return (f) => (ms) => fold((acc) => (k) => (v) => Apply0.apply(map((b) => (a) => mutate(poke2(k)(a))(b))(acc))(f(k)(v)))(dictApplicative.pure(empty))(ms);
  },
  FunctorWithIndex0: () => functorWithIndexObject,
  FoldableWithIndex1: () => foldableWithIndexObject,
  Traversable2: () => traversableObject
};
var traversableObject = {
  traverse: (dictApplicative) => {
    const $1 = traversableWithIndexObject.traverseWithIndex(dictApplicative);
    return (x) => $1((v) => x);
  },
  sequence: (dictApplicative) => traversableObject.traverse(dictApplicative)(identity10),
  Functor0: () => functorObject,
  Foldable1: () => foldableObject
};

// output-es/Data.Argonaut.Core/foreign.js
function id(x) {
  return x;
}
var jsonNull = null;
function stringify(j) {
  return JSON.stringify(j);
}
function stringifyWithIndent(i) {
  return function(j) {
    return JSON.stringify(j, null, i);
  };
}
function _caseJson(isNull2, isBool, isNum, isStr, isArr, isObj, j) {
  if (j == null)
    return isNull2();
  else if (typeof j === "boolean")
    return isBool(j);
  else if (typeof j === "number")
    return isNum(j);
  else if (typeof j === "string")
    return isStr(j);
  else if (Object.prototype.toString.call(j) === "[object Array]")
    return isArr(j);
  else
    return isObj(j);
}

// output-es/Data.Argonaut.Core/index.js
var jsonSingletonObject = (key) => (val) => id(runST(bind_(newImpl)(poke2(key)(val))));
var jsonEmptyObject = /* @__PURE__ */ id(empty);
var caseJsonString = (d) => (f) => (j) => _caseJson((v) => d, (v) => d, (v) => d, f, (v) => d, (v) => d, j);
var caseJsonObject = (d) => (f) => (j) => _caseJson((v) => d, (v) => d, (v) => d, (v) => d, (v) => d, f, j);
var caseJsonNumber = (d) => (f) => (j) => _caseJson((v) => d, (v) => d, f, (v) => d, (v) => d, (v) => d, j);

// output-es/Data.Argonaut.Decode.Error/index.js
var $JsonDecodeError = (tag, _1, _2) => ({ tag, _1, _2 });
var AtKey = (value0) => (value1) => $JsonDecodeError("AtKey", value0, value1);
var Named = (value0) => (value1) => $JsonDecodeError("Named", value0, value1);
var printJsonDecodeError = (err) => {
  const go = (v) => {
    if (v.tag === "TypeMismatch") {
      return "  Expected value of type '" + (v._1 + "'.");
    }
    if (v.tag === "UnexpectedValue") {
      return "  Unexpected value " + (stringify(v._1) + ".");
    }
    if (v.tag === "AtIndex") {
      return "  At array index " + (showIntImpl(v._1) + (":\n" + go(v._2)));
    }
    if (v.tag === "AtKey") {
      return "  At object key '" + (v._1 + ("':\n" + go(v._2)));
    }
    if (v.tag === "Named") {
      return "  Under '" + (v._1 + ("':\n" + go(v._2)));
    }
    if (v.tag === "MissingValue") {
      return "  No value was found.";
    }
    fail();
  };
  return "An error occurred while decoding a JSON value:\n" + go(err);
};

// output-es/Data.Lazy/foreign.js
var defer = function(thunk) {
  var v = null;
  return function() {
    if (thunk === void 0)
      return v;
    v = thunk();
    thunk = void 0;
    return v;
  };
};
var force = function(l) {
  return l();
};

// output-es/Data.List.Lazy.Types/index.js
var $Step2 = (tag, _1, _2) => ({ tag, _1, _2 });
var Nil2 = /* @__PURE__ */ $Step2("Nil");
var nil = /* @__PURE__ */ defer((v) => Nil2);
var foldableList2 = {
  foldr: (op) => (z) => (xs) => foldableList2.foldl((b) => (a) => op(a)(b))(z)(foldableList2.foldl((b) => (a) => defer((v) => $Step2("Cons", a, b)))(nil)(xs)),
  foldl: (op) => {
    const go = (go$a0$copy) => (go$a1$copy) => {
      let go$a0 = go$a0$copy, go$a1 = go$a1$copy, go$c = true, go$r;
      while (go$c) {
        const b = go$a0, xs = go$a1;
        const v = force(xs);
        if (v.tag === "Nil") {
          go$c = false;
          go$r = b;
          continue;
        }
        if (v.tag === "Cons") {
          go$a0 = op(b)(v._1);
          go$a1 = v._2;
          continue;
        }
        fail();
      }
      ;
      return go$r;
    };
    return go;
  },
  foldMap: (dictMonoid) => {
    const append2 = dictMonoid.Semigroup0().append;
    return (f) => foldableList2.foldl((b) => (a) => append2(b)(f(a)))(dictMonoid.mempty);
  }
};
var unfoldable1List = {
  unfoldr1: /* @__PURE__ */ (() => {
    const go = (f) => (b) => defer((x) => force((() => {
      const v1 = f(b);
      if (v1._2.tag === "Just") {
        const $5 = go(f)(v1._2._1);
        return defer((v) => $Step2("Cons", v1._1, $5));
      }
      if (v1._2.tag === "Nothing") {
        return defer((v) => $Step2("Cons", v1._1, nil));
      }
      fail();
    })()));
    return go;
  })()
};
var unfoldableList = {
  unfoldr: /* @__PURE__ */ (() => {
    const go = (f) => (b) => defer((x) => force((() => {
      const v1 = f(b);
      if (v1.tag === "Nothing") {
        return nil;
      }
      if (v1.tag === "Just") {
        const $5 = go(f)(v1._1._2);
        return defer((v) => $Step2("Cons", v1._1._1, $5));
      }
      fail();
    })()));
    return go;
  })(),
  Unfoldable10: () => unfoldable1List
};

// output-es/Data.List.Lazy/index.js
var filter2 = (p) => {
  const go = (go$a0$copy) => {
    let go$a0 = go$a0$copy, go$c = true, go$r;
    while (go$c) {
      const v = go$a0;
      if (v.tag === "Nil") {
        go$c = false;
        go$r = Nil2;
        continue;
      }
      if (v.tag === "Cons") {
        if (p(v._1)) {
          go$c = false;
          go$r = $Step2("Cons", v._1, filter2(p)(v._2));
          continue;
        }
        go$a0 = force(v._2);
        continue;
      }
      fail();
    }
    ;
    return go$r;
  };
  return (x) => defer((v) => go(force(x)));
};

// output-es/Partial/foreign.js
var _crashWith = function(msg) {
  throw new Error(msg);
};

// output-es/Data.Map.Internal/index.js
var $KickUp = (_1, _2, _3, _4) => ({ tag: "KickUp", _1, _2, _3, _4 });
var $Map = (tag, _1, _2, _3, _4, _5, _6, _7) => ({ tag, _1, _2, _3, _4, _5, _6, _7 });
var $TreeContext = (tag, _1, _2, _3, _4, _5, _6) => ({ tag, _1, _2, _3, _4, _5, _6 });
var Leaf2 = /* @__PURE__ */ $Map("Leaf");
var toUnfoldable3 = (dictUnfoldable) => (m) => {
  const go = (go$a0$copy) => {
    let go$a0 = go$a0$copy, go$c = true, go$r;
    while (go$c) {
      const v = go$a0;
      if (v.tag === "Nil") {
        go$c = false;
        go$r = Nothing;
        continue;
      }
      if (v.tag === "Cons") {
        if (v._1.tag === "Leaf") {
          go$a0 = v._2;
          continue;
        }
        if (v._1.tag === "Two") {
          if (v._1._1.tag === "Leaf") {
            if (v._1._4.tag === "Leaf") {
              go$c = false;
              go$r = $Maybe("Just", $Tuple($Tuple(v._1._2, v._1._3), v._2));
              continue;
            }
            go$c = false;
            go$r = $Maybe("Just", $Tuple($Tuple(v._1._2, v._1._3), $List("Cons", v._1._4, v._2)));
            continue;
          }
          go$a0 = $List(
            "Cons",
            v._1._1,
            $List("Cons", $Map("Two", Leaf2, v._1._2, v._1._3, Leaf2), $List("Cons", v._1._4, v._2))
          );
          continue;
        }
        if (v._1.tag === "Three") {
          go$a0 = $List(
            "Cons",
            v._1._1,
            $List(
              "Cons",
              $Map("Two", Leaf2, v._1._2, v._1._3, Leaf2),
              $List("Cons", v._1._4, $List("Cons", $Map("Two", Leaf2, v._1._5, v._1._6, Leaf2), $List("Cons", v._1._7, v._2)))
            )
          );
          continue;
        }
        fail();
      }
      fail();
    }
    ;
    return go$r;
  };
  return dictUnfoldable.unfoldr(go)($List("Cons", m, Nil));
};
var lookup = (dictOrd) => (k) => {
  const go = (go$a0$copy) => {
    let go$a0 = go$a0$copy, go$c = true, go$r;
    while (go$c) {
      const v = go$a0;
      if (v.tag === "Leaf") {
        go$c = false;
        go$r = Nothing;
        continue;
      }
      if (v.tag === "Two") {
        const v2 = dictOrd.compare(k)(v._2);
        if (v2.tag === "EQ") {
          go$c = false;
          go$r = $Maybe("Just", v._3);
          continue;
        }
        if (v2.tag === "LT") {
          go$a0 = v._1;
          continue;
        }
        go$a0 = v._4;
        continue;
      }
      if (v.tag === "Three") {
        const v3 = dictOrd.compare(k)(v._2);
        if (v3.tag === "EQ") {
          go$c = false;
          go$r = $Maybe("Just", v._3);
          continue;
        }
        const v4 = dictOrd.compare(k)(v._5);
        if (v4.tag === "EQ") {
          go$c = false;
          go$r = $Maybe("Just", v._6);
          continue;
        }
        if (v3.tag === "LT") {
          go$a0 = v._1;
          continue;
        }
        if (v4.tag === "GT") {
          go$a0 = v._7;
          continue;
        }
        go$a0 = v._4;
        continue;
      }
      fail();
    }
    ;
    return go$r;
  };
  return go;
};
var functorMap = {
  map: (v) => (v1) => {
    if (v1.tag === "Leaf") {
      return Leaf2;
    }
    if (v1.tag === "Two") {
      return $Map("Two", functorMap.map(v)(v1._1), v1._2, v(v1._3), functorMap.map(v)(v1._4));
    }
    if (v1.tag === "Three") {
      return $Map("Three", functorMap.map(v)(v1._1), v1._2, v(v1._3), functorMap.map(v)(v1._4), v1._5, v(v1._6), functorMap.map(v)(v1._7));
    }
    fail();
  }
};
var fromZipper = (fromZipper$a0$copy) => (fromZipper$a1$copy) => (fromZipper$a2$copy) => {
  let fromZipper$a0 = fromZipper$a0$copy, fromZipper$a1 = fromZipper$a1$copy, fromZipper$a2 = fromZipper$a2$copy, fromZipper$c = true, fromZipper$r;
  while (fromZipper$c) {
    const dictOrd = fromZipper$a0, v = fromZipper$a1, tree = fromZipper$a2;
    if (v.tag === "Nil") {
      fromZipper$c = false;
      fromZipper$r = tree;
      continue;
    }
    if (v.tag === "Cons") {
      if (v._1.tag === "TwoLeft") {
        fromZipper$a0 = dictOrd;
        fromZipper$a1 = v._2;
        fromZipper$a2 = $Map("Two", tree, v._1._1, v._1._2, v._1._3);
        continue;
      }
      if (v._1.tag === "TwoRight") {
        fromZipper$a0 = dictOrd;
        fromZipper$a1 = v._2;
        fromZipper$a2 = $Map("Two", v._1._1, v._1._2, v._1._3, tree);
        continue;
      }
      if (v._1.tag === "ThreeLeft") {
        fromZipper$a0 = dictOrd;
        fromZipper$a1 = v._2;
        fromZipper$a2 = $Map("Three", tree, v._1._1, v._1._2, v._1._3, v._1._4, v._1._5, v._1._6);
        continue;
      }
      if (v._1.tag === "ThreeMiddle") {
        fromZipper$a0 = dictOrd;
        fromZipper$a1 = v._2;
        fromZipper$a2 = $Map("Three", v._1._1, v._1._2, v._1._3, tree, v._1._4, v._1._5, v._1._6);
        continue;
      }
      if (v._1.tag === "ThreeRight") {
        fromZipper$a0 = dictOrd;
        fromZipper$a1 = v._2;
        fromZipper$a2 = $Map("Three", v._1._1, v._1._2, v._1._3, v._1._4, v._1._5, v._1._6, tree);
        continue;
      }
      fail();
    }
    fail();
  }
  ;
  return fromZipper$r;
};
var insert = (dictOrd) => (k) => (v) => {
  const up = (up$a0$copy) => (up$a1$copy) => {
    let up$a0 = up$a0$copy, up$a1 = up$a1$copy, up$c = true, up$r;
    while (up$c) {
      const v1 = up$a0, v2 = up$a1;
      if (v1.tag === "Nil") {
        up$c = false;
        up$r = $Map("Two", v2._1, v2._2, v2._3, v2._4);
        continue;
      }
      if (v1.tag === "Cons") {
        if (v1._1.tag === "TwoLeft") {
          up$c = false;
          up$r = fromZipper(dictOrd)(v1._2)($Map("Three", v2._1, v2._2, v2._3, v2._4, v1._1._1, v1._1._2, v1._1._3));
          continue;
        }
        if (v1._1.tag === "TwoRight") {
          up$c = false;
          up$r = fromZipper(dictOrd)(v1._2)($Map("Three", v1._1._1, v1._1._2, v1._1._3, v2._1, v2._2, v2._3, v2._4));
          continue;
        }
        if (v1._1.tag === "ThreeLeft") {
          up$a0 = v1._2;
          up$a1 = $KickUp($Map("Two", v2._1, v2._2, v2._3, v2._4), v1._1._1, v1._1._2, $Map("Two", v1._1._3, v1._1._4, v1._1._5, v1._1._6));
          continue;
        }
        if (v1._1.tag === "ThreeMiddle") {
          up$a0 = v1._2;
          up$a1 = $KickUp($Map("Two", v1._1._1, v1._1._2, v1._1._3, v2._1), v2._2, v2._3, $Map("Two", v2._4, v1._1._4, v1._1._5, v1._1._6));
          continue;
        }
        if (v1._1.tag === "ThreeRight") {
          up$a0 = v1._2;
          up$a1 = $KickUp($Map("Two", v1._1._1, v1._1._2, v1._1._3, v1._1._4), v1._1._5, v1._1._6, $Map("Two", v2._1, v2._2, v2._3, v2._4));
          continue;
        }
        fail();
      }
      fail();
    }
    ;
    return up$r;
  };
  const down = (down$a0$copy) => (down$a1$copy) => {
    let down$a0 = down$a0$copy, down$a1 = down$a1$copy, down$c = true, down$r;
    while (down$c) {
      const ctx = down$a0, v1 = down$a1;
      if (v1.tag === "Leaf") {
        down$c = false;
        down$r = up(ctx)($KickUp(Leaf2, k, v, Leaf2));
        continue;
      }
      if (v1.tag === "Two") {
        const v2 = dictOrd.compare(k)(v1._2);
        if (v2.tag === "EQ") {
          down$c = false;
          down$r = fromZipper(dictOrd)(ctx)($Map("Two", v1._1, k, v, v1._4));
          continue;
        }
        if (v2.tag === "LT") {
          down$a0 = $List("Cons", $TreeContext("TwoLeft", v1._2, v1._3, v1._4), ctx);
          down$a1 = v1._1;
          continue;
        }
        down$a0 = $List("Cons", $TreeContext("TwoRight", v1._1, v1._2, v1._3), ctx);
        down$a1 = v1._4;
        continue;
      }
      if (v1.tag === "Three") {
        const v3 = dictOrd.compare(k)(v1._2);
        if (v3.tag === "EQ") {
          down$c = false;
          down$r = fromZipper(dictOrd)(ctx)($Map("Three", v1._1, k, v, v1._4, v1._5, v1._6, v1._7));
          continue;
        }
        const v4 = dictOrd.compare(k)(v1._5);
        if (v4.tag === "EQ") {
          down$c = false;
          down$r = fromZipper(dictOrd)(ctx)($Map("Three", v1._1, v1._2, v1._3, v1._4, k, v, v1._7));
          continue;
        }
        if (v3.tag === "LT") {
          down$a0 = $List("Cons", $TreeContext("ThreeLeft", v1._2, v1._3, v1._4, v1._5, v1._6, v1._7), ctx);
          down$a1 = v1._1;
          continue;
        }
        if (v3.tag === "GT") {
          if (v4.tag === "LT") {
            down$a0 = $List("Cons", $TreeContext("ThreeMiddle", v1._1, v1._2, v1._3, v1._5, v1._6, v1._7), ctx);
            down$a1 = v1._4;
            continue;
          }
          down$a0 = $List("Cons", $TreeContext("ThreeRight", v1._1, v1._2, v1._3, v1._4, v1._5, v1._6), ctx);
          down$a1 = v1._7;
          continue;
        }
        down$a0 = $List("Cons", $TreeContext("ThreeRight", v1._1, v1._2, v1._3, v1._4, v1._5, v1._6), ctx);
        down$a1 = v1._7;
        continue;
      }
      fail();
    }
    ;
    return down$r;
  };
  return down(Nil);
};
var pop = (dictOrd) => (k) => {
  const up = (up$a0$copy) => (up$a1$copy) => {
    let up$a0 = up$a0$copy, up$a1 = up$a1$copy, up$c = true, up$r;
    while (up$c) {
      const ctxs = up$a0, tree = up$a1;
      if (ctxs.tag === "Nil") {
        up$c = false;
        up$r = tree;
        continue;
      }
      if (ctxs.tag === "Cons") {
        const $5 = (a, b, c, d, k1, k2, k3, v1, v2, v3) => fromZipper(dictOrd)(ctxs._2)($Map("Two", $Map("Two", a, k1, v1, b), k2, v2, $Map("Two", c, k3, v3, d)));
        const $6 = (a, b, c, d, k1, k2, k3, v1, v2, v3) => fromZipper(dictOrd)(ctxs._2)($Map("Two", $Map("Two", a, k1, v1, b), k2, v2, $Map("Two", c, k3, v3, d)));
        const $7 = (a, b, c, d, k1, k2, k3, v1, v2, v3) => fromZipper(dictOrd)(ctxs._2)($Map("Two", $Map("Three", a, k1, v1, b, k2, v2, c), k3, v3, d));
        const $8 = (a, b, c, d, k1, k2, k3, v1, v2, v3) => fromZipper(dictOrd)(ctxs._2)($Map("Two", $Map("Three", a, k1, v1, b, k2, v2, c), k3, v3, d));
        const $9 = (a, b, c, d, k1, k2, k3, v1, v2, v3) => fromZipper(dictOrd)(ctxs._2)($Map("Two", a, k1, v1, $Map("Three", b, k2, v2, c, k3, v3, d)));
        const $10 = (a, b, c, d, k1, k2, k3, v1, v2, v3) => fromZipper(dictOrd)(ctxs._2)($Map("Two", a, k1, v1, $Map("Three", b, k2, v2, c, k3, v3, d)));
        const $11 = (a, b, c, d, e, k1, k2, k3, k4, v1, v2, v3, v4) => fromZipper(dictOrd)(ctxs._2)($Map(
          "Three",
          $Map("Two", a, k1, v1, b),
          k2,
          v2,
          $Map("Two", c, k3, v3, d),
          k4,
          v4,
          e
        ));
        const $12 = (a, b, c, d, e, k1, k2, k3, k4, v1, v2, v3, v4) => fromZipper(dictOrd)(ctxs._2)($Map(
          "Three",
          $Map("Two", a, k1, v1, b),
          k2,
          v2,
          $Map("Two", c, k3, v3, d),
          k4,
          v4,
          e
        ));
        const $13 = (a, b, c, d, e, k1, k2, k3, k4, v1, v2, v3, v4) => fromZipper(dictOrd)(ctxs._2)($Map(
          "Three",
          a,
          k1,
          v1,
          $Map("Two", b, k2, v2, c),
          k3,
          v3,
          $Map("Two", d, k4, v4, e)
        ));
        const $14 = (a, b, c, d, e, k1, k2, k3, k4, v1, v2, v3, v4) => fromZipper(dictOrd)(ctxs._2)($Map(
          "Three",
          a,
          k1,
          v1,
          $Map("Two", b, k2, v2, c),
          k3,
          v3,
          $Map("Two", d, k4, v4, e)
        ));
        if (tree.tag === "Leaf") {
          if (ctxs._1.tag === "TwoLeft") {
            if (ctxs._1._3.tag === "Leaf") {
              up$c = false;
              up$r = fromZipper(dictOrd)(ctxs._2)($Map("Two", Leaf2, ctxs._1._1, ctxs._1._2, Leaf2));
              continue;
            }
            if (ctxs._1._3.tag === "Two") {
              up$a0 = ctxs._2;
              up$a1 = $Map("Three", tree, ctxs._1._1, ctxs._1._2, ctxs._1._3._1, ctxs._1._3._2, ctxs._1._3._3, ctxs._1._3._4);
              continue;
            }
            if (ctxs._1._3.tag === "Three") {
              up$c = false;
              up$r = $5(tree, ctxs._1._3._1, ctxs._1._3._4, ctxs._1._3._7, ctxs._1._1, ctxs._1._3._2, ctxs._1._3._5, ctxs._1._2, ctxs._1._3._3, ctxs._1._3._6);
              continue;
            }
            up$c = false;
            up$r = _crashWith("The impossible happened in partial function `up`.");
            continue;
          }
          if (ctxs._1.tag === "TwoRight") {
            if (ctxs._1._1.tag === "Leaf") {
              up$c = false;
              up$r = fromZipper(dictOrd)(ctxs._2)($Map("Two", Leaf2, ctxs._1._2, ctxs._1._3, Leaf2));
              continue;
            }
            if (ctxs._1._1.tag === "Two") {
              up$a0 = ctxs._2;
              up$a1 = $Map("Three", ctxs._1._1._1, ctxs._1._1._2, ctxs._1._1._3, ctxs._1._1._4, ctxs._1._2, ctxs._1._3, tree);
              continue;
            }
            if (ctxs._1._1.tag === "Three") {
              up$c = false;
              up$r = $6(ctxs._1._1._1, ctxs._1._1._4, ctxs._1._1._7, tree, ctxs._1._1._2, ctxs._1._1._5, ctxs._1._2, ctxs._1._1._3, ctxs._1._1._6, ctxs._1._3);
              continue;
            }
            up$c = false;
            up$r = _crashWith("The impossible happened in partial function `up`.");
            continue;
          }
          if (ctxs._1.tag === "ThreeLeft") {
            if (ctxs._1._6.tag === "Leaf") {
              if (ctxs._1._3.tag === "Leaf") {
                up$c = false;
                up$r = fromZipper(dictOrd)(ctxs._2)($Map("Three", Leaf2, ctxs._1._1, ctxs._1._2, Leaf2, ctxs._1._4, ctxs._1._5, Leaf2));
                continue;
              }
              if (ctxs._1._3.tag === "Two") {
                up$c = false;
                up$r = $7(tree, ctxs._1._3._1, ctxs._1._3._4, ctxs._1._6, ctxs._1._1, ctxs._1._3._2, ctxs._1._4, ctxs._1._2, ctxs._1._3._3, ctxs._1._5);
                continue;
              }
              if (ctxs._1._3.tag === "Three") {
                up$c = false;
                up$r = $11(
                  tree,
                  ctxs._1._3._1,
                  ctxs._1._3._4,
                  ctxs._1._3._7,
                  ctxs._1._6,
                  ctxs._1._1,
                  ctxs._1._3._2,
                  ctxs._1._3._5,
                  ctxs._1._4,
                  ctxs._1._2,
                  ctxs._1._3._3,
                  ctxs._1._3._6,
                  ctxs._1._5
                );
                continue;
              }
              up$c = false;
              up$r = _crashWith("The impossible happened in partial function `up`.");
              continue;
            }
            if (ctxs._1._3.tag === "Two") {
              up$c = false;
              up$r = $7(tree, ctxs._1._3._1, ctxs._1._3._4, ctxs._1._6, ctxs._1._1, ctxs._1._3._2, ctxs._1._4, ctxs._1._2, ctxs._1._3._3, ctxs._1._5);
              continue;
            }
            if (ctxs._1._3.tag === "Three") {
              up$c = false;
              up$r = $11(
                tree,
                ctxs._1._3._1,
                ctxs._1._3._4,
                ctxs._1._3._7,
                ctxs._1._6,
                ctxs._1._1,
                ctxs._1._3._2,
                ctxs._1._3._5,
                ctxs._1._4,
                ctxs._1._2,
                ctxs._1._3._3,
                ctxs._1._3._6,
                ctxs._1._5
              );
              continue;
            }
            up$c = false;
            up$r = _crashWith("The impossible happened in partial function `up`.");
            continue;
          }
          if (ctxs._1.tag === "ThreeMiddle") {
            if (ctxs._1._1.tag === "Leaf") {
              if (ctxs._1._6.tag === "Leaf") {
                up$c = false;
                up$r = fromZipper(dictOrd)(ctxs._2)($Map("Three", Leaf2, ctxs._1._2, ctxs._1._3, Leaf2, ctxs._1._4, ctxs._1._5, Leaf2));
                continue;
              }
              if (ctxs._1._6.tag === "Two") {
                up$c = false;
                up$r = $9(ctxs._1._1, tree, ctxs._1._6._1, ctxs._1._6._4, ctxs._1._2, ctxs._1._4, ctxs._1._6._2, ctxs._1._3, ctxs._1._5, ctxs._1._6._3);
                continue;
              }
              if (ctxs._1._6.tag === "Three") {
                up$c = false;
                up$r = $13(
                  ctxs._1._1,
                  tree,
                  ctxs._1._6._1,
                  ctxs._1._6._4,
                  ctxs._1._6._7,
                  ctxs._1._2,
                  ctxs._1._4,
                  ctxs._1._6._2,
                  ctxs._1._6._5,
                  ctxs._1._3,
                  ctxs._1._5,
                  ctxs._1._6._3,
                  ctxs._1._6._6
                );
                continue;
              }
              up$c = false;
              up$r = _crashWith("The impossible happened in partial function `up`.");
              continue;
            }
            if (ctxs._1._1.tag === "Two") {
              up$c = false;
              up$r = $8(ctxs._1._1._1, ctxs._1._1._4, tree, ctxs._1._6, ctxs._1._1._2, ctxs._1._2, ctxs._1._4, ctxs._1._1._3, ctxs._1._3, ctxs._1._5);
              continue;
            }
            if (ctxs._1._6.tag === "Two") {
              up$c = false;
              up$r = $9(ctxs._1._1, tree, ctxs._1._6._1, ctxs._1._6._4, ctxs._1._2, ctxs._1._4, ctxs._1._6._2, ctxs._1._3, ctxs._1._5, ctxs._1._6._3);
              continue;
            }
            if (ctxs._1._1.tag === "Three") {
              up$c = false;
              up$r = $12(
                ctxs._1._1._1,
                ctxs._1._1._4,
                ctxs._1._1._7,
                tree,
                ctxs._1._6,
                ctxs._1._1._2,
                ctxs._1._1._5,
                ctxs._1._2,
                ctxs._1._4,
                ctxs._1._1._3,
                ctxs._1._1._6,
                ctxs._1._3,
                ctxs._1._5
              );
              continue;
            }
            if (ctxs._1._6.tag === "Three") {
              up$c = false;
              up$r = $13(
                ctxs._1._1,
                tree,
                ctxs._1._6._1,
                ctxs._1._6._4,
                ctxs._1._6._7,
                ctxs._1._2,
                ctxs._1._4,
                ctxs._1._6._2,
                ctxs._1._6._5,
                ctxs._1._3,
                ctxs._1._5,
                ctxs._1._6._3,
                ctxs._1._6._6
              );
              continue;
            }
            up$c = false;
            up$r = _crashWith("The impossible happened in partial function `up`.");
            continue;
          }
          if (ctxs._1.tag === "ThreeRight") {
            if (ctxs._1._1.tag === "Leaf") {
              if (ctxs._1._4.tag === "Leaf") {
                up$c = false;
                up$r = fromZipper(dictOrd)(ctxs._2)($Map("Three", Leaf2, ctxs._1._2, ctxs._1._3, Leaf2, ctxs._1._5, ctxs._1._6, Leaf2));
                continue;
              }
              if (ctxs._1._4.tag === "Two") {
                up$c = false;
                up$r = $10(ctxs._1._1, ctxs._1._4._1, ctxs._1._4._4, tree, ctxs._1._2, ctxs._1._4._2, ctxs._1._5, ctxs._1._3, ctxs._1._4._3, ctxs._1._6);
                continue;
              }
              if (ctxs._1._4.tag === "Three") {
                up$c = false;
                up$r = $14(
                  ctxs._1._1,
                  ctxs._1._4._1,
                  ctxs._1._4._4,
                  ctxs._1._4._7,
                  tree,
                  ctxs._1._2,
                  ctxs._1._4._2,
                  ctxs._1._4._5,
                  ctxs._1._5,
                  ctxs._1._3,
                  ctxs._1._4._3,
                  ctxs._1._4._6,
                  ctxs._1._6
                );
                continue;
              }
              up$c = false;
              up$r = _crashWith("The impossible happened in partial function `up`.");
              continue;
            }
            if (ctxs._1._4.tag === "Two") {
              up$c = false;
              up$r = $10(ctxs._1._1, ctxs._1._4._1, ctxs._1._4._4, tree, ctxs._1._2, ctxs._1._4._2, ctxs._1._5, ctxs._1._3, ctxs._1._4._3, ctxs._1._6);
              continue;
            }
            if (ctxs._1._4.tag === "Three") {
              up$c = false;
              up$r = $14(
                ctxs._1._1,
                ctxs._1._4._1,
                ctxs._1._4._4,
                ctxs._1._4._7,
                tree,
                ctxs._1._2,
                ctxs._1._4._2,
                ctxs._1._4._5,
                ctxs._1._5,
                ctxs._1._3,
                ctxs._1._4._3,
                ctxs._1._4._6,
                ctxs._1._6
              );
              continue;
            }
            up$c = false;
            up$r = _crashWith("The impossible happened in partial function `up`.");
            continue;
          }
          up$c = false;
          up$r = _crashWith("The impossible happened in partial function `up`.");
          continue;
        }
        if (ctxs._1.tag === "TwoLeft") {
          if (ctxs._1._3.tag === "Two") {
            up$a0 = ctxs._2;
            up$a1 = $Map("Three", tree, ctxs._1._1, ctxs._1._2, ctxs._1._3._1, ctxs._1._3._2, ctxs._1._3._3, ctxs._1._3._4);
            continue;
          }
          if (ctxs._1._3.tag === "Three") {
            up$c = false;
            up$r = $5(tree, ctxs._1._3._1, ctxs._1._3._4, ctxs._1._3._7, ctxs._1._1, ctxs._1._3._2, ctxs._1._3._5, ctxs._1._2, ctxs._1._3._3, ctxs._1._3._6);
            continue;
          }
          up$c = false;
          up$r = _crashWith("The impossible happened in partial function `up`.");
          continue;
        }
        if (ctxs._1.tag === "TwoRight") {
          if (ctxs._1._1.tag === "Two") {
            up$a0 = ctxs._2;
            up$a1 = $Map("Three", ctxs._1._1._1, ctxs._1._1._2, ctxs._1._1._3, ctxs._1._1._4, ctxs._1._2, ctxs._1._3, tree);
            continue;
          }
          if (ctxs._1._1.tag === "Three") {
            up$c = false;
            up$r = $6(ctxs._1._1._1, ctxs._1._1._4, ctxs._1._1._7, tree, ctxs._1._1._2, ctxs._1._1._5, ctxs._1._2, ctxs._1._1._3, ctxs._1._1._6, ctxs._1._3);
            continue;
          }
          up$c = false;
          up$r = _crashWith("The impossible happened in partial function `up`.");
          continue;
        }
        if (ctxs._1.tag === "ThreeLeft") {
          if (ctxs._1._3.tag === "Two") {
            up$c = false;
            up$r = $7(tree, ctxs._1._3._1, ctxs._1._3._4, ctxs._1._6, ctxs._1._1, ctxs._1._3._2, ctxs._1._4, ctxs._1._2, ctxs._1._3._3, ctxs._1._5);
            continue;
          }
          if (ctxs._1._3.tag === "Three") {
            up$c = false;
            up$r = $11(
              tree,
              ctxs._1._3._1,
              ctxs._1._3._4,
              ctxs._1._3._7,
              ctxs._1._6,
              ctxs._1._1,
              ctxs._1._3._2,
              ctxs._1._3._5,
              ctxs._1._4,
              ctxs._1._2,
              ctxs._1._3._3,
              ctxs._1._3._6,
              ctxs._1._5
            );
            continue;
          }
          up$c = false;
          up$r = _crashWith("The impossible happened in partial function `up`.");
          continue;
        }
        if (ctxs._1.tag === "ThreeMiddle") {
          if (ctxs._1._1.tag === "Two") {
            up$c = false;
            up$r = $8(ctxs._1._1._1, ctxs._1._1._4, tree, ctxs._1._6, ctxs._1._1._2, ctxs._1._2, ctxs._1._4, ctxs._1._1._3, ctxs._1._3, ctxs._1._5);
            continue;
          }
          if (ctxs._1._6.tag === "Two") {
            up$c = false;
            up$r = $9(ctxs._1._1, tree, ctxs._1._6._1, ctxs._1._6._4, ctxs._1._2, ctxs._1._4, ctxs._1._6._2, ctxs._1._3, ctxs._1._5, ctxs._1._6._3);
            continue;
          }
          if (ctxs._1._1.tag === "Three") {
            up$c = false;
            up$r = $12(
              ctxs._1._1._1,
              ctxs._1._1._4,
              ctxs._1._1._7,
              tree,
              ctxs._1._6,
              ctxs._1._1._2,
              ctxs._1._1._5,
              ctxs._1._2,
              ctxs._1._4,
              ctxs._1._1._3,
              ctxs._1._1._6,
              ctxs._1._3,
              ctxs._1._5
            );
            continue;
          }
          if (ctxs._1._6.tag === "Three") {
            up$c = false;
            up$r = $13(
              ctxs._1._1,
              tree,
              ctxs._1._6._1,
              ctxs._1._6._4,
              ctxs._1._6._7,
              ctxs._1._2,
              ctxs._1._4,
              ctxs._1._6._2,
              ctxs._1._6._5,
              ctxs._1._3,
              ctxs._1._5,
              ctxs._1._6._3,
              ctxs._1._6._6
            );
            continue;
          }
          up$c = false;
          up$r = _crashWith("The impossible happened in partial function `up`.");
          continue;
        }
        if (ctxs._1.tag === "ThreeRight") {
          if (ctxs._1._4.tag === "Two") {
            up$c = false;
            up$r = $10(ctxs._1._1, ctxs._1._4._1, ctxs._1._4._4, tree, ctxs._1._2, ctxs._1._4._2, ctxs._1._5, ctxs._1._3, ctxs._1._4._3, ctxs._1._6);
            continue;
          }
          if (ctxs._1._4.tag === "Three") {
            up$c = false;
            up$r = $14(
              ctxs._1._1,
              ctxs._1._4._1,
              ctxs._1._4._4,
              ctxs._1._4._7,
              tree,
              ctxs._1._2,
              ctxs._1._4._2,
              ctxs._1._4._5,
              ctxs._1._5,
              ctxs._1._3,
              ctxs._1._4._3,
              ctxs._1._4._6,
              ctxs._1._6
            );
            continue;
          }
          up$c = false;
          up$r = _crashWith("The impossible happened in partial function `up`.");
          continue;
        }
        up$c = false;
        up$r = _crashWith("The impossible happened in partial function `up`.");
        continue;
      }
      fail();
    }
    ;
    return up$r;
  };
  const removeMaxNode = (removeMaxNode$a0$copy) => (removeMaxNode$a1$copy) => {
    let removeMaxNode$a0 = removeMaxNode$a0$copy, removeMaxNode$a1 = removeMaxNode$a1$copy, removeMaxNode$c = true, removeMaxNode$r;
    while (removeMaxNode$c) {
      const ctx = removeMaxNode$a0, m = removeMaxNode$a1;
      if (m.tag === "Two") {
        if (m._1.tag === "Leaf") {
          if (m._4.tag === "Leaf") {
            removeMaxNode$c = false;
            removeMaxNode$r = up(ctx)(Leaf2);
            continue;
          }
          removeMaxNode$a0 = $List("Cons", $TreeContext("TwoRight", m._1, m._2, m._3), ctx);
          removeMaxNode$a1 = m._4;
          continue;
        }
        removeMaxNode$a0 = $List("Cons", $TreeContext("TwoRight", m._1, m._2, m._3), ctx);
        removeMaxNode$a1 = m._4;
        continue;
      }
      if (m.tag === "Three") {
        if (m._1.tag === "Leaf") {
          if (m._4.tag === "Leaf") {
            if (m._7.tag === "Leaf") {
              removeMaxNode$c = false;
              removeMaxNode$r = up($List("Cons", $TreeContext("TwoRight", Leaf2, m._2, m._3), ctx))(Leaf2);
              continue;
            }
            removeMaxNode$a0 = $List("Cons", $TreeContext("ThreeRight", m._1, m._2, m._3, m._4, m._5, m._6), ctx);
            removeMaxNode$a1 = m._7;
            continue;
          }
          removeMaxNode$a0 = $List("Cons", $TreeContext("ThreeRight", m._1, m._2, m._3, m._4, m._5, m._6), ctx);
          removeMaxNode$a1 = m._7;
          continue;
        }
        removeMaxNode$a0 = $List("Cons", $TreeContext("ThreeRight", m._1, m._2, m._3, m._4, m._5, m._6), ctx);
        removeMaxNode$a1 = m._7;
        continue;
      }
      removeMaxNode$c = false;
      removeMaxNode$r = _crashWith("The impossible happened in partial function `removeMaxNode`.");
      continue;
    }
    ;
    return removeMaxNode$r;
  };
  const maxNode = (maxNode$a0$copy) => {
    let maxNode$a0 = maxNode$a0$copy, maxNode$c = true, maxNode$r;
    while (maxNode$c) {
      const m = maxNode$a0;
      if (m.tag === "Two") {
        if (m._4.tag === "Leaf") {
          maxNode$c = false;
          maxNode$r = { key: m._2, value: m._3 };
          continue;
        }
        maxNode$a0 = m._4;
        continue;
      }
      if (m.tag === "Three") {
        if (m._7.tag === "Leaf") {
          maxNode$c = false;
          maxNode$r = { key: m._5, value: m._6 };
          continue;
        }
        maxNode$a0 = m._7;
        continue;
      }
      maxNode$c = false;
      maxNode$r = _crashWith("The impossible happened in partial function `maxNode`.");
      continue;
    }
    ;
    return maxNode$r;
  };
  const down = (down$a0$copy) => (down$a1$copy) => {
    let down$a0 = down$a0$copy, down$a1 = down$a1$copy, down$c = true, down$r;
    while (down$c) {
      const ctx = down$a0, m = down$a1;
      if (m.tag === "Leaf") {
        down$c = false;
        down$r = Nothing;
        continue;
      }
      if (m.tag === "Two") {
        const v = dictOrd.compare(k)(m._2);
        if (v.tag === "EQ") {
          if (m._4.tag === "Leaf") {
            down$c = false;
            down$r = $Maybe("Just", $Tuple(m._3, up(ctx)(Leaf2)));
            continue;
          }
          const max6 = maxNode(m._1);
          down$c = false;
          down$r = $Maybe(
            "Just",
            $Tuple(m._3, removeMaxNode($List("Cons", $TreeContext("TwoLeft", max6.key, max6.value, m._4), ctx))(m._1))
          );
          continue;
        }
        if (v.tag === "LT") {
          down$a0 = $List("Cons", $TreeContext("TwoLeft", m._2, m._3, m._4), ctx);
          down$a1 = m._1;
          continue;
        }
        down$a0 = $List("Cons", $TreeContext("TwoRight", m._1, m._2, m._3), ctx);
        down$a1 = m._4;
        continue;
      }
      if (m.tag === "Three") {
        const v = dictOrd.compare(k)(m._5);
        const v3 = dictOrd.compare(k)(m._2);
        if ((() => {
          if (m._1.tag === "Leaf") {
            if (m._4.tag === "Leaf") {
              return m._7.tag === "Leaf";
            }
            return false;
          }
          return false;
        })()) {
          if (v3.tag === "EQ") {
            down$c = false;
            down$r = $Maybe("Just", $Tuple(m._3, fromZipper(dictOrd)(ctx)($Map("Two", Leaf2, m._5, m._6, Leaf2))));
            continue;
          }
          if (v.tag === "EQ") {
            down$c = false;
            down$r = $Maybe("Just", $Tuple(m._6, fromZipper(dictOrd)(ctx)($Map("Two", Leaf2, m._2, m._3, Leaf2))));
            continue;
          }
          if (v3.tag === "LT") {
            down$a0 = $List("Cons", $TreeContext("ThreeLeft", m._2, m._3, m._4, m._5, m._6, m._7), ctx);
            down$a1 = m._1;
            continue;
          }
          if (v3.tag === "GT") {
            if (v.tag === "LT") {
              down$a0 = $List("Cons", $TreeContext("ThreeMiddle", m._1, m._2, m._3, m._5, m._6, m._7), ctx);
              down$a1 = m._4;
              continue;
            }
            down$a0 = $List("Cons", $TreeContext("ThreeRight", m._1, m._2, m._3, m._4, m._5, m._6), ctx);
            down$a1 = m._7;
            continue;
          }
          down$a0 = $List("Cons", $TreeContext("ThreeRight", m._1, m._2, m._3, m._4, m._5, m._6), ctx);
          down$a1 = m._7;
          continue;
        }
        if (v3.tag === "EQ") {
          const max6 = maxNode(m._1);
          down$c = false;
          down$r = $Maybe(
            "Just",
            $Tuple(m._3, removeMaxNode($List("Cons", $TreeContext("ThreeLeft", max6.key, max6.value, m._4, m._5, m._6, m._7), ctx))(m._1))
          );
          continue;
        }
        if (v.tag === "EQ") {
          const max6 = maxNode(m._4);
          down$c = false;
          down$r = $Maybe(
            "Just",
            $Tuple(m._6, removeMaxNode($List("Cons", $TreeContext("ThreeMiddle", m._1, m._2, m._3, max6.key, max6.value, m._7), ctx))(m._4))
          );
          continue;
        }
        if (v3.tag === "LT") {
          down$a0 = $List("Cons", $TreeContext("ThreeLeft", m._2, m._3, m._4, m._5, m._6, m._7), ctx);
          down$a1 = m._1;
          continue;
        }
        if (v3.tag === "GT") {
          if (v.tag === "LT") {
            down$a0 = $List("Cons", $TreeContext("ThreeMiddle", m._1, m._2, m._3, m._5, m._6, m._7), ctx);
            down$a1 = m._4;
            continue;
          }
          down$a0 = $List("Cons", $TreeContext("ThreeRight", m._1, m._2, m._3, m._4, m._5, m._6), ctx);
          down$a1 = m._7;
          continue;
        }
        down$a0 = $List("Cons", $TreeContext("ThreeRight", m._1, m._2, m._3, m._4, m._5, m._6), ctx);
        down$a1 = m._7;
        continue;
      }
      fail();
    }
    ;
    return down$r;
  };
  return down(Nil);
};
var foldableMap = {
  foldr: (f) => (z) => (m) => {
    if (m.tag === "Leaf") {
      return z;
    }
    if (m.tag === "Two") {
      return foldableMap.foldr(f)(f(m._3)(foldableMap.foldr(f)(z)(m._4)))(m._1);
    }
    if (m.tag === "Three") {
      return foldableMap.foldr(f)(f(m._3)(foldableMap.foldr(f)(f(m._6)(foldableMap.foldr(f)(z)(m._7)))(m._4)))(m._1);
    }
    fail();
  },
  foldl: (f) => (z) => (m) => {
    if (m.tag === "Leaf") {
      return z;
    }
    if (m.tag === "Two") {
      return foldableMap.foldl(f)(f(foldableMap.foldl(f)(z)(m._1))(m._3))(m._4);
    }
    if (m.tag === "Three") {
      return foldableMap.foldl(f)(f(foldableMap.foldl(f)(f(foldableMap.foldl(f)(z)(m._1))(m._3))(m._4))(m._6))(m._7);
    }
    fail();
  },
  foldMap: (dictMonoid) => {
    const append2 = dictMonoid.Semigroup0().append;
    return (f) => (m) => {
      if (m.tag === "Leaf") {
        return dictMonoid.mempty;
      }
      if (m.tag === "Two") {
        return append2(foldableMap.foldMap(dictMonoid)(f)(m._1))(append2(f(m._3))(foldableMap.foldMap(dictMonoid)(f)(m._4)));
      }
      if (m.tag === "Three") {
        return append2(foldableMap.foldMap(dictMonoid)(f)(m._1))(append2(f(m._3))(append2(foldableMap.foldMap(dictMonoid)(f)(m._4))(append2(f(m._6))(foldableMap.foldMap(dictMonoid)(f)(m._7)))));
      }
      fail();
    };
  }
};
var foldableWithIndexMap = {
  foldrWithIndex: (f) => (z) => (m) => {
    if (m.tag === "Leaf") {
      return z;
    }
    if (m.tag === "Two") {
      return foldableWithIndexMap.foldrWithIndex(f)(f(m._2)(m._3)(foldableWithIndexMap.foldrWithIndex(f)(z)(m._4)))(m._1);
    }
    if (m.tag === "Three") {
      return foldableWithIndexMap.foldrWithIndex(f)(f(m._2)(m._3)(foldableWithIndexMap.foldrWithIndex(f)(f(m._5)(m._6)(foldableWithIndexMap.foldrWithIndex(f)(z)(m._7)))(m._4)))(m._1);
    }
    fail();
  },
  foldlWithIndex: (f) => (z) => (m) => {
    if (m.tag === "Leaf") {
      return z;
    }
    if (m.tag === "Two") {
      return foldableWithIndexMap.foldlWithIndex(f)(f(m._2)(foldableWithIndexMap.foldlWithIndex(f)(z)(m._1))(m._3))(m._4);
    }
    if (m.tag === "Three") {
      return foldableWithIndexMap.foldlWithIndex(f)(f(m._5)(foldableWithIndexMap.foldlWithIndex(f)(f(m._2)(foldableWithIndexMap.foldlWithIndex(f)(z)(m._1))(m._3))(m._4))(m._6))(m._7);
    }
    fail();
  },
  foldMapWithIndex: (dictMonoid) => {
    const append2 = dictMonoid.Semigroup0().append;
    return (f) => (m) => {
      if (m.tag === "Leaf") {
        return dictMonoid.mempty;
      }
      if (m.tag === "Two") {
        return append2(foldableWithIndexMap.foldMapWithIndex(dictMonoid)(f)(m._1))(append2(f(m._2)(m._3))(foldableWithIndexMap.foldMapWithIndex(dictMonoid)(f)(m._4)));
      }
      if (m.tag === "Three") {
        return append2(foldableWithIndexMap.foldMapWithIndex(dictMonoid)(f)(m._1))(append2(f(m._2)(m._3))(append2(foldableWithIndexMap.foldMapWithIndex(dictMonoid)(f)(m._4))(append2(f(m._5)(m._6))(foldableWithIndexMap.foldMapWithIndex(dictMonoid)(f)(m._7)))));
      }
      fail();
    };
  },
  Foldable0: () => foldableMap
};
var findMin = /* @__PURE__ */ (() => {
  const go = (go$a0$copy) => (go$a1$copy) => {
    let go$a0 = go$a0$copy, go$a1 = go$a1$copy, go$c = true, go$r;
    while (go$c) {
      const v = go$a0, v1 = go$a1;
      if (v1.tag === "Leaf") {
        go$c = false;
        go$r = v;
        continue;
      }
      if (v1.tag === "Two") {
        go$a0 = $Maybe("Just", { key: v1._2, value: v1._3 });
        go$a1 = v1._1;
        continue;
      }
      if (v1.tag === "Three") {
        go$a0 = $Maybe("Just", { key: v1._2, value: v1._3 });
        go$a1 = v1._1;
        continue;
      }
      fail();
    }
    ;
    return go$r;
  };
  return go(Nothing);
})();
var fromFoldable3 = (dictOrd) => (dictFoldable) => dictFoldable.foldl((m) => (v) => insert(dictOrd)(v._1)(v._2)(m))(Leaf2);
var filterWithKey = (dictOrd) => {
  const fromFoldable14 = fromFoldable3(dictOrd)(foldableList2);
  return (predicate) => {
    const $3 = filter2((v) => predicate(v._1)(v._2));
    return (x) => fromFoldable14($3(toUnfoldable3(unfoldableList)(x)));
  };
};
var filterKeys = (dictOrd) => {
  const filterWithKey1 = filterWithKey(dictOrd);
  return (predicate) => filterWithKey1((x) => {
    const $4 = predicate(x);
    return (v) => $4;
  });
};
var $$delete = (dictOrd) => (k) => (m) => {
  const $3 = pop(dictOrd)(k)(m);
  if ($3.tag === "Nothing") {
    return m;
  }
  if ($3.tag === "Just") {
    return $3._1._2;
  }
  fail();
};
var alter = (dictOrd) => (f) => (k) => (m) => {
  const v = f(lookup(dictOrd)(k)(m));
  if (v.tag === "Nothing") {
    return $$delete(dictOrd)(k)(m);
  }
  if (v.tag === "Just") {
    return insert(dictOrd)(k)(v._1)(m);
  }
  fail();
};
var fromFoldableWith = (dictOrd) => (dictFoldable) => (f) => dictFoldable.foldl((m) => (v) => alter(dictOrd)((v1) => {
  if (v1.tag === "Just") {
    return $Maybe("Just", f(v._2)(v1._1));
  }
  if (v1.tag === "Nothing") {
    return $Maybe("Just", v._2);
  }
  fail();
})(v._1)(m))(Leaf2);
var insertWith = (dictOrd) => (f) => (k) => (v) => alter(dictOrd)((x) => $Maybe(
  "Just",
  (() => {
    if (x.tag === "Nothing") {
      return v;
    }
    if (x.tag === "Just") {
      return f(x._1)(v);
    }
    fail();
  })()
))(k);
var unionWith = (dictOrd) => (f) => (m1) => (m2) => foldableWithIndexMap.foldlWithIndex((k) => (m) => (v) => alter(dictOrd)((() => {
  const $7 = f(v);
  return (x) => $Maybe(
    "Just",
    (() => {
      if (x.tag === "Nothing") {
        return v;
      }
      if (x.tag === "Just") {
        return $7(x._1);
      }
      fail();
    })()
  );
})())(k)(m))(m2)(m1);
var union = (dictOrd) => unionWith(dictOrd)($$const);

// output-es/Data.Argonaut.Decode.Decoders/index.js
var traverse5 = /* @__PURE__ */ (() => {
  const $0 = traversableWithIndexObject.traverseWithIndex(applicativeEither);
  return (x) => $0((v) => x);
})();
var getFieldOptional$p = (decoder) => (obj) => (str) => {
  const $3 = _lookup(Nothing, Just, str, obj);
  if ($3.tag === "Nothing") {
    return $Either("Right", Nothing);
  }
  if ($3.tag === "Just") {
    if (_caseJson((v) => true, (v) => false, (v) => false, (v) => false, (v) => false, (v) => false, $3._1)) {
      return $Either("Right", Nothing);
    }
    const $4 = bifunctorEither.bimap(AtKey(str))(identity4)(decoder($3._1));
    if ($4.tag === "Left") {
      return $Either("Left", $4._1);
    }
    if ($4.tag === "Right") {
      return $Either("Right", $Maybe("Just", $4._1));
    }
    fail();
  }
  fail();
};
var decodeJObject = (x) => {
  const $1 = _caseJson(
    (v) => Nothing,
    (v) => Nothing,
    (v) => Nothing,
    (v) => Nothing,
    (v) => Nothing,
    Just,
    x
  );
  if ($1.tag === "Nothing") {
    return $Either("Left", $JsonDecodeError("TypeMismatch", "Object"));
  }
  if ($1.tag === "Just") {
    return $Either("Right", $1._1);
  }
  fail();
};
var decodeInt = (a) => bindEither.bind(_caseJson(
  (v) => $Either("Left", $JsonDecodeError("TypeMismatch", "Number")),
  (v) => $Either("Left", $JsonDecodeError("TypeMismatch", "Number")),
  Right,
  (v) => $Either("Left", $JsonDecodeError("TypeMismatch", "Number")),
  (v) => $Either("Left", $JsonDecodeError("TypeMismatch", "Number")),
  (v) => $Either("Left", $JsonDecodeError("TypeMismatch", "Number")),
  a
))((x) => {
  const $2 = fromNumber(x);
  if ($2.tag === "Nothing") {
    return $Either("Left", $JsonDecodeError("TypeMismatch", "Integer"));
  }
  if ($2.tag === "Just") {
    return $Either("Right", $2._1);
  }
  fail();
});
var decodeForeignObject = (decoder) => {
  const $1 = bifunctorEither.bimap(Named("ForeignObject"))(identity4);
  const $2 = traverse5(decoder);
  return (a) => bindEither.bind(decodeJObject(a))((x) => $1($2(x)));
};

// output-es/Data.Set/index.js
var union2 = (dictOrd) => (v) => (v1) => unionWith(dictOrd)($$const)(v)(v1);
var toUnfoldable4 = (dictUnfoldable) => {
  const $1 = toUnfoldable(dictUnfoldable);
  return (x) => $1(foldableWithIndexMap.foldrWithIndex((k) => (v) => (acc) => $List("Cons", k, acc))(Nil)(x));
};
var foldableSet = {
  foldMap: (dictMonoid) => {
    const foldMap13 = foldableList.foldMap(dictMonoid);
    return (f) => {
      const $3 = foldMap13(f);
      return (x) => $3(foldableWithIndexMap.foldrWithIndex((k) => (v) => (acc) => $List("Cons", k, acc))(Nil)(x));
    };
  },
  foldl: (f) => (x) => {
    const $2 = (() => {
      const go = (go$a0$copy) => (go$a1$copy) => {
        let go$a0 = go$a0$copy, go$a1 = go$a1$copy, go$c = true, go$r;
        while (go$c) {
          const b = go$a0, v = go$a1;
          if (v.tag === "Nil") {
            go$c = false;
            go$r = b;
            continue;
          }
          if (v.tag === "Cons") {
            go$a0 = f(b)(v._1);
            go$a1 = v._2;
            continue;
          }
          fail();
        }
        ;
        return go$r;
      };
      return go(x);
    })();
    return (x$1) => $2(foldableWithIndexMap.foldrWithIndex((k) => (v) => (acc) => $List("Cons", k, acc))(Nil)(x$1));
  },
  foldr: (f) => (x) => {
    const $2 = foldableList.foldr(f)(x);
    return (x$1) => $2(foldableWithIndexMap.foldrWithIndex((k) => (v) => (acc) => $List("Cons", k, acc))(Nil)(x$1));
  }
};

// output-es/Data.Argonaut.Encode.Encoders/index.js
var extend = (encoder) => (v) => {
  const $2 = caseJsonObject(jsonSingletonObject(v._1)(v._2))((x) => id(mutate(poke2(v._1)(v._2))(x)));
  return (x) => $2(encoder(x));
};

// output-es/Data.Argonaut.Encode.Class/index.js
var encodeJsonJson = { encodeJson: (x) => x };

// output-es/Data.String.Regex/foreign.js
var regexImpl = function(left) {
  return function(right) {
    return function(s1) {
      return function(s2) {
        try {
          return right(new RegExp(s1, s2));
        } catch (e) {
          return left(e.message);
        }
      };
    };
  };
};
var _match = function(just) {
  return function(nothing) {
    return function(r) {
      return function(s) {
        var m = s.match(r);
        if (m == null || m.length === 0) {
          return nothing;
        } else {
          for (var i = 0; i < m.length; i++) {
            m[i] = m[i] == null ? nothing : just(m[i]);
          }
          return just(m);
        }
      };
    };
  };
};
var split2 = function(r) {
  return function(s) {
    return s.split(r);
  };
};

// output-es/Data.String.Regex/index.js
var regex = (s) => (f) => regexImpl(Left)(Right)(s)((() => {
  if (f.global) {
    return "g";
  }
  return "";
})() + ((() => {
  if (f.ignoreCase) {
    return "i";
  }
  return "";
})() + ((() => {
  if (f.multiline) {
    return "m";
  }
  return "";
})() + ((() => {
  if (f.dotAll) {
    return "s";
  }
  return "";
})() + ((() => {
  if (f.sticky) {
    return "y";
  }
  return "";
})() + (() => {
  if (f.unicode) {
    return "u";
  }
  return "";
})())))));
var match = /* @__PURE__ */ _match(Just)(Nothing);

// output-es/Data.String.Regex.Flags/index.js
var unicode = { global: false, ignoreCase: false, multiline: false, dotAll: false, sticky: false, unicode: true };
var global = { global: true, ignoreCase: false, multiline: false, dotAll: false, sticky: false, unicode: false };

// output-es/Data.String.Regex.Unsafe/index.js
var unsafeRegex = (s) => (f) => {
  const $2 = regex(s)(f);
  if ($2.tag === "Left") {
    return _crashWith($2._1);
  }
  if ($2.tag === "Right") {
    return $2._1;
  }
  fail();
};

// output-es/Dodo.Internal/index.js
var $Doc = (tag, _1, _2, _3) => ({ tag, _1, _2, _3 });
var Align = (value0) => (value1) => $Doc("Align", value0, value1);
var Break = /* @__PURE__ */ $Doc("Break");
var Empty = /* @__PURE__ */ $Doc("Empty");
var semigroupDoc = {
  append: (v) => (v1) => {
    if (v.tag === "Empty") {
      return v1;
    }
    if (v1.tag === "Empty") {
      return v;
    }
    if (v.tag === "Text") {
      if (v1.tag === "Text") {
        return $Doc("Text", v._1 + v1._1 | 0, v._2 + v1._2);
      }
      return $Doc("Append", v, v1);
    }
    return $Doc("Append", v, v1);
  }
};
var monoidDoc = { mempty: Empty, Semigroup0: () => semigroupDoc };

// output-es/Dodo.Internal.Buffer/index.js
var modify2 = (f) => (v) => {
  if (v.queue.tag === "Cons") {
    return { buffer: v.buffer, queue: $List("Cons", $List("Cons", f, v.queue._1), v.queue._2) };
  }
  return { buffer: f(v.buffer), queue: v.queue };
};
var commit = (v) => ({ buffer: foldableList.foldr((b) => (a) => foldableList.foldr(apply)(a)(b))(v.buffer)(v.queue), queue: Nil });

// output-es/Dodo/index.js
var $DocCmd = (tag, _1, _2) => ({ tag, _1, _2 });
var $FlexGroupStatus = (tag, _1) => ({ tag, _1 });
var max3 = (x) => (y) => {
  const v = ordInt.compare(x)(y);
  if (v.tag === "LT") {
    return y;
  }
  if (v.tag === "EQ") {
    return x;
  }
  if (v.tag === "GT") {
    return x;
  }
  fail();
};
var max1 = (x) => (y) => {
  const v = ordNumber.compare(x)(y);
  if (v.tag === "LT") {
    return y;
  }
  if (v.tag === "EQ") {
    return x;
  }
  if (v.tag === "GT") {
    return x;
  }
  fail();
};
var min2 = (x) => (y) => {
  const v = ordNumber.compare(x)(y);
  if (v.tag === "LT") {
    return x;
  }
  if (v.tag === "EQ") {
    return x;
  }
  if (v.tag === "GT") {
    return y;
  }
  fail();
};
var power3 = /* @__PURE__ */ power(monoidString);
var NoFlexGroup = /* @__PURE__ */ $FlexGroupStatus("NoFlexGroup");
var FlexGroupPending = /* @__PURE__ */ $FlexGroupStatus("FlexGroupPending");
var text = (v) => {
  if (v === "") {
    return Empty;
  }
  return $Doc("Text", toCodePointArray(v).length, v);
};
var plainText = {
  emptyBuffer: "",
  writeText: (v) => (str) => (buff) => buff + str,
  writeIndent: (v) => (str) => (buff) => buff + str,
  writeBreak: (buff) => buff + "\n",
  enterAnnotation: (v) => (v1) => (buff) => buff,
  leaveAnnotation: (v) => (v1) => (buff) => buff,
  flushBuffer: (buff) => buff
};
var flexGroup = (v) => {
  if (v.tag === "Empty") {
    return Empty;
  }
  if (v.tag === "FlexSelect") {
    if (v._2.tag === "Empty" && v._3.tag === "Empty") {
      return v;
    }
    return $Doc("FlexSelect", v, Empty, Empty);
  }
  return $Doc("FlexSelect", v, Empty, Empty);
};
var calcRibbonWidth = (v) => (n) => max3(0)(unsafeClamp(ceil(v.ribbonRatio * toNumber(v.pageWidth - n | 0))));
var storeOptions = (prevIndent) => (localOptions) => (state) => {
  const newOptions = { indentUnit: localOptions.indentUnit, indentWidth: localOptions.indentWidth, pageWidth: localOptions.pageWidth, ribbonRatio: localOptions.ribbonRatio };
  return {
    position: {
      line: state.position.line,
      column: state.position.column,
      indent: state.position.indent,
      nextIndent: localOptions.indent,
      pageWidth: newOptions.pageWidth,
      ribbonWidth: calcRibbonWidth(newOptions)(prevIndent)
    },
    buffer: state.buffer,
    annotations: state.annotations,
    indentSpaces: localOptions.indentSpaces,
    flexGroup: state.flexGroup,
    options: newOptions
  };
};
var print = (v) => (opts) => {
  const initOptions = { pageWidth: opts.pageWidth, ribbonRatio: max1(0)(min2(1)(opts.ribbonRatio)), indentUnit: opts.indentUnit, indentWidth: opts.indentWidth };
  const go = (go$a0$copy) => (go$a1$copy) => {
    let go$a0 = go$a0$copy, go$a1 = go$a1$copy, go$c = true, go$r;
    while (go$c) {
      const stack = go$a0, state = go$a1;
      if (stack.tag === "Nil") {
        go$c = false;
        go$r = v.flushBuffer(commit(state.buffer).buffer);
        continue;
      }
      if (stack.tag === "Cons") {
        if (stack._1.tag === "Doc") {
          if (stack._1._1.tag === "Append") {
            go$a0 = $List("Cons", $DocCmd("Doc", stack._1._1._1), $List("Cons", $DocCmd("Doc", stack._1._1._2), stack._2));
            go$a1 = state;
            continue;
          }
          if (stack._1._1.tag === "Text") {
            if (state.position.column === 0 && state.position.indent > 0) {
              go$a0 = stack;
              go$a1 = {
                position: {
                  line: state.position.line,
                  column: state.position.indent,
                  indent: state.position.indent,
                  nextIndent: state.position.nextIndent,
                  pageWidth: state.position.pageWidth,
                  ribbonWidth: state.position.ribbonWidth
                },
                buffer: modify2(v.writeIndent(state.position.indent)(state.indentSpaces))(state.buffer),
                annotations: state.annotations,
                indentSpaces: state.indentSpaces,
                flexGroup: state.flexGroup,
                options: state.options
              };
              continue;
            }
            if ((state.position.column + stack._1._1._1 | 0) <= (state.position.indent + state.position.ribbonWidth | 0)) {
              go$a0 = stack._2;
              go$a1 = {
                position: {
                  line: state.position.line,
                  column: state.position.column + stack._1._1._1 | 0,
                  indent: state.position.indent,
                  nextIndent: state.position.nextIndent,
                  pageWidth: state.position.pageWidth,
                  ribbonWidth: state.position.ribbonWidth
                },
                buffer: modify2(v.writeText(stack._1._1._1)(stack._1._1._2))(state.buffer),
                annotations: state.annotations,
                indentSpaces: state.indentSpaces,
                flexGroup: state.flexGroup,
                options: state.options
              };
              continue;
            }
            if (state.flexGroup.tag === "FlexGroupReset") {
              go$a0 = state.flexGroup._1.stack;
              go$a1 = {
                position: state.flexGroup._1.position,
                buffer: state.flexGroup._1.buffer,
                annotations: state.flexGroup._1.annotations,
                indentSpaces: state.flexGroup._1.indentSpaces,
                flexGroup: NoFlexGroup,
                options: state.flexGroup._1.options
              };
              continue;
            }
            go$a0 = stack._2;
            go$a1 = {
              position: {
                line: state.position.line,
                column: state.position.column + stack._1._1._1 | 0,
                indent: state.position.indent,
                nextIndent: state.position.nextIndent,
                pageWidth: state.position.pageWidth,
                ribbonWidth: state.position.ribbonWidth
              },
              buffer: modify2(v.writeText(stack._1._1._1)(stack._1._1._2))(state.buffer),
              annotations: state.annotations,
              indentSpaces: state.indentSpaces,
              flexGroup: NoFlexGroup,
              options: state.options
            };
            continue;
          }
          if (stack._1._1.tag === "Break") {
            if (state.flexGroup.tag === "FlexGroupReset") {
              go$a0 = state.flexGroup._1.stack;
              go$a1 = {
                position: state.flexGroup._1.position,
                buffer: state.flexGroup._1.buffer,
                annotations: state.flexGroup._1.annotations,
                indentSpaces: state.flexGroup._1.indentSpaces,
                flexGroup: NoFlexGroup,
                options: state.flexGroup._1.options
              };
              continue;
            }
            go$a0 = stack._2;
            go$a1 = {
              position: {
                line: state.position.line + 1 | 0,
                column: 0,
                indent: state.position.nextIndent,
                nextIndent: state.position.nextIndent,
                pageWidth: state.position.pageWidth,
                ribbonWidth: calcRibbonWidth(state.options)(state.position.nextIndent)
              },
              buffer: modify2(v.writeBreak)(state.buffer),
              annotations: state.annotations,
              indentSpaces: state.indentSpaces,
              flexGroup: NoFlexGroup,
              options: state.options
            };
            continue;
          }
          if (stack._1._1.tag === "Indent") {
            if (state.position.column === 0) {
              go$a0 = $List(
                "Cons",
                $DocCmd("Doc", stack._1._1._1),
                $List("Cons", $DocCmd("Dedent", state.indentSpaces, state.position.nextIndent), stack._2)
              );
              go$a1 = {
                position: {
                  line: state.position.line,
                  column: state.position.column,
                  indent: state.position.nextIndent + opts.indentWidth | 0,
                  nextIndent: state.position.nextIndent + opts.indentWidth | 0,
                  pageWidth: state.position.pageWidth,
                  ribbonWidth: calcRibbonWidth(state.options)(state.position.nextIndent + opts.indentWidth | 0)
                },
                buffer: state.buffer,
                annotations: state.annotations,
                indentSpaces: state.indentSpaces + opts.indentUnit,
                flexGroup: state.flexGroup,
                options: state.options
              };
              continue;
            }
            go$a0 = $List(
              "Cons",
              $DocCmd("Doc", stack._1._1._1),
              $List("Cons", $DocCmd("Dedent", state.indentSpaces, state.position.nextIndent), stack._2)
            );
            go$a1 = {
              position: {
                line: state.position.line,
                column: state.position.column,
                indent: state.position.indent,
                nextIndent: state.position.nextIndent + opts.indentWidth | 0,
                pageWidth: state.position.pageWidth,
                ribbonWidth: state.position.ribbonWidth
              },
              buffer: state.buffer,
              annotations: state.annotations,
              indentSpaces: state.indentSpaces + opts.indentUnit,
              flexGroup: state.flexGroup,
              options: state.options
            };
            continue;
          }
          if (stack._1._1.tag === "Align") {
            if (state.position.column === 0) {
              go$a0 = $List(
                "Cons",
                $DocCmd("Doc", stack._1._1._2),
                $List("Cons", $DocCmd("Dedent", state.indentSpaces, state.position.nextIndent), stack._2)
              );
              go$a1 = {
                position: {
                  line: state.position.line,
                  column: state.position.column,
                  indent: state.position.nextIndent + stack._1._1._1 | 0,
                  nextIndent: state.position.nextIndent + stack._1._1._1 | 0,
                  pageWidth: state.position.pageWidth,
                  ribbonWidth: calcRibbonWidth(state.options)(state.position.nextIndent + stack._1._1._1 | 0)
                },
                buffer: state.buffer,
                annotations: state.annotations,
                indentSpaces: state.indentSpaces + power3(" ")(stack._1._1._1),
                flexGroup: state.flexGroup,
                options: state.options
              };
              continue;
            }
            go$a0 = $List(
              "Cons",
              $DocCmd("Doc", stack._1._1._2),
              $List("Cons", $DocCmd("Dedent", state.indentSpaces, state.position.nextIndent), stack._2)
            );
            go$a1 = {
              position: {
                line: state.position.line,
                column: state.position.column,
                indent: state.position.indent,
                nextIndent: state.position.nextIndent + stack._1._1._1 | 0,
                pageWidth: state.position.pageWidth,
                ribbonWidth: state.position.ribbonWidth
              },
              buffer: state.buffer,
              annotations: state.annotations,
              indentSpaces: state.indentSpaces + power3(" ")(stack._1._1._1),
              flexGroup: state.flexGroup,
              options: state.options
            };
            continue;
          }
          if (stack._1._1.tag === "FlexSelect") {
            if (state.flexGroup.tag === "NoFlexGroup") {
              go$a0 = $List(
                "Cons",
                $DocCmd("Doc", stack._1._1._1),
                $List("Cons", $DocCmd("LeaveFlexGroup", stack._1._1._2, stack._1._1._3), stack._2)
              );
              go$a1 = {
                position: state.position,
                buffer: state.buffer,
                annotations: state.annotations,
                indentSpaces: state.indentSpaces,
                flexGroup: FlexGroupPending,
                options: state.options
              };
              continue;
            }
            if (state.flexGroup.tag === "FlexGroupPending") {
              if (state.position.ribbonWidth > 0) {
                go$a0 = $List("Cons", $DocCmd("Doc", stack._1._1._1), $List("Cons", $DocCmd("Doc", stack._1._1._2), stack._2));
                go$a1 = {
                  position: state.position,
                  buffer: { buffer: state.buffer.buffer, queue: $List("Cons", Nil, state.buffer.queue) },
                  annotations: state.annotations,
                  indentSpaces: state.indentSpaces,
                  flexGroup: $FlexGroupStatus(
                    "FlexGroupReset",
                    { position: state.position, buffer: state.buffer, annotations: state.annotations, indentSpaces: state.indentSpaces, stack, options: state.options }
                  ),
                  options: state.options
                };
                continue;
              }
              go$a0 = $List("Cons", $DocCmd("Doc", stack._1._1._1), $List("Cons", $DocCmd("Doc", stack._1._1._2), stack._2));
              go$a1 = state;
              continue;
            }
            go$a0 = $List("Cons", $DocCmd("Doc", stack._1._1._1), $List("Cons", $DocCmd("Doc", stack._1._1._2), stack._2));
            go$a1 = state;
            continue;
          }
          if (stack._1._1.tag === "FlexAlt") {
            if (state.flexGroup.tag === "FlexGroupReset") {
              go$a0 = $List("Cons", $DocCmd("Doc", stack._1._1._1), stack._2);
              go$a1 = state;
              continue;
            }
            if (state.flexGroup.tag === "FlexGroupPending") {
              if (state.position.ribbonWidth > 0) {
                go$a0 = $List("Cons", $DocCmd("Doc", stack._1._1._1), stack._2);
                go$a1 = {
                  position: state.position,
                  buffer: { buffer: state.buffer.buffer, queue: $List("Cons", Nil, state.buffer.queue) },
                  annotations: state.annotations,
                  indentSpaces: state.indentSpaces,
                  flexGroup: $FlexGroupStatus(
                    "FlexGroupReset",
                    {
                      position: state.position,
                      buffer: state.buffer,
                      annotations: state.annotations,
                      indentSpaces: state.indentSpaces,
                      stack: $List("Cons", $DocCmd("Doc", stack._1._1._2), stack._2),
                      options: state.options
                    }
                  ),
                  options: state.options
                };
                continue;
              }
              go$a0 = $List("Cons", $DocCmd("Doc", stack._1._1._2), stack._2);
              go$a1 = state;
              continue;
            }
            go$a0 = $List("Cons", $DocCmd("Doc", stack._1._1._2), stack._2);
            go$a1 = state;
            continue;
          }
          if (stack._1._1.tag === "WithPosition") {
            if (state.position.column === 0 && state.position.nextIndent > 0) {
              go$a0 = $List(
                "Cons",
                $DocCmd(
                  "Doc",
                  stack._1._1._1({
                    line: state.position.line,
                    column: state.position.nextIndent,
                    indent: state.position.indent,
                    nextIndent: state.position.nextIndent,
                    pageWidth: state.position.pageWidth,
                    ribbonWidth: state.position.ribbonWidth
                  })
                ),
                stack._2
              );
              go$a1 = state;
              continue;
            }
            go$a0 = $List("Cons", $DocCmd("Doc", stack._1._1._1(state.position)), stack._2);
            go$a1 = state;
            continue;
          }
          if (stack._1._1.tag === "Annotate") {
            go$a0 = $List(
              "Cons",
              $DocCmd("Doc", stack._1._1._2),
              $List("Cons", $DocCmd("LeaveAnnotation", stack._1._1._1, state.annotations), stack._2)
            );
            go$a1 = {
              position: state.position,
              buffer: modify2(v.enterAnnotation(stack._1._1._1)(state.annotations))(state.buffer),
              annotations: $List("Cons", stack._1._1._1, state.annotations),
              indentSpaces: state.indentSpaces,
              flexGroup: state.flexGroup,
              options: state.options
            };
            continue;
          }
          if (stack._1._1.tag === "Local") {
            const prevOptions = {
              indent: state.position.indent,
              indentSpaces: state.indentSpaces,
              indentUnit: state.options.indentUnit,
              indentWidth: state.options.indentWidth,
              pageWidth: state.options.pageWidth,
              ribbonRatio: state.options.ribbonRatio
            };
            const v1 = stack._1._1._1(prevOptions);
            go$a0 = $List("Cons", $DocCmd("Doc", v1._2), $List("Cons", $DocCmd("LeaveLocal", prevOptions), stack._2));
            go$a1 = storeOptions(state.position.indent)(v1._1)(state);
            continue;
          }
          if (stack._1._1.tag === "Empty") {
            go$a0 = stack._2;
            go$a1 = state;
            continue;
          }
          fail();
        }
        if (stack._1.tag === "LeaveFlexGroup") {
          if (state.flexGroup.tag === "NoFlexGroup") {
            go$a0 = $List("Cons", $DocCmd("Doc", stack._1._2), stack._2);
            go$a1 = {
              position: state.position,
              buffer: commit(state.buffer),
              annotations: state.annotations,
              indentSpaces: state.indentSpaces,
              flexGroup: state.flexGroup,
              options: state.options
            };
            continue;
          }
          go$a0 = $List("Cons", $DocCmd("Doc", stack._1._1), stack._2);
          go$a1 = {
            position: state.position,
            buffer: commit(state.buffer),
            annotations: state.annotations,
            indentSpaces: state.indentSpaces,
            flexGroup: NoFlexGroup,
            options: state.options
          };
          continue;
        }
        if (stack._1.tag === "Dedent") {
          go$a0 = stack._2;
          go$a1 = {
            position: {
              line: state.position.line,
              column: state.position.column,
              indent: state.position.indent,
              nextIndent: stack._1._2,
              pageWidth: state.position.pageWidth,
              ribbonWidth: state.position.ribbonWidth
            },
            buffer: state.buffer,
            annotations: state.annotations,
            indentSpaces: stack._1._1,
            flexGroup: state.flexGroup,
            options: state.options
          };
          continue;
        }
        if (stack._1.tag === "LeaveAnnotation") {
          go$a0 = stack._2;
          go$a1 = {
            position: state.position,
            buffer: modify2(v.leaveAnnotation(stack._1._1)(stack._1._2))(state.buffer),
            annotations: stack._1._2,
            indentSpaces: state.indentSpaces,
            flexGroup: state.flexGroup,
            options: state.options
          };
          continue;
        }
        if (stack._1.tag === "LeaveLocal") {
          go$a0 = stack._2;
          go$a1 = storeOptions(state.position.indent)(stack._1._1)(state);
          continue;
        }
        fail();
      }
      fail();
    }
    ;
    return go$r;
  };
  const $4 = {
    position: { line: 0, column: 0, indent: 0, nextIndent: 0, pageWidth: initOptions.pageWidth, ribbonWidth: calcRibbonWidth(initOptions)(0) },
    buffer: { buffer: v.emptyBuffer, queue: Nil },
    annotations: Nil,
    indentSpaces: "",
    flexGroup: NoFlexGroup,
    options: initOptions
  };
  return (x) => go($List("Cons", $DocCmd("Doc", x), Nil))($4);
};
var appendBreak = (v) => (v1) => {
  if (v.tag === "Empty") {
    return v1;
  }
  if (v1.tag === "Empty") {
    return v;
  }
  return semigroupDoc.append(v)(semigroupDoc.append(Break)(v1));
};
var align = (n) => (doc) => {
  if (n > 0) {
    const $2 = Align(n);
    if (doc.tag === "Empty") {
      return Empty;
    }
    return $2(doc);
  }
  return doc;
};

// output-es/PureScript.CST.Types/index.js
var $Binder = (tag, _1, _2, _3) => ({ tag, _1, _2, _3 });
var $ClassFundep = (tag, _1, _2, _3) => ({ tag, _1, _2, _3 });
var $Comment = (tag, _1, _2) => ({ tag, _1, _2 });
var $DataMembers = (tag, _1) => ({ tag, _1 });
var $Declaration = (tag, _1, _2, _3, _4) => ({ tag, _1, _2, _3, _4 });
var $DoStatement = (tag, _1, _2, _3) => ({ tag, _1, _2, _3 });
var $Export = (tag, _1, _2) => ({ tag, _1, _2 });
var $Expr = (tag, _1, _2, _3) => ({ tag, _1, _2, _3 });
var $Fixity = (tag) => ({ tag });
var $FixityOp = (tag, _1, _2, _3, _4) => ({ tag, _1, _2, _3, _4 });
var $Foreign = (tag, _1, _2) => ({ tag, _1, _2 });
var $Guarded = (tag, _1, _2) => ({ tag, _1, _2 });
var $Import = (tag, _1, _2) => ({ tag, _1, _2 });
var $InstanceBinding = (tag, _1) => ({ tag, _1 });
var $IntValue = (tag, _1) => ({ tag, _1 });
var $LetBinding = (tag, _1, _2, _3) => ({ tag, _1, _2, _3 });
var $LineFeed = (tag) => ({ tag });
var $OneOrDelimited = (tag, _1) => ({ tag, _1 });
var $RecordLabeled = (tag, _1, _2, _3) => ({ tag, _1, _2, _3 });
var $RecordUpdate = (tag, _1, _2, _3) => ({ tag, _1, _2, _3 });
var $Role = (tag) => ({ tag });
var $SourceStyle = (tag) => ({ tag });
var $Token = (tag, _1, _2) => ({ tag, _1, _2 });
var $Type = (tag, _1, _2, _3, _4) => ({ tag, _1, _2, _3, _4 });
var $TypeVarBinding = (tag, _1) => ({ tag, _1 });
var ASCII = /* @__PURE__ */ $SourceStyle("ASCII");
var Unicode = /* @__PURE__ */ $SourceStyle("Unicode");
var Nominal = /* @__PURE__ */ $Role("Nominal");
var Representational = /* @__PURE__ */ $Role("Representational");
var Phantom = /* @__PURE__ */ $Role("Phantom");
var LF = /* @__PURE__ */ $LineFeed("LF");
var CRLF = /* @__PURE__ */ $LineFeed("CRLF");
var TokLeftParen = /* @__PURE__ */ $Token("TokLeftParen");
var TokRightParen = /* @__PURE__ */ $Token("TokRightParen");
var TokLeftBrace = /* @__PURE__ */ $Token("TokLeftBrace");
var TokRightBrace = /* @__PURE__ */ $Token("TokRightBrace");
var TokLeftSquare = /* @__PURE__ */ $Token("TokLeftSquare");
var TokRightSquare = /* @__PURE__ */ $Token("TokRightSquare");
var TokEquals = /* @__PURE__ */ $Token("TokEquals");
var TokPipe = /* @__PURE__ */ $Token("TokPipe");
var TokTick = /* @__PURE__ */ $Token("TokTick");
var TokDot = /* @__PURE__ */ $Token("TokDot");
var TokComma = /* @__PURE__ */ $Token("TokComma");
var TokUnderscore = /* @__PURE__ */ $Token("TokUnderscore");
var TokBackslash = /* @__PURE__ */ $Token("TokBackslash");
var TokAt = /* @__PURE__ */ $Token("TokAt");
var Infix = /* @__PURE__ */ $Fixity("Infix");
var Infixl = /* @__PURE__ */ $Fixity("Infixl");
var Infixr = /* @__PURE__ */ $Fixity("Infixr");
var Comment = (value0) => $Comment("Comment", value0);
var Space = (value0) => $Comment("Space", value0);
var Line = (value0) => (value1) => $Comment("Line", value0, value1);
var FixityValue = (value0) => (value1) => (value2) => $FixityOp("FixityValue", value0, value1, value2);
var FixityType = (value0) => (value1) => (value2) => (value3) => $FixityOp("FixityType", value0, value1, value2, value3);
var RecordField = (value0) => (value1) => (value2) => $RecordLabeled("RecordField", value0, value1, value2);
var ExportType = (value0) => (value1) => $Export("ExportType", value0, value1);
var ExportTypeOp = (value0) => (value1) => $Export("ExportTypeOp", value0, value1);
var ExportClass = (value0) => (value1) => $Export("ExportClass", value0, value1);
var ExportModule = (value0) => (value1) => $Export("ExportModule", value0, value1);
var ImportType = (value0) => (value1) => $Import("ImportType", value0, value1);
var ImportTypeOp = (value0) => (value1) => $Import("ImportTypeOp", value0, value1);
var ImportClass = (value0) => (value1) => $Import("ImportClass", value0, value1);
var TypeInt = (value0) => (value1) => (value2) => $Type("TypeInt", value0, value1, value2);
var TypeForall = (value0) => (value1) => (value2) => (value3) => $Type("TypeForall", value0, value1, value2, value3);
var TypeKinded = (value0) => (value1) => (value2) => $Type("TypeKinded", value0, value1, value2);
var TypeArrow = (value0) => (value1) => (value2) => $Type("TypeArrow", value0, value1, value2);
var TypeConstrained = (value0) => (value1) => (value2) => $Type("TypeConstrained", value0, value1, value2);
var ForeignKind = (value0) => (value1) => $Foreign("ForeignKind", value0, value1);
var FundepDetermined = (value0) => (value1) => $ClassFundep("FundepDetermined", value0, value1);
var FundepDetermines = (value0) => (value1) => (value2) => $ClassFundep("FundepDetermines", value0, value1, value2);
var BinderNamed = (value0) => (value1) => (value2) => $Binder("BinderNamed", value0, value1, value2);
var BinderInt = (value0) => (value1) => (value2) => $Binder("BinderInt", value0, value1, value2);
var BinderNumber = (value0) => (value1) => (value2) => $Binder("BinderNumber", value0, value1, value2);
var BinderTyped = (value0) => (value1) => (value2) => $Binder("BinderTyped", value0, value1, value2);
var DoLet = (value0) => (value1) => $DoStatement("DoLet", value0, value1);
var DoBind = (value0) => (value1) => (value2) => $DoStatement("DoBind", value0, value1, value2);
var DoError = (value0) => $DoStatement("DoError", value0);
var LetBindingPattern = (value0) => (value1) => (value2) => $LetBinding("LetBindingPattern", value0, value1, value2);
var LetBindingError = (value0) => $LetBinding("LetBindingError", value0);
var Unconditional = (value0) => (value1) => $Guarded("Unconditional", value0, value1);
var ExprTyped = (value0) => (value1) => (value2) => $Expr("ExprTyped", value0, value1, value2);
var ExprNegate = (value0) => (value1) => $Expr("ExprNegate", value0, value1);
var RecordUpdateLeaf = (value0) => (value1) => (value2) => $RecordUpdate("RecordUpdateLeaf", value0, value1, value2);
var RecordUpdateBranch = (value0) => (value1) => $RecordUpdate("RecordUpdateBranch", value0, value1);
var DeclError = (value0) => $Declaration("DeclError", value0);

// output-es/Tidy.Util/index.js
var splitStringEscapeLines = /* @__PURE__ */ split2(/* @__PURE__ */ unsafeRegex("\\\\ *\\r?\\n\\s*\\\\")(global));
var splitLines = /* @__PURE__ */ split2(/* @__PURE__ */ unsafeRegex("\\r?\\n")(global));

// output-es/Tidy.Doc/index.js
var $ForceBreak = (tag) => ({ tag });
var guard3 = /* @__PURE__ */ guard(alternativeMaybe);
var power4 = /* @__PURE__ */ power(monoidString);
var lines = /* @__PURE__ */ foldrArray(appendBreak)(Empty);
var intercalate3 = (sep2) => (xs) => foldlArray((v) => (x) => {
  if (v.init) {
    return { init: false, acc: x };
  }
  return { init: false, acc: semigroupDoc.append(v.acc)(semigroupDoc.append(sep2)(x)) };
})({ init: true, acc: Empty })(xs).acc;
var max4 = (x) => (y) => {
  const v = ordInt.compare(x)(y);
  if (v.tag === "LT") {
    return y;
  }
  if (v.tag === "EQ") {
    return x;
  }
  if (v.tag === "GT") {
    return x;
  }
  fail();
};
var min3 = (x) => (y) => {
  const v = ordInt.compare(x)(y);
  if (v.tag === "LT") {
    return x;
  }
  if (v.tag === "EQ") {
    return x;
  }
  if (v.tag === "GT") {
    return y;
  }
  fail();
};
var identity12 = (x) => x;
var ForceNone = /* @__PURE__ */ $ForceBreak("ForceNone");
var ForceSpace = /* @__PURE__ */ $ForceBreak("ForceSpace");
var ForceBreak = /* @__PURE__ */ $ForceBreak("ForceBreak");
var locally = (k) => (v) => ({ doc: $Doc("Local", (options) => $Tuple(k(options), v.doc)), isEmpty: v.isEmpty, leading: v.leading, multiline: v.multiline, trailing: v.trailing });
var indent = (v) => {
  if (v.isEmpty) {
    return v;
  }
  return {
    doc: (() => {
      if (v.doc.tag === "Empty") {
        return Empty;
      }
      return $Doc("Indent", v.doc);
    })(),
    isEmpty: v.isEmpty,
    leading: {
      doc: (() => {
        if (v.leading.doc.tag === "Empty") {
          return Empty;
        }
        return $Doc("Indent", v.leading.doc);
      })(),
      left: v.leading.left,
      lines: v.leading.lines,
      multiline: v.leading.multiline,
      right: v.leading.right
    },
    multiline: v.multiline,
    trailing: {
      doc: (() => {
        if (v.trailing.doc.tag === "Empty") {
          return Empty;
        }
        return $Doc("Indent", v.trailing.doc);
      })(),
      left: v.trailing.left,
      multiline: v.trailing.multiline,
      right: v.trailing.right
    }
  };
};
var formatBlockComment = (x) => {
  const $1 = uncons(splitLines(x));
  if ($1.tag === "Nothing") {
    return $Tuple(false, Empty);
  }
  if ($1.tag === "Just") {
    const prefixSpaces = index(sortBy(ordInt.compare)(mapMaybe((str) => {
      const spaces = length2(take2(countPrefix2((y) => 32 === y)(str))(str));
      if (guard3(spaces < length2(str)).tag === "Just") {
        return $Maybe("Just", spaces);
      }
      return Nothing;
    })($1._1.tail)))(0);
    if (prefixSpaces.tag === "Nothing") {
      return $Tuple(
        false,
        (() => {
          if ($1._1.head === "") {
            return Empty;
          }
          return $Doc("Text", toCodePointArray($1._1.head).length, $1._1.head);
        })()
      );
    }
    if (prefixSpaces.tag === "Just") {
      return $Tuple(
        true,
        $Doc(
          "WithPosition",
          (pos) => {
            const newIndent = (() => {
              if (prefixSpaces._1 < pos.indent) {
                return 0;
              }
              return prefixSpaces._1;
            })();
            const spaces = power4(" ")(newIndent);
            return lines([
              (() => {
                if ($1._1.head === "") {
                  return Empty;
                }
                return $Doc("Text", toCodePointArray($1._1.head).length, $1._1.head);
              })(),
              (() => {
                const $6 = intercalate3(Break)(arrayMap((str) => {
                  const $7 = stripPrefix(spaces)(str);
                  const $8 = (() => {
                    if ($7.tag === "Nothing") {
                      return str;
                    }
                    if ($7.tag === "Just") {
                      return $7._1;
                    }
                    fail();
                  })();
                  if ($8 === "") {
                    return Empty;
                  }
                  return $Doc("Text", toCodePointArray($8).length, $8);
                })($1._1.tail));
                return $Doc(
                  "Local",
                  (options) => $Tuple(
                    (() => {
                      if (newIndent < options.indent) {
                        return {
                          indent: newIndent,
                          indentSpaces: spaces,
                          indentUnit: options.indentUnit,
                          indentWidth: options.indentWidth,
                          pageWidth: options.pageWidth,
                          ribbonRatio: options.ribbonRatio
                        };
                      }
                      return options;
                    })(),
                    $6
                  )
                );
              })()
            ]);
          }
        )
      );
    }
    fail();
  }
  fail();
};
var forceMinSourceBreaks = (n) => (v) => {
  if (v.isEmpty) {
    return v;
  }
  return {
    doc: v.doc,
    isEmpty: v.isEmpty,
    leading: { doc: v.leading.doc, left: v.leading.left, lines: max4(v.leading.lines)(n), multiline: v.leading.multiline, right: v.leading.right },
    multiline: v.multiline,
    trailing: v.trailing
  };
};
var force2 = (k) => (f) => (m) => (doc) => {
  if (f.tag === "ForceBreak") {
    return $Tuple(true, semigroupDoc.append(Break)(doc));
  }
  return $Tuple(m, k(doc));
};
var flexGroup2 = (v) => {
  if (v.multiline) {
    return v;
  }
  return { doc: flexGroup(v.doc), isEmpty: v.isEmpty, leading: v.leading, multiline: v.multiline, trailing: v.trailing };
};
var flattenMax = (n) => (v) => ({
  doc: v.doc,
  isEmpty: v.isEmpty,
  leading: { doc: v.leading.doc, left: v.leading.left, lines: min3(v.leading.lines)(n), multiline: v.leading.multiline, right: v.leading.right },
  multiline: v.multiline,
  trailing: v.trailing
});
var eqForceBreak = {
  eq: (x) => (y) => {
    if (x.tag === "ForceNone") {
      return y.tag === "ForceNone";
    }
    if (x.tag === "ForceSpace") {
      return y.tag === "ForceSpace";
    }
    if (x.tag === "ForceBreak") {
      return y.tag === "ForceBreak";
    }
    return false;
  }
};
var ordForceBreak = {
  compare: (x) => (y) => {
    if (x.tag === "ForceNone") {
      if (y.tag === "ForceNone") {
        return EQ;
      }
      return LT;
    }
    if (y.tag === "ForceNone") {
      return GT;
    }
    if (x.tag === "ForceSpace") {
      if (y.tag === "ForceSpace") {
        return EQ;
      }
      return LT;
    }
    if (y.tag === "ForceSpace") {
      return GT;
    }
    if (x.tag === "ForceBreak") {
      if (y.tag === "ForceBreak") {
        return EQ;
      }
      fail();
    }
    fail();
  },
  Eq0: () => eqForceBreak
};
var max12 = (x) => (y) => {
  const v = ordForceBreak.compare(x)(y);
  if (v.tag === "LT") {
    return y;
  }
  if (v.tag === "EQ") {
    return x;
  }
  if (v.tag === "GT") {
    return x;
  }
  fail();
};
var breaks = (fl) => (n) => {
  if (n >= 2) {
    return semigroupDoc.append(Break)(Break);
  }
  if (n === 1) {
    return Break;
  }
  if (fl.tag === "ForceBreak") {
    return Break;
  }
  if (fl.tag === "ForceSpace") {
    return $Doc("Text", 1, " ");
  }
  if (fl.tag === "ForceNone") {
    return Empty;
  }
  fail();
};
var breakDoc = (br) => (doc) => {
  if (doc.tag === "Empty") {
    return doc;
  }
  if (br.tag === "ForceBreak") {
    return semigroupDoc.append(Break)(doc);
  }
  if (br.tag === "ForceSpace") {
    return semigroupDoc.append($Doc("Text", 1, " "))(doc);
  }
  if (br.tag === "ForceNone") {
    return doc;
  }
  fail();
};
var flexDoubleBreak = (v) => (v1) => {
  if (v.isEmpty) {
    return v1;
  }
  if (v1.isEmpty) {
    return v;
  }
  const docLeft = semigroupDoc.append(v.doc)(breakDoc(v.trailing.left)(v.trailing.doc));
  const docRight = semigroupDoc.append(v1.leading.doc)(breakDoc(v1.leading.right)(v1.doc));
  if (v1.leading.lines >= 2 || v.multiline) {
    return {
      doc: semigroupDoc.append(docLeft)(semigroupDoc.append(Break)(semigroupDoc.append(Break)(docRight))),
      isEmpty: v.isEmpty,
      leading: v.leading,
      multiline: true,
      trailing: v1.trailing
    };
  }
  return {
    doc: semigroupDoc.append((() => {
      if (docLeft.tag === "Empty") {
        return Empty;
      }
      return $Doc("FlexSelect", docLeft, Empty, Break);
    })())(semigroupDoc.append(Break)(docRight)),
    isEmpty: v.isEmpty,
    leading: v.leading,
    multiline: true,
    trailing: v1.trailing
  };
};
var joinDoc = (spaceFn) => (v) => (v1) => {
  if (v.isEmpty) {
    return v1;
  }
  if (v1.isEmpty) {
    return v;
  }
  const docLeft = semigroupDoc.append(v.doc)(breakDoc(v.trailing.left)(v.trailing.doc));
  const docRight = semigroupDoc.append(v1.leading.doc)(breakDoc(v1.leading.right)(v1.doc));
  if (v1.leading.lines > 0) {
    return {
      doc: semigroupDoc.append(docLeft)(semigroupDoc.append(breaks(ForceBreak)(v1.leading.lines))(docRight)),
      isEmpty: v.isEmpty,
      leading: v.leading,
      multiline: true,
      trailing: v1.trailing
    };
  }
  const v2 = spaceFn(max12(v.trailing.right)(v1.leading.left))(v1.leading.multiline || v1.multiline)(docRight);
  return {
    doc: semigroupDoc.append(docLeft)(v2._2),
    isEmpty: v.isEmpty,
    leading: v.leading,
    multiline: v.trailing.multiline || (v.multiline || v2._1),
    trailing: v1.trailing
  };
};
var flexSoftBreak = /* @__PURE__ */ joinDoc((f) => (m) => (doc) => {
  if (f.tag === "ForceBreak") {
    return $Tuple(true, semigroupDoc.append(Break)(doc));
  }
  if (f.tag === "ForceSpace") {
    if (m) {
      return $Tuple(true, semigroupDoc.append($Doc("Text", 1, " "))(doc));
    }
    return $Tuple(
      false,
      flexGroup(semigroupDoc.append($Doc("FlexAlt", $Doc("Text", 1, " "), Break))(doc))
    );
  }
  if (f.tag === "ForceNone") {
    if (m) {
      return $Tuple(true, semigroupDoc.append(Break)(doc));
    }
    return $Tuple(false, flexGroup(semigroupDoc.append($Doc("FlexAlt", Empty, Break))(doc)));
  }
  fail();
});
var flexSpaceBreak = /* @__PURE__ */ joinDoc((f) => (m) => (doc) => {
  if (f.tag === "ForceBreak") {
    return $Tuple(true, semigroupDoc.append(Break)(doc));
  }
  if (m) {
    return $Tuple(true, semigroupDoc.append($Doc("FlexAlt", $Doc("Text", 1, " "), Break))(doc));
  }
  return $Tuple(
    false,
    flexGroup(semigroupDoc.append($Doc("FlexAlt", $Doc("Text", 1, " "), Break))(doc))
  );
});
var semigroupFormatDoc = { append: /* @__PURE__ */ joinDoc(/* @__PURE__ */ force2(identity12)) };
var softBreak = /* @__PURE__ */ joinDoc((f) => (m) => (doc) => {
  if (f.tag === "ForceBreak") {
    return $Tuple(true, semigroupDoc.append(Break)(doc));
  }
  if (f.tag === "ForceSpace") {
    return $Tuple(m, semigroupDoc.append($Doc("FlexAlt", $Doc("Text", 1, " "), Break))(doc));
  }
  if (f.tag === "ForceNone") {
    return $Tuple(m, semigroupDoc.append($Doc("FlexAlt", Empty, Break))(doc));
  }
  fail();
});
var softSpace = /* @__PURE__ */ joinDoc((f) => (m) => (doc) => {
  if (f.tag === "ForceBreak") {
    return $Tuple(true, semigroupDoc.append(Break)(doc));
  }
  if (f.tag === "ForceSpace") {
    return $Tuple(m, semigroupDoc.append($Doc("Text", 1, " "))(doc));
  }
  if (f.tag === "ForceNone") {
    return $Tuple(m, semigroupDoc.append($Doc("FlexAlt", Empty, $Doc("Text", 1, " ")))(doc));
  }
  fail();
});
var toDoc = (v) => {
  if (v.isEmpty) {
    return Empty;
  }
  return semigroupDoc.append(v.leading.doc)(semigroupDoc.append(breakDoc(v.leading.right)(v.doc))(breakDoc(v.trailing.left)(v.trailing.doc)));
};
var semigroupLeadingComment = {
  append: (v) => (v1) => {
    if (v.doc.tag === "Empty") {
      return { doc: v1.doc, left: max12(v.left)(v1.left), lines: v.lines + v1.lines | 0, multiline: v1.multiline, right: v1.right };
    }
    if (v1.doc.tag === "Empty") {
      return {
        doc: semigroupDoc.append(v.doc)(breaks(ForceNone)(v1.lines)),
        left: v.left,
        lines: v.lines,
        multiline: v.multiline || v1.lines > 0,
        right: (() => {
          if (v1.lines > 0) {
            return ForceNone;
          }
          return max12(v.right)(v1.right);
        })()
      };
    }
    const br = max12(v.right)(v1.left);
    if (v1.lines > 0 || br.tag === "ForceBreak") {
      return {
        doc: semigroupDoc.append(v.doc)(semigroupDoc.append(breaks(ForceBreak)(v1.lines))(v1.doc)),
        left: v.left,
        lines: v.lines,
        multiline: true,
        right: v1.right
      };
    }
    return { doc: semigroupDoc.append(v.doc)(breakDoc(br)(v1.doc)), left: v.left, lines: v.lines, multiline: v.multiline || v1.multiline, right: v1.right };
  }
};
var leadingBlockComment = (str) => (v) => {
  const v1 = formatBlockComment(str);
  return {
    doc: v.doc,
    isEmpty: false,
    leading: semigroupLeadingComment.append({ doc: v1._2, left: ForceSpace, lines: 0, multiline: v1._1, right: ForceSpace })(v.leading),
    multiline: v.multiline,
    trailing: v.trailing
  };
};
var leadingLineComment = (str) => (v) => ({
  doc: v.doc,
  isEmpty: false,
  leading: semigroupLeadingComment.append({
    doc: (() => {
      if (str === "") {
        return Empty;
      }
      return $Doc("Text", toCodePointArray(str).length, str);
    })(),
    left: ForceBreak,
    lines: 0,
    multiline: false,
    right: ForceBreak
  })(v.leading),
  multiline: v.multiline,
  trailing: v.trailing
});
var monoidLeadingComment = { mempty: { doc: Empty, left: ForceNone, lines: 0, multiline: false, right: ForceNone }, Semigroup0: () => semigroupLeadingComment };
var semigroupTrailingComment = {
  append: (v) => (v1) => {
    if (v.doc.tag === "Empty") {
      return { doc: v1.doc, left: max12(v.left)(v1.left), multiline: v1.multiline, right: v1.right };
    }
    if (v1.doc.tag === "Empty") {
      return { doc: v.doc, left: v.left, multiline: v.multiline, right: max12(v.right)(v1.right) };
    }
    return { doc: semigroupDoc.append(v.doc)(breakDoc(max12(v.right)(v1.left))(v1.doc)), left: v.left, multiline: v.multiline || v1.multiline, right: v1.right };
  }
};
var trailingBlockComment = (str) => (v) => {
  const v1 = formatBlockComment(str);
  return {
    doc: v.doc,
    isEmpty: false,
    leading: v.leading,
    multiline: v.multiline,
    trailing: semigroupTrailingComment.append({ doc: v1._2, left: ForceSpace, multiline: v1._1, right: ForceSpace })(v.trailing)
  };
};
var trailingLineComment = (str) => (v) => ({
  doc: v.doc,
  isEmpty: false,
  leading: v.leading,
  multiline: v.multiline,
  trailing: semigroupTrailingComment.append({
    doc: (() => {
      if (str === "") {
        return Empty;
      }
      return $Doc("Text", toCodePointArray(str).length, str);
    })(),
    left: ForceSpace,
    multiline: false,
    right: ForceBreak
  })(v.trailing)
});
var monoidTrailingComment = { mempty: { doc: Empty, left: ForceNone, multiline: false, right: ForceNone }, Semigroup0: () => semigroupTrailingComment };
var monoidFormatDoc = /* @__PURE__ */ (() => ({
  mempty: { doc: Empty, leading: monoidLeadingComment.mempty, isEmpty: true, multiline: false, trailing: monoidTrailingComment.mempty },
  Semigroup0: () => semigroupFormatDoc
}))();
var text2 = (x) => {
  const $1 = (() => {
    if (x === "") {
      return Empty;
    }
    return $Doc("Text", toCodePointArray(x).length, x);
  })();
  if ($1.tag === "Empty") {
    return monoidFormatDoc.mempty;
  }
  return { doc: $1, leading: monoidLeadingComment.mempty, isEmpty: false, multiline: false, trailing: monoidTrailingComment.mempty };
};
var joinWithMap = (dictFoldable) => (op) => (k) => dictFoldable.foldl((a) => (b) => {
  if (a.isEmpty) {
    return k(b);
  }
  return op(a)(k(b));
})(monoidFormatDoc.mempty);
var anchor = (v) => {
  if (v.leading.lines > 0) {
    return {
      doc: v.doc,
      isEmpty: v.isEmpty,
      leading: { doc: v.leading.doc, left: v.leading.left, lines: 0, multiline: v.leading.multiline, right: v.leading.right },
      multiline: true,
      trailing: v.trailing
    };
  }
  return v;
};
var alignCurrentColumn = (v) => {
  if (v.isEmpty) {
    return v;
  }
  return {
    doc: (() => {
      if (v.doc.tag === "Empty") {
        return Empty;
      }
      return $Doc("WithPosition", (pos) => align(pos.column - pos.nextIndent | 0)(v.doc));
    })(),
    isEmpty: v.isEmpty,
    leading: {
      doc: (() => {
        if (v.leading.doc.tag === "Empty") {
          return Empty;
        }
        return $Doc("WithPosition", (pos) => align(pos.column - pos.nextIndent | 0)(v.leading.doc));
      })(),
      left: v.leading.left,
      lines: v.leading.lines,
      multiline: v.leading.multiline,
      right: v.leading.right
    },
    multiline: v.multiline,
    trailing: {
      doc: (() => {
        if (v.trailing.doc.tag === "Empty") {
          return Empty;
        }
        return $Doc("WithPosition", (pos) => align(pos.column - pos.nextIndent | 0)(v.trailing.doc));
      })(),
      left: v.trailing.left,
      multiline: v.trailing.multiline,
      right: v.trailing.right
    }
  };
};
var align2 = (x) => (v) => {
  if (v.isEmpty) {
    return v;
  }
  return {
    doc: align(x)(v.doc),
    isEmpty: v.isEmpty,
    leading: { doc: align(x)(v.leading.doc), left: v.leading.left, lines: v.leading.lines, multiline: v.leading.multiline, right: v.leading.right },
    multiline: v.multiline,
    trailing: { doc: align(x)(v.trailing.doc), left: v.trailing.left, multiline: v.trailing.multiline, right: v.trailing.right }
  };
};

// output-es/Tidy.Hang/index.js
var $HangingDoc = (tag, _1, _2, _3) => ({ tag, _1, _2, _3 });
var $HangingOp = (_1, _2, _3) => ({ tag: "HangingOp", _1, _2, _3 });
var max5 = (x) => (y) => {
  const v = ordForceBreak.compare(x)(y);
  if (v.tag === "LT") {
    return y;
  }
  if (v.tag === "EQ") {
    return x;
  }
  if (v.tag === "GT") {
    return x;
  }
  fail();
};
var identity13 = (x) => x;
var HangOps = (value0) => (value1) => (value2) => $HangingDoc("HangOps", value0, value1, value2);
var HangApp = (value0) => (value1) => (value2) => $HangingDoc("HangApp", value0, value1, value2);
var overHangHead = (f) => {
  const go = (v) => {
    if (v.tag === "HangBreak") {
      return $HangingDoc("HangBreak", f(v._1));
    }
    if (v.tag === "HangOps") {
      return $HangingDoc("HangOps", v._1, go(v._2), v._3);
    }
    if (v.tag === "HangApp") {
      return $HangingDoc("HangApp", v._1, go(v._2), v._3);
    }
    fail();
  };
  return go;
};
var hangWithIndent = (ind) => (a) => {
  const $2 = HangApp(ind)(a);
  return (x) => {
    if (x.length > 0) {
      return $2(x);
    }
    return a;
  };
};
var hangOps = /* @__PURE__ */ HangOps(indent);
var hangHead = (hangHead$a0$copy) => {
  let hangHead$a0 = hangHead$a0$copy, hangHead$c = true, hangHead$r;
  while (hangHead$c) {
    const v = hangHead$a0;
    if (v.tag === "HangBreak") {
      hangHead$c = false;
      hangHead$r = v._1;
      continue;
    }
    if (v.tag === "HangOps") {
      hangHead$a0 = v._2;
      continue;
    }
    if (v.tag === "HangApp") {
      hangHead$a0 = v._2;
      continue;
    }
    fail();
  }
  ;
  return hangHead$r;
};
var hangApp = /* @__PURE__ */ HangApp(indent);
var hang = (a) => {
  const $1 = HangApp(indent)($HangingDoc("HangBreak", flexGroup2(a)));
  return (x) => $1([x]);
};
var breaks2 = (fl) => (n) => {
  if (fl.tag === "ForceBreak" || n > 0) {
    if (n >= 2) {
      return semigroupDoc.append(Break)(Break);
    }
    return Break;
  }
  if (fl.tag === "ForceSpace") {
    return $Doc("Text", 1, " ");
  }
  return Empty;
};
var toFormatDoc = /* @__PURE__ */ (() => {
  const realignOp = (realignOp$a0$copy) => (realignOp$a1$copy) => {
    let realignOp$a0 = realignOp$a0$copy, realignOp$a1 = realignOp$a1$copy, realignOp$c = true, realignOp$r;
    while (realignOp$c) {
      const op = realignOp$a0, doc = realignOp$a1;
      const v = hangHead(doc);
      if ((op.leading.left.tag === "ForceNone" || (op.leading.left.tag === "ForceSpace" || !(op.leading.left.tag === "ForceBreak"))) && (op.leading.lines === 0 && ((op.trailing.right.tag === "ForceNone" || (op.trailing.right.tag === "ForceSpace" || !(op.trailing.right.tag === "ForceBreak"))) && ((v.leading.left.tag === "ForceNone" || (v.leading.left.tag === "ForceSpace" || !(v.leading.left.tag === "ForceBreak"))) && v.leading.lines > 0)))) {
        realignOp$a0 = forceMinSourceBreaks(1)(op);
        realignOp$a1 = overHangHead(flattenMax(0))(doc);
        continue;
      }
      if (doc.tag === "HangBreak") {
        if ((op.trailing.right.tag === "ForceNone" || (op.trailing.right.tag === "ForceSpace" || !(op.trailing.right.tag === "ForceBreak"))) && ((v.leading.left.tag === "ForceNone" || (v.leading.left.tag === "ForceSpace" || !(v.leading.left.tag === "ForceBreak"))) && (v.leading.lines === 0 && (v.leading.multiline || op.multiline)))) {
          realignOp$c = false;
          realignOp$r = $Tuple(op, overHangHead(forceMinSourceBreaks(1))(doc));
          continue;
        }
        realignOp$c = false;
        realignOp$r = $Tuple(op, doc);
        continue;
      }
      realignOp$c = false;
      realignOp$r = $Tuple(op, doc);
      continue;
    }
    ;
    return realignOp$r;
  };
  const goLastOperand = (prevAlgn) => (prevInd) => (v) => {
    if (v.tag === "HangBreak") {
      const doc$p = flexGroup2((() => {
        if (v._1.isEmpty) {
          return v._1;
        }
        if ((() => {
          if (v._1.leading.left.tag === "ForceNone") {
            return false;
          }
          if (v._1.leading.left.tag === "ForceSpace") {
            return false;
          }
          return v._1.leading.left.tag === "ForceBreak";
        })() || v._1.leading.lines > 0) {
          return v._1;
        }
        if (v._1.leading.multiline || v._1.multiline) {
          return forceMinSourceBreaks(1)(v._1);
        }
        return {
          doc: semigroupDoc.append($Doc("FlexAlt", $Doc("Text", 1, " "), Break))(semigroupDoc.append(v._1.leading.doc)(breakDoc(v._1.leading.right)(v._1.doc))),
          isEmpty: v._1.isEmpty,
          leading: monoidLeadingComment.mempty,
          multiline: v._1.multiline,
          trailing: v._1.trailing
        };
      })());
      return $Tuple(doc$p, prevInd(doc$p));
    }
    if (v.tag === "HangApp") {
      const $5 = unsnoc(v._3);
      const v1 = (() => {
        if ($5.tag === "Just") {
          return $5._1;
        }
        fail();
      })();
      const $$this = goInit((() => {
        if (v._2.tag === "HangApp") {
          return overHangHead(forceMinSourceBreaks(1))(v._2);
        }
        return v._2;
      })())._1;
      const next = foldrArray(goInitApp)(goLastApp(v1.last))(v1.init);
      const docIndent = (() => {
        if (v._2.tag === "HangApp") {
          return next._1;
        }
        return v._1(next._1);
      })();
      return $Tuple(
        (() => {
          const doc1$p = semigroupDoc.append((() => {
            if ((() => {
              if ($$this.leading.left.tag === "ForceNone") {
                return false;
              }
              if ($$this.leading.left.tag === "ForceSpace") {
                return false;
              }
              return $$this.leading.left.tag === "ForceBreak";
            })() || $$this.leading.lines > 0) {
              return Break;
            }
            return $Doc("FlexAlt", $Doc("Text", 1, " "), Break);
          })())(semigroupDoc.append($$this.leading.doc)(semigroupDoc.append(breakDoc($$this.leading.right)($$this.doc))(breakDoc($$this.trailing.left)($$this.trailing.doc))));
          const doc2$p = semigroupDoc.append(breaks2(max5($$this.trailing.right)(next._1.leading.left))(next._1.leading.lines))(semigroupDoc.append(next._1.leading.doc)(semigroupDoc.append(breakDoc(next._1.leading.right)(next._1.doc))(breakDoc(next._1.trailing.left)(next._1.trailing.doc))));
          return {
            doc: (() => {
              const $12 = semigroupDoc.append(breaks2(max5($$this.trailing.right)(docIndent.leading.left))(docIndent.leading.lines))(semigroupDoc.append(docIndent.leading.doc)(semigroupDoc.append(breakDoc(next._1.leading.right)(docIndent.doc))(breakDoc(docIndent.trailing.left)(docIndent.trailing.doc))));
              if (doc1$p.tag === "Empty") {
                return doc2$p;
              }
              return $Doc("FlexSelect", doc1$p, doc2$p, $12);
            })(),
            leading: monoidLeadingComment.mempty,
            isEmpty: false,
            multiline: $$this.leading.multiline || ($$this.multiline || $$this.trailing.multiline) || (next._1.leading.multiline || (next._1.multiline || next._1.trailing.multiline)) && (docIndent.leading.multiline || (docIndent.multiline || docIndent.trailing.multiline)),
            trailing: { doc: Empty, left: ForceNone, multiline: false, right: max5(next._1.trailing.right)(docIndent.trailing.right) }
          };
        })(),
        (() => {
          const $10 = prevInd($$this);
          const $11 = prevAlgn(docIndent);
          const $12 = prevInd(docIndent);
          const doc1$p = semigroupDoc.append((() => {
            if ((() => {
              if ($10.leading.left.tag === "ForceNone") {
                return false;
              }
              if ($10.leading.left.tag === "ForceSpace") {
                return false;
              }
              return $10.leading.left.tag === "ForceBreak";
            })() || $10.leading.lines > 0) {
              return Break;
            }
            return $Doc("FlexAlt", $Doc("Text", 1, " "), Break);
          })())(semigroupDoc.append($10.leading.doc)(semigroupDoc.append(breakDoc($10.leading.right)($10.doc))(breakDoc($10.trailing.left)($10.trailing.doc))));
          const doc2$p = semigroupDoc.append(breaks2(max5($10.trailing.right)($11.leading.left))($11.leading.lines))(semigroupDoc.append($11.leading.doc)(semigroupDoc.append(breakDoc($11.leading.right)($11.doc))(breakDoc($11.trailing.left)($11.trailing.doc))));
          return {
            doc: (() => {
              const $15 = semigroupDoc.append(breaks2(max5($10.trailing.right)($12.leading.left))($12.leading.lines))(semigroupDoc.append($12.leading.doc)(semigroupDoc.append(breakDoc($11.leading.right)($12.doc))(breakDoc($12.trailing.left)($12.trailing.doc))));
              if (doc1$p.tag === "Empty") {
                return doc2$p;
              }
              return $Doc("FlexSelect", doc1$p, doc2$p, $15);
            })(),
            leading: monoidLeadingComment.mempty,
            isEmpty: false,
            multiline: $10.leading.multiline || ($10.multiline || $10.trailing.multiline) || ($11.leading.multiline || ($11.multiline || $11.trailing.multiline)) && ($12.leading.multiline || ($12.multiline || $12.trailing.multiline)),
            trailing: { doc: Empty, left: ForceNone, multiline: false, right: max5($11.trailing.right)($12.trailing.right) }
          };
        })()
      );
    }
    if (v.tag === "HangOps") {
      const $5 = unsnoc(v._3);
      const v1 = (() => {
        if ($5.tag === "Just") {
          return $5._1;
        }
        fail();
      })();
      const $$this = goInit(v._2)._1;
      const next = foldrArray(goInitOp(v._1))(goLastOp(v._1)(v1.last))(v1.init);
      const docIndent = v._1(next._1);
      return $Tuple(
        (() => {
          const doc1$p = semigroupDoc.append((() => {
            if ((() => {
              if ($$this.leading.left.tag === "ForceNone") {
                return false;
              }
              if ($$this.leading.left.tag === "ForceSpace") {
                return false;
              }
              return $$this.leading.left.tag === "ForceBreak";
            })() || $$this.leading.lines > 0) {
              return Break;
            }
            return $Doc("FlexAlt", $Doc("Text", 1, " "), Break);
          })())(semigroupDoc.append($$this.leading.doc)(semigroupDoc.append(breakDoc($$this.leading.right)($$this.doc))(breakDoc($$this.trailing.left)($$this.trailing.doc))));
          const doc2$p = semigroupDoc.append(breaks2(max5($$this.trailing.right)(next._1.leading.left))(next._1.leading.lines))(semigroupDoc.append(next._1.leading.doc)(semigroupDoc.append(breakDoc(next._1.leading.right)(next._1.doc))(breakDoc(next._1.trailing.left)(next._1.trailing.doc))));
          return {
            doc: (() => {
              const $12 = semigroupDoc.append(breaks2(max5($$this.trailing.right)(docIndent.leading.left))(docIndent.leading.lines))(semigroupDoc.append(docIndent.leading.doc)(semigroupDoc.append(breakDoc(next._1.leading.right)(docIndent.doc))(breakDoc(docIndent.trailing.left)(docIndent.trailing.doc))));
              if (doc1$p.tag === "Empty") {
                return doc2$p;
              }
              return $Doc("FlexSelect", doc1$p, doc2$p, $12);
            })(),
            leading: monoidLeadingComment.mempty,
            isEmpty: false,
            multiline: $$this.leading.multiline || ($$this.multiline || $$this.trailing.multiline) || (next._1.leading.multiline || (next._1.multiline || next._1.trailing.multiline)) && (docIndent.leading.multiline || (docIndent.multiline || docIndent.trailing.multiline)),
            trailing: { doc: Empty, left: ForceNone, multiline: false, right: max5(next._1.trailing.right)(docIndent.trailing.right) }
          };
        })(),
        (() => {
          const $10 = prevInd($$this);
          const $11 = prevAlgn(docIndent);
          const $12 = prevInd(docIndent);
          const doc1$p = semigroupDoc.append((() => {
            if ((() => {
              if ($10.leading.left.tag === "ForceNone") {
                return false;
              }
              if ($10.leading.left.tag === "ForceSpace") {
                return false;
              }
              return $10.leading.left.tag === "ForceBreak";
            })() || $10.leading.lines > 0) {
              return Break;
            }
            return $Doc("FlexAlt", $Doc("Text", 1, " "), Break);
          })())(semigroupDoc.append($10.leading.doc)(semigroupDoc.append(breakDoc($10.leading.right)($10.doc))(breakDoc($10.trailing.left)($10.trailing.doc))));
          const doc2$p = semigroupDoc.append(breaks2(max5($10.trailing.right)($11.leading.left))($11.leading.lines))(semigroupDoc.append($11.leading.doc)(semigroupDoc.append(breakDoc($11.leading.right)($11.doc))(breakDoc($11.trailing.left)($11.trailing.doc))));
          return {
            doc: (() => {
              const $15 = semigroupDoc.append(breaks2(max5($10.trailing.right)($12.leading.left))($12.leading.lines))(semigroupDoc.append($12.leading.doc)(semigroupDoc.append(breakDoc($11.leading.right)($12.doc))(breakDoc($12.trailing.left)($12.trailing.doc))));
              if (doc1$p.tag === "Empty") {
                return doc2$p;
              }
              return $Doc("FlexSelect", doc1$p, doc2$p, $15);
            })(),
            leading: monoidLeadingComment.mempty,
            isEmpty: false,
            multiline: $10.leading.multiline || ($10.multiline || $10.trailing.multiline) || ($11.leading.multiline || ($11.multiline || $11.trailing.multiline)) && ($12.leading.multiline || ($12.multiline || $12.trailing.multiline)),
            trailing: { doc: Empty, left: ForceNone, multiline: false, right: max5($11.trailing.right)($12.trailing.right) }
          };
        })()
      );
    }
    fail();
  };
  const goLastOp = (ind) => (v) => {
    const next = goLastOperand((() => {
      if (v._1 <= 1) {
        return align2(2);
      }
      return identity13;
    })())(ind)(v._3);
    return $Tuple(
      (() => {
        const doc1$p = semigroupDoc.append((() => {
          if ((() => {
            if (v._2.leading.left.tag === "ForceNone") {
              return false;
            }
            if (v._2.leading.left.tag === "ForceSpace") {
              return false;
            }
            return v._2.leading.left.tag === "ForceBreak";
          })() || v._2.leading.lines > 0) {
            return Break;
          }
          return $Doc("FlexAlt", $Doc("Text", 1, " "), Break);
        })())(semigroupDoc.append(v._2.leading.doc)(semigroupDoc.append(breakDoc(v._2.leading.right)(v._2.doc))(breakDoc(v._2.trailing.left)(v._2.trailing.doc))));
        const doc2$p = semigroupDoc.append(breaks2(max5(v._2.trailing.right)(next._1.leading.left))(next._1.leading.lines))(semigroupDoc.append(next._1.leading.doc)(semigroupDoc.append(breakDoc(next._1.leading.right)(next._1.doc))(breakDoc(next._1.trailing.left)(next._1.trailing.doc))));
        return {
          doc: (() => {
            const $7 = semigroupDoc.append(breaks2(max5(v._2.trailing.right)(next._2.leading.left))(next._2.leading.lines))(semigroupDoc.append(next._2.leading.doc)(semigroupDoc.append(breakDoc(next._1.leading.right)(next._2.doc))(breakDoc(next._2.trailing.left)(next._2.trailing.doc))));
            if (doc1$p.tag === "Empty") {
              return doc2$p;
            }
            return $Doc("FlexSelect", doc1$p, doc2$p, $7);
          })(),
          leading: monoidLeadingComment.mempty,
          isEmpty: false,
          multiline: v._2.leading.multiline || (v._2.multiline || v._2.trailing.multiline) || (next._1.leading.multiline || (next._1.multiline || next._1.trailing.multiline)) && (next._2.leading.multiline || (next._2.multiline || next._2.trailing.multiline)),
          trailing: { doc: Empty, left: ForceNone, multiline: false, right: max5(next._1.trailing.right)(next._2.trailing.right) }
        };
      })(),
      joinDoc(force2(identity12))((() => {
        if (v._2.isEmpty) {
          return v._2;
        }
        if ((() => {
          if (v._2.leading.left.tag === "ForceNone") {
            return false;
          }
          if (v._2.leading.left.tag === "ForceSpace") {
            return false;
          }
          return v._2.leading.left.tag === "ForceBreak";
        })() || v._2.leading.lines > 0) {
          return v._2;
        }
        if (v._2.leading.multiline || v._2.multiline) {
          return forceMinSourceBreaks(1)(v._2);
        }
        return {
          doc: semigroupDoc.append($Doc("FlexAlt", $Doc("Text", 1, " "), Break))(semigroupDoc.append(v._2.leading.doc)(breakDoc(v._2.leading.right)(v._2.doc))),
          isEmpty: v._2.isEmpty,
          leading: monoidLeadingComment.mempty,
          multiline: v._2.multiline,
          trailing: v._2.trailing
        };
      })())(next._2)
    );
  };
  const goLastApp = (doc) => {
    const $$this = goLast(doc);
    return $Tuple(flexGroup2($$this._1), $$this._2);
  };
  const goLast = (v) => {
    if (v.tag === "HangBreak") {
      const doc$p = (() => {
        if (v._1.isEmpty) {
          return v._1;
        }
        if ((() => {
          if (v._1.leading.left.tag === "ForceNone") {
            return false;
          }
          if (v._1.leading.left.tag === "ForceSpace") {
            return false;
          }
          return v._1.leading.left.tag === "ForceBreak";
        })() || v._1.leading.lines > 0) {
          return v._1;
        }
        if (v._1.leading.multiline || v._1.multiline) {
          return forceMinSourceBreaks(1)(v._1);
        }
        return {
          doc: semigroupDoc.append($Doc("FlexAlt", $Doc("Text", 1, " "), Break))(semigroupDoc.append(v._1.leading.doc)(breakDoc(v._1.leading.right)(v._1.doc))),
          isEmpty: v._1.isEmpty,
          leading: monoidLeadingComment.mempty,
          multiline: v._1.multiline,
          trailing: v._1.trailing
        };
      })();
      return $Tuple(doc$p, doc$p);
    }
    if (v.tag === "HangApp") {
      const $3 = unsnoc(v._3);
      const v1 = (() => {
        if ($3.tag === "Just") {
          return $3._1;
        }
        fail();
      })();
      const $$this = goInit(v._2)._1;
      const next = foldrArray(goInitApp)(goLastApp(v1.last))(v1.init);
      return $Tuple(
        (() => {
          const $7 = (() => {
            if (v._2.tag === "HangApp") {
              return next._1;
            }
            return v._1(next._1);
          })();
          const doc1$p = semigroupDoc.append((() => {
            if ((() => {
              if ($$this.leading.left.tag === "ForceNone") {
                return false;
              }
              if ($$this.leading.left.tag === "ForceSpace") {
                return false;
              }
              return $$this.leading.left.tag === "ForceBreak";
            })() || $$this.leading.lines > 0) {
              return Break;
            }
            return $Doc("FlexAlt", $Doc("Text", 1, " "), Break);
          })())(semigroupDoc.append($$this.leading.doc)(semigroupDoc.append(breakDoc($$this.leading.right)($$this.doc))(breakDoc($$this.trailing.left)($$this.trailing.doc))));
          const doc2$p = semigroupDoc.append(breaks2(max5($$this.trailing.right)(next._1.leading.left))(next._1.leading.lines))(semigroupDoc.append(next._1.leading.doc)(semigroupDoc.append(breakDoc(next._1.leading.right)(next._1.doc))(breakDoc(next._1.trailing.left)(next._1.trailing.doc))));
          return {
            doc: (() => {
              const $10 = semigroupDoc.append(breaks2(max5($$this.trailing.right)($7.leading.left))($7.leading.lines))(semigroupDoc.append($7.leading.doc)(semigroupDoc.append(breakDoc(next._1.leading.right)($7.doc))(breakDoc($7.trailing.left)($7.trailing.doc))));
              if (doc1$p.tag === "Empty") {
                return doc2$p;
              }
              return $Doc("FlexSelect", doc1$p, doc2$p, $10);
            })(),
            leading: monoidLeadingComment.mempty,
            isEmpty: false,
            multiline: $$this.leading.multiline || ($$this.multiline || $$this.trailing.multiline) || (next._1.leading.multiline || (next._1.multiline || next._1.trailing.multiline)) && ($7.leading.multiline || ($7.multiline || $7.trailing.multiline)),
            trailing: { doc: Empty, left: ForceNone, multiline: false, right: max5(next._1.trailing.right)($7.trailing.right) }
          };
        })(),
        joinDoc(force2(identity12))((() => {
          if ($$this.isEmpty) {
            return $$this;
          }
          if ((() => {
            if ($$this.leading.left.tag === "ForceNone") {
              return false;
            }
            if ($$this.leading.left.tag === "ForceSpace") {
              return false;
            }
            return $$this.leading.left.tag === "ForceBreak";
          })() || $$this.leading.lines > 0) {
            return $$this;
          }
          if ($$this.leading.multiline || $$this.multiline) {
            return forceMinSourceBreaks(1)($$this);
          }
          return {
            doc: semigroupDoc.append($Doc("FlexAlt", $Doc("Text", 1, " "), Break))(semigroupDoc.append($$this.leading.doc)(breakDoc($$this.leading.right)($$this.doc))),
            isEmpty: $$this.isEmpty,
            leading: monoidLeadingComment.mempty,
            multiline: $$this.multiline,
            trailing: $$this.trailing
          };
        })())((() => {
          if (v._2.tag === "HangApp") {
            return next._1;
          }
          return v._1(next._1);
        })())
      );
    }
    if (v.tag === "HangOps") {
      const $3 = unsnoc(v._3);
      const v1 = (() => {
        if ($3.tag === "Just") {
          return $3._1;
        }
        fail();
      })();
      const $$this = goInit(v._2)._1;
      const next = foldrArray(goInitOp(v._1))(goLastOp(v._1)(v1.last))(v1.init);
      return $Tuple(
        (() => {
          const $7 = v._1(next._1);
          const doc1$p = semigroupDoc.append((() => {
            if ((() => {
              if ($$this.leading.left.tag === "ForceNone") {
                return false;
              }
              if ($$this.leading.left.tag === "ForceSpace") {
                return false;
              }
              return $$this.leading.left.tag === "ForceBreak";
            })() || $$this.leading.lines > 0) {
              return Break;
            }
            return $Doc("FlexAlt", $Doc("Text", 1, " "), Break);
          })())(semigroupDoc.append($$this.leading.doc)(semigroupDoc.append(breakDoc($$this.leading.right)($$this.doc))(breakDoc($$this.trailing.left)($$this.trailing.doc))));
          const doc2$p = semigroupDoc.append(breaks2(max5($$this.trailing.right)(next._1.leading.left))(next._1.leading.lines))(semigroupDoc.append(next._1.leading.doc)(semigroupDoc.append(breakDoc(next._1.leading.right)(next._1.doc))(breakDoc(next._1.trailing.left)(next._1.trailing.doc))));
          return {
            doc: (() => {
              const $10 = semigroupDoc.append(breaks2(max5($$this.trailing.right)($7.leading.left))($7.leading.lines))(semigroupDoc.append($7.leading.doc)(semigroupDoc.append(breakDoc(next._1.leading.right)($7.doc))(breakDoc($7.trailing.left)($7.trailing.doc))));
              if (doc1$p.tag === "Empty") {
                return doc2$p;
              }
              return $Doc("FlexSelect", doc1$p, doc2$p, $10);
            })(),
            leading: monoidLeadingComment.mempty,
            isEmpty: false,
            multiline: $$this.leading.multiline || ($$this.multiline || $$this.trailing.multiline) || (next._1.leading.multiline || (next._1.multiline || next._1.trailing.multiline)) && ($7.leading.multiline || ($7.multiline || $7.trailing.multiline)),
            trailing: { doc: Empty, left: ForceNone, multiline: false, right: max5(next._1.trailing.right)($7.trailing.right) }
          };
        })(),
        joinDoc(force2(semigroupDoc.append(Break)))((() => {
          if ($$this.isEmpty) {
            return $$this;
          }
          if ((() => {
            if ($$this.leading.left.tag === "ForceNone") {
              return false;
            }
            if ($$this.leading.left.tag === "ForceSpace") {
              return false;
            }
            return $$this.leading.left.tag === "ForceBreak";
          })() || $$this.leading.lines > 0) {
            return $$this;
          }
          if ($$this.leading.multiline || $$this.multiline) {
            return forceMinSourceBreaks(1)($$this);
          }
          return {
            doc: semigroupDoc.append($Doc("FlexAlt", $Doc("Text", 1, " "), Break))(semigroupDoc.append($$this.leading.doc)(breakDoc($$this.leading.right)($$this.doc))),
            isEmpty: $$this.isEmpty,
            leading: monoidLeadingComment.mempty,
            multiline: $$this.multiline,
            trailing: $$this.trailing
          };
        })())(v._1(next._2))
      );
    }
    fail();
  };
  const goInitOperand = (prevAlgn) => (prevInd) => (v) => {
    if (v.tag === "HangBreak") {
      const doc$p = prevInd(flexGroup2((() => {
        if (v._1.isEmpty) {
          return v._1;
        }
        if ((() => {
          if (v._1.leading.left.tag === "ForceNone") {
            return false;
          }
          if (v._1.leading.left.tag === "ForceSpace") {
            return false;
          }
          return v._1.leading.left.tag === "ForceBreak";
        })() || v._1.leading.lines > 0) {
          return v._1;
        }
        if (v._1.leading.multiline || v._1.multiline) {
          return forceMinSourceBreaks(1)(v._1);
        }
        return {
          doc: semigroupDoc.append($Doc("FlexAlt", $Doc("Text", 1, " "), Break))(semigroupDoc.append(v._1.leading.doc)(breakDoc(v._1.leading.right)(v._1.doc))),
          isEmpty: v._1.isEmpty,
          leading: monoidLeadingComment.mempty,
          multiline: v._1.multiline,
          trailing: v._1.trailing
        };
      })()));
      return $Tuple(doc$p, doc$p);
    }
    if (v.tag === "HangApp") {
      const $5 = unsnoc(v._3);
      const v1 = (() => {
        if ($5.tag === "Just") {
          return $5._1;
        }
        fail();
      })();
      const $$this = goInit(v._2)._1;
      const next = foldrArray(goInitApp)(goLastApp(v1.last))(v1.init);
      return $Tuple(
        (() => {
          const $9 = prevInd($$this);
          const $10 = (() => {
            if (v._2.tag === "HangApp") {
              return next._1;
            }
            return prevAlgn(v._1(next._1));
          })();
          const $11 = prevInd((() => {
            if (v._2.tag === "HangApp") {
              return next._1;
            }
            return v._1(next._1);
          })());
          const doc1$p = semigroupDoc.append((() => {
            if ((() => {
              if ($9.leading.left.tag === "ForceNone") {
                return false;
              }
              if ($9.leading.left.tag === "ForceSpace") {
                return false;
              }
              return $9.leading.left.tag === "ForceBreak";
            })() || $9.leading.lines > 0) {
              return Break;
            }
            return $Doc("FlexAlt", $Doc("Text", 1, " "), Break);
          })())(semigroupDoc.append($9.leading.doc)(semigroupDoc.append(breakDoc($9.leading.right)($9.doc))(breakDoc($9.trailing.left)($9.trailing.doc))));
          const doc2$p = semigroupDoc.append(breaks2(max5($9.trailing.right)($10.leading.left))($10.leading.lines))(semigroupDoc.append($10.leading.doc)(semigroupDoc.append(breakDoc($10.leading.right)($10.doc))(breakDoc($10.trailing.left)($10.trailing.doc))));
          return {
            doc: (() => {
              const $14 = semigroupDoc.append(breaks2(max5($9.trailing.right)($11.leading.left))($11.leading.lines))(semigroupDoc.append($11.leading.doc)(semigroupDoc.append(breakDoc($10.leading.right)($11.doc))(breakDoc($11.trailing.left)($11.trailing.doc))));
              if (doc1$p.tag === "Empty") {
                return doc2$p;
              }
              return $Doc("FlexSelect", doc1$p, doc2$p, $14);
            })(),
            leading: monoidLeadingComment.mempty,
            isEmpty: false,
            multiline: $9.leading.multiline || ($9.multiline || $9.trailing.multiline) || ($10.leading.multiline || ($10.multiline || $10.trailing.multiline)) && ($11.leading.multiline || ($11.multiline || $11.trailing.multiline)),
            trailing: { doc: Empty, left: ForceNone, multiline: false, right: max5($10.trailing.right)($11.trailing.right) }
          };
        })(),
        prevInd(joinDoc(force2(identity12))((() => {
          if ($$this.isEmpty) {
            return $$this;
          }
          if ((() => {
            if ($$this.leading.left.tag === "ForceNone") {
              return false;
            }
            if ($$this.leading.left.tag === "ForceSpace") {
              return false;
            }
            return $$this.leading.left.tag === "ForceBreak";
          })() || $$this.leading.lines > 0) {
            return $$this;
          }
          if ($$this.leading.multiline || $$this.multiline) {
            return forceMinSourceBreaks(1)($$this);
          }
          return {
            doc: semigroupDoc.append($Doc("FlexAlt", $Doc("Text", 1, " "), Break))(semigroupDoc.append($$this.leading.doc)(breakDoc($$this.leading.right)($$this.doc))),
            isEmpty: $$this.isEmpty,
            leading: monoidLeadingComment.mempty,
            multiline: $$this.multiline,
            trailing: $$this.trailing
          };
        })())(v._1(next._2)))
      );
    }
    if (v.tag === "HangOps") {
      const $5 = unsnoc(v._3);
      const v1 = (() => {
        if ($5.tag === "Just") {
          return $5._1;
        }
        fail();
      })();
      const $$this = goInit(v._2)._1;
      const next = foldrArray(goInitOp(v._1))(goLastOp(v._1)(v1.last))(v1.init);
      return $Tuple(
        (() => {
          const $9 = prevInd($$this);
          const $10 = prevAlgn(v._1(next._1));
          const $11 = prevInd(v._1(next._1));
          const doc1$p = semigroupDoc.append((() => {
            if ((() => {
              if ($9.leading.left.tag === "ForceNone") {
                return false;
              }
              if ($9.leading.left.tag === "ForceSpace") {
                return false;
              }
              return $9.leading.left.tag === "ForceBreak";
            })() || $9.leading.lines > 0) {
              return Break;
            }
            return $Doc("FlexAlt", $Doc("Text", 1, " "), Break);
          })())(semigroupDoc.append($9.leading.doc)(semigroupDoc.append(breakDoc($9.leading.right)($9.doc))(breakDoc($9.trailing.left)($9.trailing.doc))));
          const doc2$p = semigroupDoc.append(breaks2(max5($9.trailing.right)($10.leading.left))($10.leading.lines))(semigroupDoc.append($10.leading.doc)(semigroupDoc.append(breakDoc($10.leading.right)($10.doc))(breakDoc($10.trailing.left)($10.trailing.doc))));
          return {
            doc: (() => {
              const $14 = semigroupDoc.append(breaks2(max5($9.trailing.right)($11.leading.left))($11.leading.lines))(semigroupDoc.append($11.leading.doc)(semigroupDoc.append(breakDoc($10.leading.right)($11.doc))(breakDoc($11.trailing.left)($11.trailing.doc))));
              if (doc1$p.tag === "Empty") {
                return doc2$p;
              }
              return $Doc("FlexSelect", doc1$p, doc2$p, $14);
            })(),
            leading: monoidLeadingComment.mempty,
            isEmpty: false,
            multiline: $9.leading.multiline || ($9.multiline || $9.trailing.multiline) || ($10.leading.multiline || ($10.multiline || $10.trailing.multiline)) && ($11.leading.multiline || ($11.multiline || $11.trailing.multiline)),
            trailing: { doc: Empty, left: ForceNone, multiline: false, right: max5($10.trailing.right)($11.trailing.right) }
          };
        })(),
        prevInd(joinDoc(force2(identity12))((() => {
          if ($$this.isEmpty) {
            return $$this;
          }
          if ((() => {
            if ($$this.leading.left.tag === "ForceNone") {
              return false;
            }
            if ($$this.leading.left.tag === "ForceSpace") {
              return false;
            }
            return $$this.leading.left.tag === "ForceBreak";
          })() || $$this.leading.lines > 0) {
            return $$this;
          }
          if ($$this.leading.multiline || $$this.multiline) {
            return forceMinSourceBreaks(1)($$this);
          }
          return {
            doc: semigroupDoc.append($Doc("FlexAlt", $Doc("Text", 1, " "), Break))(semigroupDoc.append($$this.leading.doc)(breakDoc($$this.leading.right)($$this.doc))),
            isEmpty: $$this.isEmpty,
            leading: monoidLeadingComment.mempty,
            multiline: $$this.multiline,
            trailing: $$this.trailing
          };
        })())(v._1(next._2)))
      );
    }
    fail();
  };
  const goInitOp = (ind) => (v) => (next) => {
    const v1 = realignOp(v._2)(v._3);
    const docOprd = goInitOperand((() => {
      if (v._1 <= 1) {
        return align2(2);
      }
      return identity13;
    })())(ind)(v1._2)._1;
    return $Tuple(
      (() => {
        const $7 = joinDoc(force2(identity12))(v1._1)(docOprd);
        const doc1$p = semigroupDoc.append((() => {
          if ((() => {
            if ($7.leading.left.tag === "ForceNone") {
              return false;
            }
            if ($7.leading.left.tag === "ForceSpace") {
              return false;
            }
            return $7.leading.left.tag === "ForceBreak";
          })() || $7.leading.lines > 0) {
            return Break;
          }
          return $Doc("FlexAlt", $Doc("Text", 1, " "), Break);
        })())(semigroupDoc.append($7.leading.doc)(semigroupDoc.append(breakDoc($7.leading.right)($7.doc))(breakDoc($7.trailing.left)($7.trailing.doc))));
        const doc2$p = semigroupDoc.append(breaks2(max5($7.trailing.right)(next._1.leading.left))(next._1.leading.lines))(semigroupDoc.append(next._1.leading.doc)(semigroupDoc.append(breakDoc(next._1.leading.right)(next._1.doc))(breakDoc(next._1.trailing.left)(next._1.trailing.doc))));
        return {
          doc: (() => {
            const $10 = semigroupDoc.append(breaks2(max5($7.trailing.right)(next._2.leading.left))(next._2.leading.lines))(semigroupDoc.append(next._2.leading.doc)(semigroupDoc.append(breakDoc(next._1.leading.right)(next._2.doc))(breakDoc(next._2.trailing.left)(next._2.trailing.doc))));
            if (doc1$p.tag === "Empty") {
              return doc2$p;
            }
            return $Doc("FlexSelect", doc1$p, doc2$p, $10);
          })(),
          leading: monoidLeadingComment.mempty,
          isEmpty: false,
          multiline: $7.leading.multiline || ($7.multiline || $7.trailing.multiline) || (next._1.leading.multiline || (next._1.multiline || next._1.trailing.multiline)) && (next._2.leading.multiline || (next._2.multiline || next._2.trailing.multiline)),
          trailing: { doc: Empty, left: ForceNone, multiline: false, right: max5(next._1.trailing.right)(next._2.trailing.right) }
        };
      })(),
      joinDoc(force2(identity12))((() => {
        if (v1._1.isEmpty) {
          return v1._1;
        }
        if ((() => {
          if (v1._1.leading.left.tag === "ForceNone") {
            return false;
          }
          if (v1._1.leading.left.tag === "ForceSpace") {
            return false;
          }
          return v1._1.leading.left.tag === "ForceBreak";
        })() || v1._1.leading.lines > 0) {
          return v1._1;
        }
        if (v1._1.leading.multiline || v1._1.multiline) {
          return forceMinSourceBreaks(1)(v1._1);
        }
        return {
          doc: semigroupDoc.append($Doc("FlexAlt", $Doc("Text", 1, " "), Break))(semigroupDoc.append(v1._1.leading.doc)(breakDoc(v1._1.leading.right)(v1._1.doc))),
          isEmpty: v1._1.isEmpty,
          leading: monoidLeadingComment.mempty,
          multiline: v1._1.multiline,
          trailing: v1._1.trailing
        };
      })())(joinDoc(force2(identity12))(docOprd)(next._2))
    );
  };
  const goInitApp = (doc) => (next) => {
    const $$this = goInit(doc)._1;
    return $Tuple(
      (() => {
        const doc1$p = semigroupDoc.append((() => {
          if ((() => {
            if ($$this.leading.left.tag === "ForceNone") {
              return false;
            }
            if ($$this.leading.left.tag === "ForceSpace") {
              return false;
            }
            return $$this.leading.left.tag === "ForceBreak";
          })() || $$this.leading.lines > 0) {
            return Break;
          }
          return $Doc("FlexAlt", $Doc("Text", 1, " "), Break);
        })())(semigroupDoc.append($$this.leading.doc)(semigroupDoc.append(breakDoc($$this.leading.right)($$this.doc))(breakDoc($$this.trailing.left)($$this.trailing.doc))));
        const doc2$p = semigroupDoc.append(breaks2(max5($$this.trailing.right)(next._1.leading.left))(next._1.leading.lines))(semigroupDoc.append(next._1.leading.doc)(semigroupDoc.append(breakDoc(next._1.leading.right)(next._1.doc))(breakDoc(next._1.trailing.left)(next._1.trailing.doc))));
        return {
          doc: (() => {
            const $7 = semigroupDoc.append(breaks2(max5($$this.trailing.right)(next._2.leading.left))(next._2.leading.lines))(semigroupDoc.append(next._2.leading.doc)(semigroupDoc.append(breakDoc(next._1.leading.right)(next._2.doc))(breakDoc(next._2.trailing.left)(next._2.trailing.doc))));
            if (doc1$p.tag === "Empty") {
              return doc2$p;
            }
            return $Doc("FlexSelect", doc1$p, doc2$p, $7);
          })(),
          leading: monoidLeadingComment.mempty,
          isEmpty: false,
          multiline: $$this.leading.multiline || ($$this.multiline || $$this.trailing.multiline) || (next._1.leading.multiline || (next._1.multiline || next._1.trailing.multiline)) && (next._2.leading.multiline || (next._2.multiline || next._2.trailing.multiline)),
          trailing: { doc: Empty, left: ForceNone, multiline: false, right: max5(next._1.trailing.right)(next._2.trailing.right) }
        };
      })(),
      joinDoc(force2(identity12))((() => {
        if ($$this.isEmpty) {
          return $$this;
        }
        if ((() => {
          if ($$this.leading.left.tag === "ForceNone") {
            return false;
          }
          if ($$this.leading.left.tag === "ForceSpace") {
            return false;
          }
          return $$this.leading.left.tag === "ForceBreak";
        })() || $$this.leading.lines > 0) {
          return $$this;
        }
        if ($$this.leading.multiline || $$this.multiline) {
          return forceMinSourceBreaks(1)($$this);
        }
        return {
          doc: semigroupDoc.append($Doc("FlexAlt", $Doc("Text", 1, " "), Break))(semigroupDoc.append($$this.leading.doc)(breakDoc($$this.leading.right)($$this.doc))),
          isEmpty: $$this.isEmpty,
          leading: monoidLeadingComment.mempty,
          multiline: $$this.multiline,
          trailing: $$this.trailing
        };
      })())(next._2)
    );
  };
  const goInit = (v) => {
    if (v.tag === "HangBreak") {
      return $Tuple(v._1, v._1);
    }
    if (v.tag === "HangApp") {
      const $3 = unsnoc(v._3);
      const v1 = (() => {
        if ($3.tag === "Just") {
          return $3._1;
        }
        fail();
      })();
      const $$this = goInit(v._2)._1;
      const next = foldrArray(goInitApp)(goLastApp(v1.last))(v1.init);
      return $Tuple(
        (() => {
          const $7 = v._1(next._1);
          const $8 = (() => {
            if (v._2.tag === "HangApp") {
              return next._1;
            }
            return v._1(next._1);
          })();
          const doc1$p = semigroupDoc.append($$this.doc)(breakDoc($$this.trailing.left)($$this.trailing.doc));
          const doc2$p = semigroupDoc.append(breaks2(max5($$this.trailing.right)($7.leading.left))($7.leading.lines))(semigroupDoc.append($7.leading.doc)(semigroupDoc.append(breakDoc($7.leading.right)($7.doc))(breakDoc($7.trailing.left)($7.trailing.doc))));
          return {
            doc: (() => {
              const $11 = semigroupDoc.append(breaks2(max5($$this.trailing.right)($8.leading.left))($8.leading.lines))(semigroupDoc.append($8.leading.doc)(semigroupDoc.append(breakDoc($7.leading.right)($8.doc))(breakDoc($8.trailing.left)($8.trailing.doc))));
              if (doc1$p.tag === "Empty") {
                return doc2$p;
              }
              return $Doc("FlexSelect", doc1$p, doc2$p, $11);
            })(),
            leading: $$this.leading,
            isEmpty: false,
            multiline: $$this.multiline || $$this.trailing.multiline || ($7.leading.multiline || ($7.multiline || $7.trailing.multiline)) && ($8.leading.multiline || ($8.multiline || $8.trailing.multiline)),
            trailing: { doc: Empty, left: ForceNone, multiline: false, right: max5($7.trailing.right)($8.trailing.right) }
          };
        })(),
        joinDoc(force2(semigroupDoc.append(Break)))($$this)(v._1(next._2))
      );
    }
    if (v.tag === "HangOps") {
      const $3 = unsnoc(v._3);
      const v1 = (() => {
        if ($3.tag === "Just") {
          return $3._1;
        }
        fail();
      })();
      const $$this = goInit(v._2)._1;
      const next = foldrArray(goInitOp(v._1))(goLastOp(v._1)(v1.last))(v1.init);
      return $Tuple(
        joinDoc(force2(identity12))(flexGroup2($$this))(v._1(next._1)),
        joinDoc(force2(semigroupDoc.append(Break)))($$this)(v._1(next._2))
      );
    }
    fail();
  };
  return (x) => goInit(x)._1;
})();

// output-es/Tidy.Precedence/index.js
var $OperatorNamespace = (tag) => ({ tag });
var $OperatorStk = (tag, _1, _2, _3) => ({ tag, _1, _2, _3 });
var $OperatorTree = (tag, _1, _2, _3) => ({ tag, _1, _2, _3 });
var $QualifiedOperator = (_1, _2, _3) => ({ tag: "QualifiedOperator", _1, _2, _3 });
var ordMaybe2 = /* @__PURE__ */ ordMaybe(ordString);
var foldMap2 = /* @__PURE__ */ (() => foldableArray.foldMap(monoidArray))();
var OperatorType = /* @__PURE__ */ $OperatorNamespace("OperatorType");
var OperatorValue = /* @__PURE__ */ $OperatorNamespace("OperatorValue");
var QualifiedOperator = (value0) => (value1) => (value2) => $QualifiedOperator(value0, value1, value2);
var snoc = (prevOps) => (nextPrec) => (nextOps) => {
  const $3 = unsnoc(prevOps);
  const v = (() => {
    if ($3.tag === "Just") {
      return $3._1;
    }
    fail();
  })();
  return run(withArray(pushAll([$Tuple(v.last._1, $OperatorTree("OpList", v.last._2, nextPrec, nextOps))]))(v.init));
};
var unwind = /* @__PURE__ */ (() => {
  const go = (go$a0$copy) => (go$a1$copy) => (go$a2$copy) => {
    let go$a0 = go$a0$copy, go$a1 = go$a1$copy, go$a2 = go$a2$copy, go$c = true, go$r;
    while (go$c) {
      const prec = go$a0, ops = go$a1, v = go$a2;
      if (v.tag === "OpHead") {
        go$c = false;
        go$r = $OperatorTree("OpList", v._1, prec, ops);
        continue;
      }
      if (v.tag === "OpPrec") {
        go$a0 = v._2;
        go$a1 = snoc(v._3)(prec)(ops);
        go$a2 = v._1;
        continue;
      }
      fail();
    }
    ;
    return go$r;
  };
  return (v) => {
    if (v.tag === "OpHead") {
      return v._1;
    }
    if (v.tag === "OpPrec") {
      return go(v._2)(v._3)(v._1);
    }
    fail();
  };
})();
var push = (push$a0$copy) => (push$a1$copy) => {
  let push$a0 = push$a0$copy, push$a1 = push$a1$copy, push$c = true, push$r;
  while (push$c) {
    const stk = push$a0, chs = push$a1;
    if (chs.tag === "Nil") {
      push$c = false;
      push$r = stk;
      continue;
    }
    if (chs.tag === "Cons") {
      if (chs._2.tag === "Nil") {
        if (stk.tag === "OpHead") {
          push$c = false;
          push$r = $OperatorStk("OpPrec", stk, chs._1._1, chs._1._2);
          continue;
        }
        if (stk.tag === "OpPrec") {
          const v = ordInt.compare(chs._1._1)(stk._2);
          if (v.tag === "EQ") {
            push$c = false;
            push$r = $OperatorStk("OpPrec", stk._1, stk._2, concatArray(stk._3)(chs._1._2));
            continue;
          }
          if (v.tag === "GT") {
            push$c = false;
            push$r = $OperatorStk("OpPrec", stk, chs._1._1, chs._1._2);
            continue;
          }
          if (v.tag === "LT") {
            push$a0 = stk._1;
            push$a1 = $List("Cons", $Tuple(stk._2, stk._3), chs);
            continue;
          }
          fail();
        }
        fail();
      }
      if (stk.tag === "OpHead") {
        push$a0 = $OperatorStk("OpHead", $OperatorTree("OpList", stk._1, chs._1._1, chs._1._2));
        push$a1 = chs._2;
        continue;
      }
      if (stk.tag === "OpPrec") {
        const v = ordInt.compare(chs._1._1)(stk._2);
        if (v.tag === "EQ") {
          push$a0 = $OperatorStk("OpPrec", stk._1, stk._2, concatArray(stk._3)(chs._1._2));
          push$a1 = chs._2;
          continue;
        }
        if (v.tag === "GT") {
          push$a0 = $OperatorStk("OpPrec", stk._1, stk._2, snoc(stk._3)(chs._1._1)(chs._1._2));
          push$a1 = chs._2;
          continue;
        }
        if (v.tag === "LT") {
          push$a0 = stk._1;
          push$a1 = $List("Cons", $Tuple(stk._2, snoc(stk._3)(chs._1._1)(chs._1._2)), chs._2);
          continue;
        }
        fail();
      }
      fail();
    }
    fail();
  }
  ;
  return push$r;
};
var eqOperatorNamespace = {
  eq: (x) => (y) => {
    if (x.tag === "OperatorType") {
      return y.tag === "OperatorType";
    }
    if (x.tag === "OperatorValue") {
      return y.tag === "OperatorValue";
    }
    return false;
  }
};
var ordOperatorNamespace = {
  compare: (x) => (y) => {
    if (x.tag === "OperatorType") {
      if (y.tag === "OperatorType") {
        return EQ;
      }
      return LT;
    }
    if (y.tag === "OperatorType") {
      return GT;
    }
    if (x.tag === "OperatorValue") {
      if (y.tag === "OperatorValue") {
        return EQ;
      }
      fail();
    }
    fail();
  },
  Eq0: () => eqOperatorNamespace
};
var ordTuple2 = /* @__PURE__ */ ordTuple(ordOperatorNamespace)(ordString);
var filterKeys2 = /* @__PURE__ */ filterKeys(ordTuple2);
var insertOperator = (v) => (prec) => alter(ordMaybe2)((v1) => {
  if (v1.tag === "Nothing") {
    return $Maybe("Just", $Map("Two", Leaf2, $Tuple(v._2, v._3), prec, Leaf2));
  }
  if (v1.tag === "Just") {
    return $Maybe("Just", insert(ordTuple2)($Tuple(v._2, v._3))(prec)(v1._1));
  }
  fail();
})(v._1);
var lookupOperator = (v) => (precMap) => {
  const $2 = lookup(ordMaybe2)(v._1)(precMap);
  const $3 = lookup(ordTuple2)($Tuple(v._2, v._3));
  if ($2.tag === "Just") {
    return $3($2._1);
  }
  if ($2.tag === "Nothing") {
    return Nothing;
  }
  fail();
};
var remapOperatorTo = (newModName) => (v) => (precMap) => {
  const $3 = lookupOperator(v)(precMap);
  if ($3.tag === "Just") {
    return insertOperator($QualifiedOperator(newModName, v._2, v._3))($3._1)(precMap);
  }
  if ($3.tag === "Nothing") {
    return precMap;
  }
  fail();
};
var remapModuleTo = (newModName) => (modName) => (precMap) => {
  const $3 = lookup(ordMaybe2)($Maybe("Just", modName))(precMap);
  if ($3.tag === "Just") {
    return alter(ordMaybe2)((v) => {
      if (v.tag === "Nothing") {
        return $Maybe("Just", $3._1);
      }
      if (v.tag === "Just") {
        return $Maybe("Just", unionWith(ordTuple2)($$const)($3._1)(v._1));
      }
      fail();
    })(newModName)(precMap);
  }
  if ($3.tag === "Nothing") {
    return precMap;
  }
  fail();
};
var remapModuleToHiding = (dictFoldable) => {
  const any1 = dictFoldable.foldMap((() => {
    const semigroupDisj1 = { append: (v) => (v1) => v || v1 };
    return { mempty: false, Semigroup0: () => semigroupDisj1 };
  })());
  return (hiding) => (newModName) => (modName) => (precMap) => {
    const $6 = lookup(ordMaybe2)($Maybe("Just", modName))(precMap);
    if ($6.tag === "Just") {
      const filteredOps = filterKeys2((() => {
        const $7 = QualifiedOperator($Maybe("Just", modName));
        return (x) => {
          const $9 = $7(x._1)(x._2);
          return !any1((y) => (() => {
            if ($9._1.tag === "Nothing") {
              return y._1.tag === "Nothing";
            }
            if ($9._1.tag === "Just") {
              if (y._1.tag === "Just") {
                return $9._1._1 === y._1._1;
              }
              return false;
            }
            return false;
          })() && (() => {
            if ($9._2.tag === "OperatorType") {
              return y._2.tag === "OperatorType";
            }
            if ($9._2.tag === "OperatorValue") {
              return y._2.tag === "OperatorValue";
            }
            return false;
          })() && $9._3 === y._3)(hiding);
        };
      })())($6._1);
      return alter(ordMaybe2)((v) => {
        if (v.tag === "Nothing") {
          return $Maybe("Just", filteredOps);
        }
        if (v.tag === "Just") {
          return $Maybe("Just", unionWith(ordTuple2)($$const)(filteredOps)(v._1));
        }
        fail();
      })(newModName)(precMap);
    }
    if ($6.tag === "Nothing") {
      return precMap;
    }
    fail();
  };
};
var remapModuleToHiding1 = /* @__PURE__ */ remapModuleToHiding(foldableArray);
var remapOperators = (precMap) => (v) => foldlArray((precMap$1) => (v$1) => {
  if (v$1.tag === "DeclFixity") {
    if (v$1._1.operator.tag === "FixityValue") {
      return insertOperator($QualifiedOperator($Maybe("Just", v.header.name.name), OperatorValue, v$1._1.operator._3.name))(v$1._1.prec._2)(insertOperator($QualifiedOperator(
        Nothing,
        OperatorValue,
        v$1._1.operator._3.name
      ))(v$1._1.prec._2)(precMap$1));
    }
    if (v$1._1.operator.tag === "FixityType") {
      return insertOperator($QualifiedOperator($Maybe("Just", v.header.name.name), OperatorType, v$1._1.operator._4.name))(v$1._1.prec._2)(insertOperator($QualifiedOperator(
        Nothing,
        OperatorType,
        v$1._1.operator._4.name
      ))(v$1._1.prec._2)(precMap$1));
    }
    fail();
  }
  return precMap$1;
})(foldlArray((precMap$1) => (v$1) => {
  const newModName = (() => {
    if (v$1.qualified.tag === "Just") {
      return $Maybe("Just", v$1.qualified._1._2.name);
    }
    return Nothing;
  })();
  if (v$1.names.tag === "Nothing") {
    return remapModuleTo(newModName)(v$1.module.name)(precMap$1);
  }
  if (v$1.names.tag === "Just") {
    const impOps = concatArray((() => {
      if (v$1.names._1._2.value.head.tag === "ImportOp") {
        return [$QualifiedOperator($Maybe("Just", v$1.module.name), OperatorValue, v$1.names._1._2.value.head._1.name)];
      }
      if (v$1.names._1._2.value.head.tag === "ImportTypeOp") {
        return [$QualifiedOperator($Maybe("Just", v$1.module.name), OperatorType, v$1.names._1._2.value.head._2.name)];
      }
      return [];
    })())(foldMap2((x) => {
      if (x._2.tag === "ImportOp") {
        return [$QualifiedOperator($Maybe("Just", v$1.module.name), OperatorValue, x._2._1.name)];
      }
      if (x._2.tag === "ImportTypeOp") {
        return [$QualifiedOperator($Maybe("Just", v$1.module.name), OperatorType, x._2._2.name)];
      }
      return [];
    })(v$1.names._1._2.value.tail));
    if ((() => {
      if (v$1.names._1._1.tag === "Nothing") {
        return false;
      }
      if (v$1.names._1._1.tag === "Just") {
        return true;
      }
      fail();
    })()) {
      return remapModuleToHiding1(impOps)(newModName)(v$1.module.name)(precMap$1);
    }
    return foldlArray((b) => (a) => remapOperatorTo(newModName)(a)(b))(precMap$1)(impOps);
  }
  fail();
})(precMap)(v.header.imports))(v.body.decls);
var toOperatorTree = (precMap) => (getOperator) => (init2) => {
  const $3 = foldlArray((stk) => (v) => {
    const v1 = getOperator(v._1);
    return push(stk)($List(
      "Cons",
      $Tuple(
        (() => {
          const $6 = lookup(ordTuple2)($Tuple(v1._2, v1._3));
          const $7 = lookup(ordMaybe2)(v1._1)(precMap);
          const $8 = (() => {
            if ($7.tag === "Just") {
              return $6($7._1);
            }
            if ($7.tag === "Nothing") {
              return Nothing;
            }
            fail();
          })();
          if ($8.tag === "Nothing") {
            return 10;
          }
          if ($8.tag === "Just") {
            return $8._1;
          }
          fail();
        })(),
        [$Tuple(v._1, $OperatorTree("OpPure", v._2))]
      ),
      Nil
    ));
  })($OperatorStk("OpHead", $OperatorTree("OpPure", init2)));
  return (x) => unwind($3(x));
};

// output-es/Tidy.Token/index.js
var $UnicodeOption = (tag) => ({ tag });
var UnicodeSource = /* @__PURE__ */ $UnicodeOption("UnicodeSource");
var UnicodeAlways = /* @__PURE__ */ $UnicodeOption("UnicodeAlways");
var UnicodeNever = /* @__PURE__ */ $UnicodeOption("UnicodeNever");
var printToken = (option) => (v) => {
  if (v.tag === "TokLeftParen") {
    return "(";
  }
  if (v.tag === "TokRightParen") {
    return ")";
  }
  if (v.tag === "TokLeftBrace") {
    return "{";
  }
  if (v.tag === "TokRightBrace") {
    return "}";
  }
  if (v.tag === "TokLeftSquare") {
    return "[";
  }
  if (v.tag === "TokRightSquare") {
    return "]";
  }
  if (v.tag === "TokLeftArrow") {
    if (option.tag === "UnicodeNever") {
      return "<-";
    }
    if (option.tag === "UnicodeAlways") {
      return "\u2190";
    }
    if (option.tag === "UnicodeSource") {
      if (v._1.tag === "ASCII") {
        return "<-";
      }
      if (v._1.tag === "Unicode") {
        return "\u2190";
      }
      fail();
    }
    fail();
  }
  if (v.tag === "TokRightArrow") {
    if (option.tag === "UnicodeNever") {
      return "->";
    }
    if (option.tag === "UnicodeAlways") {
      return "\u2192";
    }
    if (option.tag === "UnicodeSource") {
      if (v._1.tag === "ASCII") {
        return "->";
      }
      if (v._1.tag === "Unicode") {
        return "\u2192";
      }
      fail();
    }
    fail();
  }
  if (v.tag === "TokRightFatArrow") {
    if (option.tag === "UnicodeNever") {
      return "=>";
    }
    if (option.tag === "UnicodeAlways") {
      return "\u21D2";
    }
    if (option.tag === "UnicodeSource") {
      if (v._1.tag === "ASCII") {
        return "=>";
      }
      if (v._1.tag === "Unicode") {
        return "\u21D2";
      }
      fail();
    }
    fail();
  }
  if (v.tag === "TokDoubleColon") {
    if (option.tag === "UnicodeNever") {
      return "::";
    }
    if (option.tag === "UnicodeAlways") {
      return "\u2237";
    }
    if (option.tag === "UnicodeSource") {
      if (v._1.tag === "ASCII") {
        return "::";
      }
      if (v._1.tag === "Unicode") {
        return "\u2237";
      }
      fail();
    }
    fail();
  }
  if (v.tag === "TokForall") {
    if (option.tag === "UnicodeNever") {
      return "forall";
    }
    if (option.tag === "UnicodeAlways") {
      return "\u2200";
    }
    if (option.tag === "UnicodeSource") {
      if (v._1.tag === "ASCII") {
        return "forall";
      }
      if (v._1.tag === "Unicode") {
        return "\u2200";
      }
      fail();
    }
    fail();
  }
  if (v.tag === "TokEquals") {
    return "=";
  }
  if (v.tag === "TokPipe") {
    return "|";
  }
  if (v.tag === "TokTick") {
    return "`";
  }
  if (v.tag === "TokDot") {
    return ".";
  }
  if (v.tag === "TokComma") {
    return ",";
  }
  if (v.tag === "TokUnderscore") {
    return "_";
  }
  if (v.tag === "TokBackslash") {
    return "\\";
  }
  if (v.tag === "TokAt") {
    return "@";
  }
  if (v.tag === "TokLowerName") {
    if (v._1.tag === "Nothing") {
      return v._2;
    }
    if (v._1.tag === "Just") {
      return v._1._1 + ("." + v._2);
    }
    fail();
  }
  if (v.tag === "TokUpperName") {
    if (v._1.tag === "Nothing") {
      return v._2;
    }
    if (v._1.tag === "Just") {
      return v._1._1 + ("." + v._2);
    }
    fail();
  }
  if (v.tag === "TokOperator") {
    if (v._1.tag === "Nothing") {
      return v._2;
    }
    if (v._1.tag === "Just") {
      return v._1._1 + ("." + v._2);
    }
    fail();
  }
  if (v.tag === "TokSymbolName") {
    const $2 = "(" + (v._2 + ")");
    if (v._1.tag === "Nothing") {
      return $2;
    }
    if (v._1.tag === "Just") {
      return v._1._1 + ("." + $2);
    }
    fail();
  }
  if (v.tag === "TokSymbolArrow") {
    if (option.tag === "UnicodeNever") {
      return "(->)";
    }
    if (option.tag === "UnicodeAlways") {
      return "(\u2192)";
    }
    if (option.tag === "UnicodeSource") {
      if (v._1.tag === "ASCII") {
        return "(->)";
      }
      if (v._1.tag === "Unicode") {
        return "(\u2192)";
      }
      fail();
    }
    fail();
  }
  if (v.tag === "TokHole") {
    return "?" + v._1;
  }
  if (v.tag === "TokChar") {
    return "'" + (v._1 + "'");
  }
  if (v.tag === "TokString") {
    return '"' + (v._1 + '"');
  }
  if (v.tag === "TokRawString") {
    return '"""' + (v._1 + '"""');
  }
  if (v.tag === "TokInt") {
    return v._1;
  }
  if (v.tag === "TokNumber") {
    return v._1;
  }
  if (v.tag === "TokLayoutStart") {
    return "";
  }
  if (v.tag === "TokLayoutSep") {
    return "";
  }
  if (v.tag === "TokLayoutEnd") {
    return "";
  }
  fail();
};

// output-es/Tidy/index.js
var $DeclGroup = (tag, _1) => ({ tag, _1 });
var $DeclGroupSeparator = (tag) => ({ tag });
var $ElseIfChain = (tag, _1, _2, _3, _4, _5) => ({ tag, _1, _2, _3, _4, _5 });
var $FormatGrouped = (tag) => ({ tag });
var $ImportComparison = (tag, _1, _2, _3) => ({ tag, _1, _2, _3 });
var $ImportModuleComparison = (_1, _2, _3, _4) => ({ tag: "ImportModuleCmp", _1, _2, _3, _4 });
var $ImportSortOption = (tag) => ({ tag });
var $ImportWrapOption = (tag) => ({ tag });
var $Poly = (tag, _1, _2, _3) => ({ tag, _1, _2, _3 });
var $TypeArrowOption = (tag) => ({ tag });
var lines2 = /* @__PURE__ */ foldrArray(appendBreak)(Empty);
var intercalate4 = /* @__PURE__ */ intercalate1(monoidDoc);
var identity14 = (x) => x;
var eq5 = /* @__PURE__ */ eqArrayImpl(eqStringImpl);
var compare3 = /* @__PURE__ */ (() => ordArray(ordString).compare)();
var compare7 = /* @__PURE__ */ (() => ordMaybe(ordString).compare)();
var foldMap3 = /* @__PURE__ */ (() => foldableArray.foldMap(monoidFormatDoc))();
var TypeArrowFirst = /* @__PURE__ */ $TypeArrowOption("TypeArrowFirst");
var TypeArrowLast = /* @__PURE__ */ $TypeArrowOption("TypeArrowLast");
var ImportWrapSource = /* @__PURE__ */ $ImportWrapOption("ImportWrapSource");
var ImportWrapAuto = /* @__PURE__ */ $ImportWrapOption("ImportWrapAuto");
var ImportSortSource = /* @__PURE__ */ $ImportSortOption("ImportSortSource");
var ImportSortIde = /* @__PURE__ */ $ImportSortOption("ImportSortIde");
var ImportErrorCmp = /* @__PURE__ */ $ImportComparison("ImportErrorCmp");
var Grouped = /* @__PURE__ */ $FormatGrouped("Grouped");
var NotGrouped = /* @__PURE__ */ $FormatGrouped("NotGrouped");
var DeclGroupSame = /* @__PURE__ */ $DeclGroupSeparator("DeclGroupSame");
var DeclGroupHard = /* @__PURE__ */ $DeclGroupSeparator("DeclGroupHard");
var DeclGroupSoft = /* @__PURE__ */ $DeclGroupSeparator("DeclGroupSoft");
var DeclGroupInstance = /* @__PURE__ */ $DeclGroup("DeclGroupInstance");
var DeclGroupFixity = /* @__PURE__ */ $DeclGroup("DeclGroupFixity");
var DeclGroupForeign = /* @__PURE__ */ $DeclGroup("DeclGroupForeign");
var DeclGroupRole = /* @__PURE__ */ $DeclGroup("DeclGroupRole");
var DeclGroupUnknown = /* @__PURE__ */ $DeclGroup("DeclGroupUnknown");
var toPolytype = /* @__PURE__ */ (() => {
  const go = (go$a0$copy) => (go$a1$copy) => {
    let go$a0 = go$a0$copy, go$a1 = go$a1$copy, go$c = true, go$r;
    while (go$c) {
      const init2 = go$a0, v = go$a1;
      if (v.tag === "TypeForall") {
        go$a0 = run(withArray(pushAll([$Poly("PolyForall", v._1, v._2, v._3)]))(init2));
        go$a1 = v._4;
        continue;
      }
      if (v.tag === "TypeArrow") {
        go$a0 = run(withArray(pushAll([$Poly("PolyArrow", v._1, v._2)]))(init2));
        go$a1 = v._3;
        continue;
      }
      if (v.tag === "TypeConstrained") {
        go$a0 = run(withArray(pushAll([$Poly("PolyArrow", v._1, v._2)]))(init2));
        go$a1 = v._3;
        continue;
      }
      go$c = false;
      go$r = { init: init2, last: v };
      continue;
    }
    ;
    return go$r;
  };
  return go([]);
})();
var toElseIfChain = (ifte) => {
  const go = (go$a0$copy) => (go$a1$copy) => {
    let go$a0 = go$a0$copy, go$a1 = go$a1$copy, go$c = true, go$r;
    while (go$c) {
      const acc = go$a0, curr = go$a1;
      if (curr.false.tag === "ExprIf") {
        go$a0 = run(withArray(pushAll([
          $ElseIfChain("ElseIfThen", curr.else, curr.false._1.keyword, curr.false._1.cond, curr.false._1.then, curr.false._1.true)
        ]))(acc));
        go$a1 = curr.false._1;
        continue;
      }
      go$c = false;
      go$r = run(withArray(pushAll([$ElseIfChain("Else", curr.else, curr.false)]))(acc));
      continue;
    }
    ;
    return go$r;
  };
  return go([$ElseIfChain("IfThen", ifte.keyword, ifte.cond, ifte.then, ifte.true)])(ifte);
};
var formatString = (x) => {
  const $1 = uncons(splitStringEscapeLines(x));
  if ($1.tag === "Nothing") {
    return monoidFormatDoc.mempty;
  }
  if ($1.tag === "Just") {
    const v1 = unsnoc($1._1.tail);
    if (v1.tag === "Nothing") {
      return text2($1._1.head);
    }
    if (v1.tag === "Just") {
      return joinDoc(force2(semigroupDoc.append(Break)))(joinDoc(force2(semigroupDoc.append(Break)))(text2($1._1.head + "\\"))(joinWithMap(foldableArray)(joinDoc(force2(semigroupDoc.append(Break))))((str) => text2("\\" + (str + "\\")))(v1._1.init)))(text2("\\" + v1._1.last));
    }
    fail();
  }
  fail();
};
var formatRawString = (x) => {
  const $1 = uncons(splitLines(x));
  if ($1.tag === "Nothing") {
    return monoidFormatDoc.mempty;
  }
  if ($1.tag === "Just") {
    if ($1._1.tail.length === 0) {
      return text2($1._1.head);
    }
    const $2 = lines2([
      (() => {
        if ($1._1.head === "") {
          return Empty;
        }
        return $Doc("Text", toCodePointArray($1._1.head).length, $1._1.head);
      })(),
      (() => {
        const $22 = intercalate4(Break)(arrayMap(text)($1._1.tail));
        return $Doc(
          "Local",
          (options) => $Tuple(
            { indent: 0, indentSpaces: "", indentUnit: options.indentUnit, indentWidth: options.indentWidth, pageWidth: options.pageWidth, ribbonRatio: options.ribbonRatio },
            $22
          )
        );
      })()
    ]);
    if ($2.tag === "Empty") {
      return monoidFormatDoc.mempty;
    }
    return { doc: $2, leading: monoidLeadingComment.mempty, isEmpty: false, multiline: false, trailing: monoidTrailingComment.mempty };
  }
  fail();
};
var formatListElem = (alignment) => (format) => (conf) => (b) => flexGroup2(align2(alignment)((() => {
  const $4 = format(conf)(b);
  if ($4.leading.lines > 0) {
    return {
      doc: $4.doc,
      isEmpty: $4.isEmpty,
      leading: { doc: $4.leading.doc, left: $4.leading.left, lines: 0, multiline: $4.leading.multiline, right: $4.leading.right },
      multiline: true,
      trailing: $4.trailing
    };
  }
  return $4;
})()));
var formatHangingOperatorTree = (formatOperator) => (format) => (conf) => {
  const go = (v) => {
    if (v.tag === "OpPure") {
      return format(conf)(v._1);
    }
    if (v.tag === "OpList") {
      return hangOps(go(v._1))(arrayMap((v1) => $HangingOp(
        v1._1.token.range.end.column - v1._1.token.range.start.column | 0,
        formatOperator(conf)(v1._1),
        go(v1._2)
      ))(v._3));
    }
    fail();
  };
  return go;
};
var formatDeclGroups = (declSeparator) => (k) => (format) => (conf) => {
  const joinDecls = (acc) => {
    const newDoc = joinWithMap(foldableNonEmptyList)(joinDoc(force2(semigroupDoc.append(Break))))(format(conf))(acc.decls);
    if (acc.sep.tag === "DeclGroupSame") {
      return joinDoc(force2(semigroupDoc.append(Break)))(newDoc)(acc.doc);
    }
    if (acc.sep.tag === "DeclGroupSoft") {
      return flexDoubleBreak(newDoc)(acc.doc);
    }
    if (acc.sep.tag === "DeclGroupHard") {
      return joinDoc(force2(semigroupDoc.append(Break)))(newDoc)(forceMinSourceBreaks(2)(acc.doc));
    }
    fail();
  };
  const $5 = foldrArray((decl) => (x) => $Maybe(
    "Just",
    (() => {
      if (x.tag === "Nothing") {
        return { doc: monoidFormatDoc.mempty, sep: DeclGroupSame, group: k(decl), decls: $NonEmpty(decl, Nil) };
      }
      if (x.tag === "Just") {
        const group = k(decl);
        const v1 = declSeparator(group)(x._1.group);
        if (v1.tag === "DeclGroupSame") {
          return { doc: x._1.doc, sep: x._1.sep, group, decls: $NonEmpty(decl, $List("Cons", x._1.decls._1, x._1.decls._2)) };
        }
        return { doc: joinDecls(x._1), sep: v1, group, decls: $NonEmpty(decl, Nil) };
      }
      fail();
    })()
  ))(Nothing);
  return (x) => {
    const $7 = $5(x);
    if ($7.tag === "Nothing") {
      return monoidFormatDoc.mempty;
    }
    if ($7.tag === "Just") {
      return joinDecls($7._1);
    }
    fail();
  };
};
var formatComment = (lineComment2) => (blockComment) => (com) => (next) => {
  if (com.tag === "Comment") {
    if (take(2)(com._1) === "--") {
      return lineComment2(com._1)(next);
    }
    return blockComment(com._1)(next);
  }
  if (com.tag === "Line") {
    return {
      doc: next.doc,
      isEmpty: false,
      leading: { doc: next.leading.doc, left: next.leading.left, lines: next.leading.lines + com._2 | 0, multiline: next.leading.multiline, right: next.leading.right },
      multiline: next.multiline,
      trailing: next.trailing
    };
  }
  if (com.tag === "Space") {
    return next;
  }
  fail();
};
var formatWithComments = (leading) => (trailing) => (doc) => foldrArray(formatComment(leadingLineComment)(leadingBlockComment))(joinDoc(force2(identity12))(doc)(foldrArray(formatComment(trailingLineComment)(trailingBlockComment))(monoidFormatDoc.mempty)(trailing)))(leading);
var formatToken = (conf) => (tok) => {
  const tokStr = printToken(conf.unicode)(tok.value);
  return formatWithComments(tok.leadingComments)(tok.trailingComments)((() => {
    if (tok.value.tag === "TokRawString") {
      return formatRawString(tokStr);
    }
    if (tok.value.tag === "TokString") {
      return formatString(tokStr);
    }
    return text2(tokStr);
  })());
};
var formatEmptyList = (conf) => (v) => joinDoc(force2(identity12))(formatToken(conf)(v.open))(formatToken(conf)(v.close));
var formatListTail = (alignment) => (format) => (conf) => joinWithMap(foldableArray)(softBreak)((v) => joinDoc(force2(semigroupDoc.append($Doc(
  "Text",
  1,
  " "
))))(formatToken(conf)(v._1))(formatListElem(alignment)(format)(conf)(v._2)));
var formatList = (openSpace) => (closeSpace) => (alignment) => (grouped) => (format) => (conf) => (v) => {
  const listElems = closeSpace(softBreak(formatListElem(alignment)(format)(conf)(v.head))(formatListTail(alignment)(format)(conf)(v.tail)))(formatToken(conf)(v.close));
  if (grouped.tag === "Grouped") {
    return flexGroup2(openSpace(formatToken(conf)(v.open))(listElems));
  }
  if (grouped.tag === "NotGrouped") {
    return openSpace(formatToken(conf)(v.open))(listElems);
  }
  fail();
};
var formatDelimited = (openSpace) => (closeSpace) => (alignment) => (grouped) => (format) => (conf) => (v) => {
  if (v.value.tag === "Nothing") {
    return formatEmptyList(conf)({ open: v.open, close: v.close });
  }
  if (v.value.tag === "Just") {
    return formatList(openSpace)(closeSpace)(alignment)(grouped)(format)(conf)({ open: v.open, head: v.value._1.head, tail: v.value._1.tail, close: v.close });
  }
  fail();
};
var formatDelimitedNonEmpty = (openSpace) => (closeSpace) => (alignment) => (grouped) => (format) => (conf) => (v) => formatList(openSpace)(closeSpace)(alignment)(grouped)(format)(conf)({
  open: v.open,
  head: v.value.head,
  tail: v.value.tail,
  close: v.close
});
var formatOneOrDelimited = (format) => (conf) => (v) => {
  if (v.tag === "One") {
    return format(conf)(v._1);
  }
  if (v.tag === "Many") {
    return formatDelimitedNonEmpty(softSpace)(softBreak)(2)(NotGrouped)(format)(conf)(v._1);
  }
  fail();
};
var formatName = (conf) => (v) => formatToken(conf)(v.token);
var formatDataMembers = (conf) => (v) => {
  if (v.tag === "DataAll") {
    return formatToken(conf)(v._1);
  }
  if (v.tag === "DataEnumerated") {
    return formatDelimited(softSpace)(softBreak)(2)(NotGrouped)(formatName)(conf)(v._1);
  }
  fail();
};
var formatExport = (conf) => (v) => {
  if (v.tag === "ExportValue") {
    return formatToken(conf)(v._1.token);
  }
  if (v.tag === "ExportOp") {
    return formatToken(conf)(v._1.token);
  }
  if (v.tag === "ExportType") {
    return flexGroup2(softBreak(formatToken(conf)(v._1.token))(indent((() => {
      if (v._2.tag === "Nothing") {
        return monoidFormatDoc.mempty;
      }
      if (v._2.tag === "Just") {
        return formatDataMembers(conf)(v._2._1);
      }
      fail();
    })())));
  }
  if (v.tag === "ExportTypeOp") {
    return joinDoc(force2(semigroupDoc.append($Doc("Text", 1, " "))))(formatToken(conf)(v._1))((() => {
      const $2 = formatToken(conf)(v._2.token);
      if ($2.leading.lines > 0) {
        return {
          doc: $2.doc,
          isEmpty: $2.isEmpty,
          leading: { doc: $2.leading.doc, left: $2.leading.left, lines: 0, multiline: $2.leading.multiline, right: $2.leading.right },
          multiline: true,
          trailing: $2.trailing
        };
      }
      return $2;
    })());
  }
  if (v.tag === "ExportClass") {
    return joinDoc(force2(semigroupDoc.append($Doc("Text", 1, " "))))(formatToken(conf)(v._1))((() => {
      const $2 = formatToken(conf)(v._2.token);
      if ($2.leading.lines > 0) {
        return {
          doc: $2.doc,
          isEmpty: $2.isEmpty,
          leading: { doc: $2.leading.doc, left: $2.leading.left, lines: 0, multiline: $2.leading.multiline, right: $2.leading.right },
          multiline: true,
          trailing: $2.trailing
        };
      }
      return $2;
    })());
  }
  if (v.tag === "ExportModule") {
    return joinDoc(force2(semigroupDoc.append($Doc("Text", 1, " "))))(formatToken(conf)(v._1))((() => {
      const $2 = formatToken(conf)(v._2.token);
      if ($2.leading.lines > 0) {
        return {
          doc: $2.doc,
          isEmpty: $2.isEmpty,
          leading: { doc: $2.leading.doc, left: $2.leading.left, lines: 0, multiline: $2.leading.multiline, right: $2.leading.right },
          multiline: true,
          trailing: $2.trailing
        };
      }
      return $2;
    })());
  }
  if (v.tag === "ExportError") {
    return conf.formatError(v._1);
  }
  fail();
};
var formatFundep = (conf) => (v) => {
  if (v.tag === "FundepDetermined") {
    return joinDoc(force2(semigroupDoc.append($Doc("Text", 1, " "))))(formatToken(conf)(v._1))(joinWithMap(foldableArray)(joinDoc(force2(semigroupDoc.append($Doc(
      "Text",
      1,
      " "
    )))))(formatName(conf))(v._2));
  }
  if (v.tag === "FundepDetermines") {
    return joinDoc(force2(semigroupDoc.append($Doc("Text", 1, " "))))(joinDoc(force2(semigroupDoc.append($Doc(
      "Text",
      1,
      " "
    ))))(joinWithMap(foldableArray)(joinDoc(force2(semigroupDoc.append($Doc("Text", 1, " ")))))(formatName(conf))(v._1))(formatToken(conf)(v._2)))(joinWithMap(foldableArray)(joinDoc(force2(semigroupDoc.append($Doc(
      "Text",
      1,
      " "
    )))))(formatName(conf))(v._3));
  }
  fail();
};
var formatImport = (conf) => (v) => {
  if (v.tag === "ImportValue") {
    return formatToken(conf)(v._1.token);
  }
  if (v.tag === "ImportOp") {
    return formatToken(conf)(v._1.token);
  }
  if (v.tag === "ImportType") {
    return flexGroup2(softBreak(formatToken(conf)(v._1.token))(indent((() => {
      if (v._2.tag === "Nothing") {
        return monoidFormatDoc.mempty;
      }
      if (v._2.tag === "Just") {
        return formatDataMembers(conf)(v._2._1);
      }
      fail();
    })())));
  }
  if (v.tag === "ImportTypeOp") {
    return joinDoc(force2(semigroupDoc.append($Doc("Text", 1, " "))))(formatToken(conf)(v._1))((() => {
      const $2 = formatToken(conf)(v._2.token);
      if ($2.leading.lines > 0) {
        return {
          doc: $2.doc,
          isEmpty: $2.isEmpty,
          leading: { doc: $2.leading.doc, left: $2.leading.left, lines: 0, multiline: $2.leading.multiline, right: $2.leading.right },
          multiline: true,
          trailing: $2.trailing
        };
      }
      return $2;
    })());
  }
  if (v.tag === "ImportClass") {
    return joinDoc(force2(semigroupDoc.append($Doc("Text", 1, " "))))(formatToken(conf)(v._1))((() => {
      const $2 = formatToken(conf)(v._2.token);
      if ($2.leading.lines > 0) {
        return {
          doc: $2.doc,
          isEmpty: $2.isEmpty,
          leading: { doc: $2.leading.doc, left: $2.leading.left, lines: 0, multiline: $2.leading.multiline, right: $2.leading.right },
          multiline: true,
          trailing: $2.trailing
        };
      }
      return $2;
    })());
  }
  if (v.tag === "ImportError") {
    return conf.formatError(v._1);
  }
  fail();
};
var formatImportDecl = (conf) => (v) => {
  const formatImportQualified = (v1) => joinDoc(force2(semigroupDoc.append($Doc("Text", 1, " "))))(formatToken(conf)(v1._1))((() => {
    const $3 = formatToken(conf)(v1._2.token);
    if ($3.leading.lines > 0) {
      return {
        doc: $3.doc,
        isEmpty: $3.isEmpty,
        leading: { doc: $3.leading.doc, left: $3.leading.left, lines: 0, multiline: $3.leading.multiline, right: $3.leading.right },
        multiline: true,
        trailing: $3.trailing
      };
    }
    return $3;
  })());
  return joinDoc(force2(semigroupDoc.append($Doc("Text", 1, " "))))(formatToken(conf)(v.keyword))(indent((() => {
    const $3 = (() => {
      if (v.names.tag === "Just") {
        if (v.names._1._1.tag === "Just") {
          return joinDoc(force2(semigroupDoc.append($Doc("Text", 1, " "))))(flexSpaceBreak(joinDoc(force2(semigroupDoc.append($Doc(
            "Text",
            1,
            " "
          ))))(formatToken(conf)(v.module.token))((() => {
            const $32 = formatToken(conf)(v.names._1._1._1);
            if ($32.leading.lines > 0) {
              return {
                doc: $32.doc,
                isEmpty: $32.isEmpty,
                leading: { doc: $32.leading.doc, left: $32.leading.left, lines: 0, multiline: $32.leading.multiline, right: $32.leading.right },
                multiline: true,
                trailing: $32.trailing
              };
            }
            return $32;
          })()))((() => {
            const $32 = formatDelimitedNonEmpty(softSpace)(softBreak)(2)(NotGrouped)(formatImport)(conf)(v.names._1._2);
            if ($32.leading.lines > 0) {
              return {
                doc: $32.doc,
                isEmpty: $32.isEmpty,
                leading: { doc: $32.leading.doc, left: $32.leading.left, lines: 0, multiline: $32.leading.multiline, right: $32.leading.right },
                multiline: true,
                trailing: $32.trailing
              };
            }
            return $32;
          })()))((() => {
            const $32 = (() => {
              if (v.qualified.tag === "Nothing") {
                return monoidFormatDoc.mempty;
              }
              if (v.qualified.tag === "Just") {
                return formatImportQualified(v.qualified._1);
              }
              fail();
            })();
            if ($32.leading.lines > 0) {
              return {
                doc: $32.doc,
                isEmpty: $32.isEmpty,
                leading: { doc: $32.leading.doc, left: $32.leading.left, lines: 0, multiline: $32.leading.multiline, right: $32.leading.right },
                multiline: true,
                trailing: $32.trailing
              };
            }
            return $32;
          })());
        }
        if (v.names._1._1.tag === "Nothing") {
          return joinDoc(force2(semigroupDoc.append($Doc("Text", 1, " "))))(flexSpaceBreak(formatToken(conf)(v.module.token))((() => {
            const $32 = formatDelimitedNonEmpty(softSpace)(softBreak)(2)(NotGrouped)(formatImport)(conf)(v.names._1._2);
            if ($32.leading.lines > 0) {
              return {
                doc: $32.doc,
                isEmpty: $32.isEmpty,
                leading: { doc: $32.leading.doc, left: $32.leading.left, lines: 0, multiline: $32.leading.multiline, right: $32.leading.right },
                multiline: true,
                trailing: $32.trailing
              };
            }
            return $32;
          })()))((() => {
            const $32 = (() => {
              if (v.qualified.tag === "Nothing") {
                return monoidFormatDoc.mempty;
              }
              if (v.qualified.tag === "Just") {
                return formatImportQualified(v.qualified._1);
              }
              fail();
            })();
            if ($32.leading.lines > 0) {
              return {
                doc: $32.doc,
                isEmpty: $32.isEmpty,
                leading: { doc: $32.leading.doc, left: $32.leading.left, lines: 0, multiline: $32.leading.multiline, right: $32.leading.right },
                multiline: true,
                trailing: $32.trailing
              };
            }
            return $32;
          })());
        }
        fail();
      }
      if (v.names.tag === "Nothing") {
        return joinDoc(force2(semigroupDoc.append($Doc("Text", 1, " "))))(formatToken(conf)(v.module.token))((() => {
          const $32 = (() => {
            if (v.qualified.tag === "Nothing") {
              return monoidFormatDoc.mempty;
            }
            if (v.qualified.tag === "Just") {
              return formatImportQualified(v.qualified._1);
            }
            fail();
          })();
          if ($32.leading.lines > 0) {
            return {
              doc: $32.doc,
              isEmpty: $32.isEmpty,
              leading: { doc: $32.leading.doc, left: $32.leading.left, lines: 0, multiline: $32.leading.multiline, right: $32.leading.right },
              multiline: true,
              trailing: $32.trailing
            };
          }
          return $32;
        })());
      }
      fail();
    })();
    if ($3.leading.lines > 0) {
      return {
        doc: $3.doc,
        isEmpty: $3.isEmpty,
        leading: { doc: $3.leading.doc, left: $3.leading.left, lines: 0, multiline: $3.leading.multiline, right: $3.leading.right },
        multiline: true,
        trailing: $3.trailing
      };
    }
    return $3;
  })()));
};
var formatParens = (format) => (conf) => (v) => joinDoc(force2(identity12))(formatToken(conf)(v.open))(joinDoc(force2(identity12))((() => {
  const $3 = format(conf)(v.value);
  if ($3.leading.lines > 0) {
    return {
      doc: $3.doc,
      isEmpty: $3.isEmpty,
      leading: { doc: $3.leading.doc, left: $3.leading.left, lines: 0, multiline: $3.leading.multiline, right: $3.leading.right },
      multiline: true,
      trailing: $3.trailing
    };
  }
  return $3;
})())(formatToken(conf)(v.close)));
var formatParensBlock = (format) => (conf) => (v) => flexGroup2(softSpace(formatToken(conf)(v.open))(softBreak(align2(2)((() => {
  const $3 = format(conf)(v.value);
  if ($3.leading.lines > 0) {
    return {
      doc: $3.doc,
      isEmpty: $3.isEmpty,
      leading: { doc: $3.leading.doc, left: $3.leading.left, lines: 0, multiline: $3.leading.multiline, right: $3.leading.right },
      multiline: true,
      trailing: $3.trailing
    };
  }
  return $3;
})()))(formatToken(conf)(v.close))));
var formatQualifiedName = (conf) => (v) => formatToken(conf)(v.token);
var formatBasicListNonEmpty = /* @__PURE__ */ (() => formatDelimitedNonEmpty(joinDoc(force2(semigroupDoc.append($Doc(
  "Text",
  1,
  " "
)))))(joinDoc(force2(semigroupDoc.append($Doc("FlexAlt", $Doc("Text", 1, " "), Break)))))(2))();
var formatBasicList = /* @__PURE__ */ (() => formatDelimited(joinDoc(force2(semigroupDoc.append($Doc("Text", 1, " ")))))(joinDoc(force2(semigroupDoc.append($Doc(
  "FlexAlt",
  $Doc("Text", 1, " "),
  Break
)))))(2))();
var flatten = (x) => {
  const $1 = uncons(x);
  if ($1.tag === "Nothing") {
    return monoidFormatDoc.mempty;
  }
  if ($1.tag === "Just") {
    return joinDoc(force2(semigroupDoc.append($Doc("Text", 1, " "))))($1._1.head)(indent(joinWithMap(foldableArray)(joinDoc(force2(semigroupDoc.append($Doc(
      "Text",
      1,
      " "
    )))))(anchor)($1._1.tail)));
  }
  fail();
};
var formatTypeVarBinding = (conf) => (v) => {
  if (v.tag === "TypeVarKinded") {
    return formatParensBlock(formatKindedTypeVarBinding)(conf)(v._1);
  }
  if (v.tag === "TypeVarName") {
    return formatToken(conf)(v._1.token);
  }
  fail();
};
var formatType = (conf) => {
  const $1 = formatHangingType(conf);
  return (x) => toFormatDoc($1(x));
};
var formatRowLabeled = (conf) => (v) => joinDoc(force2(semigroupDoc.append($Doc("Text", 1, " "))))(formatToken(conf)(v.label.token))(indent(flexSpaceBreak((() => {
  const $2 = formatToken(conf)(v.separator);
  if ($2.leading.lines > 0) {
    return {
      doc: $2.doc,
      isEmpty: $2.isEmpty,
      leading: { doc: $2.leading.doc, left: $2.leading.left, lines: 0, multiline: $2.leading.multiline, right: $2.leading.right },
      multiline: true,
      trailing: $2.trailing
    };
  }
  return $2;
})())((() => {
  const $2 = formatType(conf)(v.value);
  if ($2.leading.lines > 0) {
    return {
      doc: $2.doc,
      isEmpty: $2.isEmpty,
      leading: { doc: $2.leading.doc, left: $2.leading.left, lines: 0, multiline: $2.leading.multiline, right: $2.leading.right },
      multiline: true,
      trailing: $2.trailing
    };
  }
  return $2;
})())));
var formatRow = (openSpace) => (closeSpace) => (conf) => (v) => {
  if (v.value.tail.tag === "Nothing") {
    if (v.value.labels.tag === "Nothing") {
      return formatEmptyList(conf)({ open: v.open, close: v.close });
    }
    if (v.value.labels.tag === "Just") {
      return formatDelimitedNonEmpty(openSpace)(closeSpace)(2)(Grouped)(formatRowLabeled)(conf)({ open: v.open, value: v.value.labels._1, close: v.close });
    }
    fail();
  }
  if (v.value.tail.tag === "Just") {
    if (v.value.labels.tag === "Nothing") {
      return closeSpace(openSpace(formatToken(conf)(v.open))(flatten([formatToken(conf)(v.value.tail._1._1), formatType(conf)(v.value.tail._1._2)])))(formatToken(conf)(v.close));
    }
    if (v.value.labels.tag === "Just") {
      return closeSpace(joinDoc(force2(semigroupDoc.append($Doc(
        "FlexAlt",
        $Doc("Text", 1, " "),
        Break
      ))))(softBreak(openSpace(formatToken(conf)(v.open))(formatListElem(2)(formatRowLabeled)(conf)(v.value.labels._1.head)))(formatListTail(2)(formatRowLabeled)(conf)(v.value.labels._1.tail)))(joinDoc(force2(semigroupDoc.append($Doc(
        "Text",
        1,
        " "
      ))))(formatToken(conf)(v.value.tail._1._1))(formatListElem(2)(formatType)(conf)(v.value.tail._1._2))))(formatToken(conf)(v.close));
    }
    fail();
  }
  fail();
};
var formatMonotype = (conf) => {
  const $1 = formatHangingMonotype(conf);
  return (x) => toFormatDoc($1(x));
};
var formatKindedTypeVarBinding = (conf) => (v) => joinDoc(force2(semigroupDoc.append($Doc("Text", 1, " "))))(formatToken(conf)(v.label.token))(indent(flexSpaceBreak((() => {
  const $2 = formatToken(conf)(v.separator);
  if ($2.leading.lines > 0) {
    return {
      doc: $2.doc,
      isEmpty: $2.isEmpty,
      leading: { doc: $2.leading.doc, left: $2.leading.left, lines: 0, multiline: $2.leading.multiline, right: $2.leading.right },
      multiline: true,
      trailing: $2.trailing
    };
  }
  return $2;
})())(formatType(conf)(v.value))));
var formatHangingType = (conf) => {
  const $1 = formatHangingPolytype(identity14)(conf);
  return (x) => $1(toPolytype(x));
};
var formatHangingPolytype = (ind) => (conf) => (v) => {
  if (v.init.length === 0) {
    return formatHangingMonotype(conf)(v.last);
  }
  if (conf.typeArrowPlacement.tag === "TypeArrowFirst") {
    const isUnicode = all((() => {
      if (conf.unicode.tag === "UnicodeAlways") {
        return (v$1) => true;
      }
      if (conf.unicode.tag === "UnicodeNever") {
        return (v$1) => false;
      }
      if (conf.unicode.tag === "UnicodeSource") {
        return (v1) => {
          if (v1.tag === "PolyArrow") {
            if (v1._2.value.tag === "TokRightArrow") {
              return v1._2.value._1.tag === "Unicode";
            }
            if (v1._2.value.tag === "TokRightFatArrow") {
              return v1._2.value._1.tag === "Unicode";
            }
            return false;
          }
          if (v1.tag === "PolyForall") {
            if (v1._1.value.tag === "TokForall") {
              return v1._1.value._1.tag === "Unicode";
            }
            return false;
          }
          return false;
        };
      }
      fail();
    })())(v.init);
    return $HangingDoc(
      "HangBreak",
      flexGroup2(foldlArray((k) => (v1) => {
        if (v1.tag === "PolyForall") {
          return (doc) => joinDoc(force2(semigroupDoc.append($Doc("Text", 1, " "))))(softBreak(k(foldlArray((doc$1) => (tyVar) => flexSpaceBreak(doc$1)(indent(formatTypeVarBinding(conf)(tyVar))))(formatToken(conf)(v1._1))(v1._2)))(joinDoc(force2(identity12))((() => {
            if (!isUnicode) {
              return {
                doc: $Doc("FlexAlt", Empty, $Doc("Text", 1, " ")),
                leading: monoidLeadingComment.mempty,
                isEmpty: false,
                multiline: false,
                trailing: monoidTrailingComment.mempty
              };
            }
            return monoidFormatDoc.mempty;
          })())((() => {
            const $7 = formatToken(conf)(v1._3);
            if ($7.leading.lines > 0) {
              return {
                doc: $7.doc,
                isEmpty: $7.isEmpty,
                leading: { doc: $7.leading.doc, left: $7.leading.left, lines: 0, multiline: $7.leading.multiline, right: $7.leading.right },
                multiline: true,
                trailing: $7.trailing
              };
            }
            return $7;
          })())))((() => {
            const $7 = alignCurrentColumn(doc);
            if ($7.leading.lines > 0) {
              return {
                doc: $7.doc,
                isEmpty: $7.isEmpty,
                leading: { doc: $7.leading.doc, left: $7.leading.left, lines: 0, multiline: $7.leading.multiline, right: $7.leading.right },
                multiline: true,
                trailing: $7.trailing
              };
            }
            return $7;
          })());
        }
        if (v1.tag === "PolyArrow") {
          return (doc) => joinDoc(force2(semigroupDoc.append($Doc("Text", 1, " "))))(joinDoc(force2(semigroupDoc.append($Doc(
            "FlexAlt",
            $Doc("Text", 1, " "),
            Break
          ))))(k(flexGroup2(formatMonotype(conf)(v1._1))))((() => {
            const $7 = formatToken(conf)(v1._2);
            if ($7.leading.lines > 0) {
              return {
                doc: $7.doc,
                isEmpty: $7.isEmpty,
                leading: { doc: $7.leading.doc, left: $7.leading.left, lines: 0, multiline: $7.leading.multiline, right: $7.leading.right },
                multiline: true,
                trailing: $7.trailing
              };
            }
            return $7;
          })()))((() => {
            const $7 = alignCurrentColumn(doc);
            if ($7.leading.lines > 0) {
              return {
                doc: $7.doc,
                isEmpty: $7.isEmpty,
                leading: { doc: $7.leading.doc, left: $7.leading.left, lines: 0, multiline: $7.leading.multiline, right: $7.leading.right },
                multiline: true,
                trailing: $7.trailing
              };
            }
            return $7;
          })());
        }
        fail();
      })(ind)(v.init)((() => {
        const $4 = formatMonotype(conf)(v.last);
        if ($4.leading.lines > 0) {
          return {
            doc: $4.doc,
            isEmpty: $4.isEmpty,
            leading: { doc: $4.leading.doc, left: $4.leading.left, lines: 0, multiline: $4.leading.multiline, right: $4.leading.right },
            multiline: true,
            trailing: $4.trailing
          };
        }
        return $4;
      })()))
    );
  }
  if (conf.typeArrowPlacement.tag === "TypeArrowLast") {
    return $HangingDoc(
      "HangBreak",
      flexGroup2(joinDoc(force2(semigroupDoc.append($Doc(
        "FlexAlt",
        $Doc("Text", 1, " "),
        Break
      ))))(joinWithMap(foldableArray)(joinDoc(force2(semigroupDoc.append($Doc(
        "FlexAlt",
        $Doc("Text", 1, " "),
        Break
      )))))((v1) => {
        if (v1.tag === "PolyForall") {
          return joinDoc(force2(identity12))(foldlArray((doc) => (tyVar) => flexSpaceBreak(doc)(indent(formatTypeVarBinding(conf)(tyVar))))(formatToken(conf)(v1._1))(v1._2))(indent((() => {
            const $4 = formatToken(conf)(v1._3);
            if ($4.leading.lines > 0) {
              return {
                doc: $4.doc,
                isEmpty: $4.isEmpty,
                leading: { doc: $4.leading.doc, left: $4.leading.left, lines: 0, multiline: $4.leading.multiline, right: $4.leading.right },
                multiline: true,
                trailing: $4.trailing
              };
            }
            return $4;
          })()));
        }
        if (v1.tag === "PolyArrow") {
          return joinDoc(force2(semigroupDoc.append($Doc("Text", 1, " "))))(flexGroup2(formatType(conf)(v1._1)))(indent((() => {
            const $4 = formatToken(conf)(v1._2);
            if ($4.leading.lines > 0) {
              return {
                doc: $4.doc,
                isEmpty: $4.isEmpty,
                leading: { doc: $4.leading.doc, left: $4.leading.left, lines: 0, multiline: $4.leading.multiline, right: $4.leading.right },
                multiline: true,
                trailing: $4.trailing
              };
            }
            return $4;
          })()));
        }
        fail();
      })(v.init))(flexGroup2(formatMonotype(conf)(v.last))))
    );
  }
  fail();
};
var formatHangingMonotype = (conf) => (v) => {
  if (v.tag === "TypeVar") {
    return $HangingDoc("HangBreak", flexGroup2(formatToken(conf)(v._1.token)));
  }
  if (v.tag === "TypeConstructor") {
    return $HangingDoc("HangBreak", flexGroup2(formatToken(conf)(v._1.token)));
  }
  if (v.tag === "TypeWildcard") {
    return $HangingDoc("HangBreak", flexGroup2(formatToken(conf)(v._1)));
  }
  if (v.tag === "TypeHole") {
    return $HangingDoc("HangBreak", flexGroup2(formatToken(conf)(v._1.token)));
  }
  if (v.tag === "TypeString") {
    return $HangingDoc("HangBreak", flexGroup2(formatToken(conf)(v._1)));
  }
  if (v.tag === "TypeInt") {
    return $HangingDoc(
      "HangBreak",
      flexGroup2(joinDoc(force2(identity12))((() => {
        if (v._1.tag === "Nothing") {
          return monoidFormatDoc.mempty;
        }
        if (v._1.tag === "Just") {
          return formatToken(conf)(v._1._1);
        }
        fail();
      })())(formatToken(conf)(v._2)))
    );
  }
  if (v.tag === "TypeArrowName") {
    return $HangingDoc("HangBreak", flexGroup2(formatToken(conf)(v._1)));
  }
  if (v.tag === "TypeOpName") {
    return $HangingDoc("HangBreak", flexGroup2(formatToken(conf)(v._1.token)));
  }
  if (v.tag === "TypeRow") {
    return $HangingDoc("HangBreak", flexGroup2(formatRow(softSpace)(softBreak)(conf)(v._1)));
  }
  if (v.tag === "TypeRecord") {
    return $HangingDoc(
      "HangBreak",
      flexGroup2(formatRow(joinDoc(force2(semigroupDoc.append($Doc("Text", 1, " ")))))(joinDoc(force2(semigroupDoc.append($Doc(
        "FlexAlt",
        $Doc("Text", 1, " "),
        Break
      )))))(conf)(v._1))
    );
  }
  if (v.tag === "TypeApp") {
    return hangApp(formatHangingType(conf)(v._1))(arrayMap(formatHangingType(conf))(v._2));
  }
  if (v.tag === "TypeParens") {
    return $HangingDoc("HangBreak", flexGroup2(formatParensBlock(formatType)(conf)(v._1)));
  }
  if (v.tag === "TypeKinded") {
    return $HangingDoc(
      "HangBreak",
      flexGroup2(joinDoc(force2(semigroupDoc.append($Doc("Text", 1, " "))))(formatType(conf)(v._1))(indent(flexSpaceBreak((() => {
        const $2 = formatToken(conf)(v._2);
        if ($2.leading.lines > 0) {
          return {
            doc: $2.doc,
            isEmpty: $2.isEmpty,
            leading: { doc: $2.leading.doc, left: $2.leading.left, lines: 0, multiline: $2.leading.multiline, right: $2.leading.right },
            multiline: true,
            trailing: $2.trailing
          };
        }
        return $2;
      })())((() => {
        const $2 = formatType(conf)(v._3);
        if ($2.leading.lines > 0) {
          return {
            doc: $2.doc,
            isEmpty: $2.isEmpty,
            leading: { doc: $2.leading.doc, left: $2.leading.left, lines: 0, multiline: $2.leading.multiline, right: $2.leading.right },
            multiline: true,
            trailing: $2.trailing
          };
        }
        return $2;
      })()))))
    );
  }
  if (v.tag === "TypeOp") {
    return formatHangingOperatorTree(formatQualifiedName)(formatHangingType)(conf)(toOperatorTree(conf.operators)((v$1) => $QualifiedOperator(
      v$1.module,
      OperatorType,
      v$1.name
    ))(v._1)(v._2));
  }
  if (v.tag === "TypeError") {
    return $HangingDoc("HangBreak", flexGroup2(conf.formatError(v._1)));
  }
  if (v.tag === "TypeArrow") {
    return _crashWith("formatMonotype: TypeArrow handled by formatPolytype");
  }
  if (v.tag === "TypeConstrained") {
    return _crashWith("formatMonotype: TypeConstrained handled by formatPolytype");
  }
  if (v.tag === "TypeForall") {
    return _crashWith("formatMonotype: TypeForall handled by formatPolytype");
  }
  fail();
};
var formatHangingDataCtor = (conf) => (v) => {
  const hangingName = $HangingDoc("HangBreak", flexGroup2(formatToken(conf)(v.name.token)));
  if (v.fields.length > 0) {
    return hangApp(hangingName)(arrayMap(formatHangingType(conf))(v.fields));
  }
  return hangingName;
};
var formatDataCtor = (conf) => (x) => toFormatDoc(formatHangingDataCtor(conf)(x));
var formatConstraints = (conf) => (v) => joinDoc(force2(semigroupDoc.append($Doc("Text", 1, " "))))(formatOneOrDelimited(formatType)(conf)(v._1))((() => {
  const $2 = formatToken(conf)((() => {
    if (v._2.value.tag === "TokOperator") {
      if (v._2.value._1.tag === "Nothing") {
        if (v._2.value._2 === "<=") {
          if ((() => {
            if (conf.unicode.tag === "UnicodeSource") {
              return false;
            }
            return conf.unicode.tag === "UnicodeAlways";
          })()) {
            return {
              value: $Token("TokOperator", Nothing, "\u21D0"),
              leadingComments: v._2.leadingComments,
              range: v._2.range,
              trailingComments: v._2.trailingComments
            };
          }
          return v._2;
        }
        if (v._2.value._2 === "\u21D0") {
          if ((() => {
            if (conf.unicode.tag === "UnicodeSource") {
              return false;
            }
            if (conf.unicode.tag === "UnicodeAlways") {
              return false;
            }
            return conf.unicode.tag === "UnicodeNever";
          })()) {
            return {
              value: $Token("TokOperator", Nothing, "<="),
              leadingComments: v._2.leadingComments,
              range: v._2.range,
              trailingComments: v._2.trailingComments
            };
          }
          return v._2;
        }
        return v._2;
      }
      return v._2;
    }
    return v._2;
  })());
  if ($2.leading.lines > 0) {
    return {
      doc: $2.doc,
      isEmpty: $2.isEmpty,
      leading: { doc: $2.leading.doc, left: $2.leading.left, lines: 0, multiline: $2.leading.multiline, right: $2.leading.right },
      multiline: true,
      trailing: $2.trailing
    };
  }
  return $2;
})());
var formatInstanceHead = (conf) => (v) => {
  const hdTypes = joinDoc(force2(semigroupDoc.append($Doc("FlexAlt", $Doc("Text", 1, " "), Break))))((() => {
    if (v._1.constraints.tag === "Nothing") {
      return monoidFormatDoc.mempty;
    }
    if (v._1.constraints.tag === "Just") {
      return formatConstraints(conf)(v._1.constraints._1);
    }
    fail();
  })())(flexGroup2(joinDoc(force2(semigroupDoc.append($Doc("Text", 1, " "))))(formatToken(conf)(v._1.className.token))(indent(joinWithMap(foldableArray)(joinDoc(force2(semigroupDoc.append($Doc(
    "FlexAlt",
    $Doc("Text", 1, " "),
    Break
  )))))(formatType(conf))(v._1.types)))));
  if (v._1.name.tag === "Just") {
    return joinDoc(force2(semigroupDoc.append($Doc("Text", 1, " "))))(flexSpaceBreak(joinDoc(force2(semigroupDoc.append($Doc(
      "Text",
      1,
      " "
    ))))(joinDoc(force2(semigroupDoc.append($Doc("Text", 1, " "))))(formatToken(conf)(v._1.keyword))((() => {
      const $3 = formatToken(conf)(v._1.name._1._1.token);
      if ($3.leading.lines > 0) {
        return {
          doc: $3.doc,
          isEmpty: $3.isEmpty,
          leading: { doc: $3.leading.doc, left: $3.leading.left, lines: 0, multiline: $3.leading.multiline, right: $3.leading.right },
          multiline: true,
          trailing: $3.trailing
        };
      }
      return $3;
    })()))((() => {
      const $3 = formatToken(conf)(v._1.name._1._2);
      if ($3.leading.lines > 0) {
        return {
          doc: $3.doc,
          isEmpty: $3.isEmpty,
          leading: { doc: $3.leading.doc, left: $3.leading.left, lines: 0, multiline: $3.leading.multiline, right: $3.leading.right },
          multiline: true,
          trailing: $3.trailing
        };
      }
      return $3;
    })()))(indent(hdTypes)))(indent((() => {
      if (v._2.tag === "Nothing") {
        return monoidFormatDoc.mempty;
      }
      if (v._2.tag === "Just") {
        return formatToken(conf)(v._2._1);
      }
      fail();
    })()));
  }
  if (v._1.name.tag === "Nothing") {
    return joinDoc(force2(semigroupDoc.append($Doc("Text", 1, " "))))(flexSpaceBreak(formatToken(conf)(v._1.keyword))(indent(hdTypes)))(indent((() => {
      if (v._2.tag === "Nothing") {
        return monoidFormatDoc.mempty;
      }
      if (v._2.tag === "Just") {
        return formatToken(conf)(v._2._1);
      }
      fail();
    })()));
  }
  fail();
};
var formatClassHead = (conf) => (v) => flexSpaceBreak(formatToken(conf)(v._1.keyword))(indent(joinDoc(force2(semigroupDoc.append($Doc(
  "Text",
  1,
  " "
))))(joinDoc(force2(semigroupDoc.append($Doc("FlexAlt", $Doc("Text", 1, " "), Break))))(joinDoc(force2(semigroupDoc.append($Doc(
  "FlexAlt",
  $Doc("Text", 1, " "),
  Break
))))((() => {
  const $2 = (() => {
    if (v._1.super.tag === "Nothing") {
      return monoidFormatDoc.mempty;
    }
    if (v._1.super.tag === "Just") {
      return formatConstraints(conf)(v._1.super._1);
    }
    fail();
  })();
  if ($2.leading.lines > 0) {
    return {
      doc: $2.doc,
      isEmpty: $2.isEmpty,
      leading: { doc: $2.leading.doc, left: $2.leading.left, lines: 0, multiline: $2.leading.multiline, right: $2.leading.right },
      multiline: true,
      trailing: $2.trailing
    };
  }
  return $2;
})())(flexGroup2(joinDoc(force2(semigroupDoc.append($Doc(
  "FlexAlt",
  $Doc("Text", 1, " "),
  Break
))))(formatToken(conf)(v._1.name.token))(joinWithMap(foldableArray)(joinDoc(force2(semigroupDoc.append($Doc(
  "FlexAlt",
  $Doc("Text", 1, " "),
  Break
)))))((x) => indent(formatTypeVarBinding(conf)(x)))(v._1.vars)))))(flexGroup2((() => {
  const $2 = (() => {
    if (v._1.fundeps.tag === "Nothing") {
      return monoidFormatDoc.mempty;
    }
    if (v._1.fundeps.tag === "Just") {
      return softBreak(joinDoc(force2(semigroupDoc.append($Doc("Text", 1, " "))))(formatToken(conf)(v._1.fundeps._1._1))(formatListElem(2)(formatFundep)(conf)(v._1.fundeps._1._2.head)))(joinWithMap(foldableArray)(softBreak)((v2) => joinDoc(force2(semigroupDoc.append($Doc(
        "Text",
        1,
        " "
      ))))(formatToken(conf)(v2._1))(formatListElem(2)(formatFundep)(conf)(v2._2)))(v._1.fundeps._1._2.tail));
    }
    fail();
  })();
  if ($2.leading.lines > 0) {
    return {
      doc: $2.doc,
      isEmpty: $2.isEmpty,
      leading: { doc: $2.leading.doc, left: $2.leading.left, lines: 0, multiline: $2.leading.multiline, right: $2.leading.right },
      multiline: true,
      trailing: $2.trailing
    };
  }
  return $2;
})())))((() => {
  if (v._2.tag === "Nothing") {
    return monoidFormatDoc.mempty;
  }
  if (v._2.tag === "Just") {
    return formatToken(conf)(v._2._1);
  }
  fail();
})())));
var formatDataHead = (conf) => (v) => joinDoc(force2(semigroupDoc.append($Doc("Text", 1, " "))))(formatToken(conf)(v.keyword))(indent(flexSpaceBreak((() => {
  const $2 = formatToken(conf)(v.name.token);
  if ($2.leading.lines > 0) {
    return {
      doc: $2.doc,
      isEmpty: $2.isEmpty,
      leading: { doc: $2.leading.doc, left: $2.leading.left, lines: 0, multiline: $2.leading.multiline, right: $2.leading.right },
      multiline: true,
      trailing: $2.trailing
    };
  }
  return $2;
})())(joinWithMap(foldableArray)(joinDoc(force2(semigroupDoc.append($Doc(
  "FlexAlt",
  $Doc("Text", 1, " "),
  Break
)))))(formatTypeVarBinding(conf))(v.vars))));
var formatSignature = (conf) => (v) => {
  if (conf.typeArrowPlacement.tag === "TypeArrowFirst") {
    const polytype = toPolytype(v.value);
    const width = (() => {
      if ((() => {
        if (conf.unicode.tag === "UnicodeAlways") {
          return true;
        }
        if (conf.unicode.tag === "UnicodeNever") {
          return false;
        }
        if (conf.unicode.tag === "UnicodeSource") {
          if (v.separator.value.tag === "TokDoubleColon") {
            return v.separator.value._1.tag === "Unicode";
          }
          return false;
        }
        fail();
      })()) {
        return 2;
      }
      return 3;
    })();
    const formattedPolytype = formatHangingPolytype(align2(width))(conf)(polytype);
    if (polytype.init.length === 0) {
      return flexSpaceBreak(v.label)(indent(joinDoc(force2(semigroupDoc.append($Doc("Text", 1, " "))))((() => {
        const $5 = formatToken(conf)(v.separator);
        if ($5.leading.lines > 0) {
          return {
            doc: $5.doc,
            isEmpty: $5.isEmpty,
            leading: { doc: $5.leading.doc, left: $5.leading.left, lines: 0, multiline: $5.leading.multiline, right: $5.leading.right },
            multiline: true,
            trailing: $5.trailing
          };
        }
        return $5;
      })())((() => {
        const $5 = align2(width)(toFormatDoc(formattedPolytype));
        if ($5.leading.lines > 0) {
          return {
            doc: $5.doc,
            isEmpty: $5.isEmpty,
            leading: { doc: $5.leading.doc, left: $5.leading.left, lines: 0, multiline: $5.leading.multiline, right: $5.leading.right },
            multiline: true,
            trailing: $5.trailing
          };
        }
        return $5;
      })())));
    }
    return flexSpaceBreak(v.label)(indent(joinDoc(force2(semigroupDoc.append($Doc("Text", 1, " "))))((() => {
      const $5 = formatToken(conf)(v.separator);
      if ($5.leading.lines > 0) {
        return {
          doc: $5.doc,
          isEmpty: $5.isEmpty,
          leading: { doc: $5.leading.doc, left: $5.leading.left, lines: 0, multiline: $5.leading.multiline, right: $5.leading.right },
          multiline: true,
          trailing: $5.trailing
        };
      }
      return $5;
    })())((() => {
      const $5 = toFormatDoc(formattedPolytype);
      if ($5.leading.lines > 0) {
        return {
          doc: $5.doc,
          isEmpty: $5.isEmpty,
          leading: { doc: $5.leading.doc, left: $5.leading.left, lines: 0, multiline: $5.leading.multiline, right: $5.leading.right },
          multiline: true,
          trailing: $5.trailing
        };
      }
      return $5;
    })())));
  }
  if (conf.typeArrowPlacement.tag === "TypeArrowLast") {
    return joinDoc(force2(semigroupDoc.append($Doc("Text", 1, " "))))(v.label)(indent(flexGroup2(joinDoc(force2(semigroupDoc.append($Doc(
      "FlexAlt",
      $Doc("Text", 1, " "),
      Break
    ))))((() => {
      const $2 = formatToken(conf)(v.separator);
      if ($2.leading.lines > 0) {
        return {
          doc: $2.doc,
          isEmpty: $2.isEmpty,
          leading: { doc: $2.leading.doc, left: $2.leading.left, lines: 0, multiline: $2.leading.multiline, right: $2.leading.right },
          multiline: true,
          trailing: $2.trailing
        };
      }
      return $2;
    })())((() => {
      const $2 = flexGroup2(formatType(conf)(v.value));
      if ($2.leading.lines > 0) {
        return {
          doc: $2.doc,
          isEmpty: $2.isEmpty,
          leading: { doc: $2.leading.doc, left: $2.leading.left, lines: 0, multiline: $2.leading.multiline, right: $2.leading.right },
          multiline: true,
          trailing: $2.trailing
        };
      }
      return $2;
    })()))));
  }
  fail();
};
var eqImportComparison = {
  eq: (x) => (y) => {
    if (x.tag === "ImportClassCmp") {
      if (y.tag === "ImportClassCmp") {
        return x._1 === y._1;
      }
      return false;
    }
    if (x.tag === "ImportTypeOpCmp") {
      if (y.tag === "ImportTypeOpCmp") {
        return x._1 === y._1;
      }
      return false;
    }
    if (x.tag === "ImportTypeCmp") {
      if (y.tag === "ImportTypeCmp") {
        return x._1 === y._1 && x._2 === y._2 && eq5(x._3)(y._3);
      }
      return false;
    }
    if (x.tag === "ImportValueCmp") {
      if (y.tag === "ImportValueCmp") {
        return x._1 === y._1;
      }
      return false;
    }
    if (x.tag === "ImportOpCmp") {
      if (y.tag === "ImportOpCmp") {
        return x._1 === y._1;
      }
      return false;
    }
    if (x.tag === "ImportErrorCmp") {
      return y.tag === "ImportErrorCmp";
    }
    return false;
  }
};
var eq10 = /* @__PURE__ */ (() => eqArrayImpl(eqImportComparison.eq))();
var eqImportModuleComparison = {
  eq: (x) => (y) => x._1 === y._1 && x._2 === y._2 && eq10(x._3)(y._3) && (() => {
    if (x._4.tag === "Nothing") {
      return y._4.tag === "Nothing";
    }
    if (x._4.tag === "Just") {
      if (y._4.tag === "Just") {
        return x._4._1 === y._4._1;
      }
      return false;
    }
    return false;
  })()
};
var ordImportComparison = {
  compare: (x) => (y) => {
    if (x.tag === "ImportClassCmp") {
      if (y.tag === "ImportClassCmp") {
        return ordString.compare(x._1)(y._1);
      }
      return LT;
    }
    if (y.tag === "ImportClassCmp") {
      return GT;
    }
    if (x.tag === "ImportTypeOpCmp") {
      if (y.tag === "ImportTypeOpCmp") {
        return ordString.compare(x._1)(y._1);
      }
      return LT;
    }
    if (y.tag === "ImportTypeOpCmp") {
      return GT;
    }
    if (x.tag === "ImportTypeCmp") {
      if (y.tag === "ImportTypeCmp") {
        const v = ordString.compare(x._1)(y._1);
        if (v.tag === "LT") {
          return LT;
        }
        if (v.tag === "GT") {
          return GT;
        }
        const v1 = ordBoolean.compare(x._2)(y._2);
        if (v1.tag === "LT") {
          return LT;
        }
        if (v1.tag === "GT") {
          return GT;
        }
        return compare3(x._3)(y._3);
      }
      return LT;
    }
    if (y.tag === "ImportTypeCmp") {
      return GT;
    }
    if (x.tag === "ImportValueCmp") {
      if (y.tag === "ImportValueCmp") {
        return ordString.compare(x._1)(y._1);
      }
      return LT;
    }
    if (y.tag === "ImportValueCmp") {
      return GT;
    }
    if (x.tag === "ImportOpCmp") {
      if (y.tag === "ImportOpCmp") {
        return ordString.compare(x._1)(y._1);
      }
      return LT;
    }
    if (y.tag === "ImportOpCmp") {
      return GT;
    }
    if (x.tag === "ImportErrorCmp") {
      if (y.tag === "ImportErrorCmp") {
        return EQ;
      }
      fail();
    }
    fail();
  },
  Eq0: () => eqImportComparison
};
var compare8 = /* @__PURE__ */ (() => ordArray(ordImportComparison).compare)();
var ordImportModuleComparison = {
  compare: (x) => (y) => {
    const v = ordString.compare(x._1)(y._1);
    if (v.tag === "LT") {
      return LT;
    }
    if (v.tag === "GT") {
      return GT;
    }
    const v1 = ordInt.compare(x._2)(y._2);
    if (v1.tag === "LT") {
      return LT;
    }
    if (v1.tag === "GT") {
      return GT;
    }
    const v2 = compare8(x._3)(y._3);
    if (v2.tag === "LT") {
      return LT;
    }
    if (v2.tag === "GT") {
      return GT;
    }
    return compare7(x._4)(y._4);
  },
  Eq0: () => eqImportModuleComparison
};
var sortImportsIde = (v) => {
  const v1 = unzip(v.value.tail);
  const $2 = unzip(sortWith(ordImportComparison)(fst)(arrayMap((x) => $Tuple(
    (() => {
      if (x.tag === "ImportValue") {
        return $ImportComparison("ImportValueCmp", x._1.name);
      }
      if (x.tag === "ImportOp") {
        return $ImportComparison("ImportOpCmp", x._1.name);
      }
      if (x.tag === "ImportType") {
        if (x._2.tag === "Nothing") {
          return $ImportComparison("ImportTypeCmp", x._1.name, true, []);
        }
        if (x._2.tag === "Just") {
          if (x._2._1.tag === "DataEnumerated") {
            if (x._2._1._1.value.tag === "Nothing") {
              return $ImportComparison("ImportTypeCmp", x._1.name, true, []);
            }
            if (x._2._1._1.value.tag === "Just") {
              return $ImportComparison(
                "ImportTypeCmp",
                x._1.name,
                true,
                arrayMap((x$1) => x$1.name)(concatArray([x._2._1._1.value._1.head])(arrayMap(snd)(x._2._1._1.value._1.tail)))
              );
            }
            fail();
          }
          if (x._2._1.tag === "DataAll") {
            return $ImportComparison("ImportTypeCmp", x._1.name, false, []);
          }
          fail();
        }
        fail();
      }
      if (x.tag === "ImportTypeOp") {
        return $ImportComparison("ImportTypeOpCmp", x._2.name);
      }
      if (x.tag === "ImportClass") {
        return $ImportComparison("ImportClassCmp", x._2.name);
      }
      if (x.tag === "ImportError") {
        return ImportErrorCmp;
      }
      fail();
    })(),
    x
  ))(concatArray([v.value.head])(v1._2))));
  return $Tuple(
    $2._1,
    {
      open: v.open,
      value: {
        head: (() => {
          const $3 = index($2._2)(0);
          if ($3.tag === "Just") {
            return $3._1;
          }
          fail();
        })(),
        tail: zip(v1._1)((() => {
          const $3 = tail($2._2);
          if ($3.tag === "Just") {
            return $3._1;
          }
          fail();
        })())
      },
      close: v.close
    }
  );
};
var declareHanging = (label) => (spc) => (separator) => (value) => spc(label)(toFormatDoc(hang(indent(separator))(value)));
var formatRecordLabeled = (format) => (conf) => (v) => {
  if (v.tag === "RecordPun") {
    return formatToken(conf)(v._1.token);
  }
  if (v.tag === "RecordField") {
    return declareHanging(formatToken(conf)(v._1.token))(joinDoc(force2(identity12)))((() => {
      const $3 = formatToken(conf)(v._2);
      if ($3.leading.lines > 0) {
        return {
          doc: $3.doc,
          isEmpty: $3.isEmpty,
          leading: { doc: $3.leading.doc, left: $3.leading.left, lines: 0, multiline: $3.leading.multiline, right: $3.leading.right },
          multiline: true,
          trailing: $3.trailing
        };
      }
      return $3;
    })())(format(conf)(v._3));
  }
  fail();
};
var formatHangingBinder = (conf) => (v) => {
  if (v.tag === "BinderWildcard") {
    return $HangingDoc("HangBreak", flexGroup2(formatToken(conf)(v._1)));
  }
  if (v.tag === "BinderVar") {
    return $HangingDoc("HangBreak", flexGroup2(formatToken(conf)(v._1.token)));
  }
  if (v.tag === "BinderNamed") {
    return $HangingDoc(
      "HangBreak",
      flexGroup2(joinDoc(force2(identity12))(formatToken(conf)(v._1.token))(flexSoftBreak((() => {
        const $2 = formatToken(conf)(v._2);
        if ($2.leading.lines > 0) {
          return {
            doc: $2.doc,
            isEmpty: $2.isEmpty,
            leading: { doc: $2.leading.doc, left: $2.leading.left, lines: 0, multiline: $2.leading.multiline, right: $2.leading.right },
            multiline: true,
            trailing: $2.trailing
          };
        }
        return $2;
      })())(indent(formatBinder(conf)(v._3)))))
    );
  }
  if (v.tag === "BinderConstructor") {
    const ctorName = $HangingDoc("HangBreak", flexGroup2(formatToken(conf)(v._1.token)));
    if (v._2.length > 0) {
      return hangApp(ctorName)(arrayMap(formatHangingBinder(conf))(v._2));
    }
    return ctorName;
  }
  if (v.tag === "BinderBoolean") {
    return $HangingDoc("HangBreak", flexGroup2(formatToken(conf)(v._1)));
  }
  if (v.tag === "BinderChar") {
    return $HangingDoc("HangBreak", flexGroup2(formatToken(conf)(v._1)));
  }
  if (v.tag === "BinderString") {
    return $HangingDoc("HangBreak", flexGroup2(formatToken(conf)(v._1)));
  }
  if (v.tag === "BinderInt") {
    return $HangingDoc(
      "HangBreak",
      flexGroup2(joinDoc(force2(identity12))((() => {
        if (v._1.tag === "Nothing") {
          return monoidFormatDoc.mempty;
        }
        if (v._1.tag === "Just") {
          return formatToken(conf)(v._1._1);
        }
        fail();
      })())(formatToken(conf)(v._2)))
    );
  }
  if (v.tag === "BinderNumber") {
    return $HangingDoc(
      "HangBreak",
      flexGroup2(joinDoc(force2(identity12))((() => {
        if (v._1.tag === "Nothing") {
          return monoidFormatDoc.mempty;
        }
        if (v._1.tag === "Just") {
          return formatToken(conf)(v._1._1);
        }
        fail();
      })())(formatToken(conf)(v._2)))
    );
  }
  if (v.tag === "BinderArray") {
    return $HangingDoc("HangBreak", flexGroup2(formatBasicList(Grouped)(formatBinder)(conf)(v._1)));
  }
  if (v.tag === "BinderRecord") {
    return $HangingDoc("HangBreak", flexGroup2(formatBasicList(Grouped)(formatRecordLabeled(formatHangingBinder))(conf)(v._1)));
  }
  if (v.tag === "BinderParens") {
    return $HangingDoc("HangBreak", flexGroup2(formatParensBlock(formatBinder)(conf)(v._1)));
  }
  if (v.tag === "BinderTyped") {
    return $HangingDoc("HangBreak", flexGroup2(formatSignature(conf)({ label: formatBinder(conf)(v._1), separator: v._2, value: v._3 })));
  }
  if (v.tag === "BinderOp") {
    return formatHangingOperatorTree(formatQualifiedName)(formatHangingBinder)(conf)(toOperatorTree(conf.operators)((v$1) => $QualifiedOperator(
      v$1.module,
      OperatorValue,
      v$1.name
    ))(v._1)(v._2));
  }
  if (v.tag === "BinderError") {
    return $HangingDoc("HangBreak", flexGroup2(conf.formatError(v._1)));
  }
  fail();
};
var formatBinder = (conf) => (x) => toFormatDoc(formatHangingBinder(conf)(x));
var formatWhere = (conf) => (v) => joinDoc(force2(semigroupDoc.append(Break)))(formatToken(conf)(v._1))(formatLetGroups$lazy()(conf)(v._2));
var formatValueBinding = (conf) => (v) => {
  if (v.guarded.tag === "Unconditional") {
    return joinDoc(force2(semigroupDoc.append(Break)))(joinDoc(force2(semigroupDoc.append($Doc(
      "Text",
      1,
      " "
    ))))(flexSpaceBreak(formatToken(conf)(v.name.token))(indent(joinWithMap(foldableArray)(joinDoc(force2(semigroupDoc.append($Doc(
      "FlexAlt",
      $Doc("Text", 1, " "),
      Break
    )))))((x) => {
      const $3 = formatBinder(conf)(x);
      if ($3.leading.lines > 0) {
        return {
          doc: $3.doc,
          isEmpty: $3.isEmpty,
          leading: { doc: $3.leading.doc, left: $3.leading.left, lines: 0, multiline: $3.leading.multiline, right: $3.leading.right },
          multiline: true,
          trailing: $3.trailing
        };
      }
      return $3;
    })(v.binders))))(toFormatDoc(hang(indent((() => {
      const $2 = formatToken(conf)(v.guarded._1);
      if ($2.leading.lines > 0) {
        return {
          doc: $2.doc,
          isEmpty: $2.isEmpty,
          leading: { doc: $2.leading.doc, left: $2.leading.left, lines: 0, multiline: $2.leading.multiline, right: $2.leading.right },
          multiline: true,
          trailing: $2.trailing
        };
      }
      return $2;
    })()))(formatHangingExpr(conf)(v.guarded._2.expr)))))(indent((() => {
      if (v.guarded._2.bindings.tag === "Nothing") {
        return monoidFormatDoc.mempty;
      }
      if (v.guarded._2.bindings.tag === "Just") {
        return formatWhere(conf)(v.guarded._2.bindings._1);
      }
      fail();
    })()));
  }
  if (v.guarded.tag === "Guarded") {
    const valBinders = flexSpaceBreak(formatToken(conf)(v.name.token))(indent(joinWithMap(foldableArray)(joinDoc(force2(semigroupDoc.append($Doc(
      "FlexAlt",
      $Doc("Text", 1, " "),
      Break
    )))))((x) => {
      const $3 = flexGroup2(formatBinder(conf)(x));
      if ($3.leading.lines > 0) {
        return {
          doc: $3.doc,
          isEmpty: $3.isEmpty,
          leading: { doc: $3.leading.doc, left: $3.leading.left, lines: 0, multiline: $3.leading.multiline, right: $3.leading.right },
          multiline: true,
          trailing: $3.trailing
        };
      }
      return $3;
    })(v.binders)));
    if (v.guarded._1.length === 1) {
      return toFormatDoc(hang(valBinders)(formatGuardedExpr(conf)((() => {
        const $3 = index(v.guarded._1)(0);
        if ($3.tag === "Just") {
          return $3._1;
        }
        fail();
      })())));
    }
    return flexSpaceBreak(valBinders)(indent(joinWithMap(foldableArray)(joinDoc(force2(semigroupDoc.append(Break))))((() => {
      const $3 = formatGuardedExpr(conf);
      return (x) => toFormatDoc($3(x));
    })())(v.guarded._1)));
  }
  fail();
};
var formatRecordUpdate = (conf) => (v) => {
  if (v.tag === "RecordUpdateLeaf") {
    return declareHanging(formatToken(conf)(v._1.token))(joinDoc(force2(semigroupDoc.append($Doc("Text", 1, " ")))))(formatToken(conf)(v._2))(formatHangingExpr(conf)(v._3));
  }
  if (v.tag === "RecordUpdateBranch") {
    return flexSpaceBreak(formatToken(conf)(v._1.token))(indent(formatBasicListNonEmpty(Grouped)(formatRecordUpdate)(conf)(v._2)));
  }
  fail();
};
var formatPatternGuard = (conf) => (v) => {
  if (v.binder.tag === "Nothing") {
    return formatExpr(conf)(v.expr);
  }
  if (v.binder.tag === "Just") {
    return joinDoc(force2(semigroupDoc.append($Doc("Text", 1, " "))))(formatBinder(conf)(v.binder._1._1))(indent(flexSpaceBreak((() => {
      const $2 = formatToken(conf)(v.binder._1._2);
      if ($2.leading.lines > 0) {
        return {
          doc: $2.doc,
          isEmpty: $2.isEmpty,
          leading: { doc: $2.leading.doc, left: $2.leading.left, lines: 0, multiline: $2.leading.multiline, right: $2.leading.right },
          multiline: true,
          trailing: $2.trailing
        };
      }
      return $2;
    })())(formatExpr(conf)(v.expr))));
  }
  fail();
};
var formatLetBinding = (conf) => (v) => {
  if (v.tag === "LetBindingSignature") {
    return formatSignature(conf)({ label: formatToken(conf)(v._1.label.token), separator: v._1.separator, value: v._1.value });
  }
  if (v.tag === "LetBindingName") {
    return formatValueBinding(conf)(v._1);
  }
  if (v.tag === "LetBindingPattern") {
    return joinDoc(force2(semigroupDoc.append(Break)))(joinDoc(force2(semigroupDoc.append($Doc(
      "Text",
      1,
      " "
    ))))(flexGroup2(formatBinder(conf)(v._1)))(toFormatDoc(hang(indent((() => {
      const $2 = formatToken(conf)(v._2);
      if ($2.leading.lines > 0) {
        return {
          doc: $2.doc,
          isEmpty: $2.isEmpty,
          leading: { doc: $2.leading.doc, left: $2.leading.left, lines: 0, multiline: $2.leading.multiline, right: $2.leading.right },
          multiline: true,
          trailing: $2.trailing
        };
      }
      return $2;
    })()))(formatHangingExpr(conf)(v._3.expr)))))(indent((() => {
      if (v._3.bindings.tag === "Nothing") {
        return monoidFormatDoc.mempty;
      }
      if (v._3.bindings.tag === "Just") {
        return formatWhere(conf)(v._3.bindings._1);
      }
      fail();
    })()));
  }
  if (v.tag === "LetBindingError") {
    return conf.formatError(v._1);
  }
  fail();
};
var formatHangingExpr = (conf) => (v) => {
  if (v.tag === "ExprHole") {
    return $HangingDoc("HangBreak", flexGroup2(formatToken(conf)(v._1.token)));
  }
  if (v.tag === "ExprSection") {
    return $HangingDoc("HangBreak", flexGroup2(formatToken(conf)(v._1)));
  }
  if (v.tag === "ExprIdent") {
    return $HangingDoc("HangBreak", flexGroup2(formatToken(conf)(v._1.token)));
  }
  if (v.tag === "ExprConstructor") {
    return $HangingDoc("HangBreak", flexGroup2(formatToken(conf)(v._1.token)));
  }
  if (v.tag === "ExprBoolean") {
    return $HangingDoc("HangBreak", flexGroup2(formatToken(conf)(v._1)));
  }
  if (v.tag === "ExprChar") {
    return $HangingDoc("HangBreak", flexGroup2(formatToken(conf)(v._1)));
  }
  if (v.tag === "ExprString") {
    return $HangingDoc("HangBreak", flexGroup2(formatToken(conf)(v._1)));
  }
  if (v.tag === "ExprInt") {
    return $HangingDoc("HangBreak", flexGroup2(formatToken(conf)(v._1)));
  }
  if (v.tag === "ExprNumber") {
    return $HangingDoc("HangBreak", flexGroup2(formatToken(conf)(v._1)));
  }
  if (v.tag === "ExprArray") {
    return $HangingDoc("HangBreak", flexGroup2(formatBasicList(Grouped)(formatExpr)(conf)(v._1)));
  }
  if (v.tag === "ExprRecord") {
    return $HangingDoc("HangBreak", flexGroup2(formatBasicList(Grouped)(formatRecordLabeled(formatHangingExpr))(conf)(v._1)));
  }
  if (v.tag === "ExprParens") {
    return $HangingDoc("HangBreak", flexGroup2(formatParensBlock(formatExpr)(conf)(v._1)));
  }
  if (v.tag === "ExprTyped") {
    return $HangingDoc("HangBreak", flexGroup2(formatSignature(conf)({ label: formatExpr(conf)(v._1), separator: v._2, value: v._3 })));
  }
  if (v.tag === "ExprInfix") {
    return hangOps(formatHangingExpr(conf)(v._1))(arrayMap((v1) => $HangingOp(
      3,
      formatParens(formatExpr)(conf)(v1._1),
      formatHangingExpr(conf)(v1._2)
    ))(v._2));
  }
  if (v.tag === "ExprOp") {
    return formatHangingOperatorTree(formatQualifiedName)(formatHangingExpr)(conf)(toOperatorTree(conf.operators)((v$1) => $QualifiedOperator(
      v$1.module,
      OperatorValue,
      v$1.name
    ))(v._1)(v._2));
  }
  if (v.tag === "ExprOpName") {
    return $HangingDoc("HangBreak", flexGroup2(formatToken(conf)(v._1.token)));
  }
  if (v.tag === "ExprNegate") {
    return $HangingDoc("HangBreak", flexGroup2(joinDoc(force2(identity12))(formatToken(conf)(v._1))(formatExpr(conf)(v._2))));
  }
  if (v.tag === "ExprRecordAccessor") {
    return $HangingDoc(
      "HangBreak",
      flexGroup2(joinDoc(force2(identity12))(formatExpr(conf)(v._1.expr))(indent(foldMap3(anchor)([
        formatToken(conf)(v._1.dot),
        formatToken(conf)(v._1.path.head.token),
        foldMap3((v1) => joinDoc(force2(identity12))((() => {
          const $3 = formatToken(conf)(v1._1);
          if ($3.leading.lines > 0) {
            return {
              doc: $3.doc,
              isEmpty: $3.isEmpty,
              leading: { doc: $3.leading.doc, left: $3.leading.left, lines: 0, multiline: $3.leading.multiline, right: $3.leading.right },
              multiline: true,
              trailing: $3.trailing
            };
          }
          return $3;
        })())((() => {
          const $3 = formatToken(conf)(v1._2.token);
          if ($3.leading.lines > 0) {
            return {
              doc: $3.doc,
              isEmpty: $3.isEmpty,
              leading: { doc: $3.leading.doc, left: $3.leading.left, lines: 0, multiline: $3.leading.multiline, right: $3.leading.right },
              multiline: true,
              trailing: $3.trailing
            };
          }
          return $3;
        })()))(v._1.path.tail)
      ]))))
    );
  }
  if (v.tag === "ExprRecordUpdate") {
    return hang(formatExpr(conf)(v._1))($HangingDoc("HangBreak", flexGroup2(formatBasicListNonEmpty(Grouped)(formatRecordUpdate)(conf)(v._2))));
  }
  if (v.tag === "ExprApp") {
    return hangApp(formatHangingExpr(conf)(v._1))(arrayMap(formatHangingExpr(conf))(v._2));
  }
  if (v.tag === "ExprLambda") {
    return hang(joinDoc(force2(semigroupDoc.append($Doc("Text", 1, " "))))(joinDoc(force2(identity12))(formatToken(conf)(v._1.symbol))(alignCurrentColumn(flexGroup2(joinWithMap(foldableArray)(joinDoc(force2(semigroupDoc.append($Doc(
      "FlexAlt",
      $Doc("Text", 1, " "),
      Break
    )))))((x) => {
      const $3 = formatBinder(conf)(x);
      if ($3.leading.lines > 0) {
        return {
          doc: $3.doc,
          isEmpty: $3.isEmpty,
          leading: { doc: $3.leading.doc, left: $3.leading.left, lines: 0, multiline: $3.leading.multiline, right: $3.leading.right },
          multiline: true,
          trailing: $3.trailing
        };
      }
      return $3;
    })(v._1.binders)))))(indent((() => {
      const $2 = formatToken(conf)(v._1.arrow);
      if ($2.leading.lines > 0) {
        return {
          doc: $2.doc,
          isEmpty: $2.isEmpty,
          leading: { doc: $2.leading.doc, left: $2.leading.left, lines: 0, multiline: $2.leading.multiline, right: $2.leading.right },
          multiline: true,
          trailing: $2.trailing
        };
      }
      return $2;
    })())))(formatHangingExpr(conf)(v._1.body));
  }
  if (v.tag === "ExprIf") {
    return $HangingDoc("HangBreak", flexGroup2(formatElseIfChain(conf)(toElseIfChain(v._1))));
  }
  if (v.tag === "ExprCase") {
    return hang(flexSpaceBreak(formatToken(conf)(v._1.keyword))(indent(joinDoc(force2(semigroupDoc.append($Doc(
      "FlexAlt",
      $Doc("Text", 1, " "),
      Break
    ))))(foldlArray((doc) => (v1) => joinDoc(force2(semigroupDoc.append($Doc(
      "FlexAlt",
      $Doc("Text", 1, " "),
      Break
    ))))(joinDoc(force2(identity12))(doc)((() => {
      const $4 = formatToken(conf)(v1._1);
      if ($4.leading.lines > 0) {
        return {
          doc: $4.doc,
          isEmpty: $4.isEmpty,
          leading: { doc: $4.leading.doc, left: $4.leading.left, lines: 0, multiline: $4.leading.multiline, right: $4.leading.right },
          multiline: true,
          trailing: $4.trailing
        };
      }
      return $4;
    })()))(flexGroup2(formatExpr(conf)(v1._2))))(flexGroup2(formatExpr(conf)(v._1.head.head)))(v._1.head.tail))((() => {
      const $2 = formatToken(conf)(v._1.of);
      if ($2.leading.lines > 0) {
        return {
          doc: $2.doc,
          isEmpty: $2.isEmpty,
          leading: { doc: $2.leading.doc, left: $2.leading.left, lines: 0, multiline: $2.leading.multiline, right: $2.leading.right },
          multiline: true,
          trailing: $2.trailing
        };
      }
      return $2;
    })()))))($HangingDoc(
      "HangBreak",
      flexGroup2(joinWithMap(foldableArray)(joinDoc(force2(semigroupDoc.append(Break))))((() => {
        const $2 = formatCaseBranch(conf);
        return (x) => flexGroup2($2(x));
      })())(v._1.branches))
    ));
  }
  if (v.tag === "ExprLet") {
    return $HangingDoc(
      "HangBreak",
      flexGroup2(joinDoc(force2(semigroupDoc.append($Doc(
        "FlexAlt",
        $Doc("Text", 1, " "),
        Break
      ))))(joinDoc(force2(semigroupDoc.append($Doc("FlexAlt", $Doc("Text", 1, " "), Break))))(formatToken(conf)(v._1.keyword))(indent(formatLetGroups$lazy()(conf)(v._1.bindings))))(joinDoc(force2(semigroupDoc.append($Doc(
        "FlexAlt",
        $Doc("Text", 1, " "),
        Break
      ))))(formatToken(conf)(v._1.in))(indent(flexGroup2(formatExpr(conf)(v._1.body))))))
    );
  }
  if (v.tag === "ExprDo") {
    return hang(formatToken(conf)(v._1.keyword))($HangingDoc(
      "HangBreak",
      flexGroup2(joinWithMap(foldableArray)(joinDoc(force2(semigroupDoc.append(Break))))((() => {
        const $2 = formatDoStatement(conf);
        return (x) => flexGroup2($2(x));
      })())(v._1.statements))
    ));
  }
  if (v.tag === "ExprAdo") {
    return hang(formatToken(conf)(v._1.keyword))($HangingDoc(
      "HangBreak",
      flexGroup2(flexSpaceBreak(joinWithMap(foldableArray)(joinDoc(force2(semigroupDoc.append(Break))))(formatDoStatement(conf))(v._1.statements))(flexSpaceBreak(formatToken(conf)(v._1.in))(indent(formatExpr(conf)(v._1.result)))))
    ));
  }
  if (v.tag === "ExprError") {
    return $HangingDoc("HangBreak", flexGroup2(conf.formatError(v._1)));
  }
  fail();
};
var formatGuardedExpr = (conf) => (v) => hangWithIndent((x) => align2(2)(indent(x)))($HangingDoc(
  "HangBreak",
  flexGroup2(joinDoc(force2(semigroupDoc.append($Doc("Text", 1, " "))))(joinDoc(force2(semigroupDoc.append($Doc(
    "Text",
    1,
    " "
  ))))(formatToken(conf)(v.bar))(flexGroup2(softBreak(formatListElem(2)(formatPatternGuard)(conf)(v.patterns.head))(formatListTail(2)(formatPatternGuard)(conf)(v.patterns.tail)))))((() => {
    const $2 = formatToken(conf)(v.separator);
    if ($2.leading.lines > 0) {
      return {
        doc: $2.doc,
        isEmpty: $2.isEmpty,
        leading: { doc: $2.leading.doc, left: $2.leading.left, lines: 0, multiline: $2.leading.multiline, right: $2.leading.right },
        multiline: true,
        trailing: $2.trailing
      };
    }
    return $2;
  })()))
))((() => {
  if (v.where.bindings.tag === "Nothing") {
    return [formatHangingExpr(conf)(v.where.expr)];
  }
  if (v.where.bindings.tag === "Just") {
    return [formatHangingExpr(conf)(v.where.expr), $HangingDoc("HangBreak", flexGroup2(formatWhere(conf)(v.where.bindings._1)))];
  }
  fail();
})());
var formatExpr = (conf) => (x) => toFormatDoc(formatHangingExpr(conf)(x));
var formatElseIfChain = (conf) => {
  const $1 = joinWithMap(foldableArray)(joinDoc(force2(semigroupDoc.append($Doc(
    "FlexAlt",
    $Doc("Text", 1, " "),
    Break
  )))))((v) => {
    if (v.tag === "IfThen") {
      return joinDoc(force2(semigroupDoc.append($Doc("Text", 1, " "))))(flexSpaceBreak(formatToken(conf)(v._1))(indent((() => {
        const $2 = flexGroup2(formatExpr(conf)(v._2));
        if ($2.leading.lines > 0) {
          return {
            doc: $2.doc,
            isEmpty: $2.isEmpty,
            leading: { doc: $2.leading.doc, left: $2.leading.left, lines: 0, multiline: $2.leading.multiline, right: $2.leading.right },
            multiline: true,
            trailing: $2.trailing
          };
        }
        return $2;
      })())))(toFormatDoc(hang((() => {
        const $2 = formatToken(conf)(v._3);
        if ($2.leading.lines > 0) {
          return {
            doc: $2.doc,
            isEmpty: $2.isEmpty,
            leading: { doc: $2.leading.doc, left: $2.leading.left, lines: 0, multiline: $2.leading.multiline, right: $2.leading.right },
            multiline: true,
            trailing: $2.trailing
          };
        }
        return $2;
      })())(formatHangingExpr(conf)(v._4))));
    }
    if (v.tag === "ElseIfThen") {
      return joinDoc(force2(semigroupDoc.append($Doc("Text", 1, " "))))(flexSpaceBreak(joinDoc(force2(semigroupDoc.append($Doc(
        "Text",
        1,
        " "
      ))))(formatToken(conf)(v._1))(indent((() => {
        const $2 = formatToken(conf)(v._2);
        if ($2.leading.lines > 0) {
          return {
            doc: $2.doc,
            isEmpty: $2.isEmpty,
            leading: { doc: $2.leading.doc, left: $2.leading.left, lines: 0, multiline: $2.leading.multiline, right: $2.leading.right },
            multiline: true,
            trailing: $2.trailing
          };
        }
        return $2;
      })())))(indent((() => {
        const $2 = flexGroup2(formatExpr(conf)(v._3));
        if ($2.leading.lines > 0) {
          return {
            doc: $2.doc,
            isEmpty: $2.isEmpty,
            leading: { doc: $2.leading.doc, left: $2.leading.left, lines: 0, multiline: $2.leading.multiline, right: $2.leading.right },
            multiline: true,
            trailing: $2.trailing
          };
        }
        return $2;
      })())))(toFormatDoc(hang((() => {
        const $2 = formatToken(conf)(v._4);
        if ($2.leading.lines > 0) {
          return {
            doc: $2.doc,
            isEmpty: $2.isEmpty,
            leading: { doc: $2.leading.doc, left: $2.leading.left, lines: 0, multiline: $2.leading.multiline, right: $2.leading.right },
            multiline: true,
            trailing: $2.trailing
          };
        }
        return $2;
      })())(formatHangingExpr(conf)(v._5))));
    }
    if (v.tag === "Else") {
      return toFormatDoc(hang(formatToken(conf)(v._1))(formatHangingExpr(conf)(v._2)));
    }
    fail();
  });
  return (x) => flexGroup2($1(x));
};
var formatDoStatement = (conf) => (v) => {
  if (v.tag === "DoLet") {
    return flexSpaceBreak(formatToken(conf)(v._1))(indent(formatLetGroups$lazy()(conf)(v._2)));
  }
  if (v.tag === "DoDiscard") {
    return formatExpr(conf)(v._1);
  }
  if (v.tag === "DoBind") {
    return joinDoc(force2(semigroupDoc.append($Doc("Text", 1, " "))))(flexGroup2(formatBinder(conf)(v._1)))(toFormatDoc(hang(indent((() => {
      const $2 = formatToken(conf)(v._2);
      if ($2.leading.lines > 0) {
        return {
          doc: $2.doc,
          isEmpty: $2.isEmpty,
          leading: { doc: $2.leading.doc, left: $2.leading.left, lines: 0, multiline: $2.leading.multiline, right: $2.leading.right },
          multiline: true,
          trailing: $2.trailing
        };
      }
      return $2;
    })()))(formatHangingExpr(conf)(v._3))));
  }
  if (v.tag === "DoError") {
    return conf.formatError(v._1);
  }
  fail();
};
var formatCaseBranch = (conf) => (v) => {
  const caseBinders = flexGroup2(foldlArray((doc) => (v1) => joinDoc(force2(semigroupDoc.append($Doc(
    "FlexAlt",
    $Doc("Text", 1, " "),
    Break
  ))))(joinDoc(force2(identity12))(doc)(indent((() => {
    const $4 = formatToken(conf)(v1._1);
    if ($4.leading.lines > 0) {
      return {
        doc: $4.doc,
        isEmpty: $4.isEmpty,
        leading: { doc: $4.leading.doc, left: $4.leading.left, lines: 0, multiline: $4.leading.multiline, right: $4.leading.right },
        multiline: true,
        trailing: $4.trailing
      };
    }
    return $4;
  })())))(flexGroup2(formatBinder(conf)(v1._2))))(flexGroup2(formatBinder(conf)(v._1.head)))(v._1.tail));
  if (v._2.tag === "Unconditional") {
    return joinDoc(force2(semigroupDoc.append(Break)))(joinDoc(force2(semigroupDoc.append($Doc(
      "Text",
      1,
      " "
    ))))(caseBinders)(toFormatDoc(hang(formatToken(conf)(v._2._1))(formatHangingExpr(conf)(v._2._2.expr)))))(indent((() => {
      if (v._2._2.bindings.tag === "Nothing") {
        return monoidFormatDoc.mempty;
      }
      if (v._2._2.bindings.tag === "Just") {
        return formatWhere(conf)(v._2._2.bindings._1);
      }
      fail();
    })()));
  }
  if (v._2.tag === "Guarded") {
    if (v._2._1.length === 1) {
      return toFormatDoc(hang(caseBinders)(formatGuardedExpr(conf)((() => {
        const $3 = index(v._2._1)(0);
        if ($3.tag === "Just") {
          return $3._1;
        }
        fail();
      })())));
    }
    return flexSpaceBreak(caseBinders)(indent(joinWithMap(foldableArray)(joinDoc(force2(semigroupDoc.append(Break))))((x) => toFormatDoc(formatGuardedExpr(conf)(x)))(v._2._1)));
  }
  fail();
};
var formatLetGroups$lazy = /* @__PURE__ */ binding(() => formatDeclGroups((v) => (v1) => {
  if (v1.tag === "DeclGroupValueSignature") {
    return DeclGroupHard;
  }
  return DeclGroupSame;
})((v) => {
  if (v.tag === "LetBindingSignature") {
    return $DeclGroup("DeclGroupValueSignature", v._1.label.name);
  }
  if (v.tag === "LetBindingName") {
    return $DeclGroup("DeclGroupValue", v._1.name.name);
  }
  if (v.tag === "LetBindingPattern") {
    return DeclGroupUnknown;
  }
  if (v.tag === "LetBindingError") {
    return DeclGroupUnknown;
  }
  fail();
})(formatLetBinding));
var formatInstanceBinding = (conf) => (v) => {
  if (v.tag === "InstanceBindingSignature") {
    return formatSignature(conf)({ label: formatToken(conf)(v._1.label.token), separator: v._1.separator, value: v._1.value });
  }
  if (v.tag === "InstanceBindingName") {
    return formatValueBinding(conf)(v._1);
  }
  fail();
};
var formatInstance = (conf) => (v) => {
  if (v.body.tag === "Nothing") {
    return formatInstanceHead(conf)($Tuple(v.head, Nothing));
  }
  if (v.body.tag === "Just") {
    return joinDoc(force2(semigroupDoc.append(Break)))(formatInstanceHead(conf)($Tuple(
      v.head,
      $Maybe("Just", v.body._1._1)
    )))(indent(joinWithMap(foldableArray)(joinDoc(force2(semigroupDoc.append(Break))))(formatInstanceBinding(conf))(v.body._1._2)));
  }
  fail();
};
var formatDecl = (conf) => (v) => {
  if (v.tag === "DeclData") {
    if (v._2.tag === "Just") {
      const formatDataElem = (v1) => joinDoc(force2(semigroupDoc.append($Doc("Text", 1, " "))))(formatToken(conf)(v1._1))(formatListElem(2)(formatDataCtor)(conf)(v1._2));
      if (v._2._1._2.tail.length === 0) {
        return declareHanging(formatDataHead(conf)(v._1))(joinDoc(force2(semigroupDoc.append($Doc("Text", 1, " ")))))((() => {
          const $3 = formatToken(conf)(v._2._1._1);
          if ($3.leading.lines > 0) {
            return {
              doc: $3.doc,
              isEmpty: $3.isEmpty,
              leading: { doc: $3.leading.doc, left: $3.leading.left, lines: 0, multiline: $3.leading.multiline, right: $3.leading.right },
              multiline: true,
              trailing: $3.trailing
            };
          }
          return $3;
        })())(formatHangingDataCtor(conf)(v._2._1._2.head));
      }
      return flexSpaceBreak(formatDataHead(conf)(v._1))(indent(joinDoc(force2(semigroupDoc.append($Doc(
        "FlexAlt",
        $Doc("Text", 1, " "),
        Break
      ))))(formatDataElem($Tuple(v._2._1._1, v._2._1._2.head)))(joinWithMap(foldableArray)(joinDoc(force2(semigroupDoc.append($Doc(
        "FlexAlt",
        $Doc("Text", 1, " "),
        Break
      )))))(($3) => formatDataElem($3))(v._2._1._2.tail))));
    }
    return formatDataHead(conf)(v._1);
  }
  if (v.tag === "DeclType") {
    return declareHanging(formatDataHead(conf)(v._1))(joinDoc(force2(semigroupDoc.append($Doc("Text", 1, " ")))))((() => {
      const $2 = formatToken(conf)(v._2);
      if ($2.leading.lines > 0) {
        return {
          doc: $2.doc,
          isEmpty: $2.isEmpty,
          leading: { doc: $2.leading.doc, left: $2.leading.left, lines: 0, multiline: $2.leading.multiline, right: $2.leading.right },
          multiline: true,
          trailing: $2.trailing
        };
      }
      return $2;
    })())(formatHangingType(conf)(v._3));
  }
  if (v.tag === "DeclNewtype") {
    return declareHanging(formatDataHead(conf)(v._1))(joinDoc(force2(semigroupDoc.append($Doc("Text", 1, " ")))))((() => {
      const $2 = formatToken(conf)(v._2);
      if ($2.leading.lines > 0) {
        return {
          doc: $2.doc,
          isEmpty: $2.isEmpty,
          leading: { doc: $2.leading.doc, left: $2.leading.left, lines: 0, multiline: $2.leading.multiline, right: $2.leading.right },
          multiline: true,
          trailing: $2.trailing
        };
      }
      return $2;
    })())(formatHangingDataCtor(conf)({ name: v._3, fields: [v._4] }));
  }
  if (v.tag === "DeclRole") {
    return flatten(concatArray([formatToken(conf)(v._1), formatToken(conf)(v._2), formatToken(conf)(v._3.token)])(arrayMap((x) => formatToken(conf)(x._1))(v._4)));
  }
  if (v.tag === "DeclFixity") {
    if (v._1.operator.tag === "FixityValue") {
      return flatten([
        formatToken(conf)(v._1.keyword._1),
        formatToken(conf)(v._1.prec._1),
        formatToken(conf)(v._1.operator._1.token),
        formatToken(conf)(v._1.operator._2),
        formatToken(conf)(v._1.operator._3.token)
      ]);
    }
    if (v._1.operator.tag === "FixityType") {
      return flatten([
        formatToken(conf)(v._1.keyword._1),
        formatToken(conf)(v._1.prec._1),
        formatToken(conf)(v._1.operator._1),
        formatToken(conf)(v._1.operator._2.token),
        formatToken(conf)(v._1.operator._3),
        formatToken(conf)(v._1.operator._4.token)
      ]);
    }
    fail();
  }
  if (v.tag === "DeclKindSignature") {
    return formatSignature(conf)({ label: flatten([formatToken(conf)(v._1), formatToken(conf)(v._2.label.token)]), separator: v._2.separator, value: v._2.value });
  }
  if (v.tag === "DeclForeign") {
    if (v._3.tag === "ForeignValue") {
      return formatSignature(conf)({
        label: flatten([formatToken(conf)(v._1), formatToken(conf)(v._2), formatToken(conf)(v._3._1.label.token)]),
        separator: v._3._1.separator,
        value: v._3._1.value
      });
    }
    if (v._3.tag === "ForeignData") {
      return formatSignature(conf)({
        label: flatten([formatToken(conf)(v._1), formatToken(conf)(v._2), formatToken(conf)(v._3._1), formatToken(conf)(v._3._2.label.token)]),
        separator: v._3._2.separator,
        value: v._3._2.value
      });
    }
    if (v._3.tag === "ForeignKind") {
      return flatten([formatToken(conf)(v._1), formatToken(conf)(v._2), formatToken(conf)(v._3._1), formatToken(conf)(v._3._2.token)]);
    }
    fail();
  }
  if (v.tag === "DeclClass") {
    if (v._2.tag === "Nothing") {
      return formatClassHead(conf)($Tuple(v._1, Nothing));
    }
    if (v._2.tag === "Just") {
      return joinDoc(force2(semigroupDoc.append(Break)))(formatClassHead(conf)($Tuple(
        v._1,
        $Maybe("Just", v._2._1._1)
      )))(indent(joinWithMap(foldableArray)(joinDoc(force2(semigroupDoc.append(Break))))((x) => formatSignature(conf)({
        label: formatToken(conf)(x.label.token),
        separator: x.separator,
        value: x.value
      }))(v._2._1._2)));
    }
    fail();
  }
  if (v.tag === "DeclInstanceChain") {
    return joinDoc(force2(semigroupDoc.append(Break)))(formatInstance(conf)(v._1.head))(joinWithMap(foldableArray)(joinDoc(force2(semigroupDoc.append(Break))))((v1) => joinDoc(force2(semigroupDoc.append($Doc(
      "Text",
      1,
      " "
    ))))(formatToken(conf)(v1._1))((() => {
      const $3 = formatInstance(conf)(v1._2);
      if ($3.leading.lines > 0) {
        return {
          doc: $3.doc,
          isEmpty: $3.isEmpty,
          leading: { doc: $3.leading.doc, left: $3.leading.left, lines: 0, multiline: $3.leading.multiline, right: $3.leading.right },
          multiline: true,
          trailing: $3.trailing
        };
      }
      return $3;
    })()))(v._1.tail));
  }
  if (v.tag === "DeclDerive") {
    return joinDoc(force2(semigroupDoc.append($Doc("Text", 1, " "))))(joinDoc(force2(semigroupDoc.append($Doc(
      "Text",
      1,
      " "
    ))))(formatToken(conf)(v._1))((() => {
      if (v._2.tag === "Nothing") {
        return monoidFormatDoc.mempty;
      }
      if (v._2.tag === "Just") {
        return indent((() => {
          const $2 = formatToken(conf)(v._2._1);
          if ($2.leading.lines > 0) {
            return {
              doc: $2.doc,
              isEmpty: $2.isEmpty,
              leading: { doc: $2.leading.doc, left: $2.leading.left, lines: 0, multiline: $2.leading.multiline, right: $2.leading.right },
              multiline: true,
              trailing: $2.trailing
            };
          }
          return $2;
        })());
      }
      fail();
    })()))((() => {
      const $2 = formatInstanceHead(conf)($Tuple(v._3, Nothing));
      if ($2.leading.lines > 0) {
        return {
          doc: $2.doc,
          isEmpty: $2.isEmpty,
          leading: { doc: $2.leading.doc, left: $2.leading.left, lines: 0, multiline: $2.leading.multiline, right: $2.leading.right },
          multiline: true,
          trailing: $2.trailing
        };
      }
      return $2;
    })());
  }
  if (v.tag === "DeclSignature") {
    return formatSignature(conf)({ label: flatten([formatToken(conf)(v._1.label.token)]), separator: v._1.separator, value: v._1.value });
  }
  if (v.tag === "DeclValue") {
    return formatValueBinding(conf)(v._1);
  }
  if (v.tag === "DeclError") {
    return conf.formatError(v._1);
  }
  fail();
};
var formatTopLevelGroups = /* @__PURE__ */ formatDeclGroups((v) => (v1) => {
  if (v1.tag === "DeclGroupValue") {
    if (v.tag === "DeclGroupValue") {
      if (v._1 === v1._1) {
        return DeclGroupSame;
      }
      return DeclGroupSoft;
    }
    if (v.tag === "DeclGroupValueSignature") {
      if (v._1 === v1._1) {
        return DeclGroupSame;
      }
      return DeclGroupHard;
    }
    return DeclGroupSoft;
  }
  if (v1.tag === "DeclGroupValueSignature") {
    return DeclGroupHard;
  }
  if (v1.tag === "DeclGroupType") {
    if (v.tag === "DeclGroupType") {
      return DeclGroupSoft;
    }
    if (v.tag === "DeclGroupTypeSignature") {
      if (v._1 === v1._1) {
        return DeclGroupSame;
      }
      return DeclGroupHard;
    }
    return DeclGroupSoft;
  }
  if (v.tag === "DeclGroupTypeSignature") {
    if (v1.tag === "DeclGroupClass") {
      if (v._1 === v1._1) {
        return DeclGroupSame;
      }
      return DeclGroupHard;
    }
    if (v1.tag === "DeclGroupTypeSignature") {
      return DeclGroupHard;
    }
    if (v1.tag === "DeclGroupInstance") {
      return DeclGroupHard;
    }
    if (v1.tag === "DeclGroupFixity") {
      return DeclGroupHard;
    }
    if (v1.tag === "DeclGroupForeign") {
      return DeclGroupHard;
    }
    if (v1.tag === "DeclGroupRole") {
      return DeclGroupHard;
    }
    return DeclGroupSoft;
  }
  if (v1.tag === "DeclGroupTypeSignature") {
    return DeclGroupHard;
  }
  if (v1.tag === "DeclGroupClass") {
    if (v.tag === "DeclGroupClass") {
      return DeclGroupSoft;
    }
    return DeclGroupHard;
  }
  if (v1.tag === "DeclGroupInstance") {
    if (v.tag === "DeclGroupInstance") {
      return DeclGroupSoft;
    }
    return DeclGroupHard;
  }
  if (v1.tag === "DeclGroupFixity") {
    if (v.tag === "DeclGroupFixity") {
      return DeclGroupSoft;
    }
    return DeclGroupHard;
  }
  if (v1.tag === "DeclGroupForeign") {
    if (v.tag === "DeclGroupForeign") {
      return DeclGroupSoft;
    }
    return DeclGroupHard;
  }
  if (v1.tag === "DeclGroupRole") {
    if (v.tag === "DeclGroupRole") {
      return DeclGroupSoft;
    }
    return DeclGroupHard;
  }
  return DeclGroupSoft;
})((v) => {
  if (v.tag === "DeclData") {
    return $DeclGroup("DeclGroupType", v._1.name.name);
  }
  if (v.tag === "DeclType") {
    return $DeclGroup("DeclGroupType", v._1.name.name);
  }
  if (v.tag === "DeclNewtype") {
    return $DeclGroup("DeclGroupType", v._1.name.name);
  }
  if (v.tag === "DeclClass") {
    return $DeclGroup("DeclGroupClass", v._1.name.name);
  }
  if (v.tag === "DeclKindSignature") {
    return $DeclGroup("DeclGroupTypeSignature", v._2.label.name);
  }
  if (v.tag === "DeclSignature") {
    return $DeclGroup("DeclGroupValueSignature", v._1.label.name);
  }
  if (v.tag === "DeclValue") {
    return $DeclGroup("DeclGroupValue", v._1.name.name);
  }
  if (v.tag === "DeclInstanceChain") {
    return DeclGroupInstance;
  }
  if (v.tag === "DeclDerive") {
    return DeclGroupInstance;
  }
  if (v.tag === "DeclFixity") {
    return DeclGroupFixity;
  }
  if (v.tag === "DeclForeign") {
    return DeclGroupForeign;
  }
  if (v.tag === "DeclRole") {
    return DeclGroupRole;
  }
  if (v.tag === "DeclError") {
    return DeclGroupUnknown;
  }
  fail();
})(formatDecl);
var formatModule = (conf) => (v) => {
  const imports = (() => {
    if (conf.importSort.tag === "ImportSortSource") {
      return joinWithMap(foldableArray)(joinDoc(force2(semigroupDoc.append(Break))))((x) => formatImportDecl(conf)(x))(v.header.imports);
    }
    if (conf.importSort.tag === "ImportSortIde") {
      const v1 = partition((v12) => {
        if (v12.qualified.tag === "Nothing") {
          if (v12.names.tag === "Nothing") {
            return true;
          }
          if (v12.names.tag === "Just") {
            return v12.names._1._1.tag === "Just";
          }
          return false;
        }
        return false;
      })(arrayMap(snd)(sortWith(ordImportModuleComparison)(fst)(arrayMap((v12) => {
        const qualName = (() => {
          if (v12.qualified.tag === "Just") {
            return $Maybe("Just", v12.qualified._1._2.name);
          }
          return Nothing;
        })();
        if (v12.names.tag === "Just") {
          const v2 = sortImportsIde(v12.names._1._2);
          return $Tuple(
            $ImportModuleComparison(
              v12.module.name,
              (() => {
                if ((() => {
                  if (v12.names._1._1.tag === "Nothing") {
                    return false;
                  }
                  if (v12.names._1._1.tag === "Just") {
                    return true;
                  }
                  fail();
                })()) {
                  return 3;
                }
                return 1;
              })(),
              v2._1,
              qualName
            ),
            { keyword: v12.keyword, module: v12.module, names: $Maybe("Just", $Tuple(v12.names._1._1, v2._2)), qualified: v12.qualified }
          );
        }
        if (v12.names.tag === "Nothing") {
          return $Tuple($ImportModuleComparison(v12.module.name, 2, [], qualName), v12);
        }
        fail();
      })(v.header.imports))));
      return joinDoc(force2(identity12))(joinWithMap(foldableArray)(joinDoc(force2(semigroupDoc.append(Break))))((x) => flattenMax(0)(formatImportDecl(conf)(x)))(v1.yes))(forceMinSourceBreaks(2)(joinWithMap(foldableArray)(joinDoc(force2(semigroupDoc.append(Break))))((x) => flattenMax(0)(formatImportDecl(conf)(x)))(v1.no)));
    }
    fail();
  })();
  return joinWithMap(foldableArray)(joinDoc(force2(semigroupDoc.append(Break))))(identity12)([
    joinDoc(force2(semigroupDoc.append($Doc("Text", 1, " "))))((() => {
      const $3 = formatToken(conf)(v.header.keyword);
      if ($3.leading.lines > 0) {
        return {
          doc: $3.doc,
          isEmpty: $3.isEmpty,
          leading: { doc: $3.leading.doc, left: $3.leading.left, lines: 0, multiline: $3.leading.multiline, right: $3.leading.right },
          multiline: true,
          trailing: $3.trailing
        };
      }
      return $3;
    })())(indent(joinDoc(force2(semigroupDoc.append($Doc("Text", 1, " "))))(flexSpaceBreak((() => {
      const $3 = formatToken(conf)(v.header.name.token);
      if ($3.leading.lines > 0) {
        return {
          doc: $3.doc,
          isEmpty: $3.isEmpty,
          leading: { doc: $3.leading.doc, left: $3.leading.left, lines: 0, multiline: $3.leading.multiline, right: $3.leading.right },
          multiline: true,
          trailing: $3.trailing
        };
      }
      return $3;
    })())((() => {
      const $3 = (() => {
        if (v.header.exports.tag === "Nothing") {
          return monoidFormatDoc.mempty;
        }
        if (v.header.exports.tag === "Just") {
          return formatDelimitedNonEmpty(softSpace)(softBreak)(2)(NotGrouped)(formatExport)(conf)(v.header.exports._1);
        }
        fail();
      })();
      if ($3.leading.lines > 0) {
        return {
          doc: $3.doc,
          isEmpty: $3.isEmpty,
          leading: { doc: $3.leading.doc, left: $3.leading.left, lines: 0, multiline: $3.leading.multiline, right: $3.leading.right },
          multiline: true,
          trailing: $3.trailing
        };
      }
      return $3;
    })()))((() => {
      const $3 = formatToken(conf)(v.header.where);
      if ($3.leading.lines > 0) {
        return {
          doc: $3.doc,
          isEmpty: $3.isEmpty,
          leading: { doc: $3.leading.doc, left: $3.leading.left, lines: 0, multiline: $3.leading.multiline, right: $3.leading.right },
          multiline: true,
          trailing: $3.trailing
        };
      }
      return $3;
    })()))),
    forceMinSourceBreaks(2)((() => {
      if (conf.importWrap.tag === "ImportWrapAuto") {
        return imports;
      }
      if (conf.importWrap.tag === "ImportWrapSource") {
        return locally((v1) => ({ indent: v1.indent, indentSpaces: v1.indentSpaces, indentUnit: v1.indentUnit, indentWidth: v1.indentWidth, pageWidth: 2147483647, ribbonRatio: 1 }))(imports);
      }
      fail();
    })()),
    forceMinSourceBreaks(2)(formatTopLevelGroups(conf)(v.body.decls)),
    foldrArray(formatComment(leadingLineComment)(leadingBlockComment))(monoidFormatDoc.mempty)(v.body.trailingComments)
  ]);
};

// output-es/Bin.FormatOptions/index.js
var decodeJson = /* @__PURE__ */ decodeForeignObject(Right);
var traverse = /* @__PURE__ */ (() => traversableMaybe.traverse(applicativeEither))();
var unicodeFromString = (v) => {
  if (v === "source") {
    return $Either("Right", UnicodeSource);
  }
  if (v === "always") {
    return $Either("Right", UnicodeAlways);
  }
  if (v === "never") {
    return $Either("Right", UnicodeNever);
  }
  return $Either("Left", $JsonDecodeError("UnexpectedValue", id(v)));
};
var typeArrowPlacementFromString = (v) => {
  if (v === "first") {
    return $Either("Right", TypeArrowFirst);
  }
  if (v === "last") {
    return $Either("Right", TypeArrowLast);
  }
  return $Either("Left", $JsonDecodeError("UnexpectedValue", id(v)));
};
var importWrapFromString = (v) => {
  if (v === "source") {
    return $Either("Right", ImportWrapSource);
  }
  if (v === "auto") {
    return $Either("Right", ImportWrapAuto);
  }
  return $Either("Left", $JsonDecodeError("UnexpectedValue", id(v)));
};
var toJson = (options) => extend(encodeJsonJson.encodeJson)($Tuple(
  "width",
  (() => {
    if (options.width.tag === "Nothing") {
      return jsonNull;
    }
    if (options.width.tag === "Just") {
      return id(toNumber(options.width._1));
    }
    fail();
  })()
))(extend(encodeJsonJson.encodeJson)($Tuple(
  "unicode",
  id((() => {
    if (options.unicode.tag === "UnicodeSource") {
      return "source";
    }
    if (options.unicode.tag === "UnicodeAlways") {
      return "always";
    }
    if (options.unicode.tag === "UnicodeNever") {
      return "never";
    }
    fail();
  })())
))(extend(encodeJsonJson.encodeJson)($Tuple(
  "typeArrowPlacement",
  id((() => {
    if (options.typeArrowPlacement.tag === "TypeArrowFirst") {
      return "first";
    }
    if (options.typeArrowPlacement.tag === "TypeArrowLast") {
      return "last";
    }
    fail();
  })())
))(extend(encodeJsonJson.encodeJson)($Tuple("ribbon", id(options.ribbon)))(extend(encodeJsonJson.encodeJson)($Tuple(
  "operatorsFile",
  (() => {
    if (options.operatorsFile.tag === "Nothing") {
      return jsonNull;
    }
    if (options.operatorsFile.tag === "Just") {
      return id(options.operatorsFile._1);
    }
    fail();
  })()
))(extend(encodeJsonJson.encodeJson)($Tuple(
  "indent",
  id(toNumber(options.indent))
))(extend(encodeJsonJson.encodeJson)($Tuple(
  "importWrap",
  id((() => {
    if (options.importWrap.tag === "ImportWrapSource") {
      return "source";
    }
    if (options.importWrap.tag === "ImportWrapAuto") {
      return "auto";
    }
    fail();
  })())
))(extend(encodeJsonJson.encodeJson)($Tuple(
  "importSort",
  id((() => {
    if (options.importSort.tag === "ImportSortSource") {
      return "source";
    }
    if (options.importSort.tag === "ImportSortIde") {
      return "ide";
    }
    fail();
  })())
))(jsonEmptyObject))))))));
var importSortFromString = (v) => {
  if (v === "source") {
    return $Either("Right", ImportSortSource);
  }
  if (v === "ide") {
    return $Either("Right", ImportSortIde);
  }
  return $Either("Left", $JsonDecodeError("UnexpectedValue", id(v)));
};
var fromJson = (json) => bindEither.bind(decodeJson(json))((obj) => bindEither.bind(bindEither.bind(getFieldOptional$p(caseJsonString($Either(
  "Left",
  $JsonDecodeError("TypeMismatch", "String")
))(Right))(obj)("importSort"))(traverse(importSortFromString)))((importSort) => bindEither.bind(bindEither.bind(getFieldOptional$p(caseJsonString($Either(
  "Left",
  $JsonDecodeError("TypeMismatch", "String")
))(Right))(obj)("importWrap"))(traverse(importWrapFromString)))((importWrap) => bindEither.bind(getFieldOptional$p(decodeInt)(obj)("indent"))((indent2) => bindEither.bind(getFieldOptional$p(caseJsonString($Either(
  "Left",
  $JsonDecodeError("TypeMismatch", "String")
))(Right))(obj)("operatorsFile"))((operatorsFile) => bindEither.bind(getFieldOptional$p(caseJsonNumber($Either(
  "Left",
  $JsonDecodeError("TypeMismatch", "Number")
))(Right))(obj)("ribbon"))((ribbon) => bindEither.bind(bindEither.bind(getFieldOptional$p(caseJsonString($Either(
  "Left",
  $JsonDecodeError("TypeMismatch", "String")
))(Right))(obj)("typeArrowPlacement"))(traverse(typeArrowPlacementFromString)))((typeArrowPlacement) => bindEither.bind(bindEither.bind(getFieldOptional$p(caseJsonString($Either(
  "Left",
  $JsonDecodeError("TypeMismatch", "String")
))(Right))(obj)("unicode"))(traverse(unicodeFromString)))((unicode2) => bindEither.bind(getFieldOptional$p(decodeInt)(obj)("width"))((width) => $Either(
  "Right",
  {
    importSort: (() => {
      if (importSort.tag === "Nothing") {
        return ImportSortSource;
      }
      if (importSort.tag === "Just") {
        return importSort._1;
      }
      fail();
    })(),
    importWrap: (() => {
      if (importWrap.tag === "Nothing") {
        return ImportWrapSource;
      }
      if (importWrap.tag === "Just") {
        return importWrap._1;
      }
      fail();
    })(),
    indent: (() => {
      if (indent2.tag === "Nothing") {
        return 2;
      }
      if (indent2.tag === "Just") {
        return indent2._1;
      }
      fail();
    })(),
    operatorsFile: (() => {
      if (operatorsFile.tag === "Nothing") {
        return Nothing;
      }
      return operatorsFile;
    })(),
    ribbon: (() => {
      if (ribbon.tag === "Nothing") {
        return 1;
      }
      if (ribbon.tag === "Just") {
        return ribbon._1;
      }
      fail();
    })(),
    typeArrowPlacement: (() => {
      if (typeArrowPlacement.tag === "Nothing") {
        return TypeArrowFirst;
      }
      if (typeArrowPlacement.tag === "Just") {
        return typeArrowPlacement._1;
      }
      fail();
    })(),
    unicode: (() => {
      if (unicode2.tag === "Nothing") {
        return UnicodeSource;
      }
      if (unicode2.tag === "Just") {
        return unicode2._1;
      }
      fail();
    })(),
    width: (() => {
      if (width.tag === "Nothing") {
        return Nothing;
      }
      return width;
    })()
  }
))))))))));
var unicodeOption = /* @__PURE__ */ $$default(UnicodeSource)(/* @__PURE__ */ choose("unicode argument")([
  /* @__PURE__ */ (() => {
    const $0 = flag(["--unicode-source", "-us"])("Unicode punctuation is rendered as it appears in the source input.\nDefault.");
    return $ArgParser($0._1, functorArgFold.map((v) => UnicodeSource)($0._2));
  })(),
  /* @__PURE__ */ (() => {
    const $0 = flag(["--unicode-always", "-ua"])("Unicode punctuation is always preferred.");
    return $ArgParser($0._1, functorArgFold.map((v) => UnicodeAlways)($0._2));
  })(),
  /* @__PURE__ */ (() => {
    const $0 = flag(["--unicode-never", "-un"])("Unicode punctuation is never preferred.");
    return $ArgParser($0._1, functorArgFold.map((v) => UnicodeNever)($0._2));
  })()
]));
var formatOptions = /* @__PURE__ */ fromRecord()(/* @__PURE__ */ buildArgsCons({ reflectSymbol: () => "importSort" })()()()(/* @__PURE__ */ buildArgsCons({
  reflectSymbol: () => "importWrap"
})()()()(/* @__PURE__ */ buildArgsCons({ reflectSymbol: () => "indent" })()()()(/* @__PURE__ */ buildArgsCons({ reflectSymbol: () => "operatorsFile" })()()()(/* @__PURE__ */ buildArgsCons({
  reflectSymbol: () => "ribbon"
})()()()(/* @__PURE__ */ buildArgsCons({ reflectSymbol: () => "typeArrowPlacement" })()()()(/* @__PURE__ */ buildArgsCons({
  reflectSymbol: () => "unicode"
})()()()(/* @__PURE__ */ buildArgsCons({ reflectSymbol: () => "width" })()()()(buildRecordArgsNil)))))))))({
  importSort: /* @__PURE__ */ $$default(ImportSortSource)(/* @__PURE__ */ choose("import sort")([
    /* @__PURE__ */ (() => {
      const $0 = flag(["--import-sort-source", "-iss"])("Imports are not automatically sorted and keep the same order as in the source.\nDefault.");
      return $ArgParser($0._1, functorArgFold.map((v) => ImportSortSource)($0._2));
    })(),
    /* @__PURE__ */ (() => {
      const $0 = flag(["--import-sort-ide", "-isi"])("Imports are automatically sorted like purs-ide.");
      return $ArgParser($0._1, functorArgFold.map((v) => ImportSortIde)($0._2));
    })()
  ])),
  importWrap: /* @__PURE__ */ $$default(ImportWrapSource)(/* @__PURE__ */ choose("import wrap")([
    /* @__PURE__ */ (() => {
      const $0 = flag(["--import-wrap-source", "-iws"])("Imports are wrapped only when breaks are in the source.\nDefault. Works well with IDE imports.");
      return $ArgParser($0._1, functorArgFold.map((v) => ImportWrapSource)($0._2));
    })(),
    /* @__PURE__ */ (() => {
      const $0 = flag(["--import-wrap-auto", "-iwa"])("Imports are wrapped based on the `--width` option.");
      return $ArgParser($0._1, functorArgFold.map((v) => ImportWrapAuto)($0._2));
    })()
  ])),
  indent: /* @__PURE__ */ $$default(2)(/* @__PURE__ */ $$int(/* @__PURE__ */ argument(["--indent", "-i"])("Number of spaces to use as indentation.\nDefaults to 2."))),
  operatorsFile: /* @__PURE__ */ (() => {
    const $0 = unformat("FILE_PATH")(Right)(argument(["--operators", "-o"])("Path to an operator table generated by `generate-operators`.\nDefault is to use a pre-generated table of core and contrib."));
    return $$default(Nothing)($ArgParser($0._1, functorArgFold.map(Just)($0._2)));
  })(),
  ribbon: /* @__PURE__ */ $$default(1)(/* @__PURE__ */ number(/* @__PURE__ */ argument(["--ribbon", "-r"])("The ratio of printable width to maximum width.\nFrom 0 to 1. Defaults to 1."))),
  typeArrowPlacement: /* @__PURE__ */ $$default(TypeArrowFirst)(/* @__PURE__ */ choose("type arrow placement")([
    /* @__PURE__ */ (() => {
      const $0 = flag(["--arrow-first", "-af"])("Type signatures put arrows first on the line.\nDefault.");
      return $ArgParser($0._1, functorArgFold.map((v) => TypeArrowFirst)($0._2));
    })(),
    /* @__PURE__ */ (() => {
      const $0 = flag(["--arrow-last", "-al"])("Type signatures put arrows last on the line.");
      return $ArgParser($0._1, functorArgFold.map((v) => TypeArrowLast)($0._2));
    })()
  ])),
  unicode: unicodeOption,
  width: /* @__PURE__ */ (() => {
    const $0 = $$int(argument(["--width", "-w"])("The maximum width of the document in columns.\nDefaults to no maximum."));
    return $$default(Nothing)($ArgParser($0._1, functorArgFold.map(Just)($0._2)));
  })()
});

// output-es/Bin.Version/foreign.js
var version = "v0.9.2";

// output-es/Bin.Timing/foreign.js
import process2 from "process";
function hrtime() {
  var t = process2.hrtime();
  return { seconds: t[0], nanos: t[1] };
}
function hrtimeDiff(old) {
  return function() {
    var t = process2.hrtime([old.seconds, old.nanos]);
    return { seconds: t[0], nanos: t[1] };
  };
}

// output-es/Effect.Exception/foreign.js
function error(msg) {
  return new Error(msg);
}
function throwException(e) {
  return function() {
    throw e;
  };
}

// output-es/Control.Monad.Error.Class/index.js
var $$try = (dictMonadError) => {
  const Monad0 = dictMonadError.MonadThrow0().Monad0();
  const map = Monad0.Bind1().Apply0().Functor0().map;
  const pure = Monad0.Applicative0().pure;
  return (a) => dictMonadError.catchError(map(Right)(a))((x) => pure($Either("Left", x)));
};

// output-es/Control.Parallel/index.js
var parTraverse_ = (dictParallel) => {
  const traverse_2 = traverse_(dictParallel.Applicative1());
  return (dictFoldable) => {
    const traverse_1 = traverse_2(dictFoldable);
    return (f) => {
      const $5 = traverse_1((x) => dictParallel.parallel(f(x)));
      return (x) => dictParallel.sequential($5(x));
    };
  };
};

// output-es/Effect.Aff/foreign.js
var Aff = function() {
  var EMPTY = {};
  var PURE = "Pure";
  var THROW = "Throw";
  var CATCH = "Catch";
  var SYNC = "Sync";
  var ASYNC = "Async";
  var BIND = "Bind";
  var BRACKET = "Bracket";
  var FORK = "Fork";
  var SEQ = "Sequential";
  var MAP = "Map";
  var APPLY = "Apply";
  var ALT = "Alt";
  var CONS = "Cons";
  var RESUME = "Resume";
  var RELEASE = "Release";
  var FINALIZER = "Finalizer";
  var FINALIZED = "Finalized";
  var FORKED = "Forked";
  var FIBER = "Fiber";
  var THUNK = "Thunk";
  function Aff2(tag, _1, _2, _3) {
    this.tag = tag;
    this._1 = _1;
    this._2 = _2;
    this._3 = _3;
  }
  function AffCtr(tag) {
    var fn = function(_1, _2, _3) {
      return new Aff2(tag, _1, _2, _3);
    };
    fn.tag = tag;
    return fn;
  }
  function nonCanceler2(error4) {
    return new Aff2(PURE, void 0);
  }
  function runEff(eff) {
    try {
      eff();
    } catch (error4) {
      setTimeout(function() {
        throw error4;
      }, 0);
    }
  }
  function runSync(left, right, eff) {
    try {
      return right(eff());
    } catch (error4) {
      return left(error4);
    }
  }
  function runAsync(left, eff, k) {
    try {
      return eff(k)();
    } catch (error4) {
      k(left(error4))();
      return nonCanceler2;
    }
  }
  var Scheduler = function() {
    var limit = 1024;
    var size5 = 0;
    var ix = 0;
    var queue = new Array(limit);
    var draining = false;
    function drain() {
      var thunk;
      draining = true;
      while (size5 !== 0) {
        size5--;
        thunk = queue[ix];
        queue[ix] = void 0;
        ix = (ix + 1) % limit;
        thunk();
      }
      draining = false;
    }
    return {
      isDraining: function() {
        return draining;
      },
      enqueue: function(cb) {
        var i, tmp;
        if (size5 === limit) {
          tmp = draining;
          drain();
          draining = tmp;
        }
        queue[(ix + size5) % limit] = cb;
        size5++;
        if (!draining) {
          drain();
        }
      }
    };
  }();
  function Supervisor(util) {
    var fibers = {};
    var fiberId = 0;
    var count = 0;
    return {
      register: function(fiber) {
        var fid = fiberId++;
        fiber.onComplete({
          rethrow: true,
          handler: function(result) {
            return function() {
              count--;
              delete fibers[fid];
            };
          }
        })();
        fibers[fid] = fiber;
        count++;
      },
      isEmpty: function() {
        return count === 0;
      },
      killAll: function(killError, cb) {
        return function() {
          if (count === 0) {
            return cb();
          }
          var killCount = 0;
          var kills = {};
          function kill(fid) {
            kills[fid] = fibers[fid].kill(killError, function(result) {
              return function() {
                delete kills[fid];
                killCount--;
                if (util.isLeft(result) && util.fromLeft(result)) {
                  setTimeout(function() {
                    throw util.fromLeft(result);
                  }, 0);
                }
                if (killCount === 0) {
                  cb();
                }
              };
            })();
          }
          for (var k in fibers) {
            if (fibers.hasOwnProperty(k)) {
              killCount++;
              kill(k);
            }
          }
          fibers = {};
          fiberId = 0;
          count = 0;
          return function(error4) {
            return new Aff2(SYNC, function() {
              for (var k2 in kills) {
                if (kills.hasOwnProperty(k2)) {
                  kills[k2]();
                }
              }
            });
          };
        };
      }
    };
  }
  var SUSPENDED = 0;
  var CONTINUE = 1;
  var STEP_BIND = 2;
  var STEP_RESULT = 3;
  var PENDING = 4;
  var RETURN = 5;
  var COMPLETED = 6;
  function Fiber(util, supervisor, aff) {
    var runTick = 0;
    var status = SUSPENDED;
    var step = aff;
    var fail2 = null;
    var interrupt = null;
    var bhead = null;
    var btail = null;
    var attempts = null;
    var bracketCount = 0;
    var joinId = 0;
    var joins = null;
    var rethrow = true;
    function run2(localRunTick) {
      var tmp, result, attempt;
      while (true) {
        tmp = null;
        result = null;
        attempt = null;
        switch (status) {
          case STEP_BIND:
            status = CONTINUE;
            try {
              step = bhead(step);
              if (btail === null) {
                bhead = null;
              } else {
                bhead = btail._1;
                btail = btail._2;
              }
            } catch (e) {
              status = RETURN;
              fail2 = util.left(e);
              step = null;
            }
            break;
          case STEP_RESULT:
            if (util.isLeft(step)) {
              status = RETURN;
              fail2 = step;
              step = null;
            } else if (bhead === null) {
              status = RETURN;
            } else {
              status = STEP_BIND;
              step = util.fromRight(step);
            }
            break;
          case CONTINUE:
            switch (step.tag) {
              case BIND:
                if (bhead) {
                  btail = new Aff2(CONS, bhead, btail);
                }
                bhead = step._2;
                status = CONTINUE;
                step = step._1;
                break;
              case PURE:
                if (bhead === null) {
                  status = RETURN;
                  step = util.right(step._1);
                } else {
                  status = STEP_BIND;
                  step = step._1;
                }
                break;
              case SYNC:
                status = STEP_RESULT;
                step = runSync(util.left, util.right, step._1);
                break;
              case ASYNC:
                status = PENDING;
                step = runAsync(util.left, step._1, function(result2) {
                  return function() {
                    if (runTick !== localRunTick) {
                      return;
                    }
                    runTick++;
                    Scheduler.enqueue(function() {
                      if (runTick !== localRunTick + 1) {
                        return;
                      }
                      status = STEP_RESULT;
                      step = result2;
                      run2(runTick);
                    });
                  };
                });
                return;
              case THROW:
                status = RETURN;
                fail2 = util.left(step._1);
                step = null;
                break;
              case CATCH:
                if (bhead === null) {
                  attempts = new Aff2(CONS, step, attempts, interrupt);
                } else {
                  attempts = new Aff2(CONS, step, new Aff2(CONS, new Aff2(RESUME, bhead, btail), attempts, interrupt), interrupt);
                }
                bhead = null;
                btail = null;
                status = CONTINUE;
                step = step._1;
                break;
              case BRACKET:
                bracketCount++;
                if (bhead === null) {
                  attempts = new Aff2(CONS, step, attempts, interrupt);
                } else {
                  attempts = new Aff2(CONS, step, new Aff2(CONS, new Aff2(RESUME, bhead, btail), attempts, interrupt), interrupt);
                }
                bhead = null;
                btail = null;
                status = CONTINUE;
                step = step._1;
                break;
              case FORK:
                status = STEP_RESULT;
                tmp = Fiber(util, supervisor, step._2);
                if (supervisor) {
                  supervisor.register(tmp);
                }
                if (step._1) {
                  tmp.run();
                }
                step = util.right(tmp);
                break;
              case SEQ:
                status = CONTINUE;
                step = sequential(util, supervisor, step._1);
                break;
            }
            break;
          case RETURN:
            bhead = null;
            btail = null;
            if (attempts === null) {
              status = COMPLETED;
              step = interrupt || fail2 || step;
            } else {
              tmp = attempts._3;
              attempt = attempts._1;
              attempts = attempts._2;
              switch (attempt.tag) {
                case CATCH:
                  if (interrupt && interrupt !== tmp && bracketCount === 0) {
                    status = RETURN;
                  } else if (fail2) {
                    status = CONTINUE;
                    step = attempt._2(util.fromLeft(fail2));
                    fail2 = null;
                  }
                  break;
                case RESUME:
                  if (interrupt && interrupt !== tmp && bracketCount === 0 || fail2) {
                    status = RETURN;
                  } else {
                    bhead = attempt._1;
                    btail = attempt._2;
                    status = STEP_BIND;
                    step = util.fromRight(step);
                  }
                  break;
                case BRACKET:
                  bracketCount--;
                  if (fail2 === null) {
                    result = util.fromRight(step);
                    attempts = new Aff2(CONS, new Aff2(RELEASE, attempt._2, result), attempts, tmp);
                    if (interrupt === tmp || bracketCount > 0) {
                      status = CONTINUE;
                      step = attempt._3(result);
                    }
                  }
                  break;
                case RELEASE:
                  attempts = new Aff2(CONS, new Aff2(FINALIZED, step, fail2), attempts, interrupt);
                  status = CONTINUE;
                  if (interrupt && interrupt !== tmp && bracketCount === 0) {
                    step = attempt._1.killed(util.fromLeft(interrupt))(attempt._2);
                  } else if (fail2) {
                    step = attempt._1.failed(util.fromLeft(fail2))(attempt._2);
                  } else {
                    step = attempt._1.completed(util.fromRight(step))(attempt._2);
                  }
                  fail2 = null;
                  bracketCount++;
                  break;
                case FINALIZER:
                  bracketCount++;
                  attempts = new Aff2(CONS, new Aff2(FINALIZED, step, fail2), attempts, interrupt);
                  status = CONTINUE;
                  step = attempt._1;
                  break;
                case FINALIZED:
                  bracketCount--;
                  status = RETURN;
                  step = attempt._1;
                  fail2 = attempt._2;
                  break;
              }
            }
            break;
          case COMPLETED:
            for (var k in joins) {
              if (joins.hasOwnProperty(k)) {
                rethrow = rethrow && joins[k].rethrow;
                runEff(joins[k].handler(step));
              }
            }
            joins = null;
            if (interrupt && fail2) {
              setTimeout(function() {
                throw util.fromLeft(fail2);
              }, 0);
            } else if (util.isLeft(step) && rethrow) {
              setTimeout(function() {
                if (rethrow) {
                  throw util.fromLeft(step);
                }
              }, 0);
            }
            return;
          case SUSPENDED:
            status = CONTINUE;
            break;
          case PENDING:
            return;
        }
      }
    }
    function onComplete(join2) {
      return function() {
        if (status === COMPLETED) {
          rethrow = rethrow && join2.rethrow;
          join2.handler(step)();
          return function() {
          };
        }
        var jid = joinId++;
        joins = joins || {};
        joins[jid] = join2;
        return function() {
          if (joins !== null) {
            delete joins[jid];
          }
        };
      };
    }
    function kill(error4, cb) {
      return function() {
        if (status === COMPLETED) {
          cb(util.right(void 0))();
          return function() {
          };
        }
        var canceler = onComplete({
          rethrow: false,
          handler: function() {
            return cb(util.right(void 0));
          }
        })();
        switch (status) {
          case SUSPENDED:
            interrupt = util.left(error4);
            status = COMPLETED;
            step = interrupt;
            run2(runTick);
            break;
          case PENDING:
            if (interrupt === null) {
              interrupt = util.left(error4);
            }
            if (bracketCount === 0) {
              if (status === PENDING) {
                attempts = new Aff2(CONS, new Aff2(FINALIZER, step(error4)), attempts, interrupt);
              }
              status = RETURN;
              step = null;
              fail2 = null;
              run2(++runTick);
            }
            break;
          default:
            if (interrupt === null) {
              interrupt = util.left(error4);
            }
            if (bracketCount === 0) {
              status = RETURN;
              step = null;
              fail2 = null;
            }
        }
        return canceler;
      };
    }
    function join(cb) {
      return function() {
        var canceler = onComplete({
          rethrow: false,
          handler: cb
        })();
        if (status === SUSPENDED) {
          run2(runTick);
        }
        return canceler;
      };
    }
    return {
      kill,
      join,
      onComplete,
      isSuspended: function() {
        return status === SUSPENDED;
      },
      run: function() {
        if (status === SUSPENDED) {
          if (!Scheduler.isDraining()) {
            Scheduler.enqueue(function() {
              run2(runTick);
            });
          } else {
            run2(runTick);
          }
        }
      }
    };
  }
  function runPar(util, supervisor, par, cb) {
    var fiberId = 0;
    var fibers = {};
    var killId = 0;
    var kills = {};
    var early = new Error("[ParAff] Early exit");
    var interrupt = null;
    var root = EMPTY;
    function kill(error4, par2, cb2) {
      var step = par2;
      var head = null;
      var tail2 = null;
      var count = 0;
      var kills2 = {};
      var tmp, kid;
      loop:
        while (true) {
          tmp = null;
          switch (step.tag) {
            case FORKED:
              if (step._3 === EMPTY) {
                tmp = fibers[step._1];
                kills2[count++] = tmp.kill(error4, function(result) {
                  return function() {
                    count--;
                    if (count === 0) {
                      cb2(result)();
                    }
                  };
                });
              }
              if (head === null) {
                break loop;
              }
              step = head._2;
              if (tail2 === null) {
                head = null;
              } else {
                head = tail2._1;
                tail2 = tail2._2;
              }
              break;
            case MAP:
              step = step._2;
              break;
            case APPLY:
            case ALT:
              if (head) {
                tail2 = new Aff2(CONS, head, tail2);
              }
              head = step;
              step = step._1;
              break;
          }
        }
      if (count === 0) {
        cb2(util.right(void 0))();
      } else {
        kid = 0;
        tmp = count;
        for (; kid < tmp; kid++) {
          kills2[kid] = kills2[kid]();
        }
      }
      return kills2;
    }
    function join(result, head, tail2) {
      var fail2, step, lhs, rhs, tmp, kid;
      if (util.isLeft(result)) {
        fail2 = result;
        step = null;
      } else {
        step = result;
        fail2 = null;
      }
      loop:
        while (true) {
          lhs = null;
          rhs = null;
          tmp = null;
          kid = null;
          if (interrupt !== null) {
            return;
          }
          if (head === null) {
            cb(fail2 || step)();
            return;
          }
          if (head._3 !== EMPTY) {
            return;
          }
          switch (head.tag) {
            case MAP:
              if (fail2 === null) {
                head._3 = util.right(head._1(util.fromRight(step)));
                step = head._3;
              } else {
                head._3 = fail2;
              }
              break;
            case APPLY:
              lhs = head._1._3;
              rhs = head._2._3;
              if (fail2) {
                head._3 = fail2;
                tmp = true;
                kid = killId++;
                kills[kid] = kill(early, fail2 === lhs ? head._2 : head._1, function() {
                  return function() {
                    delete kills[kid];
                    if (tmp) {
                      tmp = false;
                    } else if (tail2 === null) {
                      join(fail2, null, null);
                    } else {
                      join(fail2, tail2._1, tail2._2);
                    }
                  };
                });
                if (tmp) {
                  tmp = false;
                  return;
                }
              } else if (lhs === EMPTY || rhs === EMPTY) {
                return;
              } else {
                step = util.right(util.fromRight(lhs)(util.fromRight(rhs)));
                head._3 = step;
              }
              break;
            case ALT:
              lhs = head._1._3;
              rhs = head._2._3;
              if (lhs === EMPTY && util.isLeft(rhs) || rhs === EMPTY && util.isLeft(lhs)) {
                return;
              }
              if (lhs !== EMPTY && util.isLeft(lhs) && rhs !== EMPTY && util.isLeft(rhs)) {
                fail2 = step === lhs ? rhs : lhs;
                step = null;
                head._3 = fail2;
              } else {
                head._3 = step;
                tmp = true;
                kid = killId++;
                kills[kid] = kill(early, step === lhs ? head._2 : head._1, function() {
                  return function() {
                    delete kills[kid];
                    if (tmp) {
                      tmp = false;
                    } else if (tail2 === null) {
                      join(step, null, null);
                    } else {
                      join(step, tail2._1, tail2._2);
                    }
                  };
                });
                if (tmp) {
                  tmp = false;
                  return;
                }
              }
              break;
          }
          if (tail2 === null) {
            head = null;
          } else {
            head = tail2._1;
            tail2 = tail2._2;
          }
        }
    }
    function resolve2(fiber) {
      return function(result) {
        return function() {
          delete fibers[fiber._1];
          fiber._3 = result;
          join(result, fiber._2._1, fiber._2._2);
        };
      };
    }
    function run2() {
      var status = CONTINUE;
      var step = par;
      var head = null;
      var tail2 = null;
      var tmp, fid;
      loop:
        while (true) {
          tmp = null;
          fid = null;
          switch (status) {
            case CONTINUE:
              switch (step.tag) {
                case MAP:
                  if (head) {
                    tail2 = new Aff2(CONS, head, tail2);
                  }
                  head = new Aff2(MAP, step._1, EMPTY, EMPTY);
                  step = step._2;
                  break;
                case APPLY:
                  if (head) {
                    tail2 = new Aff2(CONS, head, tail2);
                  }
                  head = new Aff2(APPLY, EMPTY, step._2, EMPTY);
                  step = step._1;
                  break;
                case ALT:
                  if (head) {
                    tail2 = new Aff2(CONS, head, tail2);
                  }
                  head = new Aff2(ALT, EMPTY, step._2, EMPTY);
                  step = step._1;
                  break;
                default:
                  fid = fiberId++;
                  status = RETURN;
                  tmp = step;
                  step = new Aff2(FORKED, fid, new Aff2(CONS, head, tail2), EMPTY);
                  tmp = Fiber(util, supervisor, tmp);
                  tmp.onComplete({
                    rethrow: false,
                    handler: resolve2(step)
                  })();
                  fibers[fid] = tmp;
                  if (supervisor) {
                    supervisor.register(tmp);
                  }
              }
              break;
            case RETURN:
              if (head === null) {
                break loop;
              }
              if (head._1 === EMPTY) {
                head._1 = step;
                status = CONTINUE;
                step = head._2;
                head._2 = EMPTY;
              } else {
                head._2 = step;
                step = head;
                if (tail2 === null) {
                  head = null;
                } else {
                  head = tail2._1;
                  tail2 = tail2._2;
                }
              }
          }
        }
      root = step;
      for (fid = 0; fid < fiberId; fid++) {
        fibers[fid].run();
      }
    }
    function cancel(error4, cb2) {
      interrupt = util.left(error4);
      var innerKills;
      for (var kid in kills) {
        if (kills.hasOwnProperty(kid)) {
          innerKills = kills[kid];
          for (kid in innerKills) {
            if (innerKills.hasOwnProperty(kid)) {
              innerKills[kid]();
            }
          }
        }
      }
      kills = null;
      var newKills = kill(error4, root, cb2);
      return function(killError) {
        return new Aff2(ASYNC, function(killCb) {
          return function() {
            for (var kid2 in newKills) {
              if (newKills.hasOwnProperty(kid2)) {
                newKills[kid2]();
              }
            }
            return nonCanceler2;
          };
        });
      };
    }
    run2();
    return function(killError) {
      return new Aff2(ASYNC, function(killCb) {
        return function() {
          return cancel(killError, killCb);
        };
      });
    };
  }
  function sequential(util, supervisor, par) {
    return new Aff2(ASYNC, function(cb) {
      return function() {
        return runPar(util, supervisor, par, cb);
      };
    });
  }
  Aff2.EMPTY = EMPTY;
  Aff2.Pure = AffCtr(PURE);
  Aff2.Throw = AffCtr(THROW);
  Aff2.Catch = AffCtr(CATCH);
  Aff2.Sync = AffCtr(SYNC);
  Aff2.Async = AffCtr(ASYNC);
  Aff2.Bind = AffCtr(BIND);
  Aff2.Bracket = AffCtr(BRACKET);
  Aff2.Fork = AffCtr(FORK);
  Aff2.Seq = AffCtr(SEQ);
  Aff2.ParMap = AffCtr(MAP);
  Aff2.ParApply = AffCtr(APPLY);
  Aff2.ParAlt = AffCtr(ALT);
  Aff2.Fiber = Fiber;
  Aff2.Supervisor = Supervisor;
  Aff2.Scheduler = Scheduler;
  Aff2.nonCanceler = nonCanceler2;
  return Aff2;
}();
var _pure = Aff.Pure;
var _throwError = Aff.Throw;
function _catchError(aff) {
  return function(k) {
    return Aff.Catch(aff, k);
  };
}
function _map(f) {
  return function(aff) {
    if (aff.tag === Aff.Pure.tag) {
      return Aff.Pure(f(aff._1));
    } else {
      return Aff.Bind(aff, function(value) {
        return Aff.Pure(f(value));
      });
    }
  };
}
function _bind(aff) {
  return function(k) {
    return Aff.Bind(aff, k);
  };
}
function _fork(immediate) {
  return function(aff) {
    return Aff.Fork(immediate, aff);
  };
}
var _liftEffect = Aff.Sync;
function _parAffMap(f) {
  return function(aff) {
    return Aff.ParMap(f, aff);
  };
}
function _parAffApply(aff1) {
  return function(aff2) {
    return Aff.ParApply(aff1, aff2);
  };
}
var makeAff = Aff.Async;
function generalBracket(acquire) {
  return function(options) {
    return function(k) {
      return Aff.Bracket(acquire, options, k);
    };
  };
}
function _makeFiber(util, aff) {
  return function() {
    return Aff.Fiber(util, null, aff);
  };
}
var _delay = function() {
  function setDelay(n, k) {
    if (n === 0 && typeof setImmediate !== "undefined") {
      return setImmediate(k);
    } else {
      return setTimeout(k, n);
    }
  }
  function clearDelay(n, t) {
    if (n === 0 && typeof clearImmediate !== "undefined") {
      return clearImmediate(t);
    } else {
      return clearTimeout(t);
    }
  }
  return function(right, ms) {
    return Aff.Async(function(cb) {
      return function() {
        var timer = setDelay(ms, cb(right()));
        return function() {
          return Aff.Sync(function() {
            return right(clearDelay(ms, timer));
          });
        };
      };
    });
  };
}();
var _sequential = Aff.Seq;

// output-es/Effect.Aff/index.js
var functorParAff = { map: _parAffMap };
var functorAff = { map: _map };
var forkAff = /* @__PURE__ */ _fork(true);
var ffiUtil = {
  isLeft: (v) => {
    if (v.tag === "Left") {
      return true;
    }
    if (v.tag === "Right") {
      return false;
    }
    fail();
  },
  fromLeft: (v) => {
    if (v.tag === "Left") {
      return v._1;
    }
    if (v.tag === "Right") {
      return _crashWith("unsafeFromLeft: Right");
    }
    fail();
  },
  fromRight: (v) => {
    if (v.tag === "Right") {
      return v._1;
    }
    if (v.tag === "Left") {
      return _crashWith("unsafeFromRight: Left");
    }
    fail();
  },
  left: Left,
  right: Right
};
var applyParAff = { apply: _parAffApply, Functor0: () => functorParAff };
var monadAff = { Applicative0: () => applicativeAff, Bind1: () => bindAff };
var bindAff = { bind: _bind, Apply0: () => applyAff };
var applyAff = { apply: (f) => (a) => _bind(f)((f$p) => _bind(a)((a$p) => applicativeAff.pure(f$p(a$p)))), Functor0: () => functorAff };
var applicativeAff = { pure: _pure, Apply0: () => applyAff };
var invincible = (a) => {
  const $1 = _pure(unit);
  return generalBracket(a)({ killed: (v) => (v$1) => $1, failed: (v) => (v$1) => $1, completed: (v) => (v$1) => $1 })(_pure);
};
var killFiber = (e) => (v) => _bind(_liftEffect(v.isSuspended))((suspended) => {
  if (suspended) {
    return _liftEffect((() => {
      const $3 = v.kill(e, (v$1) => () => unit);
      return () => {
        $3();
        return unit;
      };
    })());
  }
  return makeAff((k) => {
    const $4 = v.kill(e, k);
    return () => {
      const a$p = $4();
      return (() => {
        const $6 = _liftEffect(a$p);
        return (v$1) => $6;
      })();
    };
  });
});
var monadThrowAff = { throwError: _throwError, Monad0: () => monadAff };
var monadErrorAff = { catchError: _catchError, MonadThrow0: () => monadThrowAff };
var $$try2 = /* @__PURE__ */ $$try(monadErrorAff);
var parallelAff = { parallel: unsafeCoerce, sequential: _sequential, Monad0: () => monadAff, Applicative1: () => applicativeParAff };
var applicativeParAff = { pure: (x) => _pure(x), Apply0: () => applyParAff };
var monoidAff = (dictMonoid) => {
  const $1 = dictMonoid.Semigroup0();
  const semigroupAff1 = { append: (a) => (b) => applyAff.apply(_map($1.append)(a))(b) };
  return { mempty: _pure(dictMonoid.mempty), Semigroup0: () => semigroupAff1 };
};
var nonCanceler = /* @__PURE__ */ (() => {
  const $0 = _pure(unit);
  return (v) => $0;
})();
var altAff = { alt: (a1) => (a2) => _catchError(a1)((v) => a2), Functor0: () => functorAff };
var plusAff = { empty: /* @__PURE__ */ _throwError(/* @__PURE__ */ error("Always fails")), Alt0: () => altAff };

// output-es/Node.Encoding/index.js
var $Encoding = (tag) => ({ tag });
var UTF8 = /* @__PURE__ */ $Encoding("UTF8");

// output-es/Data.Nullable/foreign.js
function nullable(a, r, f) {
  return a == null ? r : f(a);
}

// output-es/Node.Buffer.Immutable/foreign.js
function create(size5) {
  return Buffer.alloc(size5);
}
function fromArray(octets) {
  return Buffer.from(octets);
}
function size3(buff) {
  return buff.length;
}
function toArray(buff) {
  var json = buff.toJSON();
  return json.data || json;
}
function toArrayBuffer(buff) {
  return buff.buffer.slice(buff.byteOffset, buff.byteOffset + buff.byteLength);
}
function fromArrayBuffer(ab) {
  return Buffer.from(ab);
}
function fromStringImpl2(str) {
  return (encoding) => {
    return Buffer.from(str, encoding);
  };
}
function readImpl(ty) {
  return (offset) => {
    return (buf) => {
      return buf["read" + ty](offset);
    };
  };
}
function readStringImpl(enc) {
  return (start) => {
    return (end) => {
      return (buff) => {
        return buff.toString(enc, start, end);
      };
    };
  };
}
function getAtOffsetImpl(just) {
  return (nothing) => {
    return (offset) => {
      return (buff) => {
        var octet = buff[offset];
        return octet == null ? nothing : just(octet);
      };
    };
  };
}
function toStringImpl(enc) {
  return (buff) => {
    return buff.toString(enc);
  };
}
function slice3(start) {
  return (end) => {
    return (buff) => {
      return buff.slice(start, end);
    };
  };
}
function concat2(buffs) {
  return Buffer.concat(buffs);
}
function concatToLength(buffs) {
  return (totalLength) => {
    return Buffer.concat(buffs, totalLength);
  };
}

// output-es/Node.Buffer.Immutable/index.js
var toString = (x) => toStringImpl((() => {
  if (x.tag === "ASCII") {
    return "ascii";
  }
  if (x.tag === "UTF8") {
    return "utf8";
  }
  if (x.tag === "UTF16LE") {
    return "utf16le";
  }
  if (x.tag === "UCS2") {
    return "ucs2";
  }
  if (x.tag === "Base64") {
    return "base64";
  }
  if (x.tag === "Latin1") {
    return "latin1";
  }
  if (x.tag === "Binary") {
    return "binary";
  }
  if (x.tag === "Hex") {
    return "hex";
  }
  fail();
})());
var readString = (x) => readStringImpl((() => {
  if (x.tag === "ASCII") {
    return "ascii";
  }
  if (x.tag === "UTF8") {
    return "utf8";
  }
  if (x.tag === "UTF16LE") {
    return "utf16le";
  }
  if (x.tag === "UCS2") {
    return "ucs2";
  }
  if (x.tag === "Base64") {
    return "base64";
  }
  if (x.tag === "Latin1") {
    return "latin1";
  }
  if (x.tag === "Binary") {
    return "binary";
  }
  if (x.tag === "Hex") {
    return "hex";
  }
  fail();
})());
var read3 = (x) => readImpl((() => {
  if (x.tag === "UInt8") {
    return "UInt8";
  }
  if (x.tag === "UInt16LE") {
    return "UInt16LE";
  }
  if (x.tag === "UInt16BE") {
    return "UInt16BE";
  }
  if (x.tag === "UInt32LE") {
    return "UInt32LE";
  }
  if (x.tag === "UInt32BE") {
    return "UInt32BE";
  }
  if (x.tag === "Int8") {
    return "Int8";
  }
  if (x.tag === "Int16LE") {
    return "Int16LE";
  }
  if (x.tag === "Int16BE") {
    return "Int16BE";
  }
  if (x.tag === "Int32LE") {
    return "Int32LE";
  }
  if (x.tag === "Int32BE") {
    return "Int32BE";
  }
  if (x.tag === "FloatLE") {
    return "FloatLE";
  }
  if (x.tag === "FloatBE") {
    return "FloatBE";
  }
  if (x.tag === "DoubleLE") {
    return "DoubleLE";
  }
  if (x.tag === "DoubleBE") {
    return "DoubleBE";
  }
  fail();
})());
var getAtOffset = /* @__PURE__ */ getAtOffsetImpl(Just)(Nothing);
var fromString2 = (str) => {
  const $1 = fromStringImpl2(str);
  return (x) => $1((() => {
    if (x.tag === "ASCII") {
      return "ascii";
    }
    if (x.tag === "UTF8") {
      return "utf8";
    }
    if (x.tag === "UTF16LE") {
      return "utf16le";
    }
    if (x.tag === "UCS2") {
      return "ucs2";
    }
    if (x.tag === "Base64") {
      return "base64";
    }
    if (x.tag === "Latin1") {
      return "latin1";
    }
    if (x.tag === "Binary") {
      return "binary";
    }
    if (x.tag === "Hex") {
      return "hex";
    }
    fail();
  })());
};

// output-es/Node.Buffer.Internal/foreign.js
function copyAll(a) {
  return () => {
    return Buffer.from(a);
  };
}
function writeInternal(ty) {
  return (value) => {
    return (offset) => {
      return (buf) => {
        return () => {
          buf["write" + ty](value, offset);
        };
      };
    };
  };
}
function writeStringInternal(encoding) {
  return (offset) => {
    return (length3) => {
      return (value) => {
        return (buff) => {
          return () => {
            return buff.write(value, offset, length3, encoding);
          };
        };
      };
    };
  };
}
function setAtOffset(value) {
  return (offset) => {
    return (buff) => {
      return () => {
        buff[offset] = value;
      };
    };
  };
}
function copy(srcStart) {
  return (srcEnd) => {
    return (src) => {
      return (targStart) => {
        return (targ) => {
          return () => {
            return src.copy(targ, targStart, srcStart, srcEnd);
          };
        };
      };
    };
  };
}
function fill(octet) {
  return (start) => {
    return (end) => {
      return (buf) => {
        return () => {
          buf.fill(octet, start, end);
        };
      };
    };
  };
}

// output-es/Node.Buffer.Internal/index.js
var writeString = (dictMonad) => (x) => writeStringInternal((() => {
  if (x.tag === "ASCII") {
    return "ascii";
  }
  if (x.tag === "UTF8") {
    return "utf8";
  }
  if (x.tag === "UTF16LE") {
    return "utf16le";
  }
  if (x.tag === "UCS2") {
    return "ucs2";
  }
  if (x.tag === "Base64") {
    return "base64";
  }
  if (x.tag === "Latin1") {
    return "latin1";
  }
  if (x.tag === "Binary") {
    return "binary";
  }
  if (x.tag === "Hex") {
    return "hex";
  }
  fail();
})());
var write3 = (dictMonad) => (x) => writeInternal((() => {
  if (x.tag === "UInt8") {
    return "UInt8";
  }
  if (x.tag === "UInt16LE") {
    return "UInt16LE";
  }
  if (x.tag === "UInt16BE") {
    return "UInt16BE";
  }
  if (x.tag === "UInt32LE") {
    return "UInt32LE";
  }
  if (x.tag === "UInt32BE") {
    return "UInt32BE";
  }
  if (x.tag === "Int8") {
    return "Int8";
  }
  if (x.tag === "Int16LE") {
    return "Int16LE";
  }
  if (x.tag === "Int16BE") {
    return "Int16BE";
  }
  if (x.tag === "Int32LE") {
    return "Int32LE";
  }
  if (x.tag === "Int32BE") {
    return "Int32BE";
  }
  if (x.tag === "FloatLE") {
    return "FloatLE";
  }
  if (x.tag === "FloatBE") {
    return "FloatBE";
  }
  if (x.tag === "DoubleLE") {
    return "DoubleLE";
  }
  if (x.tag === "DoubleBE") {
    return "DoubleBE";
  }
  fail();
})());
var toString2 = (dictMonad) => {
  const map = dictMonad.Bind1().Apply0().Functor0().map;
  const unsafeFreeze1 = dictMonad.Applicative0().pure;
  return (m) => {
    const $4 = toString(m);
    return (buf) => map($4)(unsafeFreeze1(buf));
  };
};
var toArrayBuffer2 = (dictMonad) => {
  const map = dictMonad.Bind1().Apply0().Functor0().map;
  const unsafeFreeze1 = dictMonad.Applicative0().pure;
  return (buf) => map(toArrayBuffer)(unsafeFreeze1(buf));
};
var toArray2 = (dictMonad) => {
  const map = dictMonad.Bind1().Apply0().Functor0().map;
  const unsafeFreeze1 = dictMonad.Applicative0().pure;
  return (buf) => map(toArray)(unsafeFreeze1(buf));
};
var size4 = (dictMonad) => {
  const map = dictMonad.Bind1().Apply0().Functor0().map;
  const unsafeFreeze1 = dictMonad.Applicative0().pure;
  return (buf) => map(size3)(unsafeFreeze1(buf));
};
var readString2 = (dictMonad) => {
  const map = dictMonad.Bind1().Apply0().Functor0().map;
  const unsafeFreeze1 = dictMonad.Applicative0().pure;
  return (m) => (o) => (o$p) => {
    const $6 = readString(m)(o)(o$p);
    return (buf) => map($6)(unsafeFreeze1(buf));
  };
};
var read4 = (dictMonad) => {
  const map = dictMonad.Bind1().Apply0().Functor0().map;
  const unsafeFreeze1 = dictMonad.Applicative0().pure;
  return (t) => (o) => {
    const $5 = read3(t)(o);
    return (buf) => map($5)(unsafeFreeze1(buf));
  };
};
var getAtOffset2 = (dictMonad) => {
  const map = dictMonad.Bind1().Apply0().Functor0().map;
  const unsafeFreeze1 = dictMonad.Applicative0().pure;
  return (o) => {
    const $4 = getAtOffset(o);
    return (buf) => map($4)(unsafeFreeze1(buf));
  };
};
var fromString3 = (dictMonad) => {
  const unsafeThaw1 = dictMonad.Applicative0().pure;
  return (s) => {
    const $3 = fromString2(s);
    return (x) => unsafeThaw1($3(x));
  };
};
var fromArrayBuffer2 = (dictMonad) => {
  const unsafeThaw1 = dictMonad.Applicative0().pure;
  return (x) => unsafeThaw1(fromArrayBuffer(x));
};
var fromArray2 = (dictMonad) => {
  const unsafeThaw1 = dictMonad.Applicative0().pure;
  return (x) => unsafeThaw1(fromArray(x));
};
var create2 = (dictMonad) => {
  const unsafeThaw1 = dictMonad.Applicative0().pure;
  return (x) => unsafeThaw1(create(x));
};
var concat$p = (dictMonad) => (arrs) => (n) => (v) => concatToLength(arrs)(n);
var concat3 = (arrs) => (v) => concat2(arrs);

// output-es/Node.Buffer/index.js
var mutableBufferEffect = {
  create: /* @__PURE__ */ create2(monadEffect),
  freeze: copyAll,
  unsafeFreeze: pureE,
  thaw: copyAll,
  unsafeThaw: pureE,
  fromArray: /* @__PURE__ */ fromArray2(monadEffect),
  fromString: /* @__PURE__ */ fromString3(monadEffect),
  fromArrayBuffer: /* @__PURE__ */ fromArrayBuffer2(monadEffect),
  toArrayBuffer: /* @__PURE__ */ toArrayBuffer2(monadEffect),
  read: /* @__PURE__ */ read4(monadEffect),
  readString: /* @__PURE__ */ readString2(monadEffect),
  toString: /* @__PURE__ */ toString2(monadEffect),
  write: /* @__PURE__ */ write3(monadEffect),
  writeString: /* @__PURE__ */ writeString(monadEffect),
  toArray: /* @__PURE__ */ toArray2(monadEffect),
  getAtOffset: /* @__PURE__ */ getAtOffset2(monadEffect),
  setAtOffset,
  slice: slice3,
  size: /* @__PURE__ */ size4(monadEffect),
  concat: concat3,
  "concat'": /* @__PURE__ */ concat$p(monadEffect),
  copy,
  fill,
  Monad0: () => monadEffect
};

// output-es/Foreign/foreign.js
var isArray = Array.isArray || function(value) {
  return Object.prototype.toString.call(value) === "[object Array]";
};

// output-es/Node.FS.Stats/foreign.js
function statsMethod(m, s) {
  return s[m]();
}

// output-es/Node.FS.Stats/index.js
var $Stats = (_1) => ({ tag: "Stats", _1 });
var isFile = (v) => statsMethod("isFile", v._1);

// output-es/Node.FS.Async/foreign.js
import {
  rename,
  truncate,
  chown,
  chmod,
  stat,
  link,
  symlink,
  readlink,
  realpath,
  unlink,
  rmdir,
  mkdir,
  readdir,
  utimes,
  readFile,
  writeFile,
  appendFile,
  open,
  read as read5,
  write as write4,
  close
} from "fs";
function handleCallbackImpl(left, right, f) {
  return function(err, value) {
    if (err) {
      f(left(err))();
    } else {
      f(right(value))();
    }
  };
}

// output-es/Node.FS.Async/index.js
var readFile2 = (file) => (cb) => (v) => readFile(file, {}, handleCallbackImpl(Left, Right, cb));
var readTextFile = (encoding) => (file) => (cb) => (v) => readFile(
  file,
  {
    encoding: (() => {
      if (encoding.tag === "ASCII") {
        return "ASCII";
      }
      if (encoding.tag === "UTF8") {
        return "UTF8";
      }
      if (encoding.tag === "UTF16LE") {
        return "UTF16LE";
      }
      if (encoding.tag === "UCS2") {
        return "UCS2";
      }
      if (encoding.tag === "Base64") {
        return "Base64";
      }
      if (encoding.tag === "Latin1") {
        return "Latin1";
      }
      if (encoding.tag === "Binary") {
        return "Binary";
      }
      if (encoding.tag === "Hex") {
        return "Hex";
      }
      fail();
    })()
  },
  handleCallbackImpl(Left, Right, cb)
);
var readdir2 = (file) => (cb) => (v) => readdir(file, handleCallbackImpl(Left, Right, cb));
var stat2 = (file) => (cb) => (v) => stat(
  file,
  handleCallbackImpl(
    Left,
    Right,
    (x) => cb((() => {
      if (x.tag === "Left") {
        return $Either("Left", x._1);
      }
      if (x.tag === "Right") {
        return $Either("Right", $Stats(x._1));
      }
      fail();
    })())
  )
);
var writeTextFile = (encoding) => (file) => (buff) => (cb) => (v) => writeFile(
  file,
  buff,
  {
    encoding: (() => {
      if (encoding.tag === "ASCII") {
        return "ASCII";
      }
      if (encoding.tag === "UTF8") {
        return "UTF8";
      }
      if (encoding.tag === "UTF16LE") {
        return "UTF16LE";
      }
      if (encoding.tag === "UCS2") {
        return "UCS2";
      }
      if (encoding.tag === "Base64") {
        return "Base64";
      }
      if (encoding.tag === "Latin1") {
        return "Latin1";
      }
      if (encoding.tag === "Binary") {
        return "Binary";
      }
      if (encoding.tag === "Hex") {
        return "Hex";
      }
      fail();
    })()
  },
  handleCallbackImpl(Left, Right, cb)
);

// output-es/Node.FS.Aff/index.js
var toAff1 = (f) => (a) => {
  const $2 = f(a);
  return makeAff((k) => {
    const $4 = $2(k);
    return () => {
      $4();
      return nonCanceler;
    };
  });
};
var toAff2 = (f) => (a) => (b) => {
  const $3 = f(a)(b);
  return makeAff((k) => {
    const $5 = $3(k);
    return () => {
      $5();
      return nonCanceler;
    };
  });
};
var toAff3 = (f) => (a) => (b) => (c) => {
  const $4 = f(a)(b)(c);
  return makeAff((k) => {
    const $6 = $4(k);
    return () => {
      $6();
      return nonCanceler;
    };
  });
};

// output-es/Effect.Uncurried/foreign.js
var runEffectFn2 = function runEffectFn22(fn) {
  return function(a) {
    return function(b) {
      return function() {
        return fn(a, b);
      };
    };
  };
};
var runEffectFn4 = function runEffectFn42(fn) {
  return function(a) {
    return function(b) {
      return function(c) {
        return function(d) {
          return function() {
            return fn(a, b, c, d);
          };
        };
      };
    };
  };
};
var runEffectFn5 = function runEffectFn52(fn) {
  return function(a) {
    return function(b) {
      return function(c) {
        return function(d) {
          return function(e) {
            return function() {
              return fn(a, b, c, d, e);
            };
          };
        };
      };
    };
  };
};

// output-es/Node.WorkerBees/foreign.js
import workerThreads from "worker_threads";
function spawnImpl(left, right, worker, options, cb) {
  worker.resolve(function(err, res) {
    if (err) {
      return cb(left(err))();
    }
    var thread;
    var importPath = res.filePath;
    try {
      thread = new workerThreads.Worker(importPath, {
        workerData: options.workerData
      });
      thread.on("message", function(value) {
        return options.onMessage(value)();
      });
      thread.on("error", function(err2) {
        return options.onError(err2)();
      });
      thread.on("exit", function(code) {
        return options.onExit(code)();
      });
      thread.on("online", function() {
        cb(right(thread))();
      });
    } catch (e) {
      cb(left(e))();
    }
  });
}
function unsafeMakeImpl(params) {
  return {
    resolve: function(cb) {
      cb(void 0, params);
    },
    spawn: function() {
      throw new Error("Cannot spawn unsafe worker directly.");
    }
  };
}
function postImpl(value, worker) {
  worker.postMessage(value);
}
function terminateImpl(left, right, worker, cb) {
  worker.terminate().then(function() {
    cb(right(void 0))();
  }).catch(function(err) {
    cb(left(err))();
  });
}

// output-es/Node.WorkerBees/index.js
var terminate = /* @__PURE__ */ runEffectFn4(terminateImpl)(Left)(Right);

// output-es/PureScript.CST.Errors/index.js
var $ParseError = (tag, _1, _2) => ({ tag, _1, _2 });
var UnexpectedEof = /* @__PURE__ */ $ParseError("UnexpectedEof");
var LexExpected = (value0) => (value1) => $ParseError("LexExpected", value0, value1);
var printTokenError = (v) => {
  if (v.tag === "TokLeftParen") {
    return "'('";
  }
  if (v.tag === "TokRightParen") {
    return "')'";
  }
  if (v.tag === "TokLeftBrace") {
    return "'{'";
  }
  if (v.tag === "TokRightBrace") {
    return "'}'";
  }
  if (v.tag === "TokLeftSquare") {
    return "'['";
  }
  if (v.tag === "TokRightSquare") {
    return "']'";
  }
  if (v.tag === "TokLeftArrow") {
    if (v._1.tag === "ASCII") {
      return "'<-'";
    }
    if (v._1.tag === "Unicode") {
      return "'\u2190'";
    }
    fail();
  }
  if (v.tag === "TokRightArrow") {
    if (v._1.tag === "ASCII") {
      return "'->'";
    }
    if (v._1.tag === "Unicode") {
      return "'\u2192'";
    }
    fail();
  }
  if (v.tag === "TokRightFatArrow") {
    if (v._1.tag === "ASCII") {
      return "'=>'";
    }
    if (v._1.tag === "Unicode") {
      return "'\u21D2'";
    }
    fail();
  }
  if (v.tag === "TokDoubleColon") {
    if (v._1.tag === "ASCII") {
      return "'::'";
    }
    if (v._1.tag === "Unicode") {
      return "'\u2237'";
    }
    fail();
  }
  if (v.tag === "TokForall") {
    if (v._1.tag === "ASCII") {
      return "forall";
    }
    if (v._1.tag === "Unicode") {
      return "'\u2200'";
    }
    fail();
  }
  if (v.tag === "TokEquals") {
    return "'='";
  }
  if (v.tag === "TokPipe") {
    return "'|'";
  }
  if (v.tag === "TokTick") {
    return "`";
  }
  if (v.tag === "TokDot") {
    return ".";
  }
  if (v.tag === "TokComma") {
    return "','";
  }
  if (v.tag === "TokUnderscore") {
    return "'_'";
  }
  if (v.tag === "TokBackslash") {
    return "'\\'";
  }
  if (v.tag === "TokAt") {
    return "'@'";
  }
  if (v.tag === "TokLowerName") {
    if (v._1.tag === "Nothing") {
      return "identifier " + v._2;
    }
    if (v._1.tag === "Just") {
      return "identifier " + (v._1._1 + ("." + v._2));
    }
    fail();
  }
  if (v.tag === "TokUpperName") {
    if (v._1.tag === "Nothing") {
      return "proper identifier " + v._2;
    }
    if (v._1.tag === "Just") {
      return "proper identifier " + (v._1._1 + ("." + v._2));
    }
    fail();
  }
  if (v.tag === "TokOperator") {
    if (v._1.tag === "Nothing") {
      return "operator " + v._2;
    }
    if (v._1.tag === "Just") {
      return "operator " + (v._1._1 + ("." + v._2));
    }
    fail();
  }
  if (v.tag === "TokSymbolName") {
    if (v._1.tag === "Nothing") {
      return "symbol " + v._2;
    }
    if (v._1.tag === "Just") {
      return "symbol " + (v._1._1 + ("." + v._2));
    }
    fail();
  }
  if (v.tag === "TokSymbolArrow") {
    if (v._1.tag === "ASCII") {
      return "(->)";
    }
    if (v._1.tag === "Unicode") {
      return "(\u2192)";
    }
    fail();
  }
  if (v.tag === "TokHole") {
    return "hole ?" + v._1;
  }
  if (v.tag === "TokChar") {
    return "char literal '" + (v._1 + "'");
  }
  if (v.tag === "TokString") {
    return "string literal";
  }
  if (v.tag === "TokRawString") {
    return "raw string literal";
  }
  if (v.tag === "TokInt") {
    return "int literal " + v._1;
  }
  if (v.tag === "TokNumber") {
    return "number literal " + v._1;
  }
  if (v.tag === "TokLayoutStart") {
    return "start of indented block";
  }
  if (v.tag === "TokLayoutSep") {
    return "new indented block item";
  }
  if (v.tag === "TokLayoutEnd") {
    return "end of indented block";
  }
  fail();
};
var printParseError = (v) => {
  if (v.tag === "UnexpectedEof") {
    return "Unexpected end of file";
  }
  if (v.tag === "ExpectedEof") {
    return "Expected end of file, saw " + printTokenError(v._1);
  }
  if (v.tag === "UnexpectedToken") {
    return "Unexpected " + printTokenError(v._1);
  }
  if (v.tag === "ExpectedToken") {
    return "Expected " + (printTokenError(v._1) + (", saw " + printTokenError(v._2)));
  }
  if (v.tag === "ExpectedClass") {
    return "Expected " + (v._1 + (", saw " + printTokenError(v._2)));
  }
  if (v.tag === "LexExpected") {
    return "Expected " + (v._1 + (", saw " + v._2));
  }
  if (v.tag === "LexInvalidCharEscape") {
    return "Invalid character escape \\" + v._1;
  }
  if (v.tag === "LexCharEscapeOutOfRange") {
    return "Character escape out of range \\" + v._1;
  }
  if (v.tag === "LexHexOutOfRange") {
    return "Hex integer out of range 0x" + v._1;
  }
  if (v.tag === "LexIntOutOfRange") {
    return "Int out of range " + v._1;
  }
  if (v.tag === "LexNumberOutOfRange") {
    return "Number out of range " + v._1;
  }
  fail();
};

// output-es/PureScript.CST.Layout/index.js
var $LayoutDelim = (tag) => ({ tag });
var LytRoot = /* @__PURE__ */ $LayoutDelim("LytRoot");
var LytTopDecl = /* @__PURE__ */ $LayoutDelim("LytTopDecl");
var LytTopDeclHead = /* @__PURE__ */ $LayoutDelim("LytTopDeclHead");
var LytDeclGuard = /* @__PURE__ */ $LayoutDelim("LytDeclGuard");
var LytCase = /* @__PURE__ */ $LayoutDelim("LytCase");
var LytCaseBinders = /* @__PURE__ */ $LayoutDelim("LytCaseBinders");
var LytCaseGuard = /* @__PURE__ */ $LayoutDelim("LytCaseGuard");
var LytLambdaBinders = /* @__PURE__ */ $LayoutDelim("LytLambdaBinders");
var LytParen = /* @__PURE__ */ $LayoutDelim("LytParen");
var LytBrace = /* @__PURE__ */ $LayoutDelim("LytBrace");
var LytSquare = /* @__PURE__ */ $LayoutDelim("LytSquare");
var LytIf = /* @__PURE__ */ $LayoutDelim("LytIf");
var LytThen = /* @__PURE__ */ $LayoutDelim("LytThen");
var LytProperty = /* @__PURE__ */ $LayoutDelim("LytProperty");
var LytForall = /* @__PURE__ */ $LayoutDelim("LytForall");
var LytTick = /* @__PURE__ */ $LayoutDelim("LytTick");
var LytLet = /* @__PURE__ */ $LayoutDelim("LytLet");
var LytLetStmt = /* @__PURE__ */ $LayoutDelim("LytLetStmt");
var LytWhere = /* @__PURE__ */ $LayoutDelim("LytWhere");
var LytOf = /* @__PURE__ */ $LayoutDelim("LytOf");
var LytDo = /* @__PURE__ */ $LayoutDelim("LytDo");
var LytAdo = /* @__PURE__ */ $LayoutDelim("LytAdo");
var isIndented = (v) => v.tag === "LytLet" || (v.tag === "LytLetStmt" || (v.tag === "LytWhere" || (v.tag === "LytOf" || (v.tag === "LytDo" || v.tag === "LytAdo"))));
var eqLayoutDelim = {
  eq: (x) => (y) => {
    if (x.tag === "LytRoot") {
      return y.tag === "LytRoot";
    }
    if (x.tag === "LytTopDecl") {
      return y.tag === "LytTopDecl";
    }
    if (x.tag === "LytTopDeclHead") {
      return y.tag === "LytTopDeclHead";
    }
    if (x.tag === "LytDeclGuard") {
      return y.tag === "LytDeclGuard";
    }
    if (x.tag === "LytCase") {
      return y.tag === "LytCase";
    }
    if (x.tag === "LytCaseBinders") {
      return y.tag === "LytCaseBinders";
    }
    if (x.tag === "LytCaseGuard") {
      return y.tag === "LytCaseGuard";
    }
    if (x.tag === "LytLambdaBinders") {
      return y.tag === "LytLambdaBinders";
    }
    if (x.tag === "LytParen") {
      return y.tag === "LytParen";
    }
    if (x.tag === "LytBrace") {
      return y.tag === "LytBrace";
    }
    if (x.tag === "LytSquare") {
      return y.tag === "LytSquare";
    }
    if (x.tag === "LytIf") {
      return y.tag === "LytIf";
    }
    if (x.tag === "LytThen") {
      return y.tag === "LytThen";
    }
    if (x.tag === "LytProperty") {
      return y.tag === "LytProperty";
    }
    if (x.tag === "LytForall") {
      return y.tag === "LytForall";
    }
    if (x.tag === "LytTick") {
      return y.tag === "LytTick";
    }
    if (x.tag === "LytLet") {
      return y.tag === "LytLet";
    }
    if (x.tag === "LytLetStmt") {
      return y.tag === "LytLetStmt";
    }
    if (x.tag === "LytWhere") {
      return y.tag === "LytWhere";
    }
    if (x.tag === "LytOf") {
      return y.tag === "LytOf";
    }
    if (x.tag === "LytDo") {
      return y.tag === "LytDo";
    }
    if (x.tag === "LytAdo") {
      return y.tag === "LytAdo";
    }
    return false;
  }
};
var insertLayout = (v) => (nextPos) => (stack) => {
  const sepP = (lytPos) => v.range.start.column === lytPos.column && v.range.start.line !== lytPos.line;
  const insertStart = (lyt) => (v1) => {
    const v2 = find(foldableList)((x) => x._2.tag === "LytLet" || (x._2.tag === "LytLetStmt" || (x._2.tag === "LytWhere" || (x._2.tag === "LytOf" || (x._2.tag === "LytDo" || x._2.tag === "LytAdo")))))(v1._1);
    const $7 = () => $Tuple(
      $List("Cons", $Tuple(nextPos, lyt), v1._1),
      run(withArray(pushAll([
        $Tuple(
          { range: { start: nextPos, end: nextPos }, leadingComments: [], trailingComments: [], value: $Token("TokLayoutStart", nextPos.column) },
          $List("Cons", $Tuple(nextPos, lyt), v1._1)
        )
      ]))(v1._2))
    );
    if (v2.tag === "Just") {
      if (nextPos.column <= v2._1._1.column) {
        return v1;
      }
      return $7();
    }
    return $7();
  };
  const insertSep = (v1) => {
    const sepTok = {
      range: { start: v.range.start, end: v.range.start },
      leadingComments: [],
      trailingComments: [],
      value: $Token("TokLayoutSep", v.range.start.column)
    };
    const $7 = (lyt, lytPos) => {
      if (lyt.tag === "LytOf") {
        return $Tuple(
          $List("Cons", $Tuple(v.range.start, LytCaseBinders), v1._1),
          run(withArray(pushAll([$Tuple(sepTok, v1._1)]))(v1._2))
        );
      }
      return $Tuple(v1._1, run(withArray(pushAll([$Tuple(sepTok, v1._1)]))(v1._2)));
    };
    if (v1._1.tag === "Cons") {
      if (v1._1._1._2.tag === "LytTopDecl") {
        if (sepP(v1._1._1._1)) {
          return $Tuple(v1._1._2, run(withArray(pushAll([$Tuple(sepTok, v1._1._2)]))(v1._2)));
        }
        if ((v1._1._1._2.tag === "LytLet" || (v1._1._1._2.tag === "LytLetStmt" || (v1._1._1._2.tag === "LytWhere" || (v1._1._1._2.tag === "LytOf" || (v1._1._1._2.tag === "LytDo" || v1._1._1._2.tag === "LytAdo"))))) && sepP(v1._1._1._1)) {
          return $7(v1._1._1._2, v1._1._1._1);
        }
        return v1;
      }
      if (v1._1._1._2.tag === "LytTopDeclHead") {
        if (sepP(v1._1._1._1)) {
          return $Tuple(v1._1._2, run(withArray(pushAll([$Tuple(sepTok, v1._1._2)]))(v1._2)));
        }
        if ((v1._1._1._2.tag === "LytLet" || (v1._1._1._2.tag === "LytLetStmt" || (v1._1._1._2.tag === "LytWhere" || (v1._1._1._2.tag === "LytOf" || (v1._1._1._2.tag === "LytDo" || v1._1._1._2.tag === "LytAdo"))))) && sepP(v1._1._1._1)) {
          return $7(v1._1._1._2, v1._1._1._1);
        }
        return v1;
      }
      if ((v1._1._1._2.tag === "LytLet" || (v1._1._1._2.tag === "LytLetStmt" || (v1._1._1._2.tag === "LytWhere" || (v1._1._1._2.tag === "LytOf" || (v1._1._1._2.tag === "LytDo" || v1._1._1._2.tag === "LytAdo"))))) && sepP(v1._1._1._1)) {
        return $7(v1._1._1._2, v1._1._1._1);
      }
      return v1;
    }
    return v1;
  };
  const collapse = (p) => {
    const go = (go$a0$copy) => (go$a1$copy) => {
      let go$a0 = go$a0$copy, go$a1 = go$a1$copy, go$c = true, go$r;
      while (go$c) {
        const v1 = go$a0, acc = go$a1;
        if (v1.tag === "Cons") {
          if (p(v1._1._1)(v1._1._2)) {
            go$a0 = v1._2;
            go$a1 = (() => {
              if (v1._1._2.tag === "LytLet" || (v1._1._2.tag === "LytLetStmt" || (v1._1._2.tag === "LytWhere" || (v1._1._2.tag === "LytOf" || (v1._1._2.tag === "LytDo" || v1._1._2.tag === "LytAdo"))))) {
                return run(withArray(pushAll([
                  $Tuple(
                    {
                      range: { start: v.range.start, end: v.range.start },
                      leadingComments: [],
                      trailingComments: [],
                      value: $Token("TokLayoutEnd", v1._1._1.column)
                    },
                    v1._2
                  )
                ]))(acc));
              }
              return acc;
            })();
            continue;
          }
          go$c = false;
          go$r = $Tuple(v1, acc);
          continue;
        }
        go$c = false;
        go$r = $Tuple(v1, acc);
        continue;
      }
      ;
      return go$r;
    };
    return (v$1) => go(v$1._1)(v$1._2);
  };
  const insertKwProperty = (k, state) => {
    const $9 = insertSep(collapse((lytPos) => (lyt) => (lyt.tag === "LytLet" || (lyt.tag === "LytLetStmt" || (lyt.tag === "LytWhere" || (lyt.tag === "LytOf" || (lyt.tag === "LytDo" || lyt.tag === "LytAdo"))))) && v.range.start.column < lytPos.column)(state));
    const v1 = $Tuple($9._1, run(withArray(pushAll([$Tuple(v, $9._1)]))($9._2)));
    if (v1._1.tag === "Cons") {
      if (v1._1._1._2.tag === "LytProperty") {
        return $Tuple(v1._1._2, v1._2);
      }
      return k(v1);
    }
    return k(v1);
  };
  if (v.value.tag === "TokLowerName") {
    if (v.value._1.tag === "Nothing") {
      if (v.value._2 === "data") {
        const $84 = insertSep(collapse((lytPos) => (lyt) => (lyt.tag === "LytLet" || (lyt.tag === "LytLetStmt" || (lyt.tag === "LytWhere" || (lyt.tag === "LytOf" || (lyt.tag === "LytDo" || lyt.tag === "LytAdo"))))) && v.range.start.column < lytPos.column)($Tuple(stack, [])));
        const v2 = $Tuple($84._1, run(withArray(pushAll([$Tuple(v, $84._1)]))($84._2)));
        if ((() => {
          if (v2._1.tag === "Cons") {
            if (v2._1._1._2.tag === "LytWhere") {
              if (v2._1._2.tag === "Cons") {
                if (v2._1._2._1._2.tag === "LytRoot") {
                  if (v2._1._2._2.tag === "Nil") {
                    return v.range.start.column === v2._1._1._1.column;
                  }
                  return false;
                }
                return false;
              }
              return false;
            }
            return false;
          }
          return false;
        })()) {
          return $Tuple($List("Cons", $Tuple(v.range.start, LytTopDecl), v2._1), v2._2);
        }
        if (v2._1.tag === "Cons") {
          if (eqLayoutDelim.eq(v2._1._1._2)(LytProperty)) {
            return $Tuple(v2._1._2, v2._2);
          }
          return v2;
        }
        return v2;
      }
      if (v.value._2 === "class") {
        const $84 = insertSep(collapse((lytPos) => (lyt) => (lyt.tag === "LytLet" || (lyt.tag === "LytLetStmt" || (lyt.tag === "LytWhere" || (lyt.tag === "LytOf" || (lyt.tag === "LytDo" || lyt.tag === "LytAdo"))))) && v.range.start.column < lytPos.column)($Tuple(stack, [])));
        const v2 = $Tuple($84._1, run(withArray(pushAll([$Tuple(v, $84._1)]))($84._2)));
        if ((() => {
          if (v2._1.tag === "Cons") {
            if (v2._1._1._2.tag === "LytWhere") {
              if (v2._1._2.tag === "Cons") {
                if (v2._1._2._1._2.tag === "LytRoot") {
                  if (v2._1._2._2.tag === "Nil") {
                    return v.range.start.column === v2._1._1._1.column;
                  }
                  return false;
                }
                return false;
              }
              return false;
            }
            return false;
          }
          return false;
        })()) {
          return $Tuple($List("Cons", $Tuple(v.range.start, LytTopDeclHead), v2._1), v2._2);
        }
        if (v2._1.tag === "Cons") {
          if (eqLayoutDelim.eq(v2._1._1._2)(LytProperty)) {
            return $Tuple(v2._1._2, v2._2);
          }
          return v2;
        }
        return v2;
      }
      if (v.value._2 === "where") {
        const whereP = (v2) => (v3) => v3.tag === "LytDo" || (v3.tag === "LytLet" || (v3.tag === "LytLetStmt" || (v3.tag === "LytWhere" || (v3.tag === "LytOf" || (v3.tag === "LytDo" || v3.tag === "LytAdo"))))) && v.range.start.column <= v2.column;
        if (stack.tag === "Cons") {
          if (stack._1._2.tag === "LytTopDeclHead") {
            return insertStart(LytWhere)($Tuple(
              stack._2,
              run(withArray(pushAll([$Tuple(v, stack._2)]))([]))
            ));
          }
          if (stack._1._2.tag === "LytProperty") {
            return $Tuple(stack._2, run(withArray(pushAll([$Tuple(v, stack._2)]))([])));
          }
          return insertStart(LytWhere)((() => {
            const $92 = collapse(whereP)($Tuple(stack, []));
            return $Tuple($92._1, run(withArray(pushAll([$Tuple(v, $92._1)]))($92._2)));
          })());
        }
        return insertStart(LytWhere)((() => {
          const $92 = collapse(whereP)($Tuple(stack, []));
          return $Tuple($92._1, run(withArray(pushAll([$Tuple(v, $92._1)]))($92._2)));
        })());
      }
      if (v.value._2 === "in") {
        const v2 = collapse((v22) => (v3) => {
          if (v3.tag === "LytLet") {
            return false;
          }
          if (v3.tag === "LytAdo") {
            return false;
          }
          return v3.tag === "LytLet" || (v3.tag === "LytLetStmt" || (v3.tag === "LytWhere" || (v3.tag === "LytOf" || (v3.tag === "LytDo" || v3.tag === "LytAdo"))));
        })($Tuple(stack, []));
        if (v2._1.tag === "Cons") {
          if (v2._1._1._2.tag === "LytLetStmt") {
            if (v2._1._2.tag === "Cons") {
              if (v2._1._2._1._2.tag === "LytAdo") {
                return $Tuple(
                  v2._1._2._2,
                  run(withArray(pushAll([$Tuple(v, v2._1._2._2)]))(run(withArray(pushAll([
                    $Tuple(
                      {
                        range: { start: v.range.start, end: v.range.start },
                        leadingComments: [],
                        trailingComments: [],
                        value: $Token("TokLayoutEnd", v2._1._2._1._1.column)
                      },
                      v2._1._2._2
                    )
                  ]))(run(withArray(pushAll([
                    $Tuple(
                      {
                        range: { start: v.range.start, end: v.range.start },
                        leadingComments: [],
                        trailingComments: [],
                        value: $Token("TokLayoutEnd", v2._1._1._1.column)
                      },
                      v2._1._2._2
                    )
                  ]))(v2._2))))))
                );
              }
              if (v2._1._1._2.tag === "LytLet" || (v2._1._1._2.tag === "LytLetStmt" || (v2._1._1._2.tag === "LytWhere" || (v2._1._1._2.tag === "LytOf" || (v2._1._1._2.tag === "LytDo" || v2._1._1._2.tag === "LytAdo"))))) {
                return $Tuple(
                  v2._1._2,
                  run(withArray(pushAll([$Tuple(v, v2._1._2)]))(run(withArray(pushAll([
                    $Tuple(
                      {
                        range: { start: v.range.start, end: v.range.start },
                        leadingComments: [],
                        trailingComments: [],
                        value: $Token("TokLayoutEnd", v2._1._1._1.column)
                      },
                      v2._1._2
                    )
                  ]))(v2._2))))
                );
              }
              const $95 = insertSep(collapse((lytPos) => (lyt) => (lyt.tag === "LytLet" || (lyt.tag === "LytLetStmt" || (lyt.tag === "LytWhere" || (lyt.tag === "LytOf" || (lyt.tag === "LytDo" || lyt.tag === "LytAdo"))))) && v.range.start.column < lytPos.column)($Tuple(stack, [])));
              const $104 = $Tuple($95._1, run(withArray(pushAll([$Tuple(v, $95._1)]))($95._2)));
              if ($104._1.tag === "Cons") {
                if (eqLayoutDelim.eq($104._1._1._2)(LytProperty)) {
                  return $Tuple($104._1._2, $104._2);
                }
                return $104;
              }
              return $104;
            }
            if (v2._1._1._2.tag === "LytLet" || (v2._1._1._2.tag === "LytLetStmt" || (v2._1._1._2.tag === "LytWhere" || (v2._1._1._2.tag === "LytOf" || (v2._1._1._2.tag === "LytDo" || v2._1._1._2.tag === "LytAdo"))))) {
              return $Tuple(
                v2._1._2,
                run(withArray(pushAll([$Tuple(v, v2._1._2)]))(run(withArray(pushAll([
                  $Tuple(
                    {
                      range: { start: v.range.start, end: v.range.start },
                      leadingComments: [],
                      trailingComments: [],
                      value: $Token("TokLayoutEnd", v2._1._1._1.column)
                    },
                    v2._1._2
                  )
                ]))(v2._2))))
              );
            }
            const $94 = insertSep(collapse((lytPos) => (lyt) => (lyt.tag === "LytLet" || (lyt.tag === "LytLetStmt" || (lyt.tag === "LytWhere" || (lyt.tag === "LytOf" || (lyt.tag === "LytDo" || lyt.tag === "LytAdo"))))) && v.range.start.column < lytPos.column)($Tuple(stack, [])));
            const $103 = $Tuple($94._1, run(withArray(pushAll([$Tuple(v, $94._1)]))($94._2)));
            if ($103._1.tag === "Cons") {
              if (eqLayoutDelim.eq($103._1._1._2)(LytProperty)) {
                return $Tuple($103._1._2, $103._2);
              }
              return $103;
            }
            return $103;
          }
          if (v2._1._1._2.tag === "LytLet" || (v2._1._1._2.tag === "LytLetStmt" || (v2._1._1._2.tag === "LytWhere" || (v2._1._1._2.tag === "LytOf" || (v2._1._1._2.tag === "LytDo" || v2._1._1._2.tag === "LytAdo"))))) {
            return $Tuple(
              v2._1._2,
              run(withArray(pushAll([$Tuple(v, v2._1._2)]))(run(withArray(pushAll([
                $Tuple(
                  {
                    range: { start: v.range.start, end: v.range.start },
                    leadingComments: [],
                    trailingComments: [],
                    value: $Token("TokLayoutEnd", v2._1._1._1.column)
                  },
                  v2._1._2
                )
              ]))(v2._2))))
            );
          }
          const $93 = insertSep(collapse((lytPos) => (lyt) => (lyt.tag === "LytLet" || (lyt.tag === "LytLetStmt" || (lyt.tag === "LytWhere" || (lyt.tag === "LytOf" || (lyt.tag === "LytDo" || lyt.tag === "LytAdo"))))) && v.range.start.column < lytPos.column)($Tuple(stack, [])));
          const $102 = $Tuple($93._1, run(withArray(pushAll([$Tuple(v, $93._1)]))($93._2)));
          if ($102._1.tag === "Cons") {
            if (eqLayoutDelim.eq($102._1._1._2)(LytProperty)) {
              return $Tuple($102._1._2, $102._2);
            }
            return $102;
          }
          return $102;
        }
        const $92 = insertSep(collapse((lytPos) => (lyt) => (lyt.tag === "LytLet" || (lyt.tag === "LytLetStmt" || (lyt.tag === "LytWhere" || (lyt.tag === "LytOf" || (lyt.tag === "LytDo" || lyt.tag === "LytAdo"))))) && v.range.start.column < lytPos.column)($Tuple(stack, [])));
        const $10 = $Tuple($92._1, run(withArray(pushAll([$Tuple(v, $92._1)]))($92._2)));
        if ($10._1.tag === "Cons") {
          if (eqLayoutDelim.eq($10._1._1._2)(LytProperty)) {
            return $Tuple($10._1._2, $10._2);
          }
          return $10;
        }
        return $10;
      }
      if (v.value._2 === "let") {
        return insertKwProperty(
          (v2) => {
            if (v2._1.tag === "Cons") {
              if (v2._1._1._2.tag === "LytDo") {
                if (v2._1._1._1.column === v.range.start.column) {
                  return insertStart(LytLetStmt)(v2);
                }
                return insertStart(LytLet)(v2);
              }
              if (v2._1._1._2.tag === "LytAdo") {
                if (v2._1._1._1.column === v.range.start.column) {
                  return insertStart(LytLetStmt)(v2);
                }
                return insertStart(LytLet)(v2);
              }
              return insertStart(LytLet)(v2);
            }
            return insertStart(LytLet)(v2);
          },
          $Tuple(stack, [])
        );
      }
      if (v.value._2 === "do") {
        return insertKwProperty(insertStart(LytDo), $Tuple(stack, []));
      }
      if (v.value._2 === "ado") {
        return insertKwProperty(insertStart(LytAdo), $Tuple(stack, []));
      }
      if (v.value._2 === "case") {
        return insertKwProperty((v1) => $Tuple($List("Cons", $Tuple(v.range.start, LytCase), v1._1), v1._2), $Tuple(stack, []));
      }
      if (v.value._2 === "of") {
        const v2 = collapse((v$1) => isIndented)($Tuple(stack, []));
        if (v2._1.tag === "Cons") {
          if (v2._1._1._2.tag === "LytCase") {
            const $94 = insertStart(LytOf)($Tuple(
              v2._1._2,
              run(withArray(pushAll([$Tuple(v, v2._1._2)]))(v2._2))
            ));
            return $Tuple($List("Cons", $Tuple(nextPos, LytCaseBinders), $94._1), $94._2);
          }
          const $93 = insertSep(collapse((lytPos) => (lyt) => (lyt.tag === "LytLet" || (lyt.tag === "LytLetStmt" || (lyt.tag === "LytWhere" || (lyt.tag === "LytOf" || (lyt.tag === "LytDo" || lyt.tag === "LytAdo"))))) && v.range.start.column < lytPos.column)(v2));
          const $102 = $Tuple($93._1, run(withArray(pushAll([$Tuple(v, $93._1)]))($93._2)));
          if ($102._1.tag === "Cons") {
            if (eqLayoutDelim.eq($102._1._1._2)(LytProperty)) {
              return $Tuple($102._1._2, $102._2);
            }
            return $102;
          }
          return $102;
        }
        const $92 = insertSep(collapse((lytPos) => (lyt) => (lyt.tag === "LytLet" || (lyt.tag === "LytLetStmt" || (lyt.tag === "LytWhere" || (lyt.tag === "LytOf" || (lyt.tag === "LytDo" || lyt.tag === "LytAdo"))))) && v.range.start.column < lytPos.column)(v2));
        const $10 = $Tuple($92._1, run(withArray(pushAll([$Tuple(v, $92._1)]))($92._2)));
        if ($10._1.tag === "Cons") {
          if (eqLayoutDelim.eq($10._1._1._2)(LytProperty)) {
            return $Tuple($10._1._2, $10._2);
          }
          return $10;
        }
        return $10;
      }
      if (v.value._2 === "if") {
        return insertKwProperty((v1) => $Tuple($List("Cons", $Tuple(v.range.start, LytIf), v1._1), v1._2), $Tuple(stack, []));
      }
      if (v.value._2 === "then") {
        const v2 = collapse((v$1) => isIndented)($Tuple(stack, []));
        if (v2._1.tag === "Cons") {
          if (v2._1._1._2.tag === "LytIf") {
            return $Tuple(
              $List("Cons", $Tuple(v.range.start, LytThen), v2._1._2),
              run(withArray(pushAll([$Tuple(v, v2._1._2)]))(v2._2))
            );
          }
          const $93 = insertSep(collapse((lytPos) => (lyt) => (lyt.tag === "LytLet" || (lyt.tag === "LytLetStmt" || (lyt.tag === "LytWhere" || (lyt.tag === "LytOf" || (lyt.tag === "LytDo" || lyt.tag === "LytAdo"))))) && v.range.start.column < lytPos.column)($Tuple(stack, [])));
          const $102 = $Tuple($93._1, run(withArray(pushAll([$Tuple(v, $93._1)]))($93._2)));
          if ($102._1.tag === "Cons") {
            if (eqLayoutDelim.eq($102._1._1._2)(LytProperty)) {
              return $Tuple($102._1._2, $102._2);
            }
            return $102;
          }
          return $102;
        }
        const $92 = insertSep(collapse((lytPos) => (lyt) => (lyt.tag === "LytLet" || (lyt.tag === "LytLetStmt" || (lyt.tag === "LytWhere" || (lyt.tag === "LytOf" || (lyt.tag === "LytDo" || lyt.tag === "LytAdo"))))) && v.range.start.column < lytPos.column)($Tuple(stack, [])));
        const $10 = $Tuple($92._1, run(withArray(pushAll([$Tuple(v, $92._1)]))($92._2)));
        if ($10._1.tag === "Cons") {
          if (eqLayoutDelim.eq($10._1._1._2)(LytProperty)) {
            return $Tuple($10._1._2, $10._2);
          }
          return $10;
        }
        return $10;
      }
      if (v.value._2 === "else") {
        const v2 = collapse((v$1) => isIndented)($Tuple(stack, []));
        const $92 = () => {
          const v3 = collapse((lytPos) => (lyt) => (lyt.tag === "LytLet" || (lyt.tag === "LytLetStmt" || (lyt.tag === "LytWhere" || (lyt.tag === "LytOf" || (lyt.tag === "LytDo" || lyt.tag === "LytAdo"))))) && v.range.start.column < lytPos.column)($Tuple(stack, []));
          if ((() => {
            if (v3._1.tag === "Cons") {
              if (v3._1._1._2.tag === "LytWhere") {
                if (v3._1._2.tag === "Cons") {
                  if (v3._1._2._1._2.tag === "LytRoot") {
                    if (v3._1._2._2.tag === "Nil") {
                      return v.range.start.column === v3._1._1._1.column;
                    }
                    return false;
                  }
                  return false;
                }
                return false;
              }
              return false;
            }
            return false;
          })()) {
            return $Tuple(v3._1, run(withArray(pushAll([$Tuple(v, v3._1)]))(v3._2)));
          }
          const $10 = insertSep(v3);
          const $11 = $Tuple($10._1, run(withArray(pushAll([$Tuple(v, $10._1)]))($10._2)));
          if ($11._1.tag === "Cons") {
            if (eqLayoutDelim.eq($11._1._1._2)(LytProperty)) {
              return $Tuple($11._1._2, $11._2);
            }
            return $11;
          }
          return $11;
        };
        if (v2._1.tag === "Cons") {
          if (v2._1._1._2.tag === "LytThen") {
            return $Tuple(v2._1._2, run(withArray(pushAll([$Tuple(v, v2._1._2)]))(v2._2)));
          }
          return $92();
        }
        return $92();
      }
      const $83 = insertSep(collapse((lytPos) => (lyt) => (lyt.tag === "LytLet" || (lyt.tag === "LytLetStmt" || (lyt.tag === "LytWhere" || (lyt.tag === "LytOf" || (lyt.tag === "LytDo" || lyt.tag === "LytAdo"))))) && v.range.start.column < lytPos.column)($Tuple(stack, [])));
      const $9 = $Tuple($83._1, run(withArray(pushAll([$Tuple(v, $83._1)]))($83._2)));
      if ($9._1.tag === "Cons") {
        if (eqLayoutDelim.eq($9._1._1._2)(LytProperty)) {
          return $Tuple($9._1._2, $9._2);
        }
        return $9;
      }
      return $9;
    }
    if (v.value._2 === "do") {
      return insertKwProperty(insertStart(LytDo), $Tuple(stack, []));
    }
    if (v.value._2 === "ado") {
      return insertKwProperty(insertStart(LytAdo), $Tuple(stack, []));
    }
    const $82 = insertSep(collapse((lytPos) => (lyt) => (lyt.tag === "LytLet" || (lyt.tag === "LytLetStmt" || (lyt.tag === "LytWhere" || (lyt.tag === "LytOf" || (lyt.tag === "LytDo" || lyt.tag === "LytAdo"))))) && v.range.start.column < lytPos.column)($Tuple(stack, [])));
    return $Tuple($82._1, run(withArray(pushAll([$Tuple(v, $82._1)]))($82._2)));
  }
  if (v.value.tag === "TokForall") {
    return insertKwProperty((v1) => $Tuple($List("Cons", $Tuple(v.range.start, LytForall), v1._1), v1._2), $Tuple(stack, []));
  }
  if (v.value.tag === "TokBackslash") {
    const $82 = insertSep(collapse((lytPos) => (lyt) => (lyt.tag === "LytLet" || (lyt.tag === "LytLetStmt" || (lyt.tag === "LytWhere" || (lyt.tag === "LytOf" || (lyt.tag === "LytDo" || lyt.tag === "LytAdo"))))) && v.range.start.column < lytPos.column)($Tuple(stack, [])));
    return $Tuple(
      $List("Cons", $Tuple(v.range.start, LytLambdaBinders), $82._1),
      run(withArray(pushAll([$Tuple(v, $82._1)]))($82._2))
    );
  }
  if (v.value.tag === "TokRightArrow") {
    const $82 = collapse((v2) => (v3) => {
      if (v3.tag === "LytDo") {
        return true;
      }
      if (v3.tag === "LytOf") {
        return false;
      }
      return (v3.tag === "LytLet" || (v3.tag === "LytLetStmt" || (v3.tag === "LytWhere" || (v3.tag === "LytOf" || (v3.tag === "LytDo" || v3.tag === "LytAdo"))))) && v.range.start.column <= v2.column;
    })($Tuple(stack, []));
    if ($82._1.tag === "Cons") {
      if ($82._1._1._2.tag === "LytCaseBinders" || ($82._1._1._2.tag === "LytCaseGuard" || $82._1._1._2.tag === "LytLambdaBinders")) {
        return $Tuple($82._1._2, run(withArray(pushAll([$Tuple(v, $82._1._2)]))($82._2)));
      }
      return $Tuple($82._1, run(withArray(pushAll([$Tuple(v, $82._1)]))($82._2)));
    }
    return $Tuple($82._1, run(withArray(pushAll([$Tuple(v, $82._1)]))($82._2)));
  }
  if (v.value.tag === "TokEquals") {
    const v2 = collapse((v22) => (v3) => v3.tag === "LytWhere" || (v3.tag === "LytLet" || v3.tag === "LytLetStmt"))($Tuple(stack, []));
    if (v2._1.tag === "Cons") {
      if (v2._1._1._2.tag === "LytDeclGuard") {
        return $Tuple(v2._1._2, run(withArray(pushAll([$Tuple(v, v2._1._2)]))(v2._2)));
      }
      const $92 = insertSep(collapse((lytPos) => (lyt) => (lyt.tag === "LytLet" || (lyt.tag === "LytLetStmt" || (lyt.tag === "LytWhere" || (lyt.tag === "LytOf" || (lyt.tag === "LytDo" || lyt.tag === "LytAdo"))))) && v.range.start.column < lytPos.column)($Tuple(stack, [])));
      return $Tuple($92._1, run(withArray(pushAll([$Tuple(v, $92._1)]))($92._2)));
    }
    const $9 = insertSep(collapse((lytPos) => (lyt) => (lyt.tag === "LytLet" || (lyt.tag === "LytLetStmt" || (lyt.tag === "LytWhere" || (lyt.tag === "LytOf" || (lyt.tag === "LytDo" || lyt.tag === "LytAdo"))))) && v.range.start.column < lytPos.column)($Tuple(stack, [])));
    return $Tuple($9._1, run(withArray(pushAll([$Tuple(v, $9._1)]))($9._2)));
  }
  if (v.value.tag === "TokPipe") {
    const v2 = collapse((lytPos) => (lyt) => (lyt.tag === "LytLet" || (lyt.tag === "LytLetStmt" || (lyt.tag === "LytWhere" || (lyt.tag === "LytOf" || (lyt.tag === "LytDo" || lyt.tag === "LytAdo"))))) && v.range.start.column <= lytPos.column)($Tuple(stack, []));
    if (v2._1.tag === "Cons") {
      if (v2._1._1._2.tag === "LytOf") {
        return $Tuple(
          $List("Cons", $Tuple(v.range.start, LytCaseGuard), v2._1),
          run(withArray(pushAll([
            $Tuple(v, $List("Cons", $Tuple(v.range.start, LytCaseGuard), v2._1))
          ]))(v2._2))
        );
      }
      if (v2._1._1._2.tag === "LytLet") {
        return $Tuple(
          $List("Cons", $Tuple(v.range.start, LytDeclGuard), v2._1),
          run(withArray(pushAll([
            $Tuple(v, $List("Cons", $Tuple(v.range.start, LytDeclGuard), v2._1))
          ]))(v2._2))
        );
      }
      if (v2._1._1._2.tag === "LytLetStmt") {
        return $Tuple(
          $List("Cons", $Tuple(v.range.start, LytDeclGuard), v2._1),
          run(withArray(pushAll([
            $Tuple(v, $List("Cons", $Tuple(v.range.start, LytDeclGuard), v2._1))
          ]))(v2._2))
        );
      }
      if (v2._1._1._2.tag === "LytWhere") {
        return $Tuple(
          $List("Cons", $Tuple(v.range.start, LytDeclGuard), v2._1),
          run(withArray(pushAll([
            $Tuple(v, $List("Cons", $Tuple(v.range.start, LytDeclGuard), v2._1))
          ]))(v2._2))
        );
      }
      const $92 = insertSep(collapse((lytPos) => (lyt) => (lyt.tag === "LytLet" || (lyt.tag === "LytLetStmt" || (lyt.tag === "LytWhere" || (lyt.tag === "LytOf" || (lyt.tag === "LytDo" || lyt.tag === "LytAdo"))))) && v.range.start.column < lytPos.column)($Tuple(stack, [])));
      return $Tuple($92._1, run(withArray(pushAll([$Tuple(v, $92._1)]))($92._2)));
    }
    const $9 = insertSep(collapse((lytPos) => (lyt) => (lyt.tag === "LytLet" || (lyt.tag === "LytLetStmt" || (lyt.tag === "LytWhere" || (lyt.tag === "LytOf" || (lyt.tag === "LytDo" || lyt.tag === "LytAdo"))))) && v.range.start.column < lytPos.column)($Tuple(stack, [])));
    return $Tuple($9._1, run(withArray(pushAll([$Tuple(v, $9._1)]))($9._2)));
  }
  if (v.value.tag === "TokTick") {
    const v2 = collapse((v$1) => isIndented)($Tuple(stack, []));
    const $9 = () => {
      const $92 = insertSep(collapse((lytPos) => (lyt) => (lyt.tag === "LytLet" || (lyt.tag === "LytLetStmt" || (lyt.tag === "LytWhere" || (lyt.tag === "LytOf" || (lyt.tag === "LytDo" || lyt.tag === "LytAdo"))))) && v.range.start.column <= lytPos.column)($Tuple(stack, [])));
      return $Tuple(
        $List("Cons", $Tuple(v.range.start, LytTick), $92._1),
        run(withArray(pushAll([$Tuple(v, $92._1)]))($92._2))
      );
    };
    if (v2._1.tag === "Cons") {
      if (v2._1._1._2.tag === "LytTick") {
        return $Tuple(v2._1._2, run(withArray(pushAll([$Tuple(v, v2._1._2)]))(v2._2)));
      }
      return $9();
    }
    return $9();
  }
  if (v.value.tag === "TokComma") {
    const v2 = collapse((v$1) => isIndented)($Tuple(stack, []));
    if (v2._1.tag === "Cons") {
      if (v2._1._1._2.tag === "LytBrace") {
        return $Tuple(
          $List("Cons", $Tuple(v.range.start, LytProperty), v2._1),
          run(withArray(pushAll([$Tuple(v, v2._1)]))(v2._2))
        );
      }
      return $Tuple(v2._1, run(withArray(pushAll([$Tuple(v, v2._1)]))(v2._2)));
    }
    return $Tuple(v2._1, run(withArray(pushAll([$Tuple(v, v2._1)]))(v2._2)));
  }
  if (v.value.tag === "TokDot") {
    const $82 = insertSep(collapse((lytPos) => (lyt) => (lyt.tag === "LytLet" || (lyt.tag === "LytLetStmt" || (lyt.tag === "LytWhere" || (lyt.tag === "LytOf" || (lyt.tag === "LytDo" || lyt.tag === "LytAdo"))))) && v.range.start.column < lytPos.column)($Tuple(stack, [])));
    const $9 = run(withArray(pushAll([$Tuple(v, $82._1)]))($82._2));
    if ($82._1.tag === "Cons") {
      if ($82._1._1._2.tag === "LytForall") {
        return $Tuple($82._1._2, $9);
      }
      return $Tuple($List("Cons", $Tuple(v.range.start, LytProperty), $82._1), $9);
    }
    return $Tuple($List("Cons", $Tuple(v.range.start, LytProperty), $82._1), $9);
  }
  if (v.value.tag === "TokLeftParen") {
    const $82 = insertSep(collapse((lytPos) => (lyt) => (lyt.tag === "LytLet" || (lyt.tag === "LytLetStmt" || (lyt.tag === "LytWhere" || (lyt.tag === "LytOf" || (lyt.tag === "LytDo" || lyt.tag === "LytAdo"))))) && v.range.start.column < lytPos.column)($Tuple(stack, [])));
    return $Tuple(
      $List("Cons", $Tuple(v.range.start, LytParen), $82._1),
      run(withArray(pushAll([$Tuple(v, $82._1)]))($82._2))
    );
  }
  if (v.value.tag === "TokLeftBrace") {
    const $82 = insertSep(collapse((lytPos) => (lyt) => (lyt.tag === "LytLet" || (lyt.tag === "LytLetStmt" || (lyt.tag === "LytWhere" || (lyt.tag === "LytOf" || (lyt.tag === "LytDo" || lyt.tag === "LytAdo"))))) && v.range.start.column < lytPos.column)($Tuple(stack, [])));
    return $Tuple(
      $List("Cons", $Tuple(v.range.start, LytProperty), $List("Cons", $Tuple(v.range.start, LytBrace), $82._1)),
      run(withArray(pushAll([$Tuple(v, $82._1)]))($82._2))
    );
  }
  if (v.value.tag === "TokLeftSquare") {
    const $82 = insertSep(collapse((lytPos) => (lyt) => (lyt.tag === "LytLet" || (lyt.tag === "LytLetStmt" || (lyt.tag === "LytWhere" || (lyt.tag === "LytOf" || (lyt.tag === "LytDo" || lyt.tag === "LytAdo"))))) && v.range.start.column < lytPos.column)($Tuple(stack, [])));
    return $Tuple(
      $List("Cons", $Tuple(v.range.start, LytSquare), $82._1),
      run(withArray(pushAll([$Tuple(v, $82._1)]))($82._2))
    );
  }
  if (v.value.tag === "TokRightParen") {
    const $82 = collapse((v$1) => isIndented)($Tuple(stack, []));
    if ($82._1.tag === "Cons") {
      if (eqLayoutDelim.eq($82._1._1._2)(LytParen)) {
        return $Tuple($82._1._2, run(withArray(pushAll([$Tuple(v, $82._1._2)]))($82._2)));
      }
      return $Tuple($82._1, run(withArray(pushAll([$Tuple(v, $82._1)]))($82._2)));
    }
    return $Tuple($82._1, run(withArray(pushAll([$Tuple(v, $82._1)]))($82._2)));
  }
  if (v.value.tag === "TokRightBrace") {
    const $82 = collapse((v$1) => isIndented)($Tuple(stack, []));
    if ($82._1.tag === "Cons") {
      if (eqLayoutDelim.eq($82._1._1._2)(LytProperty)) {
        if ($82._1._2.tag === "Cons") {
          if (eqLayoutDelim.eq($82._1._2._1._2)(LytBrace)) {
            return $Tuple(
              $82._1._2._2,
              run(withArray(pushAll([$Tuple(v, $82._1._2._2)]))($82._2))
            );
          }
          return $Tuple($82._1._2, run(withArray(pushAll([$Tuple(v, $82._1._2)]))($82._2)));
        }
        return $Tuple($82._1._2, run(withArray(pushAll([$Tuple(v, $82._1._2)]))($82._2)));
      }
      if ($82._1.tag === "Cons") {
        if (eqLayoutDelim.eq($82._1._1._2)(LytBrace)) {
          return $Tuple($82._1._2, run(withArray(pushAll([$Tuple(v, $82._1._2)]))($82._2)));
        }
        return $Tuple($82._1, run(withArray(pushAll([$Tuple(v, $82._1)]))($82._2)));
      }
      return $Tuple($82._1, run(withArray(pushAll([$Tuple(v, $82._1)]))($82._2)));
    }
    if ($82._1.tag === "Cons") {
      if (eqLayoutDelim.eq($82._1._1._2)(LytBrace)) {
        return $Tuple($82._1._2, run(withArray(pushAll([$Tuple(v, $82._1._2)]))($82._2)));
      }
      return $Tuple($82._1, run(withArray(pushAll([$Tuple(v, $82._1)]))($82._2)));
    }
    return $Tuple($82._1, run(withArray(pushAll([$Tuple(v, $82._1)]))($82._2)));
  }
  if (v.value.tag === "TokRightSquare") {
    const $82 = collapse((v$1) => isIndented)($Tuple(stack, []));
    if ($82._1.tag === "Cons") {
      if (eqLayoutDelim.eq($82._1._1._2)(LytSquare)) {
        return $Tuple($82._1._2, run(withArray(pushAll([$Tuple(v, $82._1._2)]))($82._2)));
      }
      return $Tuple($82._1, run(withArray(pushAll([$Tuple(v, $82._1)]))($82._2)));
    }
    return $Tuple($82._1, run(withArray(pushAll([$Tuple(v, $82._1)]))($82._2)));
  }
  if (v.value.tag === "TokString") {
    const $82 = insertSep(collapse((lytPos) => (lyt) => (lyt.tag === "LytLet" || (lyt.tag === "LytLetStmt" || (lyt.tag === "LytWhere" || (lyt.tag === "LytOf" || (lyt.tag === "LytDo" || lyt.tag === "LytAdo"))))) && v.range.start.column < lytPos.column)($Tuple(stack, [])));
    const $9 = $Tuple($82._1, run(withArray(pushAll([$Tuple(v, $82._1)]))($82._2)));
    if ($9._1.tag === "Cons") {
      if (eqLayoutDelim.eq($9._1._1._2)(LytProperty)) {
        return $Tuple($9._1._2, $9._2);
      }
      return $9;
    }
    return $9;
  }
  if (v.value.tag === "TokOperator") {
    const $82 = insertSep(collapse((lytPos) => (lyt) => (lyt.tag === "LytLet" || (lyt.tag === "LytLetStmt" || (lyt.tag === "LytWhere" || (lyt.tag === "LytOf" || (lyt.tag === "LytDo" || lyt.tag === "LytAdo"))))) && v.range.start.column <= lytPos.column)($Tuple(stack, [])));
    return $Tuple($82._1, run(withArray(pushAll([$Tuple(v, $82._1)]))($82._2)));
  }
  const $8 = insertSep(collapse((lytPos) => (lyt) => (lyt.tag === "LytLet" || (lyt.tag === "LytLetStmt" || (lyt.tag === "LytWhere" || (lyt.tag === "LytOf" || (lyt.tag === "LytDo" || lyt.tag === "LytAdo"))))) && v.range.start.column < lytPos.column)($Tuple(stack, [])));
  return $Tuple($8._1, run(withArray(pushAll([$Tuple(v, $8._1)]))($8._2)));
};
var currentIndent = /* @__PURE__ */ (() => {
  const go = (go$a0$copy) => {
    let go$a0 = go$a0$copy, go$c = true, go$r;
    while (go$c) {
      const v = go$a0;
      if (v.tag === "Cons") {
        if (v._1._2.tag === "LytLet" || (v._1._2.tag === "LytLetStmt" || (v._1._2.tag === "LytWhere" || (v._1._2.tag === "LytOf" || (v._1._2.tag === "LytDo" || v._1._2.tag === "LytAdo"))))) {
          go$c = false;
          go$r = $Maybe("Just", v._1._1);
          continue;
        }
        go$a0 = v._2;
        continue;
      }
      go$c = false;
      go$r = Nothing;
      continue;
    }
    ;
    return go$r;
  };
  return go;
})();

// output-es/PureScript.CST.TokenStream/index.js
var $TokenStep = (tag, _1, _2, _3, _4) => ({ tag, _1, _2, _3, _4 });
var unwindLayout = (pos) => (eof2) => {
  const go = (stk) => defer((v) => {
    if (stk.tag === "Nil") {
      return force(eof2);
    }
    if (stk.tag === "Cons") {
      if (stk._1._2.tag === "LytRoot") {
        return force(eof2);
      }
      if (stk._1._2.tag === "LytLet" || (stk._1._2.tag === "LytLetStmt" || (stk._1._2.tag === "LytWhere" || (stk._1._2.tag === "LytOf" || (stk._1._2.tag === "LytDo" || stk._1._2.tag === "LytAdo"))))) {
        return $TokenStep(
          "TokenCons",
          { range: { start: pos, end: pos }, leadingComments: [], trailingComments: [], value: $Token("TokLayoutEnd", stk._1._1.column) },
          pos,
          go(stk._2),
          stk._2
        );
      }
      return force(go(stk._2));
    }
    fail();
  });
  return go;
};
var layoutStack = (stream) => {
  const v = force(stream);
  if (v.tag === "TokenEOF") {
    return Nil;
  }
  if (v.tag === "TokenError") {
    return v._4;
  }
  if (v.tag === "TokenCons") {
    return v._4;
  }
  fail();
};
var consTokens = (dictFoldable) => {
  const $1 = dictFoldable.foldr((v) => (v1) => $Tuple(v._1.range.start, defer((v2) => $TokenStep("TokenCons", v._1, v1._1, v1._2, v._2))));
  return (b) => (a) => $1(a)(b);
};

// output-es/PureScript.CST.Lexer/index.js
var $LexResult = (tag, _1, _2) => ({ tag, _1, _2 });
var fold1 = /* @__PURE__ */ (() => foldableArray.foldMap(monoidRecord()((() => {
  const semigroupRecordCons1 = { appendRecord: (v) => (ra) => (rb) => ({ raw: ra.raw + rb.raw, string: ra.string + rb.string }) };
  return { memptyRecord: (v) => ({ raw: "", string: "" }), SemigroupRecord0: () => semigroupRecordCons1 };
})()))(identity3))();
var consTokens2 = /* @__PURE__ */ consTokens(foldableArray);
var LexFail = (value0) => (value1) => $LexResult("LexFail", value0, value1);
var LexSucc = (value0) => (value1) => $LexResult("LexSucc", value0, value1);
var $$try3 = (v) => (str) => {
  const v1 = v(str);
  if (v1.tag === "LexFail") {
    return $LexResult("LexFail", v1._1, str);
  }
  if (v1.tag === "LexSucc") {
    return $LexResult("LexSucc", v1._1, v1._2);
  }
  fail();
};
var toModuleName = (v) => {
  if (v === "") {
    return Nothing;
  }
  return $Maybe("Just", take(length2(v) - 1 | 0)(v));
};
var optional = (v) => (str) => {
  const v1 = v(str);
  if (v1.tag === "LexFail") {
    if (length2(str) === length2(v1._2)) {
      return $LexResult("LexSucc", Nothing, str);
    }
    return $LexResult("LexFail", v1._1, v1._2);
  }
  if (v1.tag === "LexSucc") {
    return $LexResult("LexSucc", $Maybe("Just", v1._1), v1._2);
  }
  fail();
};
var mkUnexpected = (str) => {
  const start = take2(6)(str);
  const len = toCodePointArray(start).length;
  if (len === 0) {
    return "end of file";
  }
  if (len < 6) {
    return start;
  }
  return start + "...";
};
var regex2 = (mkErr) => (regexStr) => {
  const matchRegex = unsafeRegex("^(?:" + (regexStr + ")"))(unicode);
  return (str) => {
    const v = match(matchRegex)(str);
    if (v.tag === "Just") {
      const $5 = index(v._1)(0);
      const $6 = (() => {
        if ($5.tag === "Just") {
          return $5._1;
        }
        fail();
      })();
      if ($6.tag === "Just") {
        return $LexResult("LexSucc", $6._1, drop2(length2($6._1))(str));
      }
      return $LexResult("LexFail", (v3) => mkErr(mkUnexpected(str)), str);
    }
    return $LexResult("LexFail", (v3) => mkErr(mkUnexpected(str)), str);
  };
};
var satisfy = (mkErr) => (p) => (str) => {
  const v = charAt2(0)(str);
  if (v.tag === "Just") {
    if (p(v._1)) {
      return $LexResult("LexSucc", v._1, drop2(1)(str));
    }
    return $LexResult("LexFail", (v1) => mkErr(mkUnexpected(str)), str);
  }
  return $LexResult("LexFail", (v1) => mkErr(mkUnexpected(str)), str);
};
var string = (mkErr) => (match3) => (str) => {
  if (take(length2(match3))(str) === match3) {
    return $LexResult("LexSucc", match3, drop2(length2(match3))(str));
  }
  return $LexResult("LexFail", (v) => mkErr(mkUnexpected(str)), str);
};
var many2 = (v) => (str) => run(() => {
  const valuesRef = newSTArray();
  const strRef = { value: str };
  const contRef = { value: true };
  const resRef = { value: $LexResult("LexSucc", [], str) };
  whileST(() => contRef.value)(() => {
    const str$p = strRef.value;
    const v1 = v(str$p);
    if (v1.tag === "LexFail") {
      if (length2(str$p) === length2(v1._2)) {
        const values2 = unsafeFreeze(valuesRef)();
        resRef.value = $LexResult("LexSucc", values2, v1._2);
        contRef.value = false;
        return unit;
      }
      resRef.value = $LexResult("LexFail", v1._1, v1._2);
      contRef.value = false;
      return unit;
    }
    if (v1.tag === "LexSucc") {
      pushAll([v1._1])(valuesRef)();
      strRef.value = v1._2;
      return unit;
    }
    fail();
  })();
  return resRef.value;
});
var functorLex = {
  map: (f) => (v) => (str) => {
    const v1 = v(str);
    if (v1.tag === "LexFail") {
      return $LexResult("LexFail", v1._1, v1._2);
    }
    if (v1.tag === "LexSucc") {
      return $LexResult("LexSucc", f(v1._1), v1._2);
    }
    fail();
  }
};
var spaceComment = /* @__PURE__ */ (() => functorLex.map(length2)(regex2(LexExpected("spaces"))(" +")))();
var char$p = (mkErr) => (res) => (match3) => (str) => {
  if (singleton(match3) === take(1)(str)) {
    return $LexResult("LexSucc", res, drop2(1)(str));
  }
  return $LexResult("LexFail", (v) => mkErr(mkUnexpected(str)), str);
};
var $$char = (mkErr) => (match3) => (str) => {
  if (singleton(match3) === take(1)(str)) {
    return $LexResult("LexSucc", match3, drop2(1)(str));
  }
  return $LexResult("LexFail", (v) => mkErr(mkUnexpected(str)), str);
};
var bumpText = (v) => (colOffset) => (str) => {
  const go = (go$a0$copy) => (go$a1$copy) => {
    let go$a0 = go$a0$copy, go$a1 = go$a1$copy, go$c = true, go$r;
    while (go$c) {
      const n = go$a0, ix = go$a1;
      const v1 = indexOf$p("\n")(ix)(str);
      if (v1.tag === "Just") {
        go$a0 = n + 1 | 0;
        go$a1 = v1._1 + 1 | 0;
        continue;
      }
      if (v1.tag === "Nothing") {
        if (n === 0) {
          go$c = false;
          go$r = { line: v.line, column: (v.column + toCodePointArray(str).length | 0) + (colOffset * 2 | 0) | 0 };
          continue;
        }
        go$c = false;
        go$r = { line: v.line + n | 0, column: toCodePointArray(drop2(ix)(str)).length + colOffset | 0 };
        continue;
      }
      fail();
    }
    ;
    return go$r;
  };
  return go(0)(0);
};
var bumpToken = (v) => (v1) => {
  if (v1.tag === "TokLeftParen") {
    return { line: v.line, column: v.column + 1 | 0 };
  }
  if (v1.tag === "TokRightParen") {
    return { line: v.line, column: v.column + 1 | 0 };
  }
  if (v1.tag === "TokLeftBrace") {
    return { line: v.line, column: v.column + 1 | 0 };
  }
  if (v1.tag === "TokRightBrace") {
    return { line: v.line, column: v.column + 1 | 0 };
  }
  if (v1.tag === "TokLeftSquare") {
    return { line: v.line, column: v.column + 1 | 0 };
  }
  if (v1.tag === "TokRightSquare") {
    return { line: v.line, column: v.column + 1 | 0 };
  }
  if (v1.tag === "TokLeftArrow") {
    if (v1._1.tag === "ASCII") {
      return { line: v.line, column: v.column + 2 | 0 };
    }
    if (v1._1.tag === "Unicode") {
      return { line: v.line, column: v.column + 1 | 0 };
    }
    fail();
  }
  if (v1.tag === "TokRightArrow") {
    if (v1._1.tag === "ASCII") {
      return { line: v.line, column: v.column + 2 | 0 };
    }
    if (v1._1.tag === "Unicode") {
      return { line: v.line, column: v.column + 1 | 0 };
    }
    fail();
  }
  if (v1.tag === "TokRightFatArrow") {
    if (v1._1.tag === "ASCII") {
      return { line: v.line, column: v.column + 2 | 0 };
    }
    if (v1._1.tag === "Unicode") {
      return { line: v.line, column: v.column + 1 | 0 };
    }
    fail();
  }
  if (v1.tag === "TokDoubleColon") {
    if (v1._1.tag === "ASCII") {
      return { line: v.line, column: v.column + 2 | 0 };
    }
    if (v1._1.tag === "Unicode") {
      return { line: v.line, column: v.column + 1 | 0 };
    }
    fail();
  }
  if (v1.tag === "TokForall") {
    if (v1._1.tag === "ASCII") {
      return { line: v.line, column: v.column + 6 | 0 };
    }
    if (v1._1.tag === "Unicode") {
      return { line: v.line, column: v.column + 1 | 0 };
    }
    fail();
  }
  if (v1.tag === "TokEquals") {
    return { line: v.line, column: v.column + 1 | 0 };
  }
  if (v1.tag === "TokPipe") {
    return { line: v.line, column: v.column + 1 | 0 };
  }
  if (v1.tag === "TokTick") {
    return { line: v.line, column: v.column + 1 | 0 };
  }
  if (v1.tag === "TokDot") {
    return { line: v.line, column: v.column + 1 | 0 };
  }
  if (v1.tag === "TokComma") {
    return { line: v.line, column: v.column + 1 | 0 };
  }
  if (v1.tag === "TokUnderscore") {
    return { line: v.line, column: v.column + 1 | 0 };
  }
  if (v1.tag === "TokBackslash") {
    return { line: v.line, column: v.column + 1 | 0 };
  }
  if (v1.tag === "TokAt") {
    return { line: v.line, column: v.column + 1 | 0 };
  }
  if (v1.tag === "TokLowerName") {
    return {
      line: v.line,
      column: (() => {
        if (v1._1.tag === "Nothing") {
          return v.column + 0 | 0;
        }
        if (v1._1.tag === "Just") {
          return v.column + (1 + toCodePointArray(v1._1._1).length | 0) | 0;
        }
        fail();
      })() + toCodePointArray(v1._2).length | 0
    };
  }
  if (v1.tag === "TokUpperName") {
    return {
      line: v.line,
      column: (() => {
        if (v1._1.tag === "Nothing") {
          return v.column + 0 | 0;
        }
        if (v1._1.tag === "Just") {
          return v.column + (1 + toCodePointArray(v1._1._1).length | 0) | 0;
        }
        fail();
      })() + toCodePointArray(v1._2).length | 0
    };
  }
  if (v1.tag === "TokOperator") {
    return {
      line: v.line,
      column: (() => {
        if (v1._1.tag === "Nothing") {
          return v.column + 0 | 0;
        }
        if (v1._1.tag === "Just") {
          return v.column + (1 + toCodePointArray(v1._1._1).length | 0) | 0;
        }
        fail();
      })() + toCodePointArray(v1._2).length | 0
    };
  }
  if (v1.tag === "TokSymbolName") {
    return {
      line: v.line,
      column: (() => {
        if (v1._1.tag === "Nothing") {
          return v.column + 0 | 0;
        }
        if (v1._1.tag === "Just") {
          return v.column + (1 + toCodePointArray(v1._1._1).length | 0) | 0;
        }
        fail();
      })() + toCodePointArray(v1._2).length | 0
    };
  }
  if (v1.tag === "TokSymbolArrow") {
    if (v1._1.tag === "Unicode") {
      return { line: v.line, column: v.column + 1 | 0 };
    }
    if (v1._1.tag === "ASCII") {
      return { line: v.line, column: v.column + 4 | 0 };
    }
    fail();
  }
  if (v1.tag === "TokHole") {
    return { line: v.line, column: (v.column + toCodePointArray(v1._1).length | 0) + 1 | 0 };
  }
  if (v1.tag === "TokChar") {
    return { line: v.line, column: (v.column + toCodePointArray(v1._1).length | 0) + 2 | 0 };
  }
  if (v1.tag === "TokInt") {
    return { line: v.line, column: v.column + toCodePointArray(v1._1).length | 0 };
  }
  if (v1.tag === "TokNumber") {
    return { line: v.line, column: v.column + toCodePointArray(v1._1).length | 0 };
  }
  if (v1.tag === "TokString") {
    return bumpText(v)(1)(v1._1);
  }
  if (v1.tag === "TokRawString") {
    return bumpText(v)(3)(v1._1);
  }
  if (v1.tag === "TokLayoutStart") {
    return v;
  }
  if (v1.tag === "TokLayoutSep") {
    return v;
  }
  if (v1.tag === "TokLayoutEnd") {
    return v;
  }
  fail();
};
var bumpComment = (v) => (v1) => {
  if (v1.tag === "Comment") {
    return bumpText(v)(0)(v1._1);
  }
  if (v1.tag === "Space") {
    return { line: v.line, column: v.column + v1._1 | 0 };
  }
  if (v1.tag === "Line") {
    return { line: v.line + v1._2 | 0, column: 0 };
  }
  fail();
};
var applyLex = {
  apply: (v) => (v1) => (str) => {
    const v2 = v(str);
    if (v2.tag === "LexFail") {
      return $LexResult("LexFail", v2._1, v2._2);
    }
    if (v2.tag === "LexSucc") {
      const v3 = v1(v2._2);
      if (v3.tag === "LexFail") {
        return $LexResult("LexFail", v3._1, v3._2);
      }
      if (v3.tag === "LexSucc") {
        return $LexResult("LexSucc", v2._1(v3._1), v3._2);
      }
      fail();
    }
    fail();
  },
  Functor0: () => functorLex
};
var bindLex = {
  bind: (v) => (k) => (str) => {
    const v1 = v(str);
    if (v1.tag === "LexFail") {
      return $LexResult("LexFail", v1._1, v1._2);
    }
    if (v1.tag === "LexSucc") {
      return k(v1._1)(v1._2);
    }
    fail();
  },
  Apply0: () => applyLex
};
var altLex = {
  alt: (v) => (v1) => (str) => {
    const v2 = v(str);
    if (v2.tag === "LexFail") {
      if (length2(str) === length2(v2._2)) {
        return v1(str);
      }
      return $LexResult("LexFail", v2._1, v2._2);
    }
    if (v2.tag === "LexSucc") {
      return $LexResult("LexSucc", v2._1, v2._2);
    }
    fail();
  },
  Functor0: () => functorLex
};
var comment = /* @__PURE__ */ (() => altLex.alt(regex2(LexExpected("block comment"))("\\{-(-(?!\\})|[^-]+)*(-\\}|$)"))(regex2(LexExpected("line comment"))("--[^\\r\\n]*")))();
var lineComment = /* @__PURE__ */ (() => altLex.alt(functorLex.map((() => {
  const $0 = Line(LF);
  return (x) => $0(toCodePointArray(x).length);
})())(regex2(LexExpected("newline"))("\n+")))(functorLex.map((() => {
  const $0 = Line(CRLF);
  return (x) => $0(intDiv(toCodePointArray(x).length)(2));
})())(regex2(LexExpected("newline"))("(?:\r\n)+"))))();
var leadingComments = /* @__PURE__ */ (() => many2(altLex.alt(functorLex.map(Comment)(comment))(altLex.alt(functorLex.map(Space)(spaceComment))(lineComment))))();
var token = /* @__PURE__ */ (() => {
  const tokenRightParen = char$p(LexExpected("right paren"))(TokRightParen)(")");
  const tokenLeftParen = char$p(LexExpected("left paren"))(TokLeftParen)("(");
  const stripUnderscores = replaceAll("_")("");
  const parseSymbolIdent = regex2(LexExpected("symbol"))("(?:[:!#$%&*+./<=>?@\\\\^|~-]|(?!\\p{P})\\p{S})+");
  const parseProper2 = regex2(LexExpected("proper name"))("\\p{Lu}[\\p{L}0-9_']*");
  const parseIdent2 = regex2(LexExpected("ident"))("[\\p{Ll}_][\\p{L}0-9_']*");
  const intPartRegex = regex2(LexExpected("int part"))("(0|[1-9][0-9_]*)");
  const parseHexEscape = bindLex.bind(regex2(LexExpected("hex"))("[a-fA-F0-9]{1,6}"))((esc) => {
    const $8 = fromStringAs(16)(esc);
    if ($8.tag === "Just") {
      if ($8._1 >= -2147483648 && $8._1 <= 2147483647) {
        return LexSucc({ raw: "\\x" + esc, char: fromCharCode($8._1) });
      }
      return LexFail((v) => $ParseError("LexCharEscapeOutOfRange", esc));
    }
    if ($8.tag === "Nothing") {
      return LexFail((v) => $ParseError("LexCharEscapeOutOfRange", esc));
    }
    fail();
  });
  const charSingleQuote = $$char(LexExpected("single quote"))("'");
  const charQuote = $$char(LexExpected("quote"))('"');
  const charAny = satisfy(LexExpected("char"))((v) => true);
  const parseEscape = bindLex.bind(charAny)((ch) => {
    if (ch === "t") {
      return LexSucc({ raw: "\\t", char: "	" });
    }
    if (ch === "r") {
      return LexSucc({ raw: "\\r", char: "\r" });
    }
    if (ch === "n") {
      return LexSucc({ raw: "\\n", char: "\n" });
    }
    if (ch === '"') {
      return LexSucc({ raw: '\\"', char: '"' });
    }
    if (ch === "'") {
      return LexSucc({ raw: "\\'", char: "'" });
    }
    if (ch === "\\") {
      return LexSucc({ raw: "\\\\", char: "\\" });
    }
    if (ch === "x") {
      return parseHexEscape;
    }
    const $12 = $ParseError("LexInvalidCharEscape", singleton(ch));
    return LexFail((v) => $12);
  });
  return altLex.alt(functorLex.map((v) => $Token("TokHole", v))($$try3(applyLex.apply(functorLex.map((v) => identity)($$char(LexExpected("question mark"))("?")))(altLex.alt(parseIdent2)(parseProper2)))))(altLex.alt(applyLex.apply(functorLex.map((v) => (v1) => v1(toModuleName(v)))(regex2(LexExpected("module name"))("(?:(?:\\p{Lu}[\\p{L}0-9_']*)\\.)*")))(altLex.alt(functorLex.map((v) => (v1) => {
    if (v1.tag === "Nothing") {
      if (v === "forall") {
        return $Token("TokForall", ASCII);
      }
      if (v === "_") {
        return TokUnderscore;
      }
      return $Token("TokLowerName", Nothing, v);
    }
    return $Token("TokLowerName", v1, v);
  })(parseIdent2))(altLex.alt(functorLex.map((b) => (a) => $Token("TokUpperName", a, b))(parseProper2))(altLex.alt(functorLex.map((v) => (v1) => {
    if (v1.tag === "Nothing") {
      if (v === "<-") {
        return $Token("TokLeftArrow", ASCII);
      }
      if (v === "\u2190") {
        return $Token("TokLeftArrow", Unicode);
      }
      if (v === "->") {
        return $Token("TokRightArrow", ASCII);
      }
      if (v === "\u2192") {
        return $Token("TokRightArrow", Unicode);
      }
      if (v === "=>") {
        return $Token("TokRightFatArrow", ASCII);
      }
      if (v === "\u21D2") {
        return $Token("TokRightFatArrow", Unicode);
      }
      if (v === "::") {
        return $Token("TokDoubleColon", ASCII);
      }
      if (v === "\u2237") {
        return $Token("TokDoubleColon", Unicode);
      }
      if (v === "\u2200") {
        return $Token("TokForall", Unicode);
      }
      if (v === "=") {
        return TokEquals;
      }
      if (v === ".") {
        return TokDot;
      }
      if (v === "\\") {
        return TokBackslash;
      }
      if (v === "|") {
        return TokPipe;
      }
      if (v === "@") {
        return TokAt;
      }
      if (v === "`") {
        return TokTick;
      }
      return $Token("TokOperator", Nothing, v);
    }
    return $Token("TokOperator", v1, v);
  })(parseSymbolIdent))(functorLex.map((v) => (v1) => {
    if (v1.tag === "Nothing") {
      if (v === "->") {
        return $Token("TokSymbolArrow", ASCII);
      }
      if (v === "\u2192") {
        return $Token("TokSymbolArrow", Unicode);
      }
      return $Token("TokSymbolName", Nothing, v);
    }
    return $Token("TokSymbolName", v1, v);
  })($$try3(applyLex.apply(functorLex.map($$const)(applyLex.apply(functorLex.map((v) => identity)(tokenLeftParen))(parseSymbolIdent)))(tokenRightParen))))))))(altLex.alt(functorLex.map((v) => $Token(
    "TokChar",
    v.raw,
    v.char
  ))(applyLex.apply(functorLex.map($$const)(applyLex.apply(functorLex.map((v) => identity)(charSingleQuote))(bindLex.bind(charAny)((ch) => {
    if (ch === "\\") {
      return parseEscape;
    }
    if (ch === "'") {
      return LexFail((v) => $ParseError("LexExpected", "character", "empty character literal"));
    }
    return LexSucc({ raw: singleton(ch), char: ch });
  }))))(charSingleQuote)))(altLex.alt(altLex.alt(functorLex.map((v) => $Token(
    "TokRawString",
    (() => {
      const $13 = drop2(3)(v);
      return take(length2($13) - 3 | 0)($13);
    })()
  ))(regex2(LexExpected("raw string characters"))('""""{0,2}([^"]+"{1,2})*[^"]*"""')))(functorLex.map((v) => {
    const v1 = fold1(v);
    return $Token("TokString", v1.raw, v1.string);
  })(applyLex.apply(functorLex.map($$const)(applyLex.apply(functorLex.map((v) => identity)(charQuote))(many2(altLex.alt(functorLex.map((v) => ({ raw: v, string: v }))(regex2(LexExpected("string characters"))('[^"\\\\]+')))(altLex.alt(functorLex.map((v) => ({ raw: v, string: "" }))(regex2(LexExpected("whitespace escape"))("\\\\[ \\r\\n]+\\\\")))(functorLex.map((v) => ({ raw: v.raw, string: singleton(v.char) }))(applyLex.apply(functorLex.map((v) => identity)($$char(LexExpected("backslash"))("\\")))(parseEscape))))))))(charQuote))))(altLex.alt(altLex.alt(bindLex.bind(applyLex.apply(functorLex.map((v) => identity)(string(LexExpected("hex int prefix"))("0x")))(regex2(LexExpected("hex int"))("[a-fA-F0-9]+")))((raw) => {
    const v = fromStringAs(16)(raw);
    if (v.tag === "Just") {
      return LexSucc($Token("TokInt", "0x" + raw, $IntValue("SmallInt", v._1)));
    }
    if (v.tag === "Nothing") {
      return LexSucc($Token("TokInt", "0x" + raw, $IntValue("BigHex", raw)));
    }
    fail();
  }))(bindLex.bind(intPartRegex)((intPart) => bindLex.bind(optional($$try3(applyLex.apply(functorLex.map((v) => identity)($$char(LexExpected("dot"))(".")))(regex2(LexExpected("fraction part"))("[0-9_]+")))))((fractionPart) => bindLex.bind(optional(applyLex.apply(functorLex.map((v) => identity)($$char(LexExpected("exponent"))("e")))(applyLex.apply(functorLex.map((v) => (v1) => ({ sign: v, exponent: v1 }))(optional(altLex.alt(string(LexExpected("negative"))("-"))(string(LexExpected("positive"))("+")))))(intPartRegex))))((exponentPart) => {
    if ((() => {
      if (fractionPart.tag === "Nothing") {
        return true;
      }
      if (fractionPart.tag === "Just") {
        return false;
      }
      fail();
    })() && (() => {
      if (exponentPart.tag === "Nothing") {
        return true;
      }
      if (exponentPart.tag === "Just") {
        return false;
      }
      fail();
    })()) {
      const intVal = stripUnderscores(intPart);
      const v2 = fromString(intVal);
      if (v2.tag === "Just") {
        return LexSucc($Token("TokInt", intPart, $IntValue("SmallInt", v2._1)));
      }
      if (v2.tag === "Nothing") {
        return LexSucc($Token("TokInt", intPart, $IntValue("BigInt", intVal)));
      }
      fail();
    }
    const raw = intPart + ((() => {
      if (fractionPart.tag === "Nothing") {
        return "";
      }
      if (fractionPart.tag === "Just") {
        return "." + fractionPart._1;
      }
      fail();
    })() + (() => {
      if (exponentPart.tag === "Nothing") {
        return "";
      }
      if (exponentPart.tag === "Just") {
        if (exponentPart._1.sign.tag === "Nothing") {
          return "e" + exponentPart._1.exponent;
        }
        if (exponentPart._1.sign.tag === "Just") {
          return "e" + (exponentPart._1.sign._1 + exponentPart._1.exponent);
        }
        fail();
      }
      fail();
    })());
    const v = fromStringImpl(stripUnderscores(raw), isFiniteImpl, Just, Nothing);
    if (v.tag === "Just") {
      return LexSucc($Token("TokNumber", raw, v._1));
    }
    if (v.tag === "Nothing") {
      return LexFail((v$1) => $ParseError("LexNumberOutOfRange", raw));
    }
    fail();
  })))))(altLex.alt(tokenLeftParen)(altLex.alt(tokenRightParen)(altLex.alt(char$p(LexExpected("left brace"))(TokLeftBrace)("{"))(altLex.alt(char$p(LexExpected("right brace"))(TokRightBrace)("}"))(altLex.alt(char$p(LexExpected("left square"))(TokLeftSquare)("["))(altLex.alt(char$p(LexExpected("right square"))(TokRightSquare)("]"))(altLex.alt(char$p(LexExpected("backtick"))(TokTick)("`"))(char$p(LexExpected("comma"))(TokComma)(",")))))))))))));
})();
var trailingComments = /* @__PURE__ */ (() => many2(altLex.alt(functorLex.map(Comment)(comment))(functorLex.map(Space)(spaceComment))))();
var lexWithState = /* @__PURE__ */ (() => {
  const go = (stack) => (startPos) => (leading) => (str) => defer((v) => {
    if (str === "") {
      return force(unwindLayout(startPos)(defer((v12) => $TokenStep("TokenEOF", startPos, leading)))(stack));
    }
    const v1 = applyLex.apply(applyLex.apply(functorLex.map((v$1) => (v12) => (v2) => ({ token: v$1, trailing: v12, nextLeading: v2 }))(token))(trailingComments))(leadingComments)(str);
    if (v1.tag === "LexFail") {
      return $TokenStep(
        "TokenError",
        bumpText(startPos)(0)(take(length2(str) - length2(v1._2) | 0)(str)),
        v1._1(unit),
        Nothing,
        stack
      );
    }
    if (v1.tag === "LexSucc") {
      const endPos = bumpToken(startPos)(v1._1.token);
      const nextStart = foldlArray(bumpComment)(foldlArray(bumpComment)(endPos)(v1._1.trailing))(v1._1.nextLeading);
      const v2 = insertLayout({ range: { start: startPos, end: endPos }, leadingComments: leading, trailingComments: v1._1.trailing, value: v1._1.token })(nextStart)(stack);
      return force(consTokens2(v2._2)($Tuple(nextStart, go(v2._1)(nextStart)(v1._1.nextLeading)(v1._2)))._2);
    }
    fail();
  });
  return (initStack) => (initPos) => (str) => defer((v) => {
    const v1 = leadingComments(str);
    if (v1.tag === "LexFail") {
      return _crashWith("Leading comments can't fail.");
    }
    if (v1.tag === "LexSucc") {
      return force(go(initStack)(foldlArray(bumpComment)(initPos)(v1._1))(v1._1)(v1._2));
    }
    fail();
  });
})();
var lex = /* @__PURE__ */ lexWithState(/* @__PURE__ */ $List(
  "Cons",
  /* @__PURE__ */ $Tuple({ line: 0, column: 0 }, LytRoot),
  Nil
))({ line: 0, column: 0 });

// output-es/PureScript.CST.Parser.Monad/index.js
var $ParserResult = (tag, _1, _2) => ({ tag, _1, _2 });
var $Trampoline = (tag, _1) => ({ tag, _1 });
var toUnfoldable5 = /* @__PURE__ */ toUnfoldable(unfoldableArray);
var More = (value0) => $Trampoline("More", value0);
var lazyParser = {
  defer: (k) => {
    const parser2 = defer(k);
    return (state, more, resume2, done) => force(parser2)(state, more, resume2, done);
  }
};
var take3 = (k) => (state, v, resume2, done) => {
  const v1 = force(state.stream);
  if (v1.tag === "TokenError") {
    return resume2(state, { error: v1._2, position: v1._1 });
  }
  if (v1.tag === "TokenEOF") {
    return resume2(state, { error: UnexpectedEof, position: v1._1 });
  }
  if (v1.tag === "TokenCons") {
    const v2 = k(v1._1);
    if (v2.tag === "Left") {
      return resume2(state, { error: v2._1, position: v1._1.range.start });
    }
    if (v2.tag === "Right") {
      return done({ consumed: true, stream: v1._3, errors: state.errors }, v2._1);
    }
    fail();
  }
  fail();
};
var runParser$p = (state1) => (v) => {
  const run2 = (run$a0$copy) => {
    let run$a0 = run$a0$copy, run$c = true, run$r;
    while (run$c) {
      const v1 = run$a0;
      if (v1.tag === "More") {
        run$a0 = v1._1(unit);
        continue;
      }
      if (v1.tag === "Done") {
        run$c = false;
        run$r = v1._1;
        continue;
      }
      fail();
    }
    ;
    return run$r;
  };
  return run2(v(
    state1,
    More,
    (state2, error4) => $Trampoline("Done", $ParserResult("ParseFail", error4, state2)),
    (state2, value) => $Trampoline("Done", $ParserResult("ParseSucc", value, state2))
  ));
};
var recover = (k) => (v) => (state1, more, resume2, done) => v(
  { consumed: false, errors: state1.errors, stream: state1.stream },
  more,
  (state2, error4) => {
    const v1 = k(error4)(state1.stream);
    if (v1.tag === "Nothing") {
      return resume2({ consumed: state1.consumed, errors: state2.errors, stream: state2.stream }, error4);
    }
    if (v1.tag === "Just") {
      return done(
        { consumed: true, errors: run(withArray(pushAll([error4]))(state2.errors)), stream: v1._1._2 },
        v1._1._1
      );
    }
    fail();
  },
  done
);
var optional2 = (p) => (state1, more, resume2, done) => p(
  (() => {
    if (state1.consumed) {
      return { consumed: false, errors: state1.errors, stream: state1.stream };
    }
    return state1;
  })(),
  more,
  (state3, error4) => {
    if (state3.consumed) {
      return resume2(state3, error4);
    }
    return done(state1, Nothing);
  },
  (state2, a) => done(state2, $Maybe("Just", a))
);
var many3 = (v) => (state1, more, resume2, done) => {
  const go = (acc, state2) => v(
    (() => {
      if (state2.consumed) {
        return { consumed: false, errors: state2.errors, stream: state2.stream };
      }
      return state2;
    })(),
    more,
    (state3, error4) => {
      if (state3.consumed) {
        return resume2(state3, error4);
      }
      return done(state2, reverse(toUnfoldable5(acc)));
    },
    (state3, value) => go($List("Cons", value, acc), state3)
  );
  return go(Nil, state1);
};
var fromParserResult = (v) => {
  if (v.tag === "ParseFail") {
    return $Either("Left", v._1);
  }
  if (v.tag === "ParseSucc") {
    return $Either("Right", $Tuple(v._1, v._2.errors));
  }
  fail();
};
var eof = (state, v, resume2, done) => {
  const v1 = force(state.stream);
  if (v1.tag === "TokenError") {
    return resume2(state, { error: v1._2, position: v1._1 });
  }
  if (v1.tag === "TokenEOF") {
    return done({ consumed: true, stream: state.stream, errors: state.errors }, $Tuple(v1._1, v1._2));
  }
  if (v1.tag === "TokenCons") {
    return resume2(state, { error: $ParseError("ExpectedEof", v1._1.value), position: v1._1.range.start });
  }
  fail();
};

// output-es/PureScript.CST.Parser/index.js
var separated = (sepParser) => (valueParser) => {
  const $2 = many3((state1, more, resume2, done) => sepParser(
    state1,
    more,
    resume2,
    (state2, a) => {
      const $8 = Tuple(a);
      return more((v2) => valueParser(state2, more, resume2, (state3, a$1) => done(state3, $8(a$1))));
    }
  ));
  return (state1, more, resume2, done) => valueParser(state1, more, resume2, (state2, a) => more((v2) => $2(state2, more, resume2, (state3, a$1) => done(state3, { head: a, tail: a$1 }))));
};
var reservedKeywords = /* @__PURE__ */ foldlArray((m) => (a) => insert(ordString)(a)(unit)(m))(Leaf2)([
  "ado",
  "case",
  "class",
  "data",
  "derive",
  "do",
  "else",
  "false",
  "foreign",
  "if",
  "import",
  "in",
  "infix",
  "infixl",
  "infixr",
  "instance",
  "let",
  "module",
  "newtype",
  "of",
  "then",
  "true",
  "type",
  "where"
]);
var recoverTokensWhile = (p) => (initStream) => {
  const $2 = currentIndent(layoutStack(initStream));
  const indent2 = (() => {
    if ($2.tag === "Nothing") {
      return 0;
    }
    if ($2.tag === "Just") {
      return $2._1.column;
    }
    fail();
  })();
  const go = (go$a0$copy) => (go$a1$copy) => {
    let go$a0 = go$a0$copy, go$a1 = go$a1$copy, go$c = true, go$r;
    while (go$c) {
      const acc = go$a0, stream = go$a1;
      const v = force(stream);
      if (v.tag === "TokenError") {
        go$c = false;
        go$r = $Tuple(acc, stream);
        continue;
      }
      if (v.tag === "TokenEOF") {
        go$c = false;
        go$r = $Tuple(acc, stream);
        continue;
      }
      if (v.tag === "TokenCons") {
        if (p(v._1)(indent2)) {
          go$a0 = run(withArray(pushAll([v._1]))(acc));
          go$a1 = v._3;
          continue;
        }
        go$c = false;
        go$r = $Tuple(acc, stream);
        continue;
      }
      fail();
    }
    ;
    return go$r;
  };
  return go([])(initStream);
};
var recoverIndent = (mkNode) => recover((v) => (stream) => {
  const v1 = recoverTokensWhile((tok) => (indent2) => {
    if (tok.value.tag === "TokLayoutEnd") {
      return tok.value._1 > indent2;
    }
    if (tok.value.tag === "TokLayoutSep") {
      return tok.value._1 > indent2;
    }
    return true;
  })(stream);
  if (v1._1.length === 0) {
    return Nothing;
  }
  return $Maybe("Just", $Tuple(mkNode({ position: v.position, error: v.error, tokens: v1._1 }), v1._2));
});
var parseSmallInt = /* @__PURE__ */ take3((v) => {
  if (v.value.tag === "TokInt") {
    if (v.value._2.tag === "SmallInt") {
      return $Either("Right", $Tuple(v, v.value._2._1));
    }
    return $Either("Left", $ParseError("LexIntOutOfRange", v.value._1));
  }
  return $Either("Left", $ParseError("UnexpectedToken", v.value));
});
var many12 = (parser2) => (state1, more, resume2, done) => parser2(
  state1,
  more,
  resume2,
  (state2, a) => more((v2) => many3(parser2)(state2, more, resume2, (state3, a$1) => done(state3, concatArray([a])(a$1))))
);
var expectMap = (k) => take3((tok) => {
  const v = k(tok);
  if (v.tag === "Just") {
    return $Either("Right", v._1);
  }
  if (v.tag === "Nothing") {
    return $Either("Left", $ParseError("UnexpectedToken", tok.value));
  }
  fail();
});
var parseBoolean = /* @__PURE__ */ expectMap((v) => {
  if (v.value.tag === "TokLowerName") {
    if (v.value._1.tag === "Nothing") {
      if (v.value._2 === "true") {
        return $Maybe("Just", $Tuple(v, true));
      }
      if (v.value._2 === "false") {
        return $Maybe("Just", $Tuple(v, false));
      }
      return Nothing;
    }
    return Nothing;
  }
  return Nothing;
});
var parseChar = /* @__PURE__ */ expectMap((v) => {
  if (v.value.tag === "TokChar") {
    return $Maybe("Just", $Tuple(v, v.value._2));
  }
  return Nothing;
});
var parseHole = /* @__PURE__ */ expectMap((v) => {
  if (v.value.tag === "TokHole") {
    return $Maybe("Just", { token: v, name: v.value._1 });
  }
  return Nothing;
});
var parseIdent = /* @__PURE__ */ expectMap((v) => {
  if (v.value.tag === "TokLowerName") {
    if (v.value._1.tag === "Nothing") {
      if ((() => {
        const $1 = lookup(ordString)(v.value._2)(reservedKeywords);
        if ($1.tag === "Nothing") {
          return true;
        }
        if ($1.tag === "Just") {
          return false;
        }
        fail();
      })()) {
        return $Maybe("Just", { token: v, name: v.value._2 });
      }
      return Nothing;
    }
    return Nothing;
  }
  return Nothing;
});
var parseInt2 = /* @__PURE__ */ expectMap((v) => {
  if (v.value.tag === "TokInt") {
    return $Maybe("Just", $Tuple(v, v.value._2));
  }
  return Nothing;
});
var parseLabel = /* @__PURE__ */ expectMap((v) => {
  if (v.value.tag === "TokRawString") {
    return $Maybe("Just", { token: v, name: v.value._1 });
  }
  if (v.value.tag === "TokString") {
    return $Maybe("Just", { token: v, name: v.value._2 });
  }
  if (v.value.tag === "TokLowerName") {
    if (v.value._1.tag === "Nothing") {
      return $Maybe("Just", { token: v, name: v.value._2 });
    }
    return Nothing;
  }
  return Nothing;
});
var parseModuleName = /* @__PURE__ */ expectMap((v) => {
  if (v.value.tag === "TokUpperName") {
    if (v.value._1.tag === "Just") {
      return $Maybe("Just", { token: v, name: v.value._1._1 + ("." + v.value._2) });
    }
    if (v.value._1.tag === "Nothing") {
      return $Maybe("Just", { token: v, name: v.value._2 });
    }
    return Nothing;
  }
  return Nothing;
});
var parseNumber = /* @__PURE__ */ expectMap((v) => {
  if (v.value.tag === "TokNumber") {
    return $Maybe("Just", $Tuple(v, v.value._2));
  }
  return Nothing;
});
var parseOperator = /* @__PURE__ */ expectMap((v) => {
  if (v.value.tag === "TokOperator") {
    if (v.value._1.tag === "Nothing") {
      return $Maybe("Just", { token: v, name: v.value._2 });
    }
    return Nothing;
  }
  return Nothing;
});
var parseProper = /* @__PURE__ */ expectMap((v) => {
  if (v.value.tag === "TokUpperName") {
    if (v.value._1.tag === "Nothing") {
      return $Maybe("Just", { token: v, name: v.value._2 });
    }
    return Nothing;
  }
  return Nothing;
});
var parseQualifiedIdent = /* @__PURE__ */ expectMap((v) => {
  if (v.value.tag === "TokLowerName") {
    if ((() => {
      const $1 = lookup(ordString)(v.value._2)(reservedKeywords);
      if ($1.tag === "Nothing") {
        return true;
      }
      if ($1.tag === "Just") {
        return false;
      }
      fail();
    })()) {
      return $Maybe("Just", { token: v, module: v.value._1, name: v.value._2 });
    }
    return Nothing;
  }
  return Nothing;
});
var parseQualifiedIdentOrProper = /* @__PURE__ */ expectMap((v) => {
  if (v.value.tag === "TokLowerName") {
    return $Maybe("Just", { token: v, module: v.value._1, name: $Either("Left", v.value._2) });
  }
  if (v.value.tag === "TokUpperName") {
    return $Maybe("Just", { token: v, module: v.value._1, name: $Either("Right", v.value._2) });
  }
  return Nothing;
});
var parseQualifiedOperator = /* @__PURE__ */ expectMap((v) => {
  if (v.value.tag === "TokOperator") {
    return $Maybe("Just", { token: v, module: v.value._1, name: v.value._2 });
  }
  return Nothing;
});
var parseQualifiedProper = /* @__PURE__ */ expectMap((v) => {
  if (v.value.tag === "TokUpperName") {
    return $Maybe("Just", { token: v, module: v.value._1, name: v.value._2 });
  }
  return Nothing;
});
var parseQualifiedSymbol = /* @__PURE__ */ expectMap((v) => {
  if (v.value.tag === "TokSymbolName") {
    return $Maybe("Just", { token: v, module: v.value._1, name: v.value._2 });
  }
  return Nothing;
});
var parseString = /* @__PURE__ */ expectMap((v) => {
  if (v.value.tag === "TokString") {
    return $Maybe("Just", $Tuple(v, v.value._2));
  }
  if (v.value.tag === "TokRawString") {
    return $Maybe("Just", $Tuple(v, v.value._1));
  }
  return Nothing;
});
var parseSymbol = /* @__PURE__ */ expectMap((v) => {
  if (v.value.tag === "TokSymbolName") {
    if (v.value._1.tag === "Nothing") {
      return $Maybe("Just", { token: v, name: v.value._2 });
    }
    return Nothing;
  }
  return Nothing;
});
var expect = (pred) => expectMap((tok) => {
  if (pred(tok.value)) {
    return $Maybe("Just", tok);
  }
  return Nothing;
});
var tokAt = /* @__PURE__ */ expect((v) => v.tag === "TokAt");
var tokBackslash = /* @__PURE__ */ expect((v) => v.tag === "TokBackslash");
var tokComma = /* @__PURE__ */ expect((v) => v.tag === "TokComma");
var tokDot = /* @__PURE__ */ expect((v) => v.tag === "TokDot");
var parseRecordAccessor = (expr) => (state1, more, resume2, done) => tokDot(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => separated(tokDot)(parseLabel)(
    state2,
    more,
    resume2,
    (state2$1, a$1) => more((v1$1) => done(state2$1, $Expr("ExprRecordAccessor", { expr, dot: a, path: a$1 })))
  ))
);
var tokDoubleColon = /* @__PURE__ */ expect((v) => v.tag === "TokDoubleColon");
var parseInstanceName = (state1, more, resume2, done) => parseIdent(
  state1,
  more,
  resume2,
  (state2, a) => {
    const $6 = Tuple(a);
    return more((v2) => tokDoubleColon(state2, more, resume2, (state3, a$1) => done(state3, $6(a$1))));
  }
);
var tokEquals = /* @__PURE__ */ expect((v) => v.tag === "TokEquals");
var tokForall = /* @__PURE__ */ expect((v) => v.tag === "TokForall");
var tokKeyOperator = (sym) => expect((v) => {
  if (v.tag === "TokOperator") {
    if (v._1.tag === "Nothing") {
      return sym === v._2;
    }
    return false;
  }
  return false;
});
var parseBinderNegative = (state1, more, resume2, done) => tokKeyOperator("-")(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => {
    const $7 = BinderInt($Maybe("Just", a));
    const $8 = BinderNumber($Maybe("Just", a));
    return parseInt2(
      (() => {
        if (state2.consumed) {
          return { consumed: false, errors: state2.errors, stream: state2.stream };
        }
        return state2;
      })(),
      more,
      (state3, error4) => {
        if (state3.consumed) {
          return resume2(state3, error4);
        }
        return parseNumber(state2, more, resume2, (state2$1, a$1) => done(state2$1, $8(a$1._1)(a$1._2)));
      },
      (state2$1, a$1) => done(state2$1, $7(a$1._1)(a$1._2))
    );
  })
);
var parseRecordLabeled = (valueParser) => (state1, more, resume2, done) => {
  const $5 = (state3, error4) => {
    if (state3.consumed) {
      return resume2(state3, error4);
    }
    return parseIdent(state1, more, resume2, (state2, a) => done(state2, $RecordLabeled("RecordPun", a)));
  };
  const $6 = (() => {
    if (state1.consumed) {
      return { consumed: false, errors: state1.errors, stream: state1.stream };
    }
    return state1;
  })();
  return parseLabel(
    $6,
    more,
    (state2, error4) => $5({ consumed: $6.consumed, errors: state2.errors, stream: state2.stream }, error4),
    (state2, a) => {
      const $9 = Tuple(a);
      return more((v2) => tokKeyOperator(":")(
        state2,
        more,
        (state2$1, error4) => $5({ consumed: $6.consumed, errors: state2$1.errors, stream: state2$1.stream }, error4),
        (state3, a$1) => {
          const $13 = $9(a$1);
          const $14 = RecordField($13._1)($13._2);
          return more((v2$1) => valueParser(state3, more, $5, (state3$1, a$2) => done(state3$1, $14(a$2))));
        }
      ));
    }
  );
};
var parseTypeNegative = (state1, more, resume2, done) => tokKeyOperator("-")(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => {
    const $7 = TypeInt($Maybe("Just", a));
    return parseInt2(state2, more, resume2, (state2$1, a$1) => done(state2$1, $7(a$1._1)(a$1._2)));
  })
);
var tokKeySymbol = (sym) => expect((v) => {
  if (v.tag === "TokSymbolName") {
    if (v._1.tag === "Nothing") {
      return sym === v._2;
    }
    return false;
  }
  return false;
});
var tokKeyword = (kw) => expect((v) => {
  if (v.tag === "TokLowerName") {
    if (v._1.tag === "Nothing") {
      return kw === v._2;
    }
    return false;
  }
  return false;
});
var parseFixityKeyword = (state1, more, resume2, done) => tokKeyword("infix")(
  (() => {
    if (state1.consumed) {
      return { consumed: false, errors: state1.errors, stream: state1.stream };
    }
    return state1;
  })(),
  more,
  (state3, error4) => {
    if (state3.consumed) {
      return resume2(state3, error4);
    }
    return tokKeyword("infixl")(
      (() => {
        if (state1.consumed) {
          return { consumed: false, errors: state1.errors, stream: state1.stream };
        }
        return state1;
      })(),
      more,
      (state3$1, error$1) => {
        if (state3$1.consumed) {
          return resume2(state3$1, error$1);
        }
        return tokKeyword("infixr")(state1, more, resume2, (state2, a) => done(state2, $Tuple(a, Infixr)));
      },
      (state2, a) => done(state2, $Tuple(a, Infixl))
    );
  },
  (state2, a) => done(state2, $Tuple(a, Infix))
);
var parseFixityOp = (state1, more, resume2, done) => tokKeyword("type")(
  (() => {
    if (state1.consumed) {
      return { consumed: false, errors: state1.errors, stream: state1.stream };
    }
    return state1;
  })(),
  more,
  (state3, error4) => {
    if (state3.consumed) {
      return resume2(state3, error4);
    }
    return parseQualifiedIdentOrProper(
      state1,
      more,
      resume2,
      (state2, a) => {
        const $8 = FixityValue(a);
        return more((v2) => tokKeyword("as")(
          state2,
          more,
          resume2,
          (state3$1, a$1) => {
            const $12 = $8(a$1);
            return more((v2$1) => parseOperator(state3$1, more, resume2, (state3$2, a$2) => done(state3$2, $12(a$2))));
          }
        ));
      }
    );
  },
  (state2, a) => {
    const $6 = FixityType(a);
    return more((v2) => parseQualifiedProper(
      state2,
      more,
      (state3, error4) => {
        if (state3.consumed) {
          return resume2(state3, error4);
        }
        return parseQualifiedIdentOrProper(
          state1,
          more,
          resume2,
          (state2$1, a$1) => {
            const $12 = FixityValue(a$1);
            return more((v2$1) => tokKeyword("as")(
              state2$1,
              more,
              resume2,
              (state3$1, a$2) => {
                const $16 = $12(a$2);
                return more((v2$2) => parseOperator(state3$1, more, resume2, (state3$2, a$3) => done(state3$2, $16(a$3))));
              }
            ));
          }
        );
      },
      (state3, a$1) => {
        const $10 = $6(a$1);
        return more((v2$1) => tokKeyword("as")(
          state3,
          more,
          (state3$1, error4) => {
            if (state3$1.consumed) {
              return resume2(state3$1, error4);
            }
            return parseQualifiedIdentOrProper(
              state1,
              more,
              resume2,
              (state2$1, a$2) => {
                const $16 = FixityValue(a$2);
                return more((v2$2) => tokKeyword("as")(
                  state2$1,
                  more,
                  resume2,
                  (state3$2, a$3) => {
                    const $20 = $16(a$3);
                    return more((v2$3) => parseOperator(state3$2, more, resume2, (state3$3, a$4) => done(state3$3, $20(a$4))));
                  }
                ));
              }
            );
          },
          (state3$1, a$2) => {
            const $14 = $10(a$2);
            return more((v2$2) => parseOperator(
              state3$1,
              more,
              (state3$2, error4) => {
                if (state3$2.consumed) {
                  return resume2(state3$2, error4);
                }
                return parseQualifiedIdentOrProper(
                  state1,
                  more,
                  resume2,
                  (state2$1, a$3) => {
                    const $20 = FixityValue(a$3);
                    return more((v2$3) => tokKeyword("as")(
                      state2$1,
                      more,
                      resume2,
                      (state3$3, a$4) => {
                        const $24 = $20(a$4);
                        return more((v2$4) => parseOperator(state3$3, more, resume2, (state3$4, a$5) => done(state3$4, $24(a$5))));
                      }
                    ));
                  }
                );
              },
              (state3$2, a$3) => done(state3$2, $14(a$3))
            ));
          }
        ));
      }
    ));
  }
);
var parseDeclFixity = (state1, more, resume2, done) => parseFixityKeyword(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => parseSmallInt(
    state2,
    more,
    resume2,
    (state2$1, a$1) => more((v1$1) => parseFixityOp(
      state2$1,
      more,
      resume2,
      (state2$2, a$2) => more((v1$2) => done(state2$2, $Declaration("DeclFixity", { keyword: a, prec: a$1, operator: a$2 })))
    ))
  ))
);
var parseForeignKind = (state1, more, resume2, done) => tokKeyword("kind")(
  state1,
  more,
  (state2, error4) => resume2({ consumed: state1.consumed, errors: state2.errors, stream: state2.stream }, error4),
  (state2, a) => {
    const $6 = ForeignKind(a);
    return more((v2) => parseProper(
      state2,
      more,
      (state2$1, error4) => resume2({ consumed: state1.consumed, errors: state2$1.errors, stream: state2$1.stream }, error4),
      (state3, a$1) => done(state3, $6(a$1))
    ));
  }
);
var parseRole = (state1, more, resume2, done) => tokKeyword("representational")(
  (() => {
    if (state1.consumed) {
      return { consumed: false, errors: state1.errors, stream: state1.stream };
    }
    return state1;
  })(),
  more,
  (state3, error4) => {
    if (state3.consumed) {
      return resume2(state3, error4);
    }
    return tokKeyword("nominal")(
      (() => {
        if (state1.consumed) {
          return { consumed: false, errors: state1.errors, stream: state1.stream };
        }
        return state1;
      })(),
      more,
      (state3$1, error$1) => {
        if (state3$1.consumed) {
          return resume2(state3$1, error$1);
        }
        return tokKeyword("phantom")(state1, more, resume2, (state2, a) => done(state2, $Tuple(a, Phantom)));
      },
      (state2, a) => done(state2, $Tuple(a, Nominal))
    );
  },
  (state2, a) => done(state2, $Tuple(a, Representational))
);
var parseDeclRole = (keyword1) => (state1, more, resume2, done) => tokKeyword("role")(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => parseProper(
    state2,
    more,
    resume2,
    (state2$1, a$1) => more((v1$1) => many12(parseRole)(
      state2$1,
      more,
      resume2,
      (state2$2, a$2) => more((v1$2) => done(state2$2, $Declaration("DeclRole", keyword1, a, a$1, a$2)))
    ))
  ))
);
var tokLayoutEnd = /* @__PURE__ */ expect((v) => v.tag === "TokLayoutEnd");
var tokLayoutSep = /* @__PURE__ */ expect((v) => v.tag === "TokLayoutSep");
var parseInstanceChainSeparator = (state1, more, resume2, done) => tokKeyword("else")(
  state1,
  more,
  resume2,
  (state2, a) => more((v2) => optional2(tokLayoutSep)(state2, more, resume2, (state3, a$1) => done(state3, a)))
);
var tokLayoutStart = /* @__PURE__ */ expect((v) => v.tag === "TokLayoutStart");
var layout = (valueParser) => (state1, more, resume2, done) => tokLayoutStart(
  state1,
  more,
  resume2,
  (state2, a) => more((v2) => valueParser(
    (() => {
      if (state2.consumed) {
        return { consumed: false, errors: state2.errors, stream: state2.stream };
      }
      return state2;
    })(),
    more,
    (state3, error4) => {
      if (state3.consumed) {
        return resume2(state3, error4);
      }
      return more((v2$1) => tokLayoutEnd(state2, more, resume2, (state3$1, a$1) => done(state3$1, [])));
    },
    (state2$1, a$1) => more((v1) => many3((state1$1, more$1, resume$1, done$1) => tokLayoutSep(
      state1$1,
      more$1,
      resume$1,
      (state2$2, a$2) => more$1((v2$1) => valueParser(state2$2, more$1, resume$1, (state3, a$3) => done$1(state3, a$3)))
    ))(
      state2$1,
      more,
      (state3, error4) => {
        if (state3.consumed) {
          return resume2(state3, error4);
        }
        return more((v2$1) => tokLayoutEnd(state2, more, resume2, (state3$1, a$2) => done(state3$1, [])));
      },
      (state2$2, a$2) => {
        const $13 = concatArray([a$1])(a$2);
        return more((v2$1) => tokLayoutEnd(state2$2, more, resume2, (state3, a$3) => done(state3, $13)));
      }
    ))
  ))
);
var layoutNonEmpty = (valueParser) => {
  const $1 = many3((state1, more, resume2, done) => tokLayoutSep(
    state1,
    more,
    resume2,
    (state2, a) => more((v2) => valueParser(state2, more, resume2, (state3, a$1) => done(state3, a$1)))
  ));
  return (state1, more, resume2, done) => tokLayoutStart(
    state1,
    more,
    resume2,
    (state2, a) => more((v2) => valueParser(
      state2,
      more,
      resume2,
      (state3, a$1) => more((v2$1) => $1(
        state3,
        more,
        resume2,
        (state2$1, a$2) => more((v2$2) => tokLayoutEnd(state2$1, more, resume2, (state3$1, a$3) => done(state3$1, concatArray([a$1])(a$2))))
      ))
    ))
  );
};
var tokLeftArrow = /* @__PURE__ */ expect((v) => v.tag === "TokLeftArrow");
var tokLeftBrace = /* @__PURE__ */ expect((v) => v.tag === "TokLeftBrace");
var tokLeftFatArrow = /* @__PURE__ */ expect((v) => {
  if (v.tag === "TokOperator") {
    if (v._1.tag === "Nothing") {
      return v._2 === "<=" || v._2 === "\u21D0";
    }
    return false;
  }
  return false;
});
var tokLeftParen = /* @__PURE__ */ expect((v) => v.tag === "TokLeftParen");
var tokLeftSquare = /* @__PURE__ */ expect((v) => v.tag === "TokLeftSquare");
var tokPipe = /* @__PURE__ */ expect((v) => v.tag === "TokPipe");
var tokQualifiedKeyword = (kw) => expect((v) => {
  if (v.tag === "TokLowerName") {
    return kw === v._2;
  }
  return false;
});
var tokRightArrow = /* @__PURE__ */ expect((v) => v.tag === "TokRightArrow");
var parseFundep = (state1, more, resume2, done) => {
  const $4 = (state3, error4) => {
    if (state3.consumed) {
      return resume2(state3, error4);
    }
    return many12(parseIdent)(
      state1,
      more,
      resume2,
      (state2, a) => {
        const $8 = FundepDetermines(a);
        return more((v2) => tokRightArrow(
          state2,
          more,
          resume2,
          (state3$1, a$1) => {
            const $12 = $8(a$1);
            return more((v2$1) => many12(parseIdent)(state3$1, more, resume2, (state3$2, a$2) => done(state3$2, $12(a$2))));
          }
        ));
      }
    );
  };
  return tokRightArrow(
    (() => {
      if (state1.consumed) {
        return { consumed: false, errors: state1.errors, stream: state1.stream };
      }
      return state1;
    })(),
    more,
    $4,
    (state2, a) => {
      const $7 = FundepDetermined(a);
      return more((v2) => many12(parseIdent)(state2, more, $4, (state3, a$1) => done(state3, $7(a$1))));
    }
  );
};
var tokRightBrace = /* @__PURE__ */ expect((v) => v.tag === "TokRightBrace");
var tokRightFatArrow = /* @__PURE__ */ expect((v) => v.tag === "TokRightFatArrow");
var tokRightParen = /* @__PURE__ */ expect((v) => v.tag === "TokRightParen");
var parens = (valueParser) => (state1, more, resume2, done) => tokLeftParen(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => valueParser(
    state2,
    more,
    resume2,
    (state2$1, a$1) => more((v1$1) => tokRightParen(state2$1, more, resume2, (state2$2, a$2) => more((v1$2) => done(state2$2, { open: a, value: a$1, close: a$2 }))))
  ))
);
var parseEmptyRow = (open2) => (state1, more, resume2, done) => tokRightParen(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => done(state2, $Type("TypeRow", { open: open2, value: { labels: Nothing, tail: Nothing }, close: a })))
);
var tokRightSquare = /* @__PURE__ */ expect((v) => v.tag === "TokRightSquare");
var tokSymbolArrow = /* @__PURE__ */ expect((v) => v.tag === "TokSymbolArrow");
var tokTick = /* @__PURE__ */ expect((v) => v.tag === "TokTick");
var tokUnderscore = /* @__PURE__ */ expect((v) => v.tag === "TokUnderscore");
var delimited = (openTok) => (closeTok) => (sepTok) => (valueParser) => (state1, more, resume2, done) => openTok(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => {
    const $11 = separated(sepTok)(valueParser);
    return closeTok(
      (() => {
        if (state2.consumed) {
          return { consumed: false, errors: state2.errors, stream: state2.stream };
        }
        return state2;
      })(),
      more,
      (state3, error4) => {
        if (state3.consumed) {
          return resume2(state3, error4);
        }
        return $11(
          state2,
          more,
          resume2,
          (state2$1, a$1) => more((v2) => closeTok(state2$1, more, resume2, (state3$1, a$2) => done(state3$1, { open: a, value: $Maybe("Just", a$1), close: a$2 })))
        );
      },
      (state2$1, a$1) => done(state2$1, { open: a, value: Nothing, close: a$1 })
    );
  })
);
var parseDataMembers = (state1, more, resume2, done) => tokKeySymbol("..")(
  (() => {
    if (state1.consumed) {
      return { consumed: false, errors: state1.errors, stream: state1.stream };
    }
    return state1;
  })(),
  more,
  (state3, error4) => {
    if (state3.consumed) {
      return resume2(state3, error4);
    }
    return delimited(tokLeftParen)(tokRightParen)(tokComma)(parseProper)(
      state1,
      more,
      resume2,
      (state2, a) => done(state2, $DataMembers("DataEnumerated", a))
    );
  },
  (state2, a) => done(state2, $DataMembers("DataAll", a))
);
var parseExport = (state1, more, resume2, done) => tokKeyword("type")(
  (() => {
    if (state1.consumed) {
      return { consumed: false, errors: state1.errors, stream: state1.stream };
    }
    return state1;
  })(),
  more,
  (state3, error4) => {
    if (state3.consumed) {
      return resume2(state3, error4);
    }
    return tokKeyword("class")(
      (() => {
        if (state1.consumed) {
          return { consumed: false, errors: state1.errors, stream: state1.stream };
        }
        return state1;
      })(),
      more,
      (state3$1, error$1) => {
        if (state3$1.consumed) {
          return resume2(state3$1, error$1);
        }
        return tokKeyword("module")(
          (() => {
            if (state1.consumed) {
              return { consumed: false, errors: state1.errors, stream: state1.stream };
            }
            return state1;
          })(),
          more,
          (state3$2, error$2) => {
            if (state3$2.consumed) {
              return resume2(state3$2, error$2);
            }
            return parseSymbol(
              (() => {
                if (state1.consumed) {
                  return { consumed: false, errors: state1.errors, stream: state1.stream };
                }
                return state1;
              })(),
              more,
              (state3$3, error$3) => {
                if (state3$3.consumed) {
                  return resume2(state3$3, error$3);
                }
                return parseIdent(
                  (() => {
                    if (state1.consumed) {
                      return { consumed: false, errors: state1.errors, stream: state1.stream };
                    }
                    return state1;
                  })(),
                  more,
                  (state3$4, error$4) => {
                    if (state3$4.consumed) {
                      return resume2(state3$4, error$4);
                    }
                    return parseProper(
                      state1,
                      more,
                      resume2,
                      (state2, a) => {
                        const $16 = ExportType(a);
                        return more((v2) => optional2(parseDataMembers)(state2, more, resume2, (state3$5, a$1) => done(state3$5, $16(a$1))));
                      }
                    );
                  },
                  (state2, a) => done(state2, $Export("ExportValue", a))
                );
              },
              (state2, a) => done(state2, $Export("ExportOp", a))
            );
          },
          (state2, a) => {
            const $10 = ExportModule(a);
            return more((v2) => parseModuleName(
              state2,
              more,
              (state3$2, error$2) => {
                if (state3$2.consumed) {
                  return resume2(state3$2, error$2);
                }
                return parseSymbol(
                  (() => {
                    if (state1.consumed) {
                      return { consumed: false, errors: state1.errors, stream: state1.stream };
                    }
                    return state1;
                  })(),
                  more,
                  (state3$3, error$3) => {
                    if (state3$3.consumed) {
                      return resume2(state3$3, error$3);
                    }
                    return parseIdent(
                      (() => {
                        if (state1.consumed) {
                          return { consumed: false, errors: state1.errors, stream: state1.stream };
                        }
                        return state1;
                      })(),
                      more,
                      (state3$4, error$4) => {
                        if (state3$4.consumed) {
                          return resume2(state3$4, error$4);
                        }
                        return parseProper(
                          state1,
                          more,
                          resume2,
                          (state2$1, a$1) => {
                            const $20 = ExportType(a$1);
                            return more((v2$1) => optional2(parseDataMembers)(state2$1, more, resume2, (state3$5, a$2) => done(state3$5, $20(a$2))));
                          }
                        );
                      },
                      (state2$1, a$1) => done(state2$1, $Export("ExportValue", a$1))
                    );
                  },
                  (state2$1, a$1) => done(state2$1, $Export("ExportOp", a$1))
                );
              },
              (state3$2, a$1) => done(state3$2, $10(a$1))
            ));
          }
        );
      },
      (state2, a) => {
        const $8 = ExportClass(a);
        return more((v2) => parseProper(
          state2,
          more,
          (state3$1, error$1) => {
            if (state3$1.consumed) {
              return resume2(state3$1, error$1);
            }
            return tokKeyword("module")(
              (() => {
                if (state1.consumed) {
                  return { consumed: false, errors: state1.errors, stream: state1.stream };
                }
                return state1;
              })(),
              more,
              (state3$2, error$2) => {
                if (state3$2.consumed) {
                  return resume2(state3$2, error$2);
                }
                return parseSymbol(
                  (() => {
                    if (state1.consumed) {
                      return { consumed: false, errors: state1.errors, stream: state1.stream };
                    }
                    return state1;
                  })(),
                  more,
                  (state3$3, error$3) => {
                    if (state3$3.consumed) {
                      return resume2(state3$3, error$3);
                    }
                    return parseIdent(
                      (() => {
                        if (state1.consumed) {
                          return { consumed: false, errors: state1.errors, stream: state1.stream };
                        }
                        return state1;
                      })(),
                      more,
                      (state3$4, error$4) => {
                        if (state3$4.consumed) {
                          return resume2(state3$4, error$4);
                        }
                        return parseProper(
                          state1,
                          more,
                          resume2,
                          (state2$1, a$1) => {
                            const $20 = ExportType(a$1);
                            return more((v2$1) => optional2(parseDataMembers)(state2$1, more, resume2, (state3$5, a$2) => done(state3$5, $20(a$2))));
                          }
                        );
                      },
                      (state2$1, a$1) => done(state2$1, $Export("ExportValue", a$1))
                    );
                  },
                  (state2$1, a$1) => done(state2$1, $Export("ExportOp", a$1))
                );
              },
              (state2$1, a$1) => {
                const $14 = ExportModule(a$1);
                return more((v2$1) => parseModuleName(
                  state2$1,
                  more,
                  (state3$2, error$2) => {
                    if (state3$2.consumed) {
                      return resume2(state3$2, error$2);
                    }
                    return parseSymbol(
                      (() => {
                        if (state1.consumed) {
                          return { consumed: false, errors: state1.errors, stream: state1.stream };
                        }
                        return state1;
                      })(),
                      more,
                      (state3$3, error$3) => {
                        if (state3$3.consumed) {
                          return resume2(state3$3, error$3);
                        }
                        return parseIdent(
                          (() => {
                            if (state1.consumed) {
                              return { consumed: false, errors: state1.errors, stream: state1.stream };
                            }
                            return state1;
                          })(),
                          more,
                          (state3$4, error$4) => {
                            if (state3$4.consumed) {
                              return resume2(state3$4, error$4);
                            }
                            return parseProper(
                              state1,
                              more,
                              resume2,
                              (state2$2, a$2) => {
                                const $24 = ExportType(a$2);
                                return more((v2$2) => optional2(parseDataMembers)(state2$2, more, resume2, (state3$5, a$3) => done(state3$5, $24(a$3))));
                              }
                            );
                          },
                          (state2$2, a$2) => done(state2$2, $Export("ExportValue", a$2))
                        );
                      },
                      (state2$2, a$2) => done(state2$2, $Export("ExportOp", a$2))
                    );
                  },
                  (state3$2, a$2) => done(state3$2, $14(a$2))
                ));
              }
            );
          },
          (state3$1, a$1) => done(state3$1, $8(a$1))
        ));
      }
    );
  },
  (state2, a) => {
    const $6 = ExportTypeOp(a);
    return more((v2) => parseSymbol(
      state2,
      more,
      (state3, error4) => {
        if (state3.consumed) {
          return resume2(state3, error4);
        }
        return tokKeyword("class")(
          (() => {
            if (state1.consumed) {
              return { consumed: false, errors: state1.errors, stream: state1.stream };
            }
            return state1;
          })(),
          more,
          (state3$1, error$1) => {
            if (state3$1.consumed) {
              return resume2(state3$1, error$1);
            }
            return tokKeyword("module")(
              (() => {
                if (state1.consumed) {
                  return { consumed: false, errors: state1.errors, stream: state1.stream };
                }
                return state1;
              })(),
              more,
              (state3$2, error$2) => {
                if (state3$2.consumed) {
                  return resume2(state3$2, error$2);
                }
                return parseSymbol(
                  (() => {
                    if (state1.consumed) {
                      return { consumed: false, errors: state1.errors, stream: state1.stream };
                    }
                    return state1;
                  })(),
                  more,
                  (state3$3, error$3) => {
                    if (state3$3.consumed) {
                      return resume2(state3$3, error$3);
                    }
                    return parseIdent(
                      (() => {
                        if (state1.consumed) {
                          return { consumed: false, errors: state1.errors, stream: state1.stream };
                        }
                        return state1;
                      })(),
                      more,
                      (state3$4, error$4) => {
                        if (state3$4.consumed) {
                          return resume2(state3$4, error$4);
                        }
                        return parseProper(
                          state1,
                          more,
                          resume2,
                          (state2$1, a$1) => {
                            const $20 = ExportType(a$1);
                            return more((v2$1) => optional2(parseDataMembers)(state2$1, more, resume2, (state3$5, a$2) => done(state3$5, $20(a$2))));
                          }
                        );
                      },
                      (state2$1, a$1) => done(state2$1, $Export("ExportValue", a$1))
                    );
                  },
                  (state2$1, a$1) => done(state2$1, $Export("ExportOp", a$1))
                );
              },
              (state2$1, a$1) => {
                const $14 = ExportModule(a$1);
                return more((v2$1) => parseModuleName(
                  state2$1,
                  more,
                  (state3$2, error$2) => {
                    if (state3$2.consumed) {
                      return resume2(state3$2, error$2);
                    }
                    return parseSymbol(
                      (() => {
                        if (state1.consumed) {
                          return { consumed: false, errors: state1.errors, stream: state1.stream };
                        }
                        return state1;
                      })(),
                      more,
                      (state3$3, error$3) => {
                        if (state3$3.consumed) {
                          return resume2(state3$3, error$3);
                        }
                        return parseIdent(
                          (() => {
                            if (state1.consumed) {
                              return { consumed: false, errors: state1.errors, stream: state1.stream };
                            }
                            return state1;
                          })(),
                          more,
                          (state3$4, error$4) => {
                            if (state3$4.consumed) {
                              return resume2(state3$4, error$4);
                            }
                            return parseProper(
                              state1,
                              more,
                              resume2,
                              (state2$2, a$2) => {
                                const $24 = ExportType(a$2);
                                return more((v2$2) => optional2(parseDataMembers)(state2$2, more, resume2, (state3$5, a$3) => done(state3$5, $24(a$3))));
                              }
                            );
                          },
                          (state2$2, a$2) => done(state2$2, $Export("ExportValue", a$2))
                        );
                      },
                      (state2$2, a$2) => done(state2$2, $Export("ExportOp", a$2))
                    );
                  },
                  (state3$2, a$2) => done(state3$2, $14(a$2))
                ));
              }
            );
          },
          (state2$1, a$1) => {
            const $12 = ExportClass(a$1);
            return more((v2$1) => parseProper(
              state2$1,
              more,
              (state3$1, error$1) => {
                if (state3$1.consumed) {
                  return resume2(state3$1, error$1);
                }
                return tokKeyword("module")(
                  (() => {
                    if (state1.consumed) {
                      return { consumed: false, errors: state1.errors, stream: state1.stream };
                    }
                    return state1;
                  })(),
                  more,
                  (state3$2, error$2) => {
                    if (state3$2.consumed) {
                      return resume2(state3$2, error$2);
                    }
                    return parseSymbol(
                      (() => {
                        if (state1.consumed) {
                          return { consumed: false, errors: state1.errors, stream: state1.stream };
                        }
                        return state1;
                      })(),
                      more,
                      (state3$3, error$3) => {
                        if (state3$3.consumed) {
                          return resume2(state3$3, error$3);
                        }
                        return parseIdent(
                          (() => {
                            if (state1.consumed) {
                              return { consumed: false, errors: state1.errors, stream: state1.stream };
                            }
                            return state1;
                          })(),
                          more,
                          (state3$4, error$4) => {
                            if (state3$4.consumed) {
                              return resume2(state3$4, error$4);
                            }
                            return parseProper(
                              state1,
                              more,
                              resume2,
                              (state2$2, a$2) => {
                                const $24 = ExportType(a$2);
                                return more((v2$2) => optional2(parseDataMembers)(state2$2, more, resume2, (state3$5, a$3) => done(state3$5, $24(a$3))));
                              }
                            );
                          },
                          (state2$2, a$2) => done(state2$2, $Export("ExportValue", a$2))
                        );
                      },
                      (state2$2, a$2) => done(state2$2, $Export("ExportOp", a$2))
                    );
                  },
                  (state2$2, a$2) => {
                    const $18 = ExportModule(a$2);
                    return more((v2$2) => parseModuleName(
                      state2$2,
                      more,
                      (state3$2, error$2) => {
                        if (state3$2.consumed) {
                          return resume2(state3$2, error$2);
                        }
                        return parseSymbol(
                          (() => {
                            if (state1.consumed) {
                              return { consumed: false, errors: state1.errors, stream: state1.stream };
                            }
                            return state1;
                          })(),
                          more,
                          (state3$3, error$3) => {
                            if (state3$3.consumed) {
                              return resume2(state3$3, error$3);
                            }
                            return parseIdent(
                              (() => {
                                if (state1.consumed) {
                                  return { consumed: false, errors: state1.errors, stream: state1.stream };
                                }
                                return state1;
                              })(),
                              more,
                              (state3$4, error$4) => {
                                if (state3$4.consumed) {
                                  return resume2(state3$4, error$4);
                                }
                                return parseProper(
                                  state1,
                                  more,
                                  resume2,
                                  (state2$3, a$3) => {
                                    const $28 = ExportType(a$3);
                                    return more((v2$3) => optional2(parseDataMembers)(
                                      state2$3,
                                      more,
                                      resume2,
                                      (state3$5, a$4) => done(state3$5, $28(a$4))
                                    ));
                                  }
                                );
                              },
                              (state2$3, a$3) => done(state2$3, $Export("ExportValue", a$3))
                            );
                          },
                          (state2$3, a$3) => done(state2$3, $Export("ExportOp", a$3))
                        );
                      },
                      (state3$2, a$3) => done(state3$2, $18(a$3))
                    ));
                  }
                );
              },
              (state3$1, a$2) => done(state3$1, $12(a$2))
            ));
          }
        );
      },
      (state3, a$1) => done(state3, $6(a$1))
    ));
  }
);
var parseImport = (state1, more, resume2, done) => parseSymbol(
  (() => {
    if (state1.consumed) {
      return { consumed: false, errors: state1.errors, stream: state1.stream };
    }
    return state1;
  })(),
  more,
  (state3, error4) => {
    if (state3.consumed) {
      return resume2(state3, error4);
    }
    return parseProper(
      (() => {
        if (state1.consumed) {
          return { consumed: false, errors: state1.errors, stream: state1.stream };
        }
        return state1;
      })(),
      more,
      (state3$1, error$1) => {
        if (state3$1.consumed) {
          return resume2(state3$1, error$1);
        }
        return tokKeyword("type")(
          (() => {
            if (state1.consumed) {
              return { consumed: false, errors: state1.errors, stream: state1.stream };
            }
            return state1;
          })(),
          more,
          (state3$2, error$2) => {
            if (state3$2.consumed) {
              return resume2(state3$2, error$2);
            }
            const $10 = (state3$3, error$3) => {
              if (state3$3.consumed) {
                return resume2(state3$3, error$3);
              }
              return parseIdent(state1, more, resume2, (state2, a) => done(state2, $Import("ImportValue", a)));
            };
            return tokKeyword("class")(
              (() => {
                if (state1.consumed) {
                  return { consumed: false, errors: state1.errors, stream: state1.stream };
                }
                return state1;
              })(),
              more,
              $10,
              (state2, a) => {
                const $13 = ImportClass(a);
                return more((v2) => parseProper(state2, more, $10, (state3$3, a$1) => done(state3$3, $13(a$1))));
              }
            );
          },
          (state2, a) => {
            const $10 = ImportTypeOp(a);
            return more((v2) => parseSymbol(
              state2,
              more,
              (state3$2, error$2) => {
                if (state3$2.consumed) {
                  return resume2(state3$2, error$2);
                }
                const $14 = (state3$3, error$3) => {
                  if (state3$3.consumed) {
                    return resume2(state3$3, error$3);
                  }
                  return parseIdent(state1, more, resume2, (state2$1, a$1) => done(state2$1, $Import("ImportValue", a$1)));
                };
                return tokKeyword("class")(
                  (() => {
                    if (state1.consumed) {
                      return { consumed: false, errors: state1.errors, stream: state1.stream };
                    }
                    return state1;
                  })(),
                  more,
                  $14,
                  (state2$1, a$1) => {
                    const $17 = ImportClass(a$1);
                    return more((v2$1) => parseProper(state2$1, more, $14, (state3$3, a$2) => done(state3$3, $17(a$2))));
                  }
                );
              },
              (state3$2, a$1) => done(state3$2, $10(a$1))
            ));
          }
        );
      },
      (state2, a) => {
        const $8 = ImportType(a);
        return more((v2) => optional2(parseDataMembers)(
          state2,
          more,
          (state3$1, error$1) => {
            if (state3$1.consumed) {
              return resume2(state3$1, error$1);
            }
            return tokKeyword("type")(
              (() => {
                if (state1.consumed) {
                  return { consumed: false, errors: state1.errors, stream: state1.stream };
                }
                return state1;
              })(),
              more,
              (state3$2, error$2) => {
                if (state3$2.consumed) {
                  return resume2(state3$2, error$2);
                }
                const $14 = (state3$3, error$3) => {
                  if (state3$3.consumed) {
                    return resume2(state3$3, error$3);
                  }
                  return parseIdent(state1, more, resume2, (state2$1, a$1) => done(state2$1, $Import("ImportValue", a$1)));
                };
                return tokKeyword("class")(
                  (() => {
                    if (state1.consumed) {
                      return { consumed: false, errors: state1.errors, stream: state1.stream };
                    }
                    return state1;
                  })(),
                  more,
                  $14,
                  (state2$1, a$1) => {
                    const $17 = ImportClass(a$1);
                    return more((v2$1) => parseProper(state2$1, more, $14, (state3$3, a$2) => done(state3$3, $17(a$2))));
                  }
                );
              },
              (state2$1, a$1) => {
                const $14 = ImportTypeOp(a$1);
                return more((v2$1) => parseSymbol(
                  state2$1,
                  more,
                  (state3$2, error$2) => {
                    if (state3$2.consumed) {
                      return resume2(state3$2, error$2);
                    }
                    const $18 = (state3$3, error$3) => {
                      if (state3$3.consumed) {
                        return resume2(state3$3, error$3);
                      }
                      return parseIdent(state1, more, resume2, (state2$2, a$2) => done(state2$2, $Import("ImportValue", a$2)));
                    };
                    return tokKeyword("class")(
                      (() => {
                        if (state1.consumed) {
                          return { consumed: false, errors: state1.errors, stream: state1.stream };
                        }
                        return state1;
                      })(),
                      more,
                      $18,
                      (state2$2, a$2) => {
                        const $21 = ImportClass(a$2);
                        return more((v2$2) => parseProper(state2$2, more, $18, (state3$3, a$3) => done(state3$3, $21(a$3))));
                      }
                    );
                  },
                  (state3$2, a$2) => done(state3$2, $14(a$2))
                ));
              }
            );
          },
          (state3$1, a$1) => done(state3$1, $8(a$1))
        ));
      }
    );
  },
  (state2, a) => done(state2, $Import("ImportOp", a))
);
var parseImportDecl = (state1, more, resume2, done) => tokKeyword("import")(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => parseModuleName(
    state2,
    more,
    resume2,
    (state2$1, a$1) => more((v1$1) => optional2((() => {
      const $10 = parens(separated(tokComma)(parseImport));
      return (state1$1, more$1, resume$1, done$1) => optional2(tokKeyword("hiding"))(
        state1$1,
        more$1,
        resume$1,
        (state2$2, a$2) => {
          const $17 = Tuple(a$2);
          return more$1((v2) => $10(state2$2, more$1, resume$1, (state3, a$3) => done$1(state3, $17(a$3))));
        }
      );
    })())(
      state2$1,
      more,
      resume2,
      (state2$2, a$2) => more((v1$2) => optional2((state1$1, more$1, resume$1, done$1) => tokKeyword("as")(
        state1$1,
        more$1,
        resume$1,
        (state2$3, a$3) => {
          const $19 = Tuple(a$3);
          return more$1((v2) => parseModuleName(state2$3, more$1, resume$1, (state3, a$4) => done$1(state3, $19(a$4))));
        }
      ))(state2$2, more, resume2, (state2$3, a$3) => more((v1$3) => done(state2$3, { keyword: a, module: a$1, names: a$2, qualified: a$3 }))))
    ))
  ))
);
var parseModuleImportDecls = /* @__PURE__ */ many3((state1, more, resume2, done) => parseImportDecl(
  state1,
  more,
  resume2,
  (state2, a) => more((v2) => tokLayoutSep(
    (() => {
      if (state2.consumed) {
        return { consumed: false, errors: state2.errors, stream: state2.stream };
      }
      return state2;
    })(),
    more,
    (state3, error4) => {
      if (state3.consumed) {
        return resume2(state3, error4);
      }
      return tokLayoutEnd(state2, more, (v1, error$1) => resume2(state2, error$1), (v1, value) => done(state2, a));
    },
    (state3, a$1) => done(state3, a)
  ))
));
var parseModuleHeader = (state1, more, resume2, done) => tokKeyword("module")(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => parseModuleName(
    state2,
    more,
    resume2,
    (state2$1, a$1) => more((v1$1) => optional2(parens(separated(tokComma)(parseExport)))(
      state2$1,
      more,
      resume2,
      (state2$2, a$2) => more((v1$2) => tokKeyword("where")(
        state2$2,
        more,
        resume2,
        (state2$3, a$3) => more((v1$3) => tokLayoutStart(
          state2$3,
          more,
          resume2,
          (state2$4, a$4) => more((v2) => parseModuleImportDecls(
            state2$4,
            more,
            resume2,
            (state3, a$5) => more((v1$4) => done(state3, { keyword: a, name: a$1, exports: a$2, where: a$3, imports: a$5 }))
          ))
        ))
      ))
    ))
  ))
);
var braces = (valueParser) => (state1, more, resume2, done) => tokLeftBrace(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => valueParser(
    state2,
    more,
    resume2,
    (state2$1, a$1) => more((v1$1) => tokRightBrace(state2$1, more, resume2, (state2$2, a$2) => more((v1$2) => done(state2$2, { open: a, value: a$1, close: a$2 }))))
  ))
);
var parseTypeParens = (state1, more, resume2, done) => tokLeftParen(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => {
    const $7 = parseRowTailParen(a);
    const $8 = parseKindedVar(a);
    const $9 = parseTypeParen(a);
    return parseRowParen(a)(
      (() => {
        if (state2.consumed) {
          return { consumed: false, errors: state2.errors, stream: state2.stream };
        }
        return state2;
      })(),
      more,
      (state3, error4) => {
        if (state3.consumed) {
          return resume2(state3, error4);
        }
        return $7(
          (() => {
            if (state2.consumed) {
              return { consumed: false, errors: state2.errors, stream: state2.stream };
            }
            return state2;
          })(),
          more,
          (state3$1, error$1) => {
            if (state3$1.consumed) {
              return resume2(state3$1, error$1);
            }
            return $8(
              (() => {
                if (state2.consumed) {
                  return { consumed: false, errors: state2.errors, stream: state2.stream };
                }
                return state2;
              })(),
              more,
              (state3$2, error$2) => {
                if (state3$2.consumed) {
                  return resume2(state3$2, error$2);
                }
                return $9(
                  (() => {
                    if (state2.consumed) {
                      return { consumed: false, errors: state2.errors, stream: state2.stream };
                    }
                    return state2;
                  })(),
                  more,
                  (state3$3, error$3) => {
                    if (state3$3.consumed) {
                      return resume2(state3$3, error$3);
                    }
                    return parseEmptyRow(a)(state2, more, resume2, done);
                  },
                  done
                );
              },
              done
            );
          },
          done
        );
      },
      done
    );
  })
);
var parseTypeParen = (open2) => (state1, more, resume2, done) => parseType$lazy()(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => tokRightParen(
    state2,
    more,
    resume2,
    (state2$1, a$1) => more((v1$1) => done(state2$1, $Type("TypeParens", { open: open2, value: a, close: a$1 })))
  ))
);
var parseRowTailParen = (open2) => (state1, more, resume2, done) => tokPipe(
  state1,
  more,
  resume2,
  (state2, a) => {
    const $7 = Tuple(a);
    return more((v2) => parseType$lazy()(
      state2,
      more,
      resume2,
      (state3, a$1) => {
        const $11 = $7(a$1);
        return more((v1) => tokRightParen(
          state3,
          more,
          resume2,
          (state2$1, a$2) => more((v1$1) => done(
            state2$1,
            $Type("TypeRow", { open: open2, value: { labels: Nothing, tail: $Maybe("Just", $11) }, close: a$2 })
          ))
        ));
      }
    ));
  }
);
var parseRowParen = (open2) => (state1, more, resume2, done) => parseLabel(
  state1,
  more,
  (state2, error4) => resume2({ consumed: state1.consumed, errors: state2.errors, stream: state2.stream }, error4),
  (state2, a) => {
    const $7 = Tuple(a);
    return more((v2) => tokDoubleColon(
      state2,
      more,
      (state2$1, error4) => resume2({ consumed: state1.consumed, errors: state2$1.errors, stream: state2$1.stream }, error4),
      (state3, a$1) => {
        const $11 = $7(a$1);
        return more((v1) => parseType$lazy()(
          state3,
          more,
          resume2,
          (state2$1, a$2) => more((v1$1) => many3((state1$1, more$1, resume$1, done$1) => tokComma(
            state1$1,
            more$1,
            resume$1,
            (state2$2, a$3) => {
              const $22 = Tuple(a$3);
              return more$1((v2$1) => parseRowLabel(state2$2, more$1, resume$1, (state3$1, a$4) => done$1(state3$1, $22(a$4))));
            }
          ))(
            state2$1,
            more,
            resume2,
            (state2$2, a$3) => more((v1$2) => optional2((state1$1, more$1, resume$1, done$1) => tokPipe(
              state1$1,
              more$1,
              resume$1,
              (state2$3, a$4) => {
                const $25 = Tuple(a$4);
                return more$1((v2$1) => parseType$lazy()(state2$3, more$1, resume$1, (state3$1, a$5) => done$1(state3$1, $25(a$5))));
              }
            ))(
              state2$2,
              more,
              resume2,
              (state2$3, a$4) => more((v1$3) => tokRightParen(
                state2$3,
                more,
                resume2,
                (state2$4, a$5) => more((v1$4) => done(
                  state2$4,
                  $Type(
                    "TypeRow",
                    { open: open2, value: { labels: $Maybe("Just", { head: { label: $11._1, separator: $11._2, value: a$2 }, tail: a$3 }), tail: a$4 }, close: a$5 }
                  )
                ))
              ))
            ))
          ))
        ));
      }
    ));
  }
);
var parseRowLabel = (state1, more, resume2, done) => parseLabel(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => tokDoubleColon(
    state2,
    more,
    resume2,
    (state2$1, a$1) => more((v1$1) => parseType$lazy()(state2$1, more, resume2, (state2$2, a$2) => more((v1$2) => done(state2$2, { label: a, separator: a$1, value: a$2 }))))
  ))
);
var parseKindedVar = (open2) => {
  const $1 = parens((state1, more, resume2, done) => parseIdent(state1, more, resume2, (state2, a) => done(state2, $Type("TypeVar", a))));
  return (state1, more, resume2, done) => $1(
    state1,
    more,
    (state2, error4) => resume2({ consumed: state1.consumed, errors: state2.errors, stream: state2.stream }, error4),
    (state2, a) => {
      const $8 = Tuple(a);
      return more((v2) => tokDoubleColon(
        state2,
        more,
        (state2$1, error4) => resume2({ consumed: state1.consumed, errors: state2$1.errors, stream: state2$1.stream }, error4),
        (state3, a$1) => {
          const $12 = $8(a$1);
          return more((v1) => parseType$lazy()(
            state3,
            more,
            resume2,
            (state2$1, a$2) => more((v1$1) => tokRightParen(
              state2$1,
              more,
              resume2,
              (state2$2, a$3) => more((v1$2) => done(
                state2$2,
                $Type(
                  "TypeParens",
                  { open: open2, value: $Type("TypeKinded", $Type("TypeParens", $12._1), $12._2, a$2), close: a$3 }
                )
              ))
            ))
          ));
        }
      ));
    }
  );
};
var parseTypeVarKinded$lazy = /* @__PURE__ */ binding(() => {
  const $0 = parens((state1, more, resume2, done) => parseIdent(
    state1,
    more,
    resume2,
    (state2, a) => more((v1) => tokDoubleColon(
      state2,
      more,
      resume2,
      (state2$1, a$1) => more((v1$1) => parseType$lazy()(state2$1, more, resume2, (state2$2, a$2) => more((v1$2) => done(state2$2, { label: a, separator: a$1, value: a$2 }))))
    ))
  ));
  return (state1, more, resume2, done) => $0(state1, more, resume2, (state2, a) => done(state2, $TypeVarBinding("TypeVarKinded", a)));
});
var parseTypeVarBinding$lazy = /* @__PURE__ */ binding(() => lazyParser.defer((v) => (state1, more, resume2, done) => parseTypeVarKinded$lazy()(
  (() => {
    if (state1.consumed) {
      return { consumed: false, errors: state1.errors, stream: state1.stream };
    }
    return state1;
  })(),
  more,
  (state3, error4) => {
    if (state3.consumed) {
      return resume2(state3, error4);
    }
    return parseIdent(state1, more, resume2, (state2, a) => done(state2, $TypeVarBinding("TypeVarName", a)));
  },
  done
)));
var parseTypeAtom$lazy = /* @__PURE__ */ binding(() => lazyParser.defer((v) => {
  const $1 = TypeInt(Nothing);
  return (state1, more, resume2, done) => parseIdent(
    (() => {
      if (state1.consumed) {
        return { consumed: false, errors: state1.errors, stream: state1.stream };
      }
      return state1;
    })(),
    more,
    (state3, error4) => {
      if (state3.consumed) {
        return resume2(state3, error4);
      }
      return parseQualifiedProper(
        (() => {
          if (state1.consumed) {
            return { consumed: false, errors: state1.errors, stream: state1.stream };
          }
          return state1;
        })(),
        more,
        (state3$1, error$1) => {
          if (state3$1.consumed) {
            return resume2(state3$1, error$1);
          }
          return parseString(
            (() => {
              if (state1.consumed) {
                return { consumed: false, errors: state1.errors, stream: state1.stream };
              }
              return state1;
            })(),
            more,
            (state3$2, error$2) => {
              if (state3$2.consumed) {
                return resume2(state3$2, error$2);
              }
              return parseInt2(
                (() => {
                  if (state1.consumed) {
                    return { consumed: false, errors: state1.errors, stream: state1.stream };
                  }
                  return state1;
                })(),
                more,
                (state3$3, error$3) => {
                  if (state3$3.consumed) {
                    return resume2(state3$3, error$3);
                  }
                  return parseTypeParens(
                    (() => {
                      if (state1.consumed) {
                        return { consumed: false, errors: state1.errors, stream: state1.stream };
                      }
                      return state1;
                    })(),
                    more,
                    (state3$4, error$4) => {
                      if (state3$4.consumed) {
                        return resume2(state3$4, error$4);
                      }
                      return braces(parseRow$lazy())(
                        (() => {
                          if (state1.consumed) {
                            return { consumed: false, errors: state1.errors, stream: state1.stream };
                          }
                          return state1;
                        })(),
                        more,
                        (state3$5, error$5) => {
                          if (state3$5.consumed) {
                            return resume2(state3$5, error$5);
                          }
                          return parseQualifiedSymbol(
                            (() => {
                              if (state1.consumed) {
                                return { consumed: false, errors: state1.errors, stream: state1.stream };
                              }
                              return state1;
                            })(),
                            more,
                            (state3$6, error$6) => {
                              if (state3$6.consumed) {
                                return resume2(state3$6, error$6);
                              }
                              return parseHole(
                                (() => {
                                  if (state1.consumed) {
                                    return { consumed: false, errors: state1.errors, stream: state1.stream };
                                  }
                                  return state1;
                                })(),
                                more,
                                (state3$7, error$7) => {
                                  if (state3$7.consumed) {
                                    return resume2(state3$7, error$7);
                                  }
                                  return tokUnderscore(
                                    (() => {
                                      if (state1.consumed) {
                                        return { consumed: false, errors: state1.errors, stream: state1.stream };
                                      }
                                      return state1;
                                    })(),
                                    more,
                                    (state3$8, error$8) => {
                                      if (state3$8.consumed) {
                                        return resume2(state3$8, error$8);
                                      }
                                      return tokSymbolArrow(state1, more, resume2, (state2, a) => done(state2, $Type("TypeArrowName", a)));
                                    },
                                    (state2, a) => done(state2, $Type("TypeWildcard", a))
                                  );
                                },
                                (state2, a) => done(state2, $Type("TypeHole", a))
                              );
                            },
                            (state2, a) => done(state2, $Type("TypeOpName", a))
                          );
                        },
                        (state2, a) => done(state2, $Type("TypeRecord", a))
                      );
                    },
                    done
                  );
                },
                (state2, a) => done(state2, $1(a._1)(a._2))
              );
            },
            (state2, a) => done(state2, $Type("TypeString", a._1, a._2))
          );
        },
        (state2, a) => done(state2, $Type("TypeConstructor", a))
      );
    },
    (state2, a) => done(state2, $Type("TypeVar", a))
  );
}));
var parseType5$lazy = /* @__PURE__ */ binding(() => lazyParser.defer((v) => (state1, more, resume2, done) => parseTypeAtom$lazy()(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => many3(parseTypeAtom$lazy())(
    state2,
    more,
    resume2,
    (state2$1, a$1) => more((v1$1) => done(
      state2$1,
      (() => {
        if (a$1.length > 0) {
          return $Type("TypeApp", a, a$1);
        }
        return a;
      })()
    ))
  ))
)));
var parseType4$lazy = /* @__PURE__ */ binding(() => lazyParser.defer((v) => (state1, more, resume2, done) => parseTypeNegative(
  (() => {
    if (state1.consumed) {
      return { consumed: false, errors: state1.errors, stream: state1.stream };
    }
    return state1;
  })(),
  more,
  (state3, error4) => {
    if (state3.consumed) {
      return resume2(state3, error4);
    }
    return parseType5$lazy()(state1, more, resume2, done);
  },
  done
)));
var parseType3$lazy = /* @__PURE__ */ binding(() => lazyParser.defer((v) => (state1, more, resume2, done) => parseType4$lazy()(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => many3((state1$1, more$1, resume$1, done$1) => parseQualifiedOperator(
    state1$1,
    more$1,
    resume$1,
    (state2$1, a$1) => {
      const $14 = Tuple(a$1);
      return more$1((v2) => parseType4$lazy()(state2$1, more$1, resume$1, (state3, a$2) => done$1(state3, $14(a$2))));
    }
  ))(
    state2,
    more,
    resume2,
    (state2$1, a$1) => more((v1$1) => done(
      state2$1,
      (() => {
        if (a$1.length > 0) {
          return $Type("TypeOp", a, a$1);
        }
        return a;
      })()
    ))
  ))
)));
var parseType2$lazy = /* @__PURE__ */ binding(() => lazyParser.defer((v) => (state1, more, resume2, done) => parseType3$lazy()(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => {
    const $8 = TypeArrow(a);
    const $9 = TypeConstrained(a);
    const $10 = (state1$1, more$1, resume$1, done$1) => tokRightFatArrow(
      (() => {
        if (state1$1.consumed) {
          return { consumed: false, errors: state1$1.errors, stream: state1$1.stream };
        }
        return state1$1;
      })(),
      more$1,
      (state3, error4) => {
        if (state3.consumed) {
          return resume$1(state3, error4);
        }
        return done$1(state1$1, a);
      },
      (state2$1, a$1) => {
        const $16 = $9(a$1);
        return more$1((v2) => parseType1$lazy()(
          state2$1,
          more$1,
          (state3, error4) => {
            if (state3.consumed) {
              return resume$1(state3, error4);
            }
            return done$1(state1$1, a);
          },
          (state3, a$2) => done$1(state3, $16(a$2))
        ));
      }
    );
    return tokRightArrow(
      (() => {
        if (state2.consumed) {
          return { consumed: false, errors: state2.errors, stream: state2.stream };
        }
        return state2;
      })(),
      more,
      (state3, error4) => {
        if (state3.consumed) {
          return resume2(state3, error4);
        }
        return $10(state2, more, resume2, done);
      },
      (state2$1, a$1) => {
        const $13 = $8(a$1);
        return more((v2) => parseType1$lazy()(
          state2$1,
          more,
          (state3, error4) => {
            if (state3.consumed) {
              return resume2(state3, error4);
            }
            return $10(state2, more, resume2, done);
          },
          (state3, a$2) => done(state3, $13(a$2))
        ));
      }
    );
  })
)));
var parseType1$lazy = /* @__PURE__ */ binding(() => lazyParser.defer((v) => (state1, more, resume2, done) => parseForall$lazy()(
  (() => {
    if (state1.consumed) {
      return { consumed: false, errors: state1.errors, stream: state1.stream };
    }
    return state1;
  })(),
  more,
  (state3, error4) => {
    if (state3.consumed) {
      return resume2(state3, error4);
    }
    return parseType2$lazy()(state1, more, resume2, done);
  },
  done
)));
var parseType$lazy = /* @__PURE__ */ binding(() => lazyParser.defer((v) => (state1, more, resume2, done) => parseType1$lazy()(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => {
    const $8 = TypeKinded(a);
    return tokDoubleColon(
      (() => {
        if (state2.consumed) {
          return { consumed: false, errors: state2.errors, stream: state2.stream };
        }
        return state2;
      })(),
      more,
      (state3, error4) => {
        if (state3.consumed) {
          return resume2(state3, error4);
        }
        return done(state2, a);
      },
      (state2$1, a$1) => {
        const $11 = $8(a$1);
        return more((v2) => parseType$lazy()(
          state2$1,
          more,
          (state3, error4) => {
            if (state3.consumed) {
              return resume2(state3, error4);
            }
            return done(state2, a);
          },
          (state3, a$2) => done(state3, $11(a$2))
        ));
      }
    );
  })
)));
var parseRow$lazy = /* @__PURE__ */ binding(() => lazyParser.defer((v) => {
  const $1 = optional2(separated(tokComma)(parseRowLabel));
  return (state1, more, resume2, done) => $1(
    state1,
    more,
    resume2,
    (state2, a) => more((v1) => optional2((state1$1, more$1, resume$1, done$1) => tokPipe(
      state1$1,
      more$1,
      resume$1,
      (state2$1, a$1) => {
        const $15 = Tuple(a$1);
        return more$1((v2) => parseType$lazy()(state2$1, more$1, resume$1, (state3, a$2) => done$1(state3, $15(a$2))));
      }
    ))(state2, more, resume2, (state2$1, a$1) => more((v1$1) => done(state2$1, { labels: a, tail: a$1 }))))
  );
}));
var parseForall$lazy = /* @__PURE__ */ binding(() => lazyParser.defer((v) => (state1, more, resume2, done) => tokForall(
  state1,
  more,
  resume2,
  (state2, a) => {
    const $7 = TypeForall(a);
    return more((v2) => many12(parseTypeVarBinding$lazy())(
      state2,
      more,
      resume2,
      (state3, a$1) => {
        const $11 = $7(a$1);
        return more((v2$1) => tokDot(
          state3,
          more,
          resume2,
          (state3$1, a$2) => {
            const $15 = $11(a$2);
            return more((v2$2) => parseType1$lazy()(state3$1, more, resume2, (state3$2, a$3) => done(state3$2, $15(a$3))));
          }
        ));
      }
    ));
  }
)));
var parseTypeVarBinding = /* @__PURE__ */ parseTypeVarBinding$lazy();
var parseTypeAtom = /* @__PURE__ */ parseTypeAtom$lazy();
var parseType5 = /* @__PURE__ */ parseType5$lazy();
var parseType3 = /* @__PURE__ */ parseType3$lazy();
var parseType = /* @__PURE__ */ parseType$lazy();
var parseDataCtor = (state1, more, resume2, done) => parseProper(
  state1,
  more,
  resume2,
  (state2, a) => more((v2) => many3(parseTypeAtom)(state2, more, resume2, (state3, a$1) => done(state3, { name: a, fields: a$1 })))
);
var parseIdentBinder = (state1, more, resume2, done) => parseIdent(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => {
    const $7 = BinderNamed(a);
    return tokAt(
      (() => {
        if (state2.consumed) {
          return { consumed: false, errors: state2.errors, stream: state2.stream };
        }
        return state2;
      })(),
      more,
      (state3, error4) => {
        if (state3.consumed) {
          return resume2(state3, error4);
        }
        return done(state2, $Binder("BinderVar", a));
      },
      (state2$1, a$1) => {
        const $10 = $7(a$1);
        return more((v2) => parseBinderAtom$lazy()(
          state2$1,
          more,
          (state3, error4) => {
            if (state3.consumed) {
              return resume2(state3, error4);
            }
            return done(state2, $Binder("BinderVar", a));
          },
          (state3, a$2) => done(state3, $10(a$2))
        ));
      }
    );
  })
);
var parseBinderConstructor$lazy = /* @__PURE__ */ binding(() => lazyParser.defer((v) => (state1, more, resume2, done) => parseQualifiedProper(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => many3(parseBinderAtom$lazy())(
    state2,
    more,
    resume2,
    (state2$1, a$1) => more((v1$1) => done(state2$1, $Binder("BinderConstructor", a, a$1)))
  ))
)));
var parseBinderAtom$lazy = /* @__PURE__ */ binding(() => lazyParser.defer((v) => {
  const $1 = BinderInt(Nothing);
  const $2 = BinderNumber(Nothing);
  return (state1, more, resume2, done) => parseIdentBinder(
    (() => {
      if (state1.consumed) {
        return { consumed: false, errors: state1.errors, stream: state1.stream };
      }
      return state1;
    })(),
    more,
    (state3, error4) => {
      if (state3.consumed) {
        return resume2(state3, error4);
      }
      return parseQualifiedProper(
        (() => {
          if (state1.consumed) {
            return { consumed: false, errors: state1.errors, stream: state1.stream };
          }
          return state1;
        })(),
        more,
        (state3$1, error$1) => {
          if (state3$1.consumed) {
            return resume2(state3$1, error$1);
          }
          return tokUnderscore(
            (() => {
              if (state1.consumed) {
                return { consumed: false, errors: state1.errors, stream: state1.stream };
              }
              return state1;
            })(),
            more,
            (state3$2, error$2) => {
              if (state3$2.consumed) {
                return resume2(state3$2, error$2);
              }
              return parseString(
                (() => {
                  if (state1.consumed) {
                    return { consumed: false, errors: state1.errors, stream: state1.stream };
                  }
                  return state1;
                })(),
                more,
                (state3$3, error$3) => {
                  if (state3$3.consumed) {
                    return resume2(state3$3, error$3);
                  }
                  return parseChar(
                    (() => {
                      if (state1.consumed) {
                        return { consumed: false, errors: state1.errors, stream: state1.stream };
                      }
                      return state1;
                    })(),
                    more,
                    (state3$4, error$4) => {
                      if (state3$4.consumed) {
                        return resume2(state3$4, error$4);
                      }
                      return parseBoolean(
                        (() => {
                          if (state1.consumed) {
                            return { consumed: false, errors: state1.errors, stream: state1.stream };
                          }
                          return state1;
                        })(),
                        more,
                        (state3$5, error$5) => {
                          if (state3$5.consumed) {
                            return resume2(state3$5, error$5);
                          }
                          return parseInt2(
                            (() => {
                              if (state1.consumed) {
                                return { consumed: false, errors: state1.errors, stream: state1.stream };
                              }
                              return state1;
                            })(),
                            more,
                            (state3$6, error$6) => {
                              if (state3$6.consumed) {
                                return resume2(state3$6, error$6);
                              }
                              return parseNumber(
                                (() => {
                                  if (state1.consumed) {
                                    return { consumed: false, errors: state1.errors, stream: state1.stream };
                                  }
                                  return state1;
                                })(),
                                more,
                                (state3$7, error$7) => {
                                  if (state3$7.consumed) {
                                    return resume2(state3$7, error$7);
                                  }
                                  return delimited(tokLeftSquare)(tokRightSquare)(tokComma)(parseBinder$lazy())(
                                    (() => {
                                      if (state1.consumed) {
                                        return { consumed: false, errors: state1.errors, stream: state1.stream };
                                      }
                                      return state1;
                                    })(),
                                    more,
                                    (state3$8, error$8) => {
                                      if (state3$8.consumed) {
                                        return resume2(state3$8, error$8);
                                      }
                                      return delimited(tokLeftBrace)(tokRightBrace)(tokComma)(parseRecordLabeled(parseBinder$lazy()))(
                                        (() => {
                                          if (state1.consumed) {
                                            return { consumed: false, errors: state1.errors, stream: state1.stream };
                                          }
                                          return state1;
                                        })(),
                                        more,
                                        (state3$9, error$9) => {
                                          if (state3$9.consumed) {
                                            return resume2(state3$9, error$9);
                                          }
                                          return parens(parseBinder$lazy())(state1, more, resume2, (state2, a) => done(state2, $Binder("BinderParens", a)));
                                        },
                                        (state2, a) => done(state2, $Binder("BinderRecord", a))
                                      );
                                    },
                                    (state2, a) => done(state2, $Binder("BinderArray", a))
                                  );
                                },
                                (state2, a) => done(state2, $2(a._1)(a._2))
                              );
                            },
                            (state2, a) => done(state2, $1(a._1)(a._2))
                          );
                        },
                        (state2, a) => done(state2, $Binder("BinderBoolean", a._1, a._2))
                      );
                    },
                    (state2, a) => done(state2, $Binder("BinderChar", a._1, a._2))
                  );
                },
                (state2, a) => done(state2, $Binder("BinderString", a._1, a._2))
              );
            },
            (state2, a) => done(state2, $Binder("BinderWildcard", a))
          );
        },
        (state2, a) => done(state2, $Binder("BinderConstructor", a, []))
      );
    },
    done
  );
}));
var parseBinder2$lazy = /* @__PURE__ */ binding(() => lazyParser.defer((v) => (state1, more, resume2, done) => parseBinderNegative(
  (() => {
    if (state1.consumed) {
      return { consumed: false, errors: state1.errors, stream: state1.stream };
    }
    return state1;
  })(),
  more,
  (state3, error4) => {
    if (state3.consumed) {
      return resume2(state3, error4);
    }
    return parseBinderConstructor$lazy()(
      (() => {
        if (state1.consumed) {
          return { consumed: false, errors: state1.errors, stream: state1.stream };
        }
        return state1;
      })(),
      more,
      (state3$1, error$1) => {
        if (state3$1.consumed) {
          return resume2(state3$1, error$1);
        }
        return parseBinderAtom$lazy()(state1, more, resume2, done);
      },
      done
    );
  },
  done
)));
var parseBinder1$lazy = /* @__PURE__ */ binding(() => lazyParser.defer((v) => (state1, more, resume2, done) => parseBinder2$lazy()(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => many3((state1$1, more$1, resume$1, done$1) => parseQualifiedOperator(
    state1$1,
    more$1,
    resume$1,
    (state2$1, a$1) => {
      const $14 = Tuple(a$1);
      return more$1((v2) => parseBinder2$lazy()(state2$1, more$1, resume$1, (state3, a$2) => done$1(state3, $14(a$2))));
    }
  ))(
    state2,
    more,
    resume2,
    (state2$1, a$1) => more((v1$1) => done(
      state2$1,
      (() => {
        if (a$1.length > 0) {
          return $Binder("BinderOp", a, a$1);
        }
        return a;
      })()
    ))
  ))
)));
var parseBinder$lazy = /* @__PURE__ */ binding(() => lazyParser.defer((v) => (state1, more, resume2, done) => parseBinder1$lazy()(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => {
    const $8 = BinderTyped(a);
    return tokDoubleColon(
      (() => {
        if (state2.consumed) {
          return { consumed: false, errors: state2.errors, stream: state2.stream };
        }
        return state2;
      })(),
      more,
      (state3, error4) => {
        if (state3.consumed) {
          return resume2(state3, error4);
        }
        return done(state2, a);
      },
      (state2$1, a$1) => {
        const $11 = $8(a$1);
        return more((v2) => parseType(
          state2$1,
          more,
          (state3, error4) => {
            if (state3.consumed) {
              return resume2(state3, error4);
            }
            return done(state2, a);
          },
          (state3, a$2) => done(state3, $11(a$2))
        ));
      }
    );
  })
)));
var parseBinderAtom = /* @__PURE__ */ parseBinderAtom$lazy();
var parseBinder1 = /* @__PURE__ */ parseBinder1$lazy();
var parseBinder = /* @__PURE__ */ parseBinder$lazy();
var parseClassConstraints = (parseOneConstraint) => {
  const $1 = parens(separated(tokComma)(parseType));
  return (state1, more, resume2, done) => $1(
    (() => {
      if (state1.consumed) {
        return { consumed: false, errors: state1.errors, stream: state1.stream };
      }
      return state1;
    })(),
    more,
    (state3, error4) => {
      if (state3.consumed) {
        return resume2(state3, error4);
      }
      return parseOneConstraint(state1, more, resume2, (state2, a) => done(state2, $OneOrDelimited("One", a)));
    },
    (state2, a) => done(state2, $OneOrDelimited("Many", a))
  );
};
var parseDeclDerive = (state1, more, resume2, done) => tokKeyword("derive")(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => optional2(tokKeyword("newtype"))(
    state2,
    more,
    resume2,
    (state2$1, a$1) => more((v1$1) => tokKeyword("instance")(
      state2$1,
      more,
      resume2,
      (state2$2, a$2) => more((v1$2) => optional2(parseInstanceName)(
        state2$2,
        more,
        resume2,
        (state2$3, a$3) => more((v1$3) => optional2((() => {
          const $16 = parseClassConstraints(parseType3);
          return (state1$1, more$1, resume$1, done$1) => $16(
            state1$1,
            more$1,
            (state2$4, error4) => resume$1({ consumed: state1$1.consumed, errors: state2$4.errors, stream: state2$4.stream }, error4),
            (state2$4, a$4) => {
              const $23 = Tuple(a$4);
              return more$1((v2) => tokRightFatArrow(
                state2$4,
                more$1,
                (state2$5, error4) => resume$1({ consumed: state1$1.consumed, errors: state2$5.errors, stream: state2$5.stream }, error4),
                (state3, a$5) => done$1(state3, $23(a$5))
              ));
            }
          );
        })())(
          state2$3,
          more,
          resume2,
          (state2$4, a$4) => more((v1$4) => parseQualifiedProper(
            state2$4,
            more,
            resume2,
            (state2$5, a$5) => more((v1$5) => many3(parseTypeAtom)(
              state2$5,
              more,
              resume2,
              (state2$6, a$6) => more((v1$6) => done(
                state2$6,
                $Declaration("DeclDerive", a, a$1, { keyword: a$2, name: a$3, constraints: a$4, className: a$5, types: a$6 })
              ))
            ))
          ))
        ))
      ))
    ))
  ))
);
var parseClassMember = (state1, more, resume2, done) => parseIdent(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => tokDoubleColon(
    state2,
    more,
    resume2,
    (state2$1, a$1) => more((v1$1) => parseType(state2$1, more, resume2, (state2$2, a$2) => more((v1$2) => done(state2$2, { label: a, separator: a$1, value: a$2 }))))
  ))
);
var parseDeclClassSignature = (keyword) => (state1, more, resume2, done) => parseProper(
  state1,
  more,
  (state2, error4) => resume2({ consumed: state1.consumed, errors: state2.errors, stream: state2.stream }, error4),
  (state2, a) => {
    const $7 = Tuple(a);
    return more((v2) => tokDoubleColon(
      state2,
      more,
      (state2$1, error4) => resume2({ consumed: state1.consumed, errors: state2$1.errors, stream: state2$1.stream }, error4),
      (state3, a$1) => {
        const $11 = $7(a$1);
        return more((v1) => parseType(
          state3,
          more,
          resume2,
          (state2$1, a$2) => more((v1$1) => done(state2$1, $Declaration("DeclKindSignature", keyword, { label: $11._1, separator: $11._2, value: a$2 })))
        ));
      }
    ));
  }
);
var parseDeclKindSignature = (keyword) => (label) => (state1, more, resume2, done) => tokDoubleColon(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => parseType(
    state2,
    more,
    resume2,
    (state2$1, a$1) => more((v1$1) => done(state2$1, $Declaration("DeclKindSignature", keyword, { label, separator: a, value: a$1 })))
  ))
);
var parseDeclSignature = (label) => (state1, more, resume2, done) => tokDoubleColon(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => parseType(
    state2,
    more,
    resume2,
    (state2$1, a$1) => more((v1$1) => done(state2$1, $Declaration("DeclSignature", { label, separator: a, value: a$1 })))
  ))
);
var parseForeignData = (state1, more, resume2, done) => tokKeyword("data")(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => parseProper(
    state2,
    more,
    resume2,
    (state2$1, a$1) => more((v1$1) => tokDoubleColon(
      state2$1,
      more,
      resume2,
      (state2$2, a$2) => more((v1$2) => parseType(
        state2$2,
        more,
        resume2,
        (state2$3, a$3) => more((v1$3) => done(state2$3, $Foreign("ForeignData", a, { label: a$1, separator: a$2, value: a$3 })))
      ))
    ))
  ))
);
var parseForeignValue = (state1, more, resume2, done) => parseIdent(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => tokDoubleColon(
    state2,
    more,
    resume2,
    (state2$1, a$1) => more((v1$1) => parseType(
      state2$1,
      more,
      resume2,
      (state2$2, a$2) => more((v1$2) => done(state2$2, $Foreign("ForeignValue", { label: a, separator: a$1, value: a$2 })))
    ))
  ))
);
var parseDeclForeign = (state1, more, resume2, done) => tokKeyword("foreign")(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => tokKeyword("import")(
    state2,
    more,
    resume2,
    (state2$1, a$1) => more((v1$1) => parseForeignData(
      (() => {
        if (state2$1.consumed) {
          return { consumed: false, errors: state2$1.errors, stream: state2$1.stream };
        }
        return state2$1;
      })(),
      more,
      (state3, error4) => {
        if (state3.consumed) {
          return resume2(state3, error4);
        }
        return parseForeignKind(
          (() => {
            if (state2$1.consumed) {
              return { consumed: false, errors: state2$1.errors, stream: state2$1.stream };
            }
            return state2$1;
          })(),
          more,
          (state3$1, error$1) => {
            if (state3$1.consumed) {
              return resume2(state3$1, error$1);
            }
            return parseForeignValue(state2$1, more, resume2, (state2$2, a$2) => more((v1$2) => done(state2$2, $Declaration("DeclForeign", a, a$1, a$2))));
          },
          (state2$2, a$2) => more((v1$2) => done(state2$2, $Declaration("DeclForeign", a, a$1, a$2)))
        );
      },
      (state2$2, a$2) => more((v1$2) => done(state2$2, $Declaration("DeclForeign", a, a$1, a$2)))
    ))
  ))
);
var parseInstanceBindingSignature = (label) => (state1, more, resume2, done) => tokDoubleColon(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => parseType(
    state2,
    more,
    resume2,
    (state2$1, a$1) => more((v1$1) => done(state2$1, $InstanceBinding("InstanceBindingSignature", { label, separator: a, value: a$1 })))
  ))
);
var parseLetBindingSignature = (label) => (state1, more, resume2, done) => tokDoubleColon(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => parseType(
    state2,
    more,
    resume2,
    (state2$1, a$1) => more((v1$1) => done(state2$1, $LetBinding("LetBindingSignature", { label, separator: a, value: a$1 })))
  ))
);
var parseTickExpr = (state1, more, resume2, done) => tokTick(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => parseTickExpr1$lazy()(
    state2,
    more,
    resume2,
    (state2$1, a$1) => more((v1$1) => tokTick(state2$1, more, resume2, (state2$2, a$2) => more((v1$2) => done(state2$2, { open: a, value: a$1, close: a$2 }))))
  ))
);
var parseRecordUpdates = (expr) => (state1, more, resume2, done) => {
  const $5 = (state2, a) => more((v1) => separated(tokComma)(parseRecordUpdate)(
    state2,
    more,
    resume2,
    (state2$1, a$1) => more((v1$1) => tokRightBrace(
      state2$1,
      more,
      resume2,
      (state2$2, a$2) => more((v1$2) => done(state2$2, $Expr("ExprRecordUpdate", expr, { open: a, value: a$1, close: a$2 })))
    ))
  ));
  return tokLeftBrace(
    state1,
    more,
    (state2, error4) => resume2({ consumed: state1.consumed, errors: state2.errors, stream: state2.stream }, error4),
    (state2, a) => more((v2) => parseLabel(
      state2,
      more,
      (v1, error4) => resume2({ consumed: state1.consumed, errors: state2.errors, stream: state2.stream }, error4),
      (state2$1, a$1) => more((v2$1) => tokEquals(
        (() => {
          if (state2$1.consumed) {
            return { consumed: false, errors: state2$1.errors, stream: state2$1.stream };
          }
          return state2$1;
        })(),
        more,
        (state3, error4) => {
          if (state3.consumed) {
            return resume2({ consumed: state1.consumed, errors: state2.errors, stream: state2.stream }, error4);
          }
          return tokLeftBrace(
            state2$1,
            more,
            (v1, error$1) => resume2({ consumed: state1.consumed, errors: state2.errors, stream: state2.stream }, error$1),
            (state3$1, a$2) => $5(state2, a)
          );
        },
        (state3, a$2) => $5(state2, a)
      ))
    ))
  );
};
var parseRecordUpdateLeaf = (label) => {
  const $1 = RecordUpdateLeaf(label);
  return (state1, more, resume2, done) => tokEquals(
    state1,
    more,
    resume2,
    (state2, a) => {
      const $8 = $1(a);
      return more((v2) => parseExpr$lazy()(state2, more, resume2, (state3, a$1) => done(state3, $8(a$1))));
    }
  );
};
var parseRecordUpdateBranch = (label) => {
  const $1 = RecordUpdateBranch(label);
  const $2 = braces(separated(tokComma)(parseRecordUpdate));
  return (state1, more, resume2, done) => $2(state1, more, resume2, (state2, a) => done(state2, $1(a)));
};
var parseRecordUpdate = (state1, more, resume2, done) => parseLabel(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => {
    const $7 = parseRecordUpdateBranch(a);
    return parseRecordUpdateLeaf(a)(
      (() => {
        if (state2.consumed) {
          return { consumed: false, errors: state2.errors, stream: state2.stream };
        }
        return state2;
      })(),
      more,
      (state3, error4) => {
        if (state3.consumed) {
          return resume2(state3, error4);
        }
        return $7(state2, more, resume2, done);
      },
      done
    );
  })
);
var parseLetIn = (state1, more, resume2, done) => tokKeyword("let")(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => layoutNonEmpty(recoverIndent(LetBindingError)(parseLetBinding$lazy()))(
    state2,
    more,
    resume2,
    (state2$1, a$1) => more((v1$1) => tokKeyword("in")(
      state2$1,
      more,
      resume2,
      (state2$2, a$2) => more((v1$2) => parseExpr$lazy()(
        state2$2,
        more,
        resume2,
        (state2$3, a$3) => more((v1$3) => done(state2$3, $Expr("ExprLet", { keyword: a, bindings: a$1, in: a$2, body: a$3 })))
      ))
    ))
  ))
);
var parseLetBindingName = (name2) => (state1, more, resume2, done) => many3(parseBinderAtom)(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => parseGuarded(tokEquals)(
    state2,
    more,
    resume2,
    (state2$1, a$1) => more((v1$1) => done(state2$1, $LetBinding("LetBindingName", { name: name2, binders: a, guarded: a$1 })))
  ))
);
var parseLambda = (state1, more, resume2, done) => tokBackslash(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => many12(parseBinderAtom)(
    state2,
    more,
    resume2,
    (state2$1, a$1) => more((v1$1) => tokRightArrow(
      state2$1,
      more,
      resume2,
      (state2$2, a$2) => more((v1$2) => parseExpr$lazy()(
        state2$2,
        more,
        resume2,
        (state2$3, a$3) => more((v1$3) => done(state2$3, $Expr("ExprLambda", { symbol: a, binders: a$1, arrow: a$2, body: a$3 })))
      ))
    ))
  ))
);
var parseIf = (state1, more, resume2, done) => tokKeyword("if")(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => parseExpr$lazy()(
    state2,
    more,
    resume2,
    (state2$1, a$1) => more((v1$1) => tokKeyword("then")(
      state2$1,
      more,
      resume2,
      (state2$2, a$2) => more((v1$2) => parseExpr$lazy()(
        state2$2,
        more,
        resume2,
        (state2$3, a$3) => more((v1$3) => tokKeyword("else")(
          state2$3,
          more,
          resume2,
          (state2$4, a$4) => more((v1$4) => parseExpr$lazy()(
            state2$4,
            more,
            resume2,
            (state2$5, a$5) => more((v1$5) => done(state2$5, $Expr("ExprIf", { keyword: a, cond: a$1, then: a$2, true: a$3, else: a$4, false: a$5 })))
          ))
        ))
      ))
    ))
  ))
);
var parseIdentBinding = (state1, more, resume2, done) => parseIdent(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => parseLetBindingSignature(a)(
    (() => {
      if (state2.consumed) {
        return { consumed: false, errors: state2.errors, stream: state2.stream };
      }
      return state2;
    })(),
    more,
    (state3, error4) => {
      if (state3.consumed) {
        return resume2(state3, error4);
      }
      return parseLetBindingName(a)(state2, more, resume2, done);
    },
    done
  ))
);
var parseGuarded = (sepParser) => {
  const $1 = many12((() => {
    const $12 = separated(tokComma)((() => {
      const $13 = optional2((state1, more, resume2, done) => parseBinder(
        state1,
        more,
        (state2, error4) => resume2({ consumed: state1.consumed, errors: state2.errors, stream: state2.stream }, error4),
        (state2, a) => {
          const $7 = Tuple(a);
          return more((v2) => tokLeftArrow(
            state2,
            more,
            (state2$1, error4) => resume2({ consumed: state1.consumed, errors: state2$1.errors, stream: state2$1.stream }, error4),
            (state3, a$1) => done(state3, $7(a$1))
          ));
        }
      ));
      return (state1, more, resume2, done) => $13(
        state1,
        more,
        resume2,
        (state2, a) => more((v2) => parseExpr$lazy()(state2, more, resume2, (state3, a$1) => done(state3, { binder: a, expr: a$1 })))
      );
    })());
    return (state1, more, resume2, done) => tokPipe(
      state1,
      more,
      resume2,
      (state2, a) => more((v2) => $12(
        state2,
        more,
        resume2,
        (state3, a$1) => more((v2$1) => sepParser(
          state3,
          more,
          resume2,
          (state3$1, a$2) => more((v2$2) => parseWhere$lazy()(state3$1, more, resume2, (state3$2, a$3) => done(state3$2, { bar: a, patterns: a$1, separator: a$2, where: a$3 })))
        ))
      ))
    );
  })());
  return (state1, more, resume2, done) => sepParser(
    (() => {
      if (state1.consumed) {
        return { consumed: false, errors: state1.errors, stream: state1.stream };
      }
      return state1;
    })(),
    more,
    (state3, error4) => {
      if (state3.consumed) {
        return resume2(state3, error4);
      }
      return $1(state1, more, resume2, (state2, a) => done(state2, $Guarded("Guarded", a)));
    },
    (state2, a) => {
      const $8 = Unconditional(a);
      return more((v2) => parseWhere$lazy()(
        state2,
        more,
        (state3, error4) => {
          if (state3.consumed) {
            return resume2(state3, error4);
          }
          return $1(state1, more, resume2, (state2$1, a$1) => done(state2$1, $Guarded("Guarded", a$1)));
        },
        (state3, a$1) => done(state3, $8(a$1))
      ));
    }
  );
};
var parseDo = (state1, more, resume2, done) => tokQualifiedKeyword("do")(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => layoutNonEmpty(recoverIndent(DoError)(parseDoStatement$lazy()))(
    state2,
    more,
    resume2,
    (state2$1, a$1) => more((v1$1) => done(state2$1, $Expr("ExprDo", { keyword: a, statements: a$1 })))
  ))
);
var parseCase = (state1, more, resume2, done) => tokKeyword("case")(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => separated(tokComma)(parseExpr$lazy())(
    state2,
    more,
    resume2,
    (state2$1, a$1) => more((v1$1) => tokKeyword("of")(
      state2$1,
      more,
      resume2,
      (state2$2, a$2) => more((v1$2) => {
        const $13 = (() => {
          if (state2$2.consumed) {
            return { consumed: false, errors: state2$2.errors, stream: state2$2.stream };
          }
          return state2$2;
        })();
        return parseBadSingleCaseBranch(
          $13,
          more,
          (state2$3, error4) => {
            const $16 = { consumed: $13.consumed, errors: state2$3.errors, stream: state2$3.stream };
            if ($16.consumed) {
              return resume2($16, error4);
            }
            return parseCaseBranches$lazy()(
              state2$2,
              more,
              resume2,
              (state2$4, a$3) => more((v1$3) => done(state2$4, $Expr("ExprCase", { keyword: a, head: a$1, of: a$2, branches: a$3 })))
            );
          },
          (state2$3, a$3) => more((v1$3) => done(state2$3, $Expr("ExprCase", { keyword: a, head: a$1, of: a$2, branches: a$3 })))
        );
      })
    ))
  ))
);
var parseBadSingleCaseWhere = (binder) => (state1, more, resume2, done) => tokRightArrow(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => tokLayoutEnd(
    state2,
    more,
    resume2,
    (state2$1, a$1) => more((v2) => parseWhere$lazy()(
      state2$1,
      more,
      resume2,
      (state3, a$2) => more((v1$1) => done(state3, [$Tuple({ head: binder, tail: [] }, $Guarded("Unconditional", a, a$2))]))
    ))
  ))
);
var parseBadSingleCaseGuarded = (binder) => {
  const $1 = parseGuarded(tokRightArrow);
  return (state1, more, resume2, done) => tokLayoutEnd(
    state1,
    more,
    resume2,
    (state2, a) => more((v2) => $1(state2, more, resume2, (state3, a$1) => more((v1) => done(state3, [$Tuple({ head: binder, tail: [] }, a$1)]))))
  );
};
var parseBadSingleCaseBranch = (state1, more, resume2, done) => tokLayoutStart(
  state1,
  more,
  resume2,
  (state2, a) => more((v2) => parseBinder1(
    state2,
    more,
    resume2,
    (state3, a$1) => more((v1) => {
      const $10 = parseBadSingleCaseGuarded(a$1);
      return parseBadSingleCaseWhere(a$1)(
        (() => {
          if (state3.consumed) {
            return { consumed: false, errors: state3.errors, stream: state3.stream };
          }
          return state3;
        })(),
        more,
        (state3$1, error4) => {
          if (state3$1.consumed) {
            return resume2(state3$1, error4);
          }
          return $10(state3, more, resume2, done);
        },
        done
      );
    })
  ))
);
var parseAdo = (state1, more, resume2, done) => tokQualifiedKeyword("ado")(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => layout(recoverIndent(DoError)(parseDoStatement$lazy()))(
    state2,
    more,
    resume2,
    (state2$1, a$1) => more((v1$1) => tokKeyword("in")(
      state2$1,
      more,
      resume2,
      (state2$2, a$2) => more((v1$2) => parseExpr$lazy()(
        state2$2,
        more,
        resume2,
        (state2$3, a$3) => more((v1$3) => done(state2$3, $Expr("ExprAdo", { keyword: a, statements: a$1, in: a$2, result: a$3 })))
      ))
    ))
  ))
);
var parseWhere$lazy = /* @__PURE__ */ binding(() => lazyParser.defer((v) => (state1, more, resume2, done) => parseExpr$lazy()(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => optional2((() => {
    const $8 = layoutNonEmpty(recoverIndent(LetBindingError)(parseLetBinding$lazy()));
    return (state1$1, more$1, resume$1, done$1) => tokKeyword("where")(
      state1$1,
      more$1,
      resume$1,
      (state2$1, a$1) => {
        const $15 = Tuple(a$1);
        return more$1((v2) => $8(state2$1, more$1, resume$1, (state3, a$2) => done$1(state3, $15(a$2))));
      }
    );
  })())(state2, more, resume2, (state2$1, a$1) => more((v1$1) => done(state2$1, { expr: a, bindings: a$1 }))))
)));
var parseTickExpr1$lazy = /* @__PURE__ */ binding(() => lazyParser.defer((v) => (state1, more, resume2, done) => parseExpr3$lazy()(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => many3((state1$1, more$1, resume$1, done$1) => parseQualifiedOperator(
    state1$1,
    more$1,
    resume$1,
    (state2$1, a$1) => {
      const $14 = Tuple(a$1);
      return more$1((v2) => parseExpr3$lazy()(state2$1, more$1, resume$1, (state3, a$2) => done$1(state3, $14(a$2))));
    }
  ))(
    state2,
    more,
    resume2,
    (state2$1, a$1) => more((v1$1) => done(
      state2$1,
      (() => {
        if (a$1.length > 0) {
          return $Expr("ExprOp", a, a$1);
        }
        return a;
      })()
    ))
  ))
)));
var parseLetBinding$lazy = /* @__PURE__ */ binding(() => lazyParser.defer((v) => (state1, more, resume2, done) => {
  const $5 = (() => {
    if (state1.consumed) {
      return { consumed: false, errors: state1.errors, stream: state1.stream };
    }
    return state1;
  })();
  return parseIdentBinding(
    $5,
    more,
    (state2, error4) => {
      const $8 = { consumed: $5.consumed, errors: state2.errors, stream: state2.stream };
      if ($8.consumed) {
        return resume2($8, error4);
      }
      return parseBinder1(
        state1,
        more,
        resume2,
        (state2$1, a) => {
          const $11 = LetBindingPattern(a);
          return more((v2) => tokEquals(
            state2$1,
            more,
            resume2,
            (state3, a$1) => {
              const $15 = $11(a$1);
              return more((v2$1) => parseWhere$lazy()(state3, more, resume2, (state3$1, a$2) => done(state3$1, $15(a$2))));
            }
          ));
        }
      );
    },
    done
  );
}));
var parseExprAtom$lazy = /* @__PURE__ */ binding(() => lazyParser.defer((v) => (state1, more, resume2, done) => parseQualifiedIdent(
  (() => {
    if (state1.consumed) {
      return { consumed: false, errors: state1.errors, stream: state1.stream };
    }
    return state1;
  })(),
  more,
  (state3, error4) => {
    if (state3.consumed) {
      return resume2(state3, error4);
    }
    return parseQualifiedProper(
      (() => {
        if (state1.consumed) {
          return { consumed: false, errors: state1.errors, stream: state1.stream };
        }
        return state1;
      })(),
      more,
      (state3$1, error$1) => {
        if (state3$1.consumed) {
          return resume2(state3$1, error$1);
        }
        return parseQualifiedSymbol(
          (() => {
            if (state1.consumed) {
              return { consumed: false, errors: state1.errors, stream: state1.stream };
            }
            return state1;
          })(),
          more,
          (state3$2, error$2) => {
            if (state3$2.consumed) {
              return resume2(state3$2, error$2);
            }
            return tokUnderscore(
              (() => {
                if (state1.consumed) {
                  return { consumed: false, errors: state1.errors, stream: state1.stream };
                }
                return state1;
              })(),
              more,
              (state3$3, error$3) => {
                if (state3$3.consumed) {
                  return resume2(state3$3, error$3);
                }
                return parseHole(
                  (() => {
                    if (state1.consumed) {
                      return { consumed: false, errors: state1.errors, stream: state1.stream };
                    }
                    return state1;
                  })(),
                  more,
                  (state3$4, error$4) => {
                    if (state3$4.consumed) {
                      return resume2(state3$4, error$4);
                    }
                    return parseString(
                      (() => {
                        if (state1.consumed) {
                          return { consumed: false, errors: state1.errors, stream: state1.stream };
                        }
                        return state1;
                      })(),
                      more,
                      (state3$5, error$5) => {
                        if (state3$5.consumed) {
                          return resume2(state3$5, error$5);
                        }
                        return parseChar(
                          (() => {
                            if (state1.consumed) {
                              return { consumed: false, errors: state1.errors, stream: state1.stream };
                            }
                            return state1;
                          })(),
                          more,
                          (state3$6, error$6) => {
                            if (state3$6.consumed) {
                              return resume2(state3$6, error$6);
                            }
                            return parseBoolean(
                              (() => {
                                if (state1.consumed) {
                                  return { consumed: false, errors: state1.errors, stream: state1.stream };
                                }
                                return state1;
                              })(),
                              more,
                              (state3$7, error$7) => {
                                if (state3$7.consumed) {
                                  return resume2(state3$7, error$7);
                                }
                                return parseInt2(
                                  (() => {
                                    if (state1.consumed) {
                                      return { consumed: false, errors: state1.errors, stream: state1.stream };
                                    }
                                    return state1;
                                  })(),
                                  more,
                                  (state3$8, error$8) => {
                                    if (state3$8.consumed) {
                                      return resume2(state3$8, error$8);
                                    }
                                    return parseNumber(
                                      (() => {
                                        if (state1.consumed) {
                                          return { consumed: false, errors: state1.errors, stream: state1.stream };
                                        }
                                        return state1;
                                      })(),
                                      more,
                                      (state3$9, error$9) => {
                                        if (state3$9.consumed) {
                                          return resume2(state3$9, error$9);
                                        }
                                        return delimited(tokLeftSquare)(tokRightSquare)(tokComma)(parseExpr$lazy())(
                                          (() => {
                                            if (state1.consumed) {
                                              return { consumed: false, errors: state1.errors, stream: state1.stream };
                                            }
                                            return state1;
                                          })(),
                                          more,
                                          (state3$10, error$10) => {
                                            if (state3$10.consumed) {
                                              return resume2(state3$10, error$10);
                                            }
                                            return delimited(tokLeftBrace)(tokRightBrace)(tokComma)(parseRecordLabeled(parseExpr$lazy()))(
                                              (() => {
                                                if (state1.consumed) {
                                                  return { consumed: false, errors: state1.errors, stream: state1.stream };
                                                }
                                                return state1;
                                              })(),
                                              more,
                                              (state3$11, error$11) => {
                                                if (state3$11.consumed) {
                                                  return resume2(state3$11, error$11);
                                                }
                                                return parens(parseExpr$lazy())(state1, more, resume2, (state2, a) => done(state2, $Expr("ExprParens", a)));
                                              },
                                              (state2, a) => done(state2, $Expr("ExprRecord", a))
                                            );
                                          },
                                          (state2, a) => done(state2, $Expr("ExprArray", a))
                                        );
                                      },
                                      (state2, a) => done(state2, $Expr("ExprNumber", a._1, a._2))
                                    );
                                  },
                                  (state2, a) => done(state2, $Expr("ExprInt", a._1, a._2))
                                );
                              },
                              (state2, a) => done(state2, $Expr("ExprBoolean", a._1, a._2))
                            );
                          },
                          (state2, a) => done(state2, $Expr("ExprChar", a._1, a._2))
                        );
                      },
                      (state2, a) => done(state2, $Expr("ExprString", a._1, a._2))
                    );
                  },
                  (state2, a) => done(state2, $Expr("ExprHole", a))
                );
              },
              (state2, a) => done(state2, $Expr("ExprSection", a))
            );
          },
          (state2, a) => done(state2, $Expr("ExprOpName", a))
        );
      },
      (state2, a) => done(state2, $Expr("ExprConstructor", a))
    );
  },
  (state2, a) => done(state2, $Expr("ExprIdent", a))
)));
var parseExpr7$lazy = /* @__PURE__ */ binding(() => lazyParser.defer((v) => (state1, more, resume2, done) => parseExprAtom$lazy()(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => parseRecordAccessor(a)(
    (() => {
      if (state2.consumed) {
        return { consumed: false, errors: state2.errors, stream: state2.stream };
      }
      return state2;
    })(),
    more,
    (state3, error4) => {
      if (state3.consumed) {
        return resume2(state3, error4);
      }
      return done(state2, a);
    },
    done
  ))
)));
var parseExpr6$lazy = /* @__PURE__ */ binding(() => lazyParser.defer((v) => (state1, more, resume2, done) => parseExpr7$lazy()(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => parseRecordUpdates(a)(
    (() => {
      if (state2.consumed) {
        return { consumed: false, errors: state2.errors, stream: state2.stream };
      }
      return state2;
    })(),
    more,
    (state3, error4) => {
      if (state3.consumed) {
        return resume2(state3, error4);
      }
      return done(state2, a);
    },
    done
  ))
)));
var parseExpr5$lazy = /* @__PURE__ */ binding(() => lazyParser.defer((v) => (state1, more, resume2, done) => parseIf(
  (() => {
    if (state1.consumed) {
      return { consumed: false, errors: state1.errors, stream: state1.stream };
    }
    return state1;
  })(),
  more,
  (state3, error4) => {
    if (state3.consumed) {
      return resume2(state3, error4);
    }
    return parseLetIn(
      (() => {
        if (state1.consumed) {
          return { consumed: false, errors: state1.errors, stream: state1.stream };
        }
        return state1;
      })(),
      more,
      (state3$1, error$1) => {
        if (state3$1.consumed) {
          return resume2(state3$1, error$1);
        }
        return parseLambda(
          (() => {
            if (state1.consumed) {
              return { consumed: false, errors: state1.errors, stream: state1.stream };
            }
            return state1;
          })(),
          more,
          (state3$2, error$2) => {
            if (state3$2.consumed) {
              return resume2(state3$2, error$2);
            }
            return parseCase(
              (() => {
                if (state1.consumed) {
                  return { consumed: false, errors: state1.errors, stream: state1.stream };
                }
                return state1;
              })(),
              more,
              (state3$3, error$3) => {
                if (state3$3.consumed) {
                  return resume2(state3$3, error$3);
                }
                return parseDo(
                  (() => {
                    if (state1.consumed) {
                      return { consumed: false, errors: state1.errors, stream: state1.stream };
                    }
                    return state1;
                  })(),
                  more,
                  (state3$4, error$4) => {
                    if (state3$4.consumed) {
                      return resume2(state3$4, error$4);
                    }
                    return parseAdo(
                      (() => {
                        if (state1.consumed) {
                          return { consumed: false, errors: state1.errors, stream: state1.stream };
                        }
                        return state1;
                      })(),
                      more,
                      (state3$5, error$5) => {
                        if (state3$5.consumed) {
                          return resume2(state3$5, error$5);
                        }
                        return parseExpr6$lazy()(state1, more, resume2, done);
                      },
                      done
                    );
                  },
                  done
                );
              },
              done
            );
          },
          done
        );
      },
      done
    );
  },
  done
)));
var parseExpr4$lazy = /* @__PURE__ */ binding(() => lazyParser.defer((v) => (state1, more, resume2, done) => parseExpr5$lazy()(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => many3(parseExpr5$lazy())(
    state2,
    more,
    resume2,
    (state2$1, a$1) => more((v1$1) => done(
      state2$1,
      (() => {
        if (a$1.length > 0) {
          return $Expr("ExprApp", a, a$1);
        }
        return a;
      })()
    ))
  ))
)));
var parseExpr3$lazy = /* @__PURE__ */ binding(() => lazyParser.defer((v) => (state1, more, resume2, done) => tokKeyOperator("-")(
  (() => {
    if (state1.consumed) {
      return { consumed: false, errors: state1.errors, stream: state1.stream };
    }
    return state1;
  })(),
  more,
  (state3, error4) => {
    if (state3.consumed) {
      return resume2(state3, error4);
    }
    return parseExpr4$lazy()(state1, more, resume2, done);
  },
  (state2, a) => {
    const $7 = ExprNegate(a);
    return more((v2) => parseExpr3$lazy()(
      state2,
      more,
      (state3, error4) => {
        if (state3.consumed) {
          return resume2(state3, error4);
        }
        return parseExpr4$lazy()(state1, more, resume2, done);
      },
      (state3, a$1) => done(state3, $7(a$1))
    ));
  }
)));
var parseExpr2$lazy = /* @__PURE__ */ binding(() => lazyParser.defer((v) => (state1, more, resume2, done) => parseExpr3$lazy()(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => many3((state1$1, more$1, resume$1, done$1) => parseTickExpr(
    state1$1,
    more$1,
    resume$1,
    (state2$1, a$1) => {
      const $14 = Tuple(a$1);
      return more$1((v2) => parseExpr3$lazy()(state2$1, more$1, resume$1, (state3, a$2) => done$1(state3, $14(a$2))));
    }
  ))(
    state2,
    more,
    resume2,
    (state2$1, a$1) => more((v1$1) => done(
      state2$1,
      (() => {
        if (a$1.length > 0) {
          return $Expr("ExprInfix", a, a$1);
        }
        return a;
      })()
    ))
  ))
)));
var parseExpr1$lazy = /* @__PURE__ */ binding(() => lazyParser.defer((v) => (state1, more, resume2, done) => parseExpr2$lazy()(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => many3((state1$1, more$1, resume$1, done$1) => parseQualifiedOperator(
    state1$1,
    more$1,
    resume$1,
    (state2$1, a$1) => {
      const $14 = Tuple(a$1);
      return more$1((v2) => parseExpr2$lazy()(state2$1, more$1, resume$1, (state3, a$2) => done$1(state3, $14(a$2))));
    }
  ))(
    state2,
    more,
    resume2,
    (state2$1, a$1) => more((v1$1) => done(
      state2$1,
      (() => {
        if (a$1.length > 0) {
          return $Expr("ExprOp", a, a$1);
        }
        return a;
      })()
    ))
  ))
)));
var parseExpr$lazy = /* @__PURE__ */ binding(() => lazyParser.defer((v) => (state1, more, resume2, done) => parseExpr1$lazy()(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => {
    const $8 = ExprTyped(a);
    return tokDoubleColon(
      (() => {
        if (state2.consumed) {
          return { consumed: false, errors: state2.errors, stream: state2.stream };
        }
        return state2;
      })(),
      more,
      (state3, error4) => {
        if (state3.consumed) {
          return resume2(state3, error4);
        }
        return done(state2, a);
      },
      (state2$1, a$1) => {
        const $11 = $8(a$1);
        return more((v2) => parseType(
          state2$1,
          more,
          (state3, error4) => {
            if (state3.consumed) {
              return resume2(state3, error4);
            }
            return done(state2, a);
          },
          (state3, a$2) => done(state3, $11(a$2))
        ));
      }
    );
  })
)));
var parseDoStatement$lazy = /* @__PURE__ */ binding(() => lazyParser.defer((v) => {
  const $1 = layoutNonEmpty(recoverIndent(LetBindingError)(parseLetBinding$lazy()));
  return (state1, more, resume2, done) => {
    const $6 = (state3, error4) => {
      if (state3.consumed) {
        return resume2(state3, error4);
      }
      const $8 = (state3$1, error$1) => {
        if (state3$1.consumed) {
          return resume2(state3$1, error$1);
        }
        return parseExpr$lazy()(state1, more, resume2, (state2, a) => done(state2, $DoStatement("DoDiscard", a)));
      };
      const $9 = (() => {
        if (state1.consumed) {
          return { consumed: false, errors: state1.errors, stream: state1.stream };
        }
        return state1;
      })();
      return parseBinder(
        $9,
        more,
        (state2, error$1) => $8({ consumed: $9.consumed, errors: state2.errors, stream: state2.stream }, error$1),
        (state2, a) => {
          const $12 = Tuple(a);
          return more((v2) => tokLeftArrow(
            state2,
            more,
            (state2$1, error$1) => $8({ consumed: $9.consumed, errors: state2$1.errors, stream: state2$1.stream }, error$1),
            (state3$1, a$1) => {
              const $16 = $12(a$1);
              const $17 = DoBind($16._1)($16._2);
              return more((v2$1) => parseExpr$lazy()(state3$1, more, $8, (state3$2, a$2) => done(state3$2, $17(a$2))));
            }
          ));
        }
      );
    };
    return tokKeyword("let")(
      (() => {
        if (state1.consumed) {
          return { consumed: false, errors: state1.errors, stream: state1.stream };
        }
        return state1;
      })(),
      more,
      $6,
      (state2, a) => {
        const $9 = DoLet(a);
        return more((v2) => $1(state2, more, $6, (state3, a$1) => done(state3, $9(a$1))));
      }
    );
  };
}));
var parseCaseBranches$lazy = /* @__PURE__ */ binding(() => lazyParser.defer((v) => layoutNonEmpty((() => {
  const $1 = separated(tokComma)(parseBinder1);
  const $2 = parseGuarded(tokRightArrow);
  return (state1, more, resume2, done) => $1(
    state1,
    more,
    resume2,
    (state2, a) => {
      const $9 = Tuple(a);
      return more((v2) => $2(state2, more, resume2, (state3, a$1) => done(state3, $9(a$1))));
    }
  );
})())));
var parseDeclValue1 = (name2) => (state1, more, resume2, done) => many3(parseBinderAtom)(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => parseGuarded(tokEquals)(
    state2,
    more,
    resume2,
    (state2$1, a$1) => more((v1$1) => done(state2$1, $Declaration("DeclValue", { name: name2, binders: a, guarded: a$1 })))
  ))
);
var parseDeclValue = (state1, more, resume2, done) => parseIdent(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => parseDeclSignature(a)(
    (() => {
      if (state2.consumed) {
        return { consumed: false, errors: state2.errors, stream: state2.stream };
      }
      return state2;
    })(),
    more,
    (state3, error4) => {
      if (state3.consumed) {
        return resume2(state3, error4);
      }
      return parseDeclValue1(a)(state2, more, resume2, done);
    },
    done
  ))
);
var parseInstanceBindingName = (name2) => (state1, more, resume2, done) => many3(parseBinderAtom)(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => parseGuarded(tokEquals)(
    state2,
    more,
    resume2,
    (state2$1, a$1) => more((v1$1) => done(state2$1, $InstanceBinding("InstanceBindingName", { name: name2, binders: a, guarded: a$1 })))
  ))
);
var parseInstanceBinding = (state1, more, resume2, done) => parseIdent(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => parseInstanceBindingSignature(a)(
    (() => {
      if (state2.consumed) {
        return { consumed: false, errors: state2.errors, stream: state2.stream };
      }
      return state2;
    })(),
    more,
    (state3, error4) => {
      if (state3.consumed) {
        return resume2(state3, error4);
      }
      return parseInstanceBindingName(a)(state2, more, resume2, done);
    },
    done
  ))
);
var parseInstance = (state1, more, resume2, done) => tokKeyword("instance")(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => optional2(parseInstanceName)(
    state2,
    more,
    resume2,
    (state2$1, a$1) => more((v1$1) => optional2((() => {
      const $10 = parseClassConstraints(parseType3);
      return (state1$1, more$1, resume$1, done$1) => $10(
        state1$1,
        more$1,
        (state2$2, error4) => resume$1({ consumed: state1$1.consumed, errors: state2$2.errors, stream: state2$2.stream }, error4),
        (state2$2, a$2) => {
          const $17 = Tuple(a$2);
          return more$1((v2) => tokRightFatArrow(
            state2$2,
            more$1,
            (state2$3, error4) => resume$1({ consumed: state1$1.consumed, errors: state2$3.errors, stream: state2$3.stream }, error4),
            (state3, a$3) => done$1(state3, $17(a$3))
          ));
        }
      );
    })())(
      state2$1,
      more,
      resume2,
      (state2$2, a$2) => more((v1$2) => parseQualifiedProper(
        state2$2,
        more,
        resume2,
        (state2$3, a$3) => more((v1$3) => many3(parseTypeAtom)(
          state2$3,
          more,
          resume2,
          (state2$4, a$4) => more((v1$4) => optional2((() => {
            const $19 = layoutNonEmpty(parseInstanceBinding);
            return (state1$1, more$1, resume$1, done$1) => tokKeyword("where")(
              state1$1,
              more$1,
              resume$1,
              (state2$5, a$5) => {
                const $26 = Tuple(a$5);
                return more$1((v2) => $19(state2$5, more$1, resume$1, (state3, a$6) => done$1(state3, $26(a$6))));
              }
            );
          })())(state2$4, more, resume2, (state2$5, a$5) => more((v1$5) => done(state2$5, { head: { keyword: a, name: a$1, constraints: a$2, className: a$3, types: a$4 }, body: a$5 }))))
        ))
      ))
    ))
  ))
);
var parseDeclInstanceChain = /* @__PURE__ */ (() => {
  const $0 = separated(parseInstanceChainSeparator)(parseInstance);
  return (state1, more, resume2, done) => $0(state1, more, resume2, (state2, a) => done(state2, $Declaration("DeclInstanceChain", a)));
})();
var parseDeclClass1 = (keyword) => {
  const $1 = optional2((() => {
    const $12 = parseClassConstraints(parseType5);
    return (state1, more, resume2, done) => $12(
      state1,
      more,
      (state2, error4) => resume2({ consumed: state1.consumed, errors: state2.errors, stream: state2.stream }, error4),
      (state2, a) => {
        const $8 = Tuple(a);
        return more((v2) => tokLeftFatArrow(
          state2,
          more,
          (state2$1, error4) => resume2({ consumed: state1.consumed, errors: state2$1.errors, stream: state2$1.stream }, error4),
          (state3, a$1) => done(state3, $8(a$1))
        ));
      }
    );
  })());
  return (state1, more, resume2, done) => $1(
    state1,
    more,
    resume2,
    (state2, a) => more((v1) => parseProper(
      state2,
      more,
      resume2,
      (state2$1, a$1) => more((v1$1) => many3(parseTypeVarBinding)(
        state2$1,
        more,
        resume2,
        (state2$2, a$2) => more((v1$2) => optional2((() => {
          const $15 = separated(tokComma)(parseFundep);
          return (state1$1, more$1, resume$1, done$1) => tokPipe(
            state1$1,
            more$1,
            resume$1,
            (state2$3, a$3) => {
              const $22 = Tuple(a$3);
              return more$1((v2) => $15(state2$3, more$1, resume$1, (state3, a$4) => done$1(state3, $22(a$4))));
            }
          );
        })())(
          state2$2,
          more,
          resume2,
          (state2$3, a$3) => more((v1$3) => optional2((() => {
            const $18 = layoutNonEmpty(parseClassMember);
            return (state1$1, more$1, resume$1, done$1) => tokKeyword("where")(
              state1$1,
              more$1,
              resume$1,
              (state2$4, a$4) => {
                const $25 = Tuple(a$4);
                return more$1((v2) => $18(state2$4, more$1, resume$1, (state3, a$5) => done$1(state3, $25(a$5))));
              }
            );
          })())(
            state2$3,
            more,
            resume2,
            (state2$4, a$4) => more((v1$4) => done(state2$4, $Declaration("DeclClass", { keyword, super: a, name: a$1, vars: a$2, fundeps: a$3 }, a$4)))
          ))
        ))
      ))
    ))
  );
};
var parseDeclClass = (state1, more, resume2, done) => tokKeyword("class")(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => {
    const $7 = parseDeclClass1(a);
    return parseDeclClassSignature(a)(
      (() => {
        if (state2.consumed) {
          return { consumed: false, errors: state2.errors, stream: state2.stream };
        }
        return state2;
      })(),
      more,
      (state3, error4) => {
        if (state3.consumed) {
          return resume2(state3, error4);
        }
        return $7(state2, more, resume2, done);
      },
      done
    );
  })
);
var parseDeclData1 = (keyword) => (name2) => (state1, more, resume2, done) => many3(parseTypeVarBinding)(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => optional2((() => {
    const $9 = separated(tokPipe)(parseDataCtor);
    return (state1$1, more$1, resume$1, done$1) => tokEquals(
      state1$1,
      more$1,
      resume$1,
      (state2$1, a$1) => {
        const $16 = Tuple(a$1);
        return more$1((v2) => $9(state2$1, more$1, resume$1, (state3, a$2) => done$1(state3, $16(a$2))));
      }
    );
  })())(state2, more, resume2, (state2$1, a$1) => more((v1$1) => done(state2$1, $Declaration("DeclData", { keyword, name: name2, vars: a }, a$1)))))
);
var parseDeclData = (state1, more, resume2, done) => tokKeyword("data")(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => parseProper(
    state2,
    more,
    resume2,
    (state2$1, a$1) => more((v1$1) => parseDeclKindSignature(a)(a$1)(
      (() => {
        if (state2$1.consumed) {
          return { consumed: false, errors: state2$1.errors, stream: state2$1.stream };
        }
        return state2$1;
      })(),
      more,
      (state3, error4) => {
        if (state3.consumed) {
          return resume2(state3, error4);
        }
        return parseDeclData1(a)(a$1)(state2$1, more, resume2, done);
      },
      done
    ))
  ))
);
var parseDeclNewtype1 = (keyword) => (name2) => (state1, more, resume2, done) => many3(parseTypeVarBinding)(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => tokEquals(
    state2,
    more,
    resume2,
    (state2$1, a$1) => more((v1$1) => parseProper(
      state2$1,
      more,
      resume2,
      (state2$2, a$2) => more((v1$2) => parseTypeAtom(
        state2$2,
        more,
        resume2,
        (state2$3, a$3) => more((v1$3) => done(state2$3, $Declaration("DeclNewtype", { keyword, name: name2, vars: a }, a$1, a$2, a$3)))
      ))
    ))
  ))
);
var parseDeclNewtype = (state1, more, resume2, done) => tokKeyword("newtype")(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => parseProper(
    state2,
    more,
    resume2,
    (state2$1, a$1) => more((v1$1) => parseDeclKindSignature(a)(a$1)(
      (() => {
        if (state2$1.consumed) {
          return { consumed: false, errors: state2$1.errors, stream: state2$1.stream };
        }
        return state2$1;
      })(),
      more,
      (state3, error4) => {
        if (state3.consumed) {
          return resume2(state3, error4);
        }
        return parseDeclNewtype1(a)(a$1)(state2$1, more, resume2, done);
      },
      done
    ))
  ))
);
var parseDeclType2 = (keyword) => (name2) => (state1, more, resume2, done) => many3(parseTypeVarBinding)(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => tokEquals(
    state2,
    more,
    resume2,
    (state2$1, a$1) => more((v1$1) => parseType(
      state2$1,
      more,
      resume2,
      (state2$2, a$2) => more((v1$2) => done(state2$2, $Declaration("DeclType", { keyword, name: name2, vars: a }, a$1, a$2)))
    ))
  ))
);
var parseDeclType1 = (keyword) => (state1, more, resume2, done) => parseProper(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => parseDeclKindSignature(keyword)(a)(
    (() => {
      if (state2.consumed) {
        return { consumed: false, errors: state2.errors, stream: state2.stream };
      }
      return state2;
    })(),
    more,
    (state3, error4) => {
      if (state3.consumed) {
        return resume2(state3, error4);
      }
      return parseDeclType2(keyword)(a)(state2, more, resume2, done);
    },
    done
  ))
);
var parseDeclType = (state1, more, resume2, done) => tokKeyword("type")(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => parseDeclRole(a)(
    (() => {
      if (state2.consumed) {
        return { consumed: false, errors: state2.errors, stream: state2.stream };
      }
      return state2;
    })(),
    more,
    (state3, error4) => {
      if (state3.consumed) {
        return resume2(state3, error4);
      }
      return parseDeclType1(a)(state2, more, resume2, done);
    },
    done
  ))
);
var parseDecl = (state1, more, resume2, done) => parseDeclData(
  (() => {
    if (state1.consumed) {
      return { consumed: false, errors: state1.errors, stream: state1.stream };
    }
    return state1;
  })(),
  more,
  (state3, error4) => {
    if (state3.consumed) {
      return resume2(state3, error4);
    }
    return parseDeclNewtype(
      (() => {
        if (state1.consumed) {
          return { consumed: false, errors: state1.errors, stream: state1.stream };
        }
        return state1;
      })(),
      more,
      (state3$1, error$1) => {
        if (state3$1.consumed) {
          return resume2(state3$1, error$1);
        }
        return parseDeclType(
          (() => {
            if (state1.consumed) {
              return { consumed: false, errors: state1.errors, stream: state1.stream };
            }
            return state1;
          })(),
          more,
          (state3$2, error$2) => {
            if (state3$2.consumed) {
              return resume2(state3$2, error$2);
            }
            return parseDeclClass(
              (() => {
                if (state1.consumed) {
                  return { consumed: false, errors: state1.errors, stream: state1.stream };
                }
                return state1;
              })(),
              more,
              (state3$3, error$3) => {
                if (state3$3.consumed) {
                  return resume2(state3$3, error$3);
                }
                return parseDeclInstanceChain(
                  (() => {
                    if (state1.consumed) {
                      return { consumed: false, errors: state1.errors, stream: state1.stream };
                    }
                    return state1;
                  })(),
                  more,
                  (state3$4, error$4) => {
                    if (state3$4.consumed) {
                      return resume2(state3$4, error$4);
                    }
                    return parseDeclDerive(
                      (() => {
                        if (state1.consumed) {
                          return { consumed: false, errors: state1.errors, stream: state1.stream };
                        }
                        return state1;
                      })(),
                      more,
                      (state3$5, error$5) => {
                        if (state3$5.consumed) {
                          return resume2(state3$5, error$5);
                        }
                        return parseDeclValue(
                          (() => {
                            if (state1.consumed) {
                              return { consumed: false, errors: state1.errors, stream: state1.stream };
                            }
                            return state1;
                          })(),
                          more,
                          (state3$6, error$6) => {
                            if (state3$6.consumed) {
                              return resume2(state3$6, error$6);
                            }
                            return parseDeclForeign(
                              (() => {
                                if (state1.consumed) {
                                  return { consumed: false, errors: state1.errors, stream: state1.stream };
                                }
                                return state1;
                              })(),
                              more,
                              (state3$7, error$7) => {
                                if (state3$7.consumed) {
                                  return resume2(state3$7, error$7);
                                }
                                return parseDeclFixity(state1, more, resume2, done);
                              },
                              done
                            );
                          },
                          done
                        );
                      },
                      done
                    );
                  },
                  done
                );
              },
              done
            );
          },
          done
        );
      },
      done
    );
  },
  done
);
var parseModuleDecls = /* @__PURE__ */ many3((state1, more, resume2, done) => recoverIndent(DeclError)(parseDecl)(
  state1,
  more,
  resume2,
  (state2, a) => more((v2) => tokLayoutSep(
    (() => {
      if (state2.consumed) {
        return { consumed: false, errors: state2.errors, stream: state2.stream };
      }
      return state2;
    })(),
    more,
    (state3, error4) => {
      if (state3.consumed) {
        return resume2(state3, error4);
      }
      return tokLayoutEnd(state2, more, (v1, error$1) => resume2(state2, error$1), (v1, value) => done(state2, a));
    },
    (state3, a$1) => done(state3, a)
  ))
));
var parseModuleBody = (state1, more, resume2, done) => parseModuleDecls(
  state1,
  more,
  resume2,
  (state2, a) => more((v2) => tokLayoutEnd(
    state2,
    more,
    resume2,
    (state3, a$1) => more((v1) => eof(
      state3,
      more,
      resume2,
      (state2$1, a$2) => more((v1$1) => done(state2$1, { decls: a, trailingComments: a$2._2, end: a$2._1 }))
    ))
  ))
);
var parseModule = (state1, more, resume2, done) => parseModuleHeader(
  state1,
  more,
  resume2,
  (state2, a) => more((v1) => parseModuleBody(state2, more, resume2, (state2$1, a$1) => more((v1$1) => done(state2$1, { header: a, body: a$1 }))))
);

// output-es/PureScript.CST/index.js
var $RecoveredParserResult = (tag, _1, _2) => ({ tag, _1, _2 });
var toRecoveredParserResult = (v) => {
  if (v.tag === "Right") {
    if (v._1._2.length > 0) {
      return $RecoveredParserResult("ParseSucceededWithErrors", v._1._1, v._1._2);
    }
    if (v.tag === "Right") {
      return $RecoveredParserResult("ParseSucceeded", v._1._1);
    }
    if (v.tag === "Left") {
      return $RecoveredParserResult("ParseFailed", v._1);
    }
    fail();
  }
  if (v.tag === "Right") {
    return $RecoveredParserResult("ParseSucceeded", v._1._1);
  }
  if (v.tag === "Left") {
    return $RecoveredParserResult("ParseFailed", v._1);
  }
  fail();
};
var runRecoveredParser = (p) => (x) => toRecoveredParserResult(fromParserResult(runParser$p({
  consumed: false,
  errors: [],
  stream: lex(x)
})(p)));

// output-es/Tidy.Operators/index.js
var ordMaybe3 = /* @__PURE__ */ ordMaybe(ordString);
var union3 = /* @__PURE__ */ union(/* @__PURE__ */ ordTuple(ordOperatorNamespace)(ordString));
var resolveOperatorExports = (precMap) => (v) => {
  const remappedPrecMap = remapOperators(precMap)(v);
  if (v.header.exports.tag === "Nothing") {
    return foldlArray((pm) => (v1) => {
      if (v1.tag === "DeclFixity") {
        if (v1._1.operator.tag === "FixityValue") {
          return insertOperator($QualifiedOperator(
            $Maybe("Just", v.header.name.name),
            OperatorValue,
            v1._1.operator._3.name
          ))(v1._1.prec._2)(pm);
        }
        if (v1._1.operator.tag === "FixityType") {
          return insertOperator($QualifiedOperator(
            $Maybe("Just", v.header.name.name),
            OperatorType,
            v1._1.operator._4.name
          ))(v1._1.prec._2)(pm);
        }
        fail();
      }
      return pm;
    })(precMap)(v.body.decls);
  }
  if (v.header.exports.tag === "Just") {
    return foldlArray((pm) => (x) => {
      if (x.tag === "ExportOp") {
        const $5 = lookupOperator($QualifiedOperator(Nothing, OperatorValue, x._1.name))(remappedPrecMap);
        if ($5.tag === "Just") {
          return insertOperator($QualifiedOperator($Maybe("Just", v.header.name.name), OperatorValue, x._1.name))($5._1)(pm);
        }
        if ($5.tag === "Nothing") {
          return pm;
        }
        fail();
      }
      if (x.tag === "ExportTypeOp") {
        const $5 = lookupOperator($QualifiedOperator(Nothing, OperatorType, x._2.name))(remappedPrecMap);
        if ($5.tag === "Just") {
          return insertOperator($QualifiedOperator($Maybe("Just", v.header.name.name), OperatorType, x._2.name))($5._1)(pm);
        }
        if ($5.tag === "Nothing") {
          return pm;
        }
        fail();
      }
      if (x.tag === "ExportModule") {
        const $5 = lookup(ordMaybe3)($Maybe("Just", x._2.name))(remappedPrecMap);
        if ($5.tag === "Just") {
          return insertWith(ordMaybe3)(union3)($Maybe("Just", v.header.name.name))($5._1)(pm);
        }
        if ($5.tag === "Nothing") {
          return pm;
        }
        fail();
      }
      return pm;
    })(precMap)(concatArray([v.header.exports._1.value.head])(arrayMap(snd)(v.header.exports._1.value.tail)));
  }
  fail();
};
var parseOperatorPrec = /* @__PURE__ */ (() => {
  const $0 = (() => {
    const go = (go$a0$copy) => (go$a1$copy) => {
      let go$a0 = go$a0$copy, go$a1 = go$a1$copy, go$c = true, go$r;
      while (go$c) {
        const acc = go$a0, x = go$a1;
        const $3 = force(x);
        if ($3.tag === "TokenEOF") {
          go$c = false;
          go$r = $Either("Right", acc);
          continue;
        }
        if ($3.tag === "TokenError") {
          go$c = false;
          go$r = $Either("Left", $3._2);
          continue;
        }
        if ($3.tag === "TokenCons") {
          go$a0 = run(withArray(pushAll([$3._1.value]))(acc));
          go$a1 = $3._3;
          continue;
        }
        fail();
      }
      ;
      return go$r;
    };
    return go([]);
  })();
  return (x) => {
    const $2 = $0(lex(x));
    if ($2.tag === "Right") {
      if ($2._1.length === 2) {
        if ($2._1[0].tag === "TokSymbolName") {
          if ($2._1[1].tag === "TokInt") {
            if ($2._1[1]._2.tag === "SmallInt") {
              return $Maybe("Just", $Tuple($QualifiedOperator($2._1[0]._1, OperatorValue, $2._1[0]._2), $2._1[1]._2._1));
            }
            return Nothing;
          }
          return Nothing;
        }
        return Nothing;
      }
      if ($2._1.length === 3) {
        if ($2._1[0].tag === "TokSymbolName") {
          if ($2._1[1].tag === "TokLowerName") {
            if ($2._1[1]._1.tag === "Nothing") {
              if ($2._1[1]._2 === "type") {
                if ($2._1[2].tag === "TokInt") {
                  if ($2._1[2]._2.tag === "SmallInt") {
                    return $Maybe(
                      "Just",
                      $Tuple($QualifiedOperator($2._1[0]._1, OperatorType, $2._1[0]._2), $2._1[2]._2._1)
                    );
                  }
                  return Nothing;
                }
                return Nothing;
              }
              return Nothing;
            }
            return Nothing;
          }
          return Nothing;
        }
        return Nothing;
      }
      return Nothing;
    }
    return Nothing;
  };
})();
var parseOperatorTable = /* @__PURE__ */ (() => {
  const $0 = foldrArray((v) => insertOperator(v._1)(v._2))(Leaf2);
  return (x) => $0(mapMaybe(parseOperatorPrec)(x));
})();

// output-es/Bin.Worker/index.js
var power5 = /* @__PURE__ */ power(monoidString);
var toWorkerConfig = (options) => ({
  importSort: (() => {
    if (options.importSort.tag === "ImportSortSource") {
      return "source";
    }
    if (options.importSort.tag === "ImportSortIde") {
      return "ide";
    }
    fail();
  })(),
  importWrap: (() => {
    if (options.importWrap.tag === "ImportWrapSource") {
      return "source";
    }
    if (options.importWrap.tag === "ImportWrapAuto") {
      return "auto";
    }
    fail();
  })(),
  indent: options.indent,
  operatorsFile: (() => {
    if (options.operatorsFile.tag === "Nothing") {
      return ".tidyoperators.default";
    }
    if (options.operatorsFile.tag === "Just") {
      return options.operatorsFile._1;
    }
    fail();
  })(),
  ribbon: options.ribbon,
  typeArrowPlacement: (() => {
    if (options.typeArrowPlacement.tag === "TypeArrowFirst") {
      return "first";
    }
    if (options.typeArrowPlacement.tag === "TypeArrowLast") {
      return "last";
    }
    fail();
  })(),
  unicode: (() => {
    if (options.unicode.tag === "UnicodeSource") {
      return "source";
    }
    if (options.unicode.tag === "UnicodeAlways") {
      return "always";
    }
    if (options.unicode.tag === "UnicodeNever") {
      return "never";
    }
    fail();
  })(),
  width: (() => {
    if (options.width.tag === "Nothing") {
      return 2147483647;
    }
    if (options.width.tag === "Just") {
      return options.width._1;
    }
    fail();
  })()
});
var formatCommand = (args) => (operators) => (contents) => {
  const print2 = print(plainText)({
    pageWidth: (() => {
      if (args.width.tag === "Nothing") {
        return 2147483647;
      }
      if (args.width.tag === "Just") {
        return args.width._1;
      }
      fail();
    })(),
    ribbonRatio: args.ribbon,
    indentWidth: args.indent,
    indentUnit: power5(" ")(args.indent)
  });
  const v = runRecoveredParser(parseModule)(contents);
  if (v.tag === "ParseSucceeded") {
    return $Either(
      "Right",
      print2(toDoc(formatModule({
        importSort: args.importSort,
        importWrap: args.importWrap,
        operators: remapOperators(operators)(v._1),
        typeArrowPlacement: args.typeArrowPlacement,
        unicode: args.unicode,
        formatError: absurd
      })(v._1)))
    );
  }
  if (v.tag === "ParseSucceededWithErrors") {
    return $Either(
      "Left",
      (() => {
        const $5 = index(v._2)(0);
        if ($5.tag === "Just") {
          return $5._1.error;
        }
        fail();
      })()
    );
  }
  if (v.tag === "ParseFailed") {
    return $Either("Left", v._1.error);
  }
  fail();
};
var formatInPlaceCommand = (shouldCheck) => (operators) => (v) => {
  const formatOptions2 = {
    importSort: (() => {
      const $3 = importSortFromString(v.config.importSort);
      if ($3.tag === "Right") {
        return $3._1;
      }
      return _crashWith("Unknown importSort value");
    })(),
    importWrap: (() => {
      const $3 = importWrapFromString(v.config.importWrap);
      if ($3.tag === "Right") {
        return $3._1;
      }
      return _crashWith("Unknown importWrap value");
    })(),
    indent: v.config.indent,
    operatorsFile: Nothing,
    ribbon: v.config.ribbon,
    typeArrowPlacement: (() => {
      const $3 = typeArrowPlacementFromString(v.config.typeArrowPlacement);
      if ($3.tag === "Right") {
        return $3._1;
      }
      return _crashWith("Unknown typeArrowPlacement value");
    })(),
    unicode: (() => {
      const $3 = unicodeFromString(v.config.unicode);
      if ($3.tag === "Right") {
        return $3._1;
      }
      return _crashWith("Unknown unicode value");
    })(),
    width: $Maybe("Just", v.config.width)
  };
  return _bind(toAff2(readTextFile)(UTF8)(v.filePath))((contents) => _bind(_liftEffect(hrtime))((start) => {
    const v1 = formatCommand(formatOptions2)(operators)(contents);
    if (v1.tag === "Right") {
      return _bind(_map((x) => x.seconds * 1e3 + x.nanos / 1e6)(_liftEffect(hrtimeDiff(start))))((timing) => {
        if (shouldCheck) {
          return _pure({ filePath: v.filePath, error: "", alreadyFormatted: v1._1 === contents, timing });
        }
        return _bind(toAff3(writeTextFile)(UTF8)(v.filePath)(v1._1))(() => _pure({
          filePath: v.filePath,
          error: "",
          alreadyFormatted: false,
          timing
        }));
      });
    }
    if (v1.tag === "Left") {
      return _pure({ filePath: v.filePath, error: printParseError(v1._1), alreadyFormatted: false, timing: 0 });
    }
    fail();
  }));
};

// output-es/Control.Monad.State.Trans/index.js
var monadTransStateT = {
  lift: (dictMonad) => {
    const bind = dictMonad.Bind1().bind;
    const pure = dictMonad.Applicative0().pure;
    return (m) => (s) => bind(m)((x) => pure($Tuple(x, s)));
  }
};
var functorStateT = (dictFunctor) => ({ map: (f) => (v) => (s) => dictFunctor.map((v1) => $Tuple(f(v1._1), v1._2))(v(s)) });
var monadStateT = (dictMonad) => ({ Applicative0: () => applicativeStateT(dictMonad), Bind1: () => bindStateT(dictMonad) });
var bindStateT = (dictMonad) => {
  const bind = dictMonad.Bind1().bind;
  return { bind: (v) => (f) => (s) => bind(v(s))((v1) => f(v1._1)(v1._2)), Apply0: () => applyStateT(dictMonad) };
};
var applyStateT = (dictMonad) => {
  const functorStateT1 = functorStateT(dictMonad.Bind1().Apply0().Functor0());
  return {
    apply: (() => {
      const $2 = monadStateT(dictMonad);
      const bind = $2.Bind1().bind;
      const pure = $2.Applicative0().pure;
      return (f) => (a) => bind(f)((f$p) => bind(a)((a$p) => pure(f$p(a$p))));
    })(),
    Functor0: () => functorStateT1
  };
};
var applicativeStateT = (dictMonad) => {
  const pure = dictMonad.Applicative0().pure;
  return { pure: (a) => (s) => pure($Tuple(a, s)), Apply0: () => applyStateT(dictMonad) };
};
var monadStateStateT = (dictMonad) => {
  const pure = dictMonad.Applicative0().pure;
  const monadStateT1 = monadStateT(dictMonad);
  return { state: (f) => (x) => pure(f(x)), Monad0: () => monadStateT1 };
};

// output-es/Data.Argonaut.Parser/foreign.js
function _jsonParser(fail2, succ, s) {
  try {
    return succ(JSON.parse(s));
  } catch (e) {
    return fail2(e.message);
  }
}

// output-es/Data.Number.Format/foreign.js
function wrap(method) {
  return function(d) {
    return function(num) {
      return method.apply(num, [d]);
    };
  };
}
var toPrecisionNative = wrap(Number.prototype.toPrecision);
var toFixedNative = wrap(Number.prototype.toFixed);
var toExponentialNative = wrap(Number.prototype.toExponential);

// output-es/Data.Number.Format/index.js
var $Format = (tag, _1) => ({ tag, _1 });
var clamp = (low) => (hi) => (x) => {
  const v = ordInt.compare(low)(x);
  const $4 = (() => {
    if (v.tag === "LT") {
      return x;
    }
    if (v.tag === "EQ") {
      return low;
    }
    if (v.tag === "GT") {
      return low;
    }
    fail();
  })();
  const v$1 = ordInt.compare(hi)($4);
  if (v$1.tag === "LT") {
    return hi;
  }
  if (v$1.tag === "EQ") {
    return hi;
  }
  if (v$1.tag === "GT") {
    return $4;
  }
  fail();
};
var toStringWith = (v) => {
  if (v.tag === "Precision") {
    return toPrecisionNative(v._1);
  }
  if (v.tag === "Fixed") {
    return toFixedNative(v._1);
  }
  if (v.tag === "Exponential") {
    return toExponentialNative(v._1);
  }
  fail();
};

// output-es/Effect.Class/index.js
var monadEffectEffect = { liftEffect: (x) => x, Monad0: () => monadEffect };

// output-es/Effect.Console/foreign.js
var log2 = function(s) {
  return function() {
    console.log(s);
  };
};
var error2 = function(s) {
  return function() {
    console.error(s);
  };
};

// output-es/Effect.Class.Console/index.js
var error3 = (dictMonadEffect) => (x) => dictMonadEffect.liftEffect(error2(x));

// output-es/Data.Map/index.js
var monoidSemigroupMap = (dictOrd) => (dictSemigroup) => {
  const semigroupSemigroupMap2 = { append: (v) => (v1) => unionWith(dictOrd)(dictSemigroup.append)(v)(v1) };
  return { mempty: Leaf2, Semigroup0: () => semigroupSemigroupMap2 };
};
var keys2 = (x) => functorMap.map((v) => unit)(x);

// output-es/Node.Path/foreign.js
import path from "path";
var normalize = path.normalize;
function concat4(segments) {
  return path.join.apply(this, segments);
}
function relative(from) {
  return (to) => path.relative(from, to);
}
function dirname(p) {
  return path.normalize(path.dirname(p));
}
var basename = path.basename;
var extname = path.extname;
var sep = path.sep;
var delimiter = path.delimiter;
var parse2 = path.parse;
var isAbsolute = path.isAbsolute;

// output-es/Node.Process/foreign.js
import process3 from "process";
function exit(code) {
  return () => {
    process3.exit(code);
  };
}
function copyArray(xs) {
  return () => xs.slice();
}

// output-es/Node.Process/index.js
var lookupMutableObject = (k) => (o) => (v) => _lookup(Nothing, Just, k, o);
var lookupEnv = (k) => lookupMutableObject(k)(process3.env);
var argv = /* @__PURE__ */ (() => copyArray(process3.argv))();

// output-es/Node.Glob.Basic/index.js
var $Glob = (tag, _1) => ({ tag, _1 });
var $Match = (tag, _1, _2) => ({ tag, _1, _2 });
var fromFoldable1 = /* @__PURE__ */ foldrArray(Cons)(Nil);
var compare2 = /* @__PURE__ */ (() => ordList(ordString).compare)();
var forWithIndex_2 = /* @__PURE__ */ forWithIndex_(applicativeParAff);
var forWithIndex_1 = /* @__PURE__ */ forWithIndex_2(foldableWithIndexMap);
var mempty = /* @__PURE__ */ (() => monoidAff(monoidUnit).mempty)();
var forWithIndex_22 = /* @__PURE__ */ forWithIndex_2(foldableWithIndexMap);
var GlobStar = /* @__PURE__ */ $Glob("GlobStar");
var Match = /* @__PURE__ */ $Match("Match");
var rootOrRelative = (pwd) => (v) => {
  if (v.tag === "Cons") {
    if (v._1.tag === "GlobSegment") {
      if (v._1._1.tag === "Cons") {
        if (v._1._1._1 === "") {
          if (v._1._1._2.tag === "Nil") {
            return $Tuple(sep, $Map("Two", Leaf2, v._2, unit, Leaf2));
          }
          return $Tuple(pwd, $Map("Two", Leaf2, v, unit, Leaf2));
        }
        return $Tuple(pwd, $Map("Two", Leaf2, v, unit, Leaf2));
      }
      return $Tuple(pwd, $Map("Two", Leaf2, v, unit, Leaf2));
    }
    return $Tuple(pwd, $Map("Two", Leaf2, v, unit, Leaf2));
  }
  return $Tuple(pwd, $Map("Two", Leaf2, v, unit, Leaf2));
};
var matchSegment = /* @__PURE__ */ (() => {
  const go2 = (go2$a0$copy) => (go2$a1$copy) => {
    let go2$a0 = go2$a0$copy, go2$a1 = go2$a1$copy, go2$c = true, go2$r;
    while (go2$c) {
      const str = go2$a0, v = go2$a1;
      if (v.tag === "Nil") {
        go2$c = false;
        go2$r = str === "";
        continue;
      }
      if (v.tag === "Cons") {
        if (v._1 === "") {
          if (v._2.tag === "Nil") {
            go2$c = false;
            go2$r = true;
            continue;
          }
          go2$a0 = str;
          go2$a1 = v._2;
          continue;
        }
        const v1 = indexOf(v._1)(str);
        if (v1.tag === "Nothing") {
          go2$c = false;
          go2$r = false;
          continue;
        }
        if (v1.tag === "Just") {
          go2$a0 = drop2(v1._1 + length2(v._1) | 0)(str);
          go2$a1 = v._2;
          continue;
        }
        fail();
      }
      fail();
    }
    ;
    return go2$r;
  };
  return (str) => (v) => {
    if (v.tag === "Nil") {
      return str === "";
    }
    if (v.tag === "Cons") {
      if (v._1 === "") {
        return go2(str)(v._2);
      }
      const v1 = stripPrefix(v._1)(str);
      if (v1.tag === "Nothing") {
        return false;
      }
      if (v1.tag === "Just") {
        return go2(v1._1)(v._2);
      }
      fail();
    }
    fail();
  };
})();
var fromFoldable4 = (dictFoldable) => dictFoldable.foldr((x) => Cons((() => {
  if (x === "**") {
    return GlobStar;
  }
  return $Glob("GlobSegment", fromFoldable1(split("*")(x)));
})()))(Nil);
var fromFoldable22 = /* @__PURE__ */ fromFoldable4(foldableArray);
var fixedPrefix = (v) => {
  if (v.tag === "Cons") {
    if (v._1.tag === "GlobSegment") {
      if (v._1._1.tag === "Cons") {
        if (v._1._1._2.tag === "Nil") {
          if (v._1._1._1 !== "") {
            if (v._2.tag === "Nil") {
              return $Maybe("Just", $Map("Two", Leaf2, v._1._1._1, Match, Leaf2));
            }
            return $Maybe(
              "Just",
              $Map(
                "Two",
                Leaf2,
                v._1._1._1,
                $Match("MatchMore", false, $Map("Two", Leaf2, v._2, unit, Leaf2)),
                Leaf2
              )
            );
          }
          return Nothing;
        }
        return Nothing;
      }
      return Nothing;
    }
    return Nothing;
  }
  return Nothing;
};
var eqGlob = {
  eq: (x) => (y) => {
    if (x.tag === "GlobStar") {
      return y.tag === "GlobStar";
    }
    if (x.tag === "GlobSegment") {
      if (y.tag === "GlobSegment") {
        const go = (go$a0$copy) => (go$a1$copy) => (go$a2$copy) => {
          let go$a0 = go$a0$copy, go$a1 = go$a1$copy, go$a2 = go$a2$copy, go$c = true, go$r;
          while (go$c) {
            const v = go$a0, v1 = go$a1, v2 = go$a2;
            if (!v2) {
              go$c = false;
              go$r = false;
              continue;
            }
            if (v.tag === "Nil") {
              if (v1.tag === "Nil") {
                go$c = false;
                go$r = v2;
                continue;
              }
              go$c = false;
              go$r = false;
              continue;
            }
            if (v.tag === "Cons") {
              if (v1.tag === "Cons") {
                go$a0 = v._2;
                go$a1 = v1._2;
                go$a2 = v2 && v1._1 === v._1;
                continue;
              }
              go$c = false;
              go$r = false;
              continue;
            }
            go$c = false;
            go$r = false;
            continue;
          }
          ;
          return go$r;
        };
        return go(x._1)(y._1)(true);
      }
      return false;
    }
    return false;
  }
};
var ordGlob = {
  compare: (x) => (y) => {
    if (x.tag === "GlobStar") {
      if (y.tag === "GlobStar") {
        return EQ;
      }
      return LT;
    }
    if (y.tag === "GlobStar") {
      return GT;
    }
    if (x.tag === "GlobSegment") {
      if (y.tag === "GlobSegment") {
        return compare2(x._1)(y._1);
      }
      fail();
    }
    fail();
  },
  Eq0: () => eqGlob
};
var ordList3 = /* @__PURE__ */ ordList(ordGlob);
var fromFoldable32 = /* @__PURE__ */ foldlArray((m) => (a) => insert(ordList3)(a)(unit)(m))(Leaf2);
var matchListing = (path2) => (v) => {
  const $2 = (glob) => $Maybe(
    "Just",
    $Match(
      "MatchMore",
      (() => {
        const $3 = matchListing(path2)(glob);
        if ($3.tag === "Just") {
          return $3._1.tag === "Match";
        }
        return false;
      })(),
      fromFoldable32([glob, $List("Cons", GlobStar, glob)])
    )
  );
  if (v.tag === "Cons") {
    if (v._1.tag === "GlobStar") {
      if (v._2.tag === "Cons") {
        if (v._2._1.tag === "GlobStar") {
          return matchListing(path2)($List("Cons", GlobStar, v._2._2));
        }
        return $2(v._2);
      }
      return $2(v._2);
    }
    if (v._1.tag === "GlobSegment") {
      if (matchSegment(path2)(v._1._1)) {
        if (v._2.tag === "Nil") {
          return $Maybe("Just", Match);
        }
        return $Maybe("Just", $Match("MatchMore", false, $Map("Two", Leaf2, v._2, unit, Leaf2)));
      }
      return Nothing;
    }
    fail();
  }
  if (v.tag === "Nil") {
    return Nothing;
  }
  fail();
};
var semigroupMatch = {
  append: (a) => (b) => {
    if (a.tag === "MatchMore") {
      if (b.tag === "MatchMore") {
        return $Match("MatchMore", a._1 || b._1, unionWith(ordList3)($$const)(a._2)(b._2));
      }
      return a;
    }
    if (a.tag === "Match") {
      if (b.tag === "MatchMore") {
        return $Match("MatchMore", true, b._2);
      }
      return a;
    }
    fail();
  }
};
var monoidSemigroupMap2 = /* @__PURE__ */ monoidSemigroupMap(ordString)(semigroupMatch);
var foldMap1 = /* @__PURE__ */ (() => foldableList.foldMap(monoidSemigroupMap2))();
var foldMap32 = /* @__PURE__ */ (() => foldableSet.foldMap((() => {
  const semigroupMaybe1 = semigroupMaybe(semigroupMatch);
  return { mempty: Nothing, Semigroup0: () => semigroupMaybe1 };
})()))();
var foldMap4 = /* @__PURE__ */ (() => foldableSet.foldMap(monoidRecord()((() => {
  const Semigroup0 = monoidSemigroupMap2.Semigroup0();
  const semigroupRecordCons1 = {
    appendRecord: (v) => (ra) => (rb) => ({ left: unionWith(ordList3)($$const)(ra.left)(rb.left), right: Semigroup0.append(ra.right)(rb.right) })
  };
  return { memptyRecord: (v) => ({ left: Leaf2, right: monoidSemigroupMap2.mempty }), SemigroupRecord0: () => semigroupRecordCons1 };
})())))();
var monoidAff2 = /* @__PURE__ */ monoidAff(monoidSemigroupMap2);
var mempty3 = (v) => monoidAff2.mempty;
var match2 = (globs) => foldMap1((path2) => {
  const $2 = foldMap32(matchListing(path2))(globs);
  if ($2.tag === "Nothing") {
    return monoidSemigroupMap2.mempty;
  }
  if ($2.tag === "Just") {
    return $Map("Two", Leaf2, path2, $2._1, Leaf2);
  }
  fail();
});
var expandGlobsWithStats = (pwd) => (initGlobs) => _bind(_liftEffect(() => ({ value: Leaf2 })))((result) => {
  const go = (cwd) => (globs) => {
    const prefix = foldMap4((glob) => {
      const v = fixedPrefix(glob);
      if (v.tag === "Nothing") {
        return { left: $Map("Two", Leaf2, glob, unit, Leaf2), right: monoidSemigroupMap2.mempty };
      }
      if (v.tag === "Just") {
        return { left: Leaf2, right: v._1 };
      }
      fail();
    })(globs);
    return _bind((() => {
      const $7 = _catchError(_map((() => {
        const $72 = match2(prefix.left);
        return (x) => $72(fromFoldable1(x));
      })())(toAff1(readdir2)(cwd)))(mempty3);
      if (!(prefix.left.tag === "Leaf")) {
        return $7;
      }
      return monoidAff2.mempty;
    })())((dirMatches) => _sequential(forWithIndex_1(unionWith(ordString)(semigroupMatch.append)(prefix.right)(dirMatches))((path2) => (m) => {
      const fullPath = concat4([cwd, path2]);
      return _bind($$try2(toAff1(stat2)(fullPath)))((v) => {
        if (v.tag === "Right") {
          if (m.tag === "MatchMore") {
            if (statsMethod("isDirectory", v._1._1)) {
              return _bind((() => {
                const $12 = _liftEffect((() => {
                  const $122 = insert(ordString)(fullPath)(v._1);
                  return () => {
                    const $13 = result.value;
                    result.value = $122($13);
                    return unit;
                  };
                })());
                if (m._1) {
                  return $12;
                }
                return _pure(unit);
              })())(() => go(fullPath)(m._2));
            }
            if (m._1) {
              return _liftEffect((() => {
                const $12 = insert(ordString)(fullPath)(v._1);
                return () => {
                  const $13 = result.value;
                  result.value = $12($13);
                  return unit;
                };
              })());
            }
            return mempty;
          }
          if (m.tag === "Match") {
            return _liftEffect((() => {
              const $12 = insert(ordString)(fullPath)(v._1);
              return () => {
                const $13 = result.value;
                result.value = $12($13);
                return unit;
              };
            })());
          }
          return mempty;
        }
        return mempty;
      });
    })));
  };
  return _bind(_sequential(forWithIndex_22(fromFoldableWith(ordString)(foldableArray)(union2(ordList3))(arrayMap((() => {
    const $4 = split(sep);
    return (x) => rootOrRelative(pwd)(fromFoldable22($4((() => {
      if (sep !== "/") {
        return replaceAll("/")(sep)(x);
      }
      return x;
    })())));
  })())(initGlobs)))((dir) => (globs) => go(dir)(globs))))(() => _liftEffect(() => result.value));
});
var expandGlobsCwd = (globs) => _bind(_liftEffect(process3.cwd))((cwd) => _map(keys2)(expandGlobsWithStats(cwd)(globs)));

// output-es/Node.Stream/foreign.js
function readChunkImpl(Left2) {
  return (Right2) => (chunk) => {
    if (chunk instanceof Buffer) {
      return Right2(chunk);
    } else if (typeof chunk === "string") {
      return Left2(chunk);
    } else {
      throw new Error(
        "Node.Stream.readChunkImpl: Unrecognised chunk type; expected String or Buffer, got: " + chunk
      );
    }
  };
}
function onDataEitherImpl(readChunk2) {
  return (r) => (f) => () => {
    r.on("data", (data) => {
      f(readChunk2(data))();
    });
  };
}
function onEnd(s) {
  return (f) => () => {
    s.on("end", f);
  };
}
function writeStringImpl(w) {
  return (enc) => (s) => (done) => () => w.write(s, enc, done);
}

// output-es/Node.Stream/index.js
var writeString2 = (w) => (enc) => (s) => (cb) => writeStringImpl(w)((() => {
  if (enc.tag === "ASCII") {
    return "ASCII";
  }
  if (enc.tag === "UTF8") {
    return "UTF8";
  }
  if (enc.tag === "UTF16LE") {
    return "UTF16LE";
  }
  if (enc.tag === "UCS2") {
    return "UCS2";
  }
  if (enc.tag === "Base64") {
    return "Base64";
  }
  if (enc.tag === "Latin1") {
    return "Latin1";
  }
  if (enc.tag === "Binary") {
    return "Binary";
  }
  if (enc.tag === "Hex") {
    return "Hex";
  }
  fail();
})())(s)((x) => cb(nullable(x, Nothing, Just))());
var readChunk = /* @__PURE__ */ readChunkImpl(Left)(Right);
var onData = (r) => (cb) => onDataEitherImpl(readChunk)(r)((a) => bindE((() => {
  if (a.tag === "Left") {
    return throwException(error("Stream encoding should not be set"));
  }
  if (a.tag === "Right") {
    return () => a._1;
  }
  fail();
})())(cb));

// output-es/Effect.AVar/foreign.js
var AVar = function() {
  function MutableQueue() {
    this.head = null;
    this.last = null;
    this.size = 0;
  }
  function MutableCell(queue, value) {
    this.queue = queue;
    this.value = value;
    this.next = null;
    this.prev = null;
  }
  function AVar2(value) {
    this.draining = false;
    this.error = null;
    this.value = value;
    this.takes = new MutableQueue();
    this.reads = new MutableQueue();
    this.puts = new MutableQueue();
  }
  var EMPTY = {};
  function runEff(eff) {
    try {
      eff();
    } catch (error4) {
      setTimeout(function() {
        throw error4;
      }, 0);
    }
  }
  function putLast(queue, value) {
    var cell = new MutableCell(queue, value);
    switch (queue.size) {
      case 0:
        queue.head = cell;
        break;
      case 1:
        cell.prev = queue.head;
        queue.head.next = cell;
        queue.last = cell;
        break;
      default:
        cell.prev = queue.last;
        queue.last.next = cell;
        queue.last = cell;
    }
    queue.size++;
    return cell;
  }
  function takeLast(queue) {
    var cell;
    switch (queue.size) {
      case 0:
        return null;
      case 1:
        cell = queue.head;
        queue.head = null;
        break;
      case 2:
        cell = queue.last;
        queue.head.next = null;
        queue.last = null;
        break;
      default:
        cell = queue.last;
        queue.last = cell.prev;
        queue.last.next = null;
    }
    cell.prev = null;
    cell.queue = null;
    queue.size--;
    return cell.value;
  }
  function takeHead(queue) {
    var cell;
    switch (queue.size) {
      case 0:
        return null;
      case 1:
        cell = queue.head;
        queue.head = null;
        break;
      case 2:
        cell = queue.head;
        queue.last.prev = null;
        queue.head = queue.last;
        queue.last = null;
        break;
      default:
        cell = queue.head;
        queue.head = cell.next;
        queue.head.prev = null;
    }
    cell.next = null;
    cell.queue = null;
    queue.size--;
    return cell.value;
  }
  function deleteCell(cell) {
    if (cell.queue === null) {
      return;
    }
    if (cell.queue.last === cell) {
      takeLast(cell.queue);
      return;
    }
    if (cell.queue.head === cell) {
      takeHead(cell.queue);
      return;
    }
    if (cell.prev) {
      cell.prev.next = cell.next;
    }
    if (cell.next) {
      cell.next.prev = cell.prev;
    }
    cell.queue.size--;
    cell.queue = null;
    cell.value = null;
    cell.next = null;
    cell.prev = null;
  }
  function drainVar(util, avar) {
    if (avar.draining) {
      return;
    }
    var ps = avar.puts;
    var ts = avar.takes;
    var rs = avar.reads;
    var p, r, t, value, rsize;
    avar.draining = true;
    while (1) {
      p = null;
      r = null;
      t = null;
      value = avar.value;
      rsize = rs.size;
      if (avar.error !== null) {
        value = util.left(avar.error);
        while (p = takeHead(ps)) {
          runEff(p.cb(value));
        }
        while (r = takeHead(rs)) {
          runEff(r(value));
        }
        while (t = takeHead(ts)) {
          runEff(t(value));
        }
        break;
      }
      if (value === EMPTY && (p = takeHead(ps))) {
        avar.value = value = p.value;
      }
      if (value !== EMPTY) {
        t = takeHead(ts);
        while (rsize-- && (r = takeHead(rs))) {
          runEff(r(util.right(value)));
        }
        if (t !== null) {
          avar.value = EMPTY;
          runEff(t(util.right(value)));
        }
      }
      if (p !== null) {
        runEff(p.cb(util.right(void 0)));
      }
      if (avar.value === EMPTY && ps.size === 0 || avar.value !== EMPTY && ts.size === 0) {
        break;
      }
    }
    avar.draining = false;
  }
  AVar2.EMPTY = EMPTY;
  AVar2.putLast = putLast;
  AVar2.takeLast = takeLast;
  AVar2.takeHead = takeHead;
  AVar2.deleteCell = deleteCell;
  AVar2.drainVar = drainVar;
  return AVar2;
}();
function empty2() {
  return new AVar(AVar.EMPTY);
}
function _killVar(util, error4, avar) {
  return function() {
    if (avar.error === null) {
      avar.error = error4;
      avar.value = AVar.EMPTY;
      AVar.drainVar(util, avar);
    }
  };
}
function _putVar(util, value, avar, cb) {
  return function() {
    var cell = AVar.putLast(avar.puts, { cb, value });
    AVar.drainVar(util, avar);
    return function() {
      AVar.deleteCell(cell);
    };
  };
}
function _takeVar(util, avar, cb) {
  return function() {
    var cell = AVar.putLast(avar.takes, cb);
    AVar.drainVar(util, avar);
    return function() {
      AVar.deleteCell(cell);
    };
  };
}
function _tryReadVar(util, avar) {
  return function() {
    if (avar.value === AVar.EMPTY) {
      return util.nothing;
    } else {
      return util.just(avar.value);
    }
  };
}

// output-es/Effect.AVar/index.js
var $AVarStatus = (tag, _1) => ({ tag, _1 });
var Killed = (value0) => $AVarStatus("Killed", value0);
var Filled = (value0) => $AVarStatus("Filled", value0);
var Empty2 = /* @__PURE__ */ $AVarStatus("Empty");
var ffiUtil2 = { left: Left, right: Right, nothing: Nothing, just: Just, killed: Killed, filled: Filled, empty: Empty2 };

// output-es/Effect.Aff.AVar/index.js
var take4 = (avar) => makeAff((k) => {
  const $2 = _takeVar(ffiUtil2, avar, k);
  return () => {
    const c = $2();
    const $4 = _liftEffect(c);
    return (v) => $4;
  };
});
var put = (value) => (avar) => makeAff((k) => {
  const $3 = _putVar(ffiUtil2, value, avar, k);
  return () => {
    const c = $3();
    const $5 = _liftEffect(c);
    return (v) => $5;
  };
});
var empty3 = /* @__PURE__ */ _liftEffect(empty2);

// output-es/Node.WorkerBees.Aff/index.js
var spawn1 = /* @__PURE__ */ runEffectFn5(spawnImpl)(Left)(Right);
var mempty1 = (v) => () => unit;
var post1 = /* @__PURE__ */ runEffectFn2(postImpl);
var terminate2 = (worker) => invincible(makeAff((k) => {
  const $2 = terminate(worker)(k);
  return () => {
    $2();
    return nonCanceler;
  };
}));
var spawn = () => (worker) => (workerData) => _bind(empty3)((output) => _bind(makeAff((k) => {
  const $5 = spawn1(worker)({
    onMessage: (value) => {
      const $6 = _putVar(ffiUtil2, $Either("Right", value), output, mempty1);
      return () => {
        $6();
        return unit;
      };
    },
    onError: (err) => _killVar(ffiUtil2, err, output),
    onExit: (code) => {
      const $6 = _putVar(ffiUtil2, $Either("Left", code), output, mempty1);
      return () => {
        $6();
        return _killVar(ffiUtil2, error("Worker exited: " + showIntImpl(code)), output)();
      };
    },
    workerData
  })(k);
  return () => {
    $5();
    return nonCanceler;
  };
}))((thread) => _pure($Tuple(thread, output))));

// output-es/Node.WorkerBees.Aff.Pool/index.js
var parTraverse_2 = /* @__PURE__ */ parTraverse_(parallelAff)(foldableArray);
var for_2 = /* @__PURE__ */ for_(applicativeAff)(foldableMaybe);
var sequence = /* @__PURE__ */ (() => traversableArray.traverse(applicativeAff)(identity5))();
var parTraverse = (dictTraversable) => {
  const traverse3 = dictTraversable.traverse(applicativeParAff);
  return (f) => {
    const $3 = traverse3((x) => f(x));
    return (x) => _sequential($3(x));
  };
};
var terminate3 = (v) => {
  const termError = error("Pool terminated");
  return _bind(parTraverse_2((x) => killFiber(termError)(x._2))(v.threads))(() => _bind(parTraverse_2((x) => terminate2(x._1))(v.threads))(() => _bind(_liftEffect(_tryReadVar(
    ffiUtil2,
    v.queue
  )))((pending) => _bind(_liftEffect(_killVar(ffiUtil2, termError, v.queue)))(() => for_2(pending)((x) => _liftEffect(_killVar(
    ffiUtil2,
    termError,
    x._2
  )))))));
};
var make = () => () => (worker) => (workerData) => (numThreads) => {
  const workerLoop = (queue) => (thread) => (out) => _bind(take4(queue))((v) => _bind(_liftEffect(post1(v._1)(thread)))(() => _bind(take4(out))((rep) => {
    if (rep.tag === "Left") {
      return _liftEffect(_killVar(ffiUtil2, error("Worker exited: " + showIntImpl(rep._1)), v._2));
    }
    if (rep.tag === "Right") {
      return _bind(put(rep._1)(v._2))(() => workerLoop(queue)(thread)(out));
    }
    fail();
  })));
  return _bind(empty3)((queue) => _bind(sequence(replicate(numThreads)(_bind(spawn()(worker)(workerData))((v) => _bind(forkAff(workerLoop(queue)(v._1)(v._2)))((fiber) => _pure($Tuple(
    v._1,
    fiber
  )))))))((threads) => _pure({ queue, threads })));
};
var withPool = () => () => (worker) => (workerData) => (numThreads) => generalBracket(make()()(worker)(workerData)(numThreads))({
  killed: (v) => terminate3,
  failed: (v) => terminate3,
  completed: (v) => terminate3
});
var invoke = () => (v) => (i) => _bind(empty3)((res) => _bind(put($Tuple(i, res))(v.queue))(() => take4(res)));
var poolTraverse = () => () => (dictTraversable) => {
  const parTraverse1 = parTraverse(dictTraversable);
  return (worker) => (workerData) => (numThreads) => (fs) => withPool()()(worker)(workerData)(numThreads)((x) => parTraverse1(invoke()(x))(fs));
};

// output-es/PureScript.CST.ModuleGraph/index.js
var $ModuleSort = (tag, _1) => ({ tag, _1 });
var toUnfoldable1 = /* @__PURE__ */ toUnfoldable4(unfoldableArray);
var all3 = /* @__PURE__ */ (() => foldableMap.foldMap((() => {
  const semigroupConj1 = { append: (v) => (v1) => v && v1 };
  return { mempty: true, Semigroup0: () => semigroupConj1 };
})()))();
var fromFoldable5 = /* @__PURE__ */ foldlArray((m) => (a) => insert(ordString)(a)(unit)(m))(Leaf2);
var fromFoldable12 = /* @__PURE__ */ fromFoldable3(ordString)(foldableArray);
var toUnfoldable23 = /* @__PURE__ */ toUnfoldable(unfoldableArray);
var topoSort = (dictOrd) => {
  const filterWithKey2 = filterWithKey(dictOrd);
  return (graph) => {
    const importCounts = fromFoldableWith(dictOrd)(foldableArray)(intAdd)(arrayBind(toUnfoldable3(unfoldableArray)(graph))((v) => concatArray([
      $Tuple(v._1, 0)
    ])(arrayMap((a) => $Tuple(a, 1))(toUnfoldable1(v._2)))));
    const depthFirst = (v) => {
      if ((() => {
        const $63 = lookup(dictOrd)(v.curr)(v.visited);
        if ($63.tag === "Nothing") {
          return false;
        }
        if ($63.tag === "Just") {
          return true;
        }
        fail();
      })()) {
        return $Maybe("Just", $List("Cons", v.curr, v.path));
      }
      if ((() => {
        const $63 = lookup(dictOrd)(v.curr)(graph);
        if ($63.tag === "Nothing") {
          return true;
        }
        if ($63.tag === "Just") {
          return $63._1.tag === "Leaf";
        }
        fail();
      })()) {
        return Nothing;
      }
      const $62 = lookup(dictOrd)(v.curr)(graph);
      if ($62.tag === "Just") {
        return foldableSet.foldl((b) => (a) => {
          if ((() => {
            if (b.tag === "Nothing") {
              return false;
            }
            if (b.tag === "Just") {
              return true;
            }
            fail();
          })()) {
            return b;
          }
          return depthFirst({ path: $List("Cons", v.curr, v.path), visited: insert(dictOrd)(v.curr)(unit)(v.visited), curr: a });
        })(Nothing)($62._1);
      }
      if ($62.tag === "Nothing") {
        return Nothing;
      }
      fail();
    };
    const go = (go$a0$copy) => {
      let go$a0 = go$a0$copy, go$c = true, go$r;
      while (go$c) {
        const v = go$a0;
        const $7 = findMin(v.roots);
        const v1 = (() => {
          if ($7.tag === "Just") {
            return $Maybe("Just", $7._1.key);
          }
          return Nothing;
        })();
        if (v1.tag === "Nothing") {
          if (all3(($9) => 0 === $9)(v.usages)) {
            go$c = false;
            go$r = $Either("Right", { roots: v.roots, sorted: v.sorted, usages: v.usages });
            continue;
          }
          const detectCycles = foldableSet.foldl((b) => (a) => {
            if ((() => {
              if (b.tag === "Nothing") {
                return false;
              }
              if (b.tag === "Just") {
                return true;
              }
              fail();
            })()) {
              return b;
            }
            return depthFirst({ path: Nil, visited: Leaf2, curr: a });
          })(Nothing)(functorMap.map((v$1) => unit)(filterWithKey2((a) => (count) => {
            const $11 = lookup(dictOrd)(a)(graph);
            return count > 0 && (() => {
              if ($11.tag === "Nothing") {
                return false;
              }
              if ($11.tag === "Just") {
                return !($11._1.tag === "Leaf");
              }
              fail();
            })();
          })(v.usages)));
          if (detectCycles.tag === "Just") {
            go$c = false;
            go$r = $Either("Left", detectCycles._1);
            continue;
          }
          if (detectCycles.tag === "Nothing") {
            go$c = false;
            go$r = $Either("Left", Nil);
            continue;
          }
          fail();
        }
        if (v1.tag === "Just") {
          const $9 = lookup(dictOrd)(v1._1)(graph);
          const reachable = (() => {
            if ($9.tag === "Nothing") {
              return Leaf2;
            }
            if ($9.tag === "Just") {
              return $9._1;
            }
            fail();
          })();
          const usages$p = foldableSet.foldl((usages) => (k) => insertWith(dictOrd)(intAdd)(k)(-1)(usages))(v.usages)(reachable);
          go$a0 = {
            roots: foldableSet.foldl((roots) => (curr) => {
              const $14 = lookup(dictOrd)(curr)(usages$p);
              if ($14.tag === "Just") {
                if ($14._1 === 0) {
                  return insert(dictOrd)(curr)(unit)(roots);
                }
                return roots;
              }
              if ($14.tag === "Nothing") {
                return roots;
              }
              fail();
            })($$delete(dictOrd)(v1._1)(v.roots))(reachable),
            sorted: $List("Cons", v1._1, v.sorted),
            usages: usages$p
          };
          continue;
        }
        fail();
      }
      ;
      return go$r;
    };
    const $6 = go({
      roots: functorMap.map((v) => unit)(filterWithKey2((k) => (v) => v === 0)(importCounts)),
      sorted: Nil,
      usages: importCounts
    });
    if ($6.tag === "Left") {
      return $Either("Left", $6._1);
    }
    if ($6.tag === "Right") {
      return $Either("Right", $6._1.sorted);
    }
    fail();
  };
};
var topoSort1 = /* @__PURE__ */ topoSort(ordString);
var moduleGraph = (k) => {
  const $1 = arrayMap((x) => {
    const $2 = k(x);
    return $Tuple($2.name.name, fromFoldable5(arrayMap((v) => v.module.name)($2.imports)));
  });
  return (x) => fromFoldable12($1(x));
};
var sortModules = (k) => (moduleHeaders) => {
  const knownModuleHeaders = fromFoldable12(arrayMap((a) => $Tuple(k(a).name.name, a))(moduleHeaders));
  const v = topoSort1(moduleGraph(k)(moduleHeaders));
  if (v.tag === "Left") {
    return $ModuleSort("CycleDetected", mapMaybe((a) => lookup(ordString)(a)(knownModuleHeaders))(toUnfoldable23(v._1)));
  }
  if (v.tag === "Right") {
    return $ModuleSort("Sorted", mapMaybe((a) => lookup(ordString)(a)(knownModuleHeaders))(toUnfoldable23(v._1)));
  }
  fail();
};

// output-es/Tidy.Operators.Defaults/index.js
var defaultOperators = [
  "Control.Alt.($>) 4",
  "Control.Alt.(<#>) 1",
  "Control.Alt.(<$) 4",
  "Control.Alt.(<$>) 4",
  "Control.Alt.(<@>) 4",
  "Control.Alt.(<|>) 3",
  "Control.Alternative.($>) 4",
  "Control.Alternative.(*>) 4",
  "Control.Alternative.(<#>) 1",
  "Control.Alternative.(<$) 4",
  "Control.Alternative.(<$>) 4",
  "Control.Alternative.(<*) 4",
  "Control.Alternative.(<*>) 4",
  "Control.Alternative.(<@>) 4",
  "Control.Alternative.(<|>) 3",
  "Control.Applicative.($>) 4",
  "Control.Applicative.(*>) 4",
  "Control.Applicative.(<#>) 1",
  "Control.Applicative.(<$) 4",
  "Control.Applicative.(<$>) 4",
  "Control.Applicative.(<*) 4",
  "Control.Applicative.(<*>) 4",
  "Control.Applicative.(<@>) 4",
  "Control.Apply.($>) 4",
  "Control.Apply.(*>) 4",
  "Control.Apply.(<#>) 1",
  "Control.Apply.(<$) 4",
  "Control.Apply.(<$>) 4",
  "Control.Apply.(<*) 4",
  "Control.Apply.(<*>) 4",
  "Control.Apply.(<@>) 4",
  "Control.Biapply.(*>>) 4",
  "Control.Biapply.(<<$>>) 4",
  "Control.Biapply.(<<*) 4",
  "Control.Biapply.(<<*>>) 4",
  "Control.Bind.($>) 4",
  "Control.Bind.(*>) 4",
  "Control.Bind.(<#>) 1",
  "Control.Bind.(<$) 4",
  "Control.Bind.(<$>) 4",
  "Control.Bind.(<*) 4",
  "Control.Bind.(<*>) 4",
  "Control.Bind.(<=<) 1",
  "Control.Bind.(<@>) 4",
  "Control.Bind.(=<<) 1",
  "Control.Bind.(>=>) 1",
  "Control.Bind.(>>=) 1",
  "Control.Category.(<<<) 9",
  "Control.Category.(>>>) 9",
  "Control.Comonad.($>) 4",
  "Control.Comonad.(<#>) 1",
  "Control.Comonad.(<$) 4",
  "Control.Comonad.(<$>) 4",
  "Control.Comonad.(<<=) 1",
  "Control.Comonad.(<@>) 4",
  "Control.Comonad.(=<=) 1",
  "Control.Comonad.(=>=) 1",
  "Control.Comonad.(=>>) 1",
  "Control.Comonad.Cofree.(:<) 5",
  "Control.Coroutine.($$) 2",
  "Control.Coroutine.($~) 2",
  "Control.Coroutine.(/\\) 3",
  "Control.Coroutine.(\\/) 3",
  "Control.Coroutine.(~$) 2",
  "Control.Coroutine.(~~) 2",
  "Control.Extend.($>) 4",
  "Control.Extend.(<#>) 1",
  "Control.Extend.(<$) 4",
  "Control.Extend.(<$>) 4",
  "Control.Extend.(<<=) 1",
  "Control.Extend.(<@>) 4",
  "Control.Extend.(=<=) 1",
  "Control.Extend.(=>=) 1",
  "Control.Extend.(=>>) 1",
  "Control.Monad.($>) 4",
  "Control.Monad.(*>) 4",
  "Control.Monad.(<#>) 1",
  "Control.Monad.(<$) 4",
  "Control.Monad.(<$>) 4",
  "Control.Monad.(<*) 4",
  "Control.Monad.(<*>) 4",
  "Control.Monad.(<=<) 1",
  "Control.Monad.(<@>) 4",
  "Control.Monad.(=<<) 1",
  "Control.Monad.(>=>) 1",
  "Control.Monad.(>>=) 1",
  "Control.MonadPlus.($>) 4",
  "Control.MonadPlus.(*>) 4",
  "Control.MonadPlus.(<#>) 1",
  "Control.MonadPlus.(<$) 4",
  "Control.MonadPlus.(<$>) 4",
  "Control.MonadPlus.(<*) 4",
  "Control.MonadPlus.(<*>) 4",
  "Control.MonadPlus.(<=<) 1",
  "Control.MonadPlus.(<@>) 4",
  "Control.MonadPlus.(<|>) 3",
  "Control.MonadPlus.(=<<) 1",
  "Control.MonadPlus.(>=>) 1",
  "Control.MonadPlus.(>>=) 1",
  "Control.Plus.($>) 4",
  "Control.Plus.(<#>) 1",
  "Control.Plus.(<$) 4",
  "Control.Plus.(<$>) 4",
  "Control.Plus.(<@>) 4",
  "Control.Plus.(<|>) 3",
  "Control.Semigroupoid.(<<<) 9",
  "Control.Semigroupoid.(>>>) 9",
  "Data.Argonaut.(.!=) 6",
  "Data.Argonaut.(.:) 7",
  "Data.Argonaut.(.:!) 7",
  "Data.Argonaut.(.:?) 7",
  "Data.Argonaut.(:=) 7",
  "Data.Argonaut.(:=?) 7",
  "Data.Argonaut.(~>) 6",
  "Data.Argonaut.(~>?) 6",
  "Data.Argonaut.Decode.(.!=) 6",
  "Data.Argonaut.Decode.(.:) 7",
  "Data.Argonaut.Decode.(.:!) 7",
  "Data.Argonaut.Decode.(.:?) 7",
  "Data.Argonaut.Decode.Combinators.(.!=) 6",
  "Data.Argonaut.Decode.Combinators.(.:) 7",
  "Data.Argonaut.Decode.Combinators.(.:!) 7",
  "Data.Argonaut.Decode.Combinators.(.:?) 7",
  "Data.Argonaut.Encode.(:=) 7",
  "Data.Argonaut.Encode.(:=?) 7",
  "Data.Argonaut.Encode.(~>) 6",
  "Data.Argonaut.Encode.(~>?) 6",
  "Data.Argonaut.Encode.Combinators.(:=) 7",
  "Data.Argonaut.Encode.Combinators.(:=?) 7",
  "Data.Argonaut.Encode.Combinators.(~>) 6",
  "Data.Argonaut.Encode.Combinators.(~>?) 6",
  "Data.Array.(!!) 8",
  "Data.Array.(..) 8",
  "Data.Array.(:) 6",
  "Data.Array.(\\\\) 5",
  "Data.Array.NonEmpty.(!!) 8",
  "Data.Array.NonEmpty.(..) 8",
  "Data.Array.NonEmpty.(:) 6",
  "Data.Array.NonEmpty.(\\\\) 5",
  "Data.BooleanAlgebra.(&&) 3",
  "Data.BooleanAlgebra.(||) 2",
  "Data.Bounded.(<) 4",
  "Data.Bounded.(<=) 4",
  "Data.Bounded.(>) 4",
  "Data.Bounded.(>=) 4",
  "Data.CommutativeRing.(*) 7",
  "Data.CommutativeRing.(+) 6",
  "Data.CommutativeRing.(-) 6",
  "Data.DivisionRing.(*) 7",
  "Data.DivisionRing.(+) 6",
  "Data.DivisionRing.(-) 6",
  "Data.Either.Nested.(\\/) type 6",
  "Data.Either.Nested.(\\/) 6",
  "Data.Eq.(/=) 4",
  "Data.Eq.(==) 4",
  "Data.EuclideanRing.(*) 7",
  "Data.EuclideanRing.(+) 6",
  "Data.EuclideanRing.(-) 6",
  "Data.EuclideanRing.(/) 7",
  "Data.Field.(*) 7",
  "Data.Field.(+) 6",
  "Data.Field.(-) 6",
  "Data.Field.(/) 7",
  "Data.Function.(#) 1",
  "Data.Function.($) 0",
  "Data.Function.(<<<) 9",
  "Data.Function.(>>>) 9",
  "Data.Functor.($>) 4",
  "Data.Functor.(<#>) 1",
  "Data.Functor.(<$) 4",
  "Data.Functor.(<$>) 4",
  "Data.Functor.(<@>) 4",
  "Data.Functor.Contravariant.(>#<) 4",
  "Data.Functor.Contravariant.(>$<) 4",
  "Data.Functor.Coproduct.Nested.(<\\/>) type 6",
  "Data.Functor.Coproduct.Nested.(<\\/>) 6",
  "Data.Functor.Product.Nested.(</\\>) type 6",
  "Data.Functor.Product.Nested.(</\\>) 6",
  "Data.HeytingAlgebra.(&&) 3",
  "Data.HeytingAlgebra.(||) 2",
  "Data.HugeNum.(^) 8",
  "Data.Int.Bits.(.&.) 10",
  "Data.Int.Bits.(.^.) 10",
  "Data.Int.Bits.(.|.) 10",
  "Data.Lens.(%=) 4",
  "Data.Lens.(%~) 4",
  "Data.Lens.(&&&) 3",
  "Data.Lens.(&&=) 4",
  "Data.Lens.(&&~) 4",
  "Data.Lens.(***) 3",
  "Data.Lens.(*=) 4",
  "Data.Lens.(*~) 4",
  "Data.Lens.(+++) 2",
  "Data.Lens.(+=) 4",
  "Data.Lens.(+~) 4",
  "Data.Lens.(-=) 4",
  "Data.Lens.(-~) 4",
  "Data.Lens.(.=) 4",
  "Data.Lens.(.~) 4",
  "Data.Lens.(//=) 4",
  "Data.Lens.(//~) 4",
  "Data.Lens.(<>=) 4",
  "Data.Lens.(<>~) 4",
  "Data.Lens.(?=) 4",
  "Data.Lens.(?~) 4",
  "Data.Lens.(^.) 8",
  "Data.Lens.(^..) 8",
  "Data.Lens.(^?) 8",
  "Data.Lens.(||=) 4",
  "Data.Lens.(|||) 2",
  "Data.Lens.(||~) 4",
  "Data.Lens.Common.(&&&) 3",
  "Data.Lens.Common.(***) 3",
  "Data.Lens.Common.(+++) 2",
  "Data.Lens.Common.(|||) 2",
  "Data.Lens.Fold.(^..) 8",
  "Data.Lens.Fold.(^?) 8",
  "Data.Lens.Fold.Partial.(^?!) 8",
  "Data.Lens.Fold.Partial.(^@?!) 8",
  "Data.Lens.Getter.(^.) 8",
  "Data.Lens.Lens.Tuple.(&&&) 3",
  "Data.Lens.Lens.Tuple.(***) 3",
  "Data.Lens.Prism.Either.(+++) 2",
  "Data.Lens.Prism.Either.(|||) 2",
  "Data.Lens.Setter.(%=) 4",
  "Data.Lens.Setter.(%~) 4",
  "Data.Lens.Setter.(&&=) 4",
  "Data.Lens.Setter.(&&~) 4",
  "Data.Lens.Setter.(*=) 4",
  "Data.Lens.Setter.(*~) 4",
  "Data.Lens.Setter.(+=) 4",
  "Data.Lens.Setter.(+~) 4",
  "Data.Lens.Setter.(-=) 4",
  "Data.Lens.Setter.(-~) 4",
  "Data.Lens.Setter.(.=) 4",
  "Data.Lens.Setter.(.~) 4",
  "Data.Lens.Setter.(//=) 4",
  "Data.Lens.Setter.(//~) 4",
  "Data.Lens.Setter.(<>=) 4",
  "Data.Lens.Setter.(<>~) 4",
  "Data.Lens.Setter.(?=) 4",
  "Data.Lens.Setter.(?~) 4",
  "Data.Lens.Setter.(||=) 4",
  "Data.Lens.Setter.(||~) 4",
  "Data.List.(!!) 8",
  "Data.List.(..) 8",
  "Data.List.(:) 6",
  "Data.List.(\\\\) 5",
  "Data.List.Lazy.(!!) 8",
  "Data.List.Lazy.(..) 8",
  "Data.List.Lazy.(:) 6",
  "Data.List.Lazy.(\\\\) 5",
  "Data.List.Lazy.NonEmpty.(:) 6",
  "Data.List.Lazy.Types.(:) 6",
  "Data.List.NonEmpty.(!!) 8",
  "Data.List.NonEmpty.(:) 6",
  "Data.List.Types.(:) 6",
  "Data.Monoid.(<>) 5",
  "Data.NaturalTransformation.(~>) type 4",
  "Data.NonEmpty.(:|) 5",
  "Data.Number.(%) 7",
  "Data.Number.Approximate.(~=) 4",
  "Data.Number.Approximate.(\u2245) 4",
  "Data.Number.Approximate.(\u2247) 4",
  "Data.Options.(:=) 6",
  "Data.Ord.(<) 4",
  "Data.Ord.(<=) 4",
  "Data.Ord.(>) 4",
  "Data.Ord.(>=) 4",
  "Data.Profunctor.Choice.(+++) 2",
  "Data.Profunctor.Choice.(|||) 2",
  "Data.Profunctor.Strong.(&&&) 3",
  "Data.Profunctor.Strong.(***) 3",
  "Data.Ring.(*) 7",
  "Data.Ring.(+) 6",
  "Data.Ring.(-) 6",
  "Data.Semigroup.(<>) 5",
  "Data.Semiring.(*) 7",
  "Data.Semiring.(+) 6",
  "Data.Tuple.Nested.(/\\) type 6",
  "Data.Tuple.Nested.(/\\) 6",
  "Foreign.Index.(!) 9",
  "Parsing.Combinators.(!!) 8",
  "Parsing.Combinators.($>) 4",
  "Parsing.Combinators.(..) 8",
  "Parsing.Combinators.(:) 6",
  "Parsing.Combinators.(<#>) 1",
  "Parsing.Combinators.(<$) 4",
  "Parsing.Combinators.(<$>) 4",
  "Parsing.Combinators.(<?>) 4",
  "Parsing.Combinators.(<??>) 3",
  "Parsing.Combinators.(<@>) 4",
  "Parsing.Combinators.(<|>) 3",
  "Parsing.Combinators.(<~?>) 4",
  "Parsing.Combinators.(\\\\) 5",
  "Parsing.Indent.(<*/>) 11",
  "Parsing.Indent.(<+/>) 9",
  "Parsing.Indent.(<-/>) 10",
  "Parsing.Indent.(<?/>) 12",
  "Pathy.(<..>) 6",
  "Pathy.(<.>) 6",
  "Pathy.(</>) 6",
  "Pathy.Path.(<..>) 6",
  "Pathy.Path.(<.>) 6",
  "Pathy.Path.(</>) 6",
  "Prelude.(~>) type 4",
  "Prelude.(#) 1",
  "Prelude.($) 0",
  "Prelude.($>) 4",
  "Prelude.(&&) 3",
  "Prelude.(*) 7",
  "Prelude.(*>) 4",
  "Prelude.(+) 6",
  "Prelude.(-) 6",
  "Prelude.(/) 7",
  "Prelude.(/=) 4",
  "Prelude.(<) 4",
  "Prelude.(<#>) 1",
  "Prelude.(<$) 4",
  "Prelude.(<$>) 4",
  "Prelude.(<*) 4",
  "Prelude.(<*>) 4",
  "Prelude.(<<<) 9",
  "Prelude.(<=) 4",
  "Prelude.(<=<) 1",
  "Prelude.(<>) 5",
  "Prelude.(<@>) 4",
  "Prelude.(=<<) 1",
  "Prelude.(==) 4",
  "Prelude.(>) 4",
  "Prelude.(>=) 4",
  "Prelude.(>=>) 1",
  "Prelude.(>>=) 1",
  "Prelude.(>>>) 9",
  "Prelude.(||) 2",
  "StringParser.(<?>) 4",
  "StringParser.Combinators.(<?>) 4",
  "Test.QuickCheck.(/==) 2",
  "Test.QuickCheck.(/=?) 2",
  "Test.QuickCheck.(<=?) 2",
  "Test.QuickCheck.(<?) 2",
  "Test.QuickCheck.(<?>) 2",
  "Test.QuickCheck.(===) 2",
  "Test.QuickCheck.(==?) 2",
  "Test.QuickCheck.(>=?) 2",
  "Test.QuickCheck.(>?) 2",
  "Type.Function.(#) type 1",
  "Type.Function.($) type 0",
  "Type.Prelude.(+) type 0",
  "Type.Row.(+) type 0"
];

// output-es/Main/index.js
var $Command = (tag, _1, _2, _3, _4, _5, _6) => ({ tag, _1, _2, _3, _4, _5, _6 });
var $ConfigOption = (tag) => ({ tag });
var $FormatMode = (tag) => ({ tag });
var $$try4 = /* @__PURE__ */ $$try(monadErrorAff);
var parTraverse2 = /* @__PURE__ */ (() => {
  const traverse3 = traversableArray.traverse(applicativeParAff);
  return (f) => {
    const $2 = traverse3((x) => f(x));
    return (x) => _sequential($2(x));
  };
})();
var fromFoldable6 = /* @__PURE__ */ (() => fromFoldableImpl(foldableSet.foldr))();
var for_3 = /* @__PURE__ */ for_(applicativeAff)(foldableArray);
var fold2 = /* @__PURE__ */ (() => foldableArray.foldMap(monoidString)(identity3))();
var parseArgs2 = /* @__PURE__ */ parseArgs(foldableArray);
var fold12 = (v1) => {
  if (v1.tag === "Nothing") {
    return "";
  }
  if (v1.tag === "Just") {
    return v1._1;
  }
  fail();
};
var applicativeStateT2 = /* @__PURE__ */ applicativeStateT(monadAff);
var $$for = /* @__PURE__ */ (() => {
  const traverse22 = traversableArray.traverse(applicativeStateT2);
  return (x) => (f) => traverse22(f)(x);
})();
var bindStateT2 = /* @__PURE__ */ bindStateT(monadAff);
var monadStateStateT2 = /* @__PURE__ */ monadStateStateT(monadAff);
var $$get = /* @__PURE__ */ (() => monadStateStateT2.state((s) => $Tuple(s, s)))();
var lift = /* @__PURE__ */ (() => monadTransStateT.lift(monadAff))();
var fromFoldable13 = /* @__PURE__ */ fromFoldable2(foldableArray);
var oneOf = /* @__PURE__ */ (() => foldrArray(altAff.alt)(plusAff.empty))();
var poolTraverse2 = /* @__PURE__ */ poolTraverse()()(traversableArray);
var foldMap12 = /* @__PURE__ */ (() => foldableArray.foldMap(monoidRecord()((() => {
  const semigroupRecordCons1 = {
    appendRecord: (v) => (ra) => (rb) => ({ errors: concatArray(ra.errors)(rb.errors), notFormatted: concatArray(ra.notFormatted)(rb.notFormatted) })
  };
  return { memptyRecord: (v) => ({ errors: [], notFormatted: [] }), SemigroupRecord0: () => semigroupRecordCons1 };
})())))();
var for_1 = /* @__PURE__ */ for_(applicativeEffect)(foldableArray);
var traverse2 = /* @__PURE__ */ (() => traversableMaybe.traverse(applicativeAff))();
var Check = /* @__PURE__ */ $FormatMode("Check");
var Write = /* @__PURE__ */ $FormatMode("Write");
var Require = /* @__PURE__ */ $ConfigOption("Require");
var Ignore = /* @__PURE__ */ $ConfigOption("Ignore");
var Prefer = /* @__PURE__ */ $ConfigOption("Prefer");
var GenerateOperators = (value0) => $Command("GenerateOperators", value0);
var GenerateRc = (value0) => $Command("GenerateRc", value0);
var FormatInPlace = (value0) => (value1) => (value2) => (value3) => (value4) => (value5) => $Command("FormatInPlace", value0, value1, value2, value3, value4, value5);
var Format = (value0) => (value1) => $Command("Format", value0, value1);
var eqFormatMode = {
  eq: (x) => (y) => {
    if (x.tag === "Check") {
      return y.tag === "Check";
    }
    if (x.tag === "Write") {
      return y.tag === "Write";
    }
    return false;
  }
};
var readStdin = /* @__PURE__ */ makeAff((k) => () => {
  const contents = { value: [] };
  onData(process3.stdin)((buff) => () => {
    const $3 = contents.value;
    contents.value = run(withArray(pushAll([buff]))($3));
    return unit;
  })();
  onEnd(process3.stdin)((() => {
    const $3 = bindE(bindE(() => contents.value)(concat3))(mutableBufferEffect.toString(UTF8));
    return () => {
      const x = $3();
      return k($Either("Right", x))();
    };
  })())();
  return nonCanceler;
});
var readOperatorTable = (path2) => {
  if (path2 === ".tidyoperators.default") {
    return _pure(defaultOperators);
  }
  return _map(split("\n"))(toAff2(readTextFile)(UTF8)(path2));
};
var rcFileName = ".tidyrc.json";
var resolveRcForDir = (root) => {
  const unwind2 = (unwind$a0$copy) => (unwind$a1$copy) => (unwind$a2$copy) => {
    let unwind$a0 = unwind$a0$copy, unwind$a1 = unwind$a1$copy, unwind$a2 = unwind$a2$copy, unwind$c = true, unwind$r;
    while (unwind$c) {
      const cache = unwind$a0, res = unwind$a1, v = unwind$a2;
      if (v.tag === "Cons") {
        unwind$a0 = insert(ordString)(v._1)(res)(cache);
        unwind$a1 = res;
        unwind$a2 = v._2;
        continue;
      }
      if (v.tag === "Nil") {
        unwind$c = false;
        unwind$r = $Tuple(res, cache);
        continue;
      }
      fail();
    }
    ;
    return unwind$r;
  };
  const go = (paths) => (cache) => (dir) => {
    const v = lookup(ordString)(dir)(cache);
    if (v.tag === "Just") {
      return _pure(unwind2(cache)(v._1)(paths));
    }
    if (v.tag === "Nothing") {
      const filePath = concat4([dir, ".tidyrc.json"]);
      return _bind($$try4(toAff2(readTextFile)(UTF8)(filePath)))((contents) => {
        if (contents.tag === "Left") {
          if (dir === root) {
            return _pure(unwind2(cache)(Nothing)($List("Cons", dir, paths)));
          }
          return go($List("Cons", dir, paths))(cache)(dirname(dir));
        }
        if (contents.tag === "Right") {
          const v1 = bindEither.bind(bifunctorEither.bimap((v$1) => $JsonDecodeError("TypeMismatch", "JSON"))(identity4)(_jsonParser(
            Left,
            Right,
            contents._1
          )))(fromJson);
          if (v1.tag === "Left") {
            return _throwError(error("Could not decode " + (filePath + (": " + printJsonDecodeError(v1._1)))));
          }
          if (v1.tag === "Right") {
            return _pure(unwind2(cache)($Maybe(
              "Just",
              {
                operatorsFile: (() => {
                  const $10 = relative(dir);
                  if (v1._1.operatorsFile.tag === "Just") {
                    return $Maybe("Just", $10(v1._1.operatorsFile._1));
                  }
                  return Nothing;
                })(),
                importSort: v1._1.importSort,
                importWrap: v1._1.importWrap,
                indent: v1._1.indent,
                ribbon: v1._1.ribbon,
                typeArrowPlacement: v1._1.typeArrowPlacement,
                unicode: v1._1.unicode,
                width: v1._1.width
              }
            ))($List("Cons", dir, paths)));
          }
          fail();
        }
        fail();
      });
    }
    fail();
  };
  return go(Nil);
};
var parser = /* @__PURE__ */ (() => {
  const workerOptions = $$default(4)($$int(argument(["--threads", "-t"])("Number of worker threads to use.\nDefaults to 4.")));
  const timingOption = $$default(false)($$boolean(flag(["--timing"])("Print the time spent formatting each file.")));
  const pursGlobs = unfolded1(unfoldable1Array)(anyNotFlag("PURS_GLOB")("Globs for PureScript sources."));
  const configOption = $$default(Prefer)(choose("config behavior")([
    (() => {
      const $3 = flag(["--config-prefer", "-cp"])("Always use config files when present, otherwise use CLI options.\nDefault.");
      return $ArgParser($3._1, functorArgFold.map((v) => Prefer)($3._2));
    })(),
    (() => {
      const $3 = flag(["--config-require", "-cr"])("Require the presence of a config file.\nUseful for editors.");
      return $ArgParser($3._1, functorArgFold.map((v) => Require)($3._2));
    })(),
    (() => {
      const $3 = flag(["--config-ignore", "-ci"])("Ignore all configuration files and only use CLI options.\nNot recommended.");
      return $ArgParser($3._1, functorArgFold.map((v) => Ignore)($3._2));
    })()
  ]));
  const $4 = choose("command")([
    command(["generate-operators"])("Generate an operator precedence table for better operator formatting.\nBest used with `spago sources`. Prints to stdout.")(applyParser.apply($ArgParser(
      pursGlobs._1,
      functorArgFold.map($$const)(functorArgFold.map(GenerateOperators)(pursGlobs._2))
    ))(flagHelp)),
    command(["generate-config"])("Writes a .tidyrc file to the current working directory based\non the command line options given.")(applyParser.apply($ArgParser(
      formatOptions._1,
      functorArgFold.map($$const)(functorArgFold.map(GenerateRc)(formatOptions._2))
    ))(flagHelp)),
    command(["format-in-place"])("Format source files in place.")((() => {
      const $42 = applyParser.apply(applyParser.apply(applyParser.apply(applyParser.apply($ArgParser(
        formatOptions._1,
        functorArgFold.map(FormatInPlace(Write))(formatOptions._2)
      ))(configOption))(workerOptions))(timingOption))(pursGlobs);
      return applyParser.apply($ArgParser($42._1, functorArgFold.map($$const)($42._2)))(flagHelp);
    })()),
    command(["format"])("Format input over stdin.")((() => {
      const $42 = applyParser.apply($ArgParser(
        formatOptions._1,
        functorArgFold.map(Format)(formatOptions._2)
      ))(configOption);
      return applyParser.apply($ArgParser($42._1, functorArgFold.map($$const)($42._2)))(flagHelp);
    })()),
    command(["check"])("Check source files are formatted.")((() => {
      const $42 = applyParser.apply(applyParser.apply(applyParser.apply(applyParser.apply($ArgParser(
        formatOptions._1,
        functorArgFold.map(FormatInPlace(Check))(formatOptions._2)
      ))(configOption))(workerOptions))(timingOption))(pursGlobs);
      return applyParser.apply($ArgParser($42._1, functorArgFold.map($$const)($42._2)))(flagHelp);
    })())
  ]);
  const $5 = applyParser.apply($ArgParser($4._1, functorArgFold.map($$const)($4._2)))(flagInfo([
    "--version",
    "-v"
  ])("Shows the current version.")(version));
  return applyParser.apply($ArgParser($5._1, functorArgFold.map($$const)($5._2)))(flagHelp);
})();
var getOptions = (cliOptions) => (rcOptions) => (filePath) => (v) => {
  if (v.tag === "Prefer") {
    return _pure((() => {
      if (rcOptions.tag === "Nothing") {
        return cliOptions;
      }
      if (rcOptions.tag === "Just") {
        return rcOptions._1;
      }
      fail();
    })());
  }
  if (v.tag === "Ignore") {
    return _pure(cliOptions);
  }
  if (v.tag === "Require") {
    if (rcOptions.tag === "Nothing") {
      return _bind(_liftEffect(error2(".tidyrc.json not found for " + filePath)))(() => _liftEffect(exit(1)));
    }
    if (rcOptions.tag === "Just") {
      return _pure(rcOptions._1);
    }
    fail();
  }
  fail();
};
var generateOperatorsCommand = (globs) => _bind(expandGlobsCwd(globs))((sourcePaths) => _bind(parTraverse2((path2) => _bind((() => {
  const $3 = mutableBufferEffect.toString(UTF8);
  return _bind(toAff1(readFile2)(path2))((x) => _liftEffect($3(x)));
})())((contents) => _pure(runRecoveredParser(parseModule)(contents))))(fromFoldable6(sourcePaths)))((modules) => {
  const v = sortModules((x) => x.header)(mapMaybe((v2) => {
    if (v2.tag === "ParseSucceeded") {
      return $Maybe("Just", v2._1);
    }
    if (v2.tag === "ParseSucceededWithErrors") {
      return $Maybe("Just", v2._1);
    }
    return Nothing;
  })(modules));
  if (v.tag === "CycleDetected") {
    return _liftEffect(error2(joinWith("\n")([
      "Cycle detected in modules:",
      joinWith("\n")(arrayMap(($4) => "  " + $4)(arrayMap((x) => x.header.name.name)(v._1)))
    ])));
  }
  if (v.tag === "Sorted") {
    return for_3(toUnfoldable3(unfoldableArray)(foldlArray(resolveOperatorExports)(Leaf2)(v._1)))((v1) => {
      const modName = (() => {
        if (v1._1.tag === "Nothing") {
          return "";
        }
        if (v1._1.tag === "Just") {
          return v1._1._1;
        }
        fail();
      })();
      return for_3(toUnfoldable3(unfoldableArray)(v1._2))((v2) => _liftEffect(log2(fold2([
        modName,
        (() => {
          if (v2._1._1.tag === "OperatorType") {
            return ".(" + (v2._1._2 + ") type");
          }
          if (v2._1._1.tag === "OperatorValue") {
            return ".(" + (v2._1._2 + ")");
          }
          fail();
        })(),
        " " + showIntImpl(v2._2)
      ]))));
    });
  }
  fail();
}));
var formatInPlaceOne = (v) => (v1) => formatInPlaceCommand(v.shouldCheck)((() => {
  const $2 = _lookup(
    Nothing,
    Just,
    v1.config.operatorsFile,
    _fmapObject(v.operatorsByPath, (operators) => defer((v2) => parseOperatorTable(operators)))
  );
  if ($2.tag === "Nothing") {
    return Leaf2;
  }
  if ($2.tag === "Just") {
    return force($2._1);
  }
  fail();
})())(v1);
var expandGlobs = /* @__PURE__ */ (() => {
  const $0 = arrayMap((path2) => {
    if (extname(path2) === "") {
      if ((() => {
        const $12 = stripSuffix("**")(path2);
        if ($12.tag === "Nothing") {
          return false;
        }
        if ($12.tag === "Just") {
          return true;
        }
        fail();
      })()) {
        return concat4([path2, "*.purs"]);
      }
      return concat4([path2, "**", "*.purs"]);
    }
    return path2;
  });
  const $1 = _map((() => {
    const $12 = filterWithKey(ordString)((v) => isFile);
    const $2 = toUnfoldable4(unfoldableArray);
    return (x) => $2(functorMap.map((v) => unit)($12(x)));
  })());
  return (x) => {
    const $3 = $0(x);
    return $1(_bind(_liftEffect(process3.cwd))((cwd) => expandGlobsWithStats(cwd)($3)));
  };
})();
var main = /* @__PURE__ */ (() => {
  const $0 = _makeFiber(
    ffiUtil,
    _bind(_map(drop(2))(_liftEffect(argv)))((args) => {
      const parsedCmd = parseArgs2("purs-tidy")("A tidy-upper for PureScript source code.")(parser)(args);
      if (parsedCmd.tag === "Left") {
        return _bind(_liftEffect(log2(printArgError(parsedCmd._1))))(() => {
          if (parsedCmd._1._2.tag === "ShowHelp") {
            return _liftEffect(exit(0));
          }
          if (parsedCmd._1._2.tag === "ShowInfo") {
            return _liftEffect(exit(0));
          }
          return _liftEffect(exit(1));
        });
      }
      if (parsedCmd.tag === "Right") {
        if (parsedCmd._1.tag === "GenerateOperators") {
          return generateOperatorsCommand(parsedCmd._1._1);
        }
        if (parsedCmd._1.tag === "GenerateRc") {
          return _bind($$try4(toAff1(stat2)(".tidyrc.json")))((rcStats) => {
            if ((() => {
              if (rcStats.tag === "Left") {
                return true;
              }
              if (rcStats.tag === "Right") {
                return false;
              }
              fail();
            })()) {
              return toAff3(writeTextFile)(UTF8)(".tidyrc.json")(stringifyWithIndent(2)(toJson(parsedCmd._1._1)) + "\n");
            }
            return _bind(_liftEffect(error2(".tidyrc.json already exists.")))(() => _liftEffect(exit(1)));
          });
        }
        if (parsedCmd._1.tag === "FormatInPlace") {
          return _bind(_liftEffect(process3.cwd))((currentDir) => {
            const root = parse2(currentDir).root;
            return _bind(_map(fold12)(_liftEffect(lookupEnv("TIDY_INSTALL_LOC"))))((srcLocation) => _bind(expandGlobs(parsedCmd._1._6))((files) => _bind(_map(fst)($$for(files)((filePath) => bindStateT2.bind($$get)((rcMap) => bindStateT2.bind(bindStateT2.bind(lift(resolveRcForDir(root)(rcMap)(dirname(filePath))))((x) => monadStateStateT2.state((v) => x)))((rcOptions) => bindStateT2.bind(lift(getOptions(parsedCmd._1._2)(rcOptions)(filePath)(parsedCmd._1._3)))((options) => applicativeStateT2.pure({
              filePath,
              config: toWorkerConfig(options)
            })))))(Leaf2)))((filesWithOptions) => _bind(_map(fromFoldable13)(parTraverse2((path2) => _map(Tuple(path2))(readOperatorTable(path2)))(nubBy(ordString.compare)(arrayMap((v) => v.config.operatorsFile)(filesWithOptions)))))((operatorsByPath) => {
              const workerData = { shouldCheck: parsedCmd._1._1.tag === "Check", operatorsByPath };
              return _bind((() => {
                if (filesWithOptions.length > (parsedCmd._1._4 * 2 | 0)) {
                  const bundleLocation = concat4([srcLocation, "bundle", "Bin.Worker", "index.js"]);
                  const outputLocation = concat4([srcLocation, "output", "Bin.Worker", "index.js"]);
                  return _bind((() => {
                    const $11 = _throwError(error("Worker not found"));
                    return _catchError(oneOf([
                      (() => {
                        const $12 = unsafeMakeImpl({ filePath: bundleLocation });
                        return _map((v) => $12)(toAff1(stat2)(bundleLocation));
                      })(),
                      (() => {
                        const $12 = unsafeMakeImpl({ filePath: outputLocation });
                        return _map((v) => $12)(toAff1(stat2)(outputLocation));
                      })()
                    ]))((v) => $11);
                  })())((worker) => poolTraverse2(worker)(workerData)(parsedCmd._1._4)(filesWithOptions));
                }
                return parTraverse2(formatInPlaceOne(workerData))(filesWithOptions);
              })())((results) => {
                const v = foldMap12((v1) => ({
                  errors: (() => {
                    if (v1.error !== "") {
                      return [$Tuple(v1.filePath, v1.error)];
                    }
                    return [];
                  })(),
                  notFormatted: (() => {
                    if (!v1.alreadyFormatted) {
                      return [v1.filePath];
                    }
                    return [];
                  })()
                }))(results);
                return _bind((() => {
                  const $11 = for_3(sortBy((x) => (y) => ordNumber.compare(x.timing)(y.timing))(results))((v1) => {
                    const $12 = _liftEffect(log2(fold2([
                      relative(currentDir)(v1.filePath),
                      " ",
                      toStringWith($Format("Fixed", clamp(0)(20)(2)))(v1.timing),
                      "ms"
                    ])));
                    if (v1.timing > 0) {
                      return $12;
                    }
                    return _pure(unit);
                  });
                  if (parsedCmd._1._5) {
                    return $11;
                  }
                  return _pure(unit);
                })())(() => {
                  if (parsedCmd._1._1.tag === "Write") {
                    return for_3(v.errors)((v1) => _liftEffect(error2(v1._1 + (":\n  " + (v1._2 + "\n")))));
                  }
                  if (parsedCmd._1._1.tag === "Check") {
                    return _liftEffect((() => {
                      if (v.errors.length === 0 && v.notFormatted.length === 0) {
                        const $122 = log2("All files are formatted.");
                        return () => {
                          $122();
                          return exit(0)();
                        };
                      }
                      const $12 = v.errors.length === 0;
                      const $13 = log2("Some files have errors:\n");
                      const $14 = (() => {
                        if (!$12) {
                          return () => {
                            $13();
                            return for_1(v.errors)((v1) => error2(v1._1 + (":\n  " + (v1._2 + "\n"))))();
                          };
                        }
                        if ($12) {
                          return () => unit;
                        }
                        fail();
                      })();
                      return () => {
                        $14();
                        const $16 = v.notFormatted.length === 0;
                        const $17 = log2("Some files are not formatted:\n");
                        (() => {
                          if (!$16) {
                            return () => {
                              $17();
                              return for_1(v.notFormatted)(error3(monadEffectEffect))();
                            };
                          }
                          if ($16) {
                            return () => unit;
                          }
                          fail();
                        })()();
                        return exit(1)();
                      };
                    })());
                  }
                  fail();
                });
              });
            }))));
          });
        }
        if (parsedCmd._1.tag === "Format") {
          return _bind(_liftEffect(process3.cwd))((currentDir) => _bind(resolveRcForDir(parse2(currentDir).root)(Leaf2)(currentDir))((v) => _bind(getOptions(parsedCmd._1._1)(v._1)("the current directory.")(parsedCmd._1._2))((options) => _bind(_map((x) => parseOperatorTable((() => {
            if (x.tag === "Nothing") {
              return defaultOperators;
            }
            if (x.tag === "Just") {
              return x._1;
            }
            fail();
          })()))(traverse2(readOperatorTable)(options.operatorsFile)))((operators) => _bind(readStdin)((contents) => {
            const v1 = formatCommand(options)(operators)(contents);
            if (v1.tag === "Left") {
              return _bind(_liftEffect(error2(printParseError(v1._1))))(() => _liftEffect(exit(1)));
            }
            if (v1.tag === "Right") {
              return makeAff((k) => {
                const $9 = writeString2(process3.stdout)(UTF8)(v1._1)((() => {
                  const $92 = k($Either("Right", unit));
                  return (v$1) => $92;
                })());
                return () => {
                  $9();
                  return nonCanceler;
                };
              });
            }
            fail();
          })))));
        }
        fail();
      }
      fail();
    })
  );
  return () => {
    const fiber = $0();
    fiber.run();
    return unit;
  };
})();
export {
  $Command,
  $ConfigOption,
  $FormatMode,
  Check,
  Format,
  FormatInPlace,
  GenerateOperators,
  GenerateRc,
  Ignore,
  Prefer,
  Require,
  Write,
  applicativeStateT2 as applicativeStateT,
  bindStateT2 as bindStateT,
  eqFormatMode,
  expandGlobs,
  fold2 as fold,
  fold12 as fold1,
  foldMap12 as foldMap1,
  $$for as for,
  for_3 as for_,
  for_1,
  formatInPlaceOne,
  fromFoldable6 as fromFoldable,
  fromFoldable13 as fromFoldable1,
  generateOperatorsCommand,
  $$get as get,
  getOptions,
  lift,
  main,
  monadStateStateT2 as monadStateStateT,
  oneOf,
  parTraverse2 as parTraverse,
  parseArgs2 as parseArgs,
  parser,
  poolTraverse2 as poolTraverse,
  rcFileName,
  readOperatorTable,
  readStdin,
  resolveRcForDir,
  traverse2 as traverse,
  $$try4 as try
};
